unit F_ComClient;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Spin, ComObj,
  Activex, ComCtrls,
  qs_stat_tlb,
  qs_statevents,
  sd_simulation,
  f_dbtest, Db, DBTables;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    BB_StartServer: TBitBtn;
    BB_Disconnect: TBitBtn;
    BB_Connect: TBitBtn;
    BB_OpenFile: TBitBtn;
    OpenDialog1: TOpenDialog;
    BB_EvaluateAll: TBitBtn;
    Panel3: TPanel;
    BB_Result: TBitBtn;
    BB_Grafik: TBitBtn;
    Panel4: TPanel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    SpinEdit5: TSpinEdit;
    SpinEdit6: TSpinEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    BB_Simulation: TBitBtn;
    ProgressBar1: TProgressBar;
    BB_Testresult: TBitBtn;
    B_Break: TButton;
    SE_NrOfTestRun: TSpinEdit;
    Label6: TLabel;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    TransmitFile: TBitBtn;
    TransmitAppend: TBitBtn;
    BB_DATABASE: TBitBtn;
    Table1: TTable;
    LA_Module: TLabel;
    BB_Modul: TBitBtn;
    BB_Evaluate_1: TBitBtn;
    COB_Module: TComboBox;
    BB_Language: TBitBtn;
    LA_Language: TLabel;
    COB_Language: TComboBox;
    Label7: TLabel;
    SpinEdit7: TSpinEdit;
    BB_Strat: TBitBtn;
    La_Strat: TLabel;
    COB_Strat: TComboBox;
    procedure BB_StartServerClick(Sender: TObject);
    procedure BB_DisconnectClick(Sender: TObject);
    procedure BB_ConnectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BB_OpenFileClick(Sender: TObject);
    procedure BB_EvaluateAllClick(Sender: TObject);
    procedure BB_ResultClick(Sender: TObject);
    procedure BB_GrafikClick(Sender: TObject);
    procedure BB_SimulationClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure BB_TestresultClick(Sender: TObject);
    procedure B_BreakClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure TransmitFileClick(Sender: TObject);
    procedure TransmitAppendClick(Sender: TObject);
    procedure BB_DATABASEClick(Sender: TObject);
    procedure BB_ModulClick(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure BB_Evaluate_1Click(Sender: TObject);
    procedure BB_LanguageClick(Sender: TObject);
    procedure BB_StratClick(Sender: TObject);
  private
    { Private-Deklarationen }
    // Handle for accessing qs-STAT functionalities
    qsstatHandle : longint;
    hThreadEnde  : THandle;
    qs_modul     : Integer;
    qs_language  : integer;
    qs_strat     : integer;

    // qs-STAT Object
    IQsSTAT : ITQsstatRemoteControl;
    IQsStatDb : IDataBase;
    RemoteServer : boolean;

    // Object for connection point IQsEvents
    EventSink : TIQsEvents;

    // Nr. of characteristics loaded
    NumOfCharcteristics : integer;

    //--------------------------------------------------------------------------
    // Filetransmission
    TransmittedFileName : string;
    TransmittedFilePos  : longint;
    TransmissionInProgress : boolean;

    //--------------------------------------------------------------------------
    // simulation Parameters
    Param1,
    Param2,
    Param3,
    Param4,
    Param5,
    Param6,
    Param7,
    Param8,
    Param9,
    Param10 : double;
    bUsl,
    bLsl    : byte;
    usl,
    lsl     : double;
    Decimals  : integer;
    NrOfValues  : integer;
    SampleSize  : integer;
    Distribution : integer;

    ExportFileName : string;
    ExportKeys     : TStringList;
    NrOfRuns       : integer;
    Timeout        : longint;

    // ------------------ for Testruns -------------------
    StopTest       : boolean;

    //--------------------------------------------------------------------------
    // Events from Server
    function OnGetAliveState(  Sender : TObject;out state : integer): HResult;
    function OnDataAvail( Sender : TObject; NumOfChars: Integer): HResult;
    function OnQSSTATInitialize( Sender : TObject): HResult;
    function OnEvaluationDone(Sender : TObject): HResult;
    function OnErrorEvent(Sender : TObject; ErrorCode: Integer): HResult;
    function OnSystemAlarm(Sender : TObject; AlarmCode: LongWord): HResult;
    function OnStatisticalAlarm( Sender       : TObject;
                                  Alarm_EW_1   : LongWord;
                                  Alarm_EW_2   : LongWord;
                                  Alarm_QRK_L  : LongWord;
                                  Alarm_QRK_S  : LongWord;
                                  Alarm_CP     : LongWord;
                                  Alarm_NO_SPC : LongWord;
                                  Part_Nr      : Integer;
                                  Char_Nr      : Integer;
                                  Value_Nr     : Integer;
                                  Sample_Nr    : Integer): HResult;
    //--------------------------------------------------------------------------

    // Filetranmission
    // Dateien bertragen
    procedure Transmit( buffer : PCHAR; size: longint; Append : boolean);

    // Setting SpinEdits according to loaded data
    procedure SetSpinEdits;

    // Setting available modules
    procedure InitializeCOBModule;

    // Setting available Languages
    procedure InitializeCOBLanguage;

    // Setting available Languages
    procedure InitializeCOBStrat;

    // disabling some buttons
    // Buttons abschalten, whrend server startet
    procedure DisableButtons;

    // enabling some buttons, after server is initialized
    // Buttons anschalten, wenn Server initialisiert
    procedure EnableButtons;

  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
//      IQsSTAT : ITQsstatRemoteControl;

implementation

{$R *.DFM}

function lpStartServerProc( ptr : pointer ) : longint; stdcall;
var form : TForm1;
begin
  Result := 0;
  form := TForm1(ptr);

    // Create the object
  if form.IQsSTAT = nil then
  begin
    // Create the object
    if form.RemoteServer then
    begin
      form.IQsSTAT := CoTQsstatRemoteControl.CreateRemote(form.Edit1.Text);
      form.IQsSTAT.QueryInterface( IID_IDataBase,form.IQsStatDb);
    end else
    begin
      form.IQsSTAT := CoTQsstatRemoteControl.Create;
      form.IQsSTAT.QueryInterface( IID_IDataBase,form.IQsStatDb);
    end;

    if form.IQsSTAT <> nil then
    begin
      form.Panel1.Caption := 'server started';
    end else
    begin
      form.Panel1.Caption := 'connection failed!';
    end;
Application.ProcessMessages;

    // Set the Connection Points for IQsEvents state
    form.EventSink := TIQsEvents.Create(form);
    form.EventSink.OnGetAliveState     := form.OnGetAliveState;
    form.EventSink.OnDataAvail         := form.OnDataAvail;
    form.EventSink.OnQSSTATInitialized := form.OnQSSTATInitialize;
    form.EventSink.OnEvaluationDone    := form.OnEvaluationDone;
    form.EventSink.OnError             := form.OnErrorEvent;
    form.EventSink.OnSystemAlarm       := form.OnSystemAlarm;
    form.EventSink.OnStatisticalAlarm  := form.OnStatisticalAlarm;

    form.EventSink.Connect(form.IQsStat);

    form.hThreadEnde := CreateEvent(nil,FALSE,FALSE,nil);
    WaitForSingleObject(form.hThreadEnde,INFINITE);
    CloseHandle(form.hThreadEnde);
  end;
end;


procedure TForm1.BB_StartServerClick(Sender: TObject);
var dwID : DWORD;
begin
  Panel1.Caption := 'Starting server';
  if IQsSTAT = nil then
  begin
     CreateThread(nil,0,@lpStartServerProc,self,0,dwID);
  end;
end;

{
procedure TForm1.BB_StartServerClick(Sender: TObject);
var
  n : integer;
  hr : HRESULT;
begin
  if IQsSTAT = nil then
  begin
    // Create the object
    if RemoteServer then
    begin
      IQsSTAT := CoTQsstatRemoteControl.CreateRemote(Edit1.Text);
    end else
    begin
      IQsSTAT := CoTQsstatRemoteControl.Create;
    end;

    if IQsSTAT <> nil then
    begin
      Panel1.Caption := 'server started';
    end else
    begin
      Panel1.Caption := 'connection failed!';
    end;
    // Set the Connection Points for IQsEvents state
    EventSink := TIQsEvents.Create(self);
    EventSink.OnGetAliveState     := OnGetAliveState;
    EventSink.OnDataAvail         := OnDataAvail;
    EventSink.OnQSSTATInitialized := OnQSSTATInitialize;
    EventSink.OnEvaluationDone    := OnEvaluationDone;
    EventSink.OnError             := OnErrorEvent;
    EventSink.Connect(IQsStat);

  end;
end;
}
procedure TForm1.BB_DisconnectClick(Sender: TObject);
begin
  // release the sink object
  if EventSink <> nil then
  begin
    EventSink.Destroy;
    EventSink := nil;
  end;
  // Disconnect the client
  if IQsSTAT <> nil then
  begin
    IQsSTAT.ClientDisconnect(qsstatHandle);
    // release the server
    IQsSTAT := nil;
  end;

  Panel1.Caption := 'Disconnected';
  Label6.Caption := 'discon.';

  DisableButtons;
end;

procedure TForm1.BB_ConnectClick(Sender: TObject);
var
  VersionStr     : Widestring;
begin
  if IQsStat <> nil then
  begin

    Panel1.Caption := 'Connecting to qs-STAT';
    Application.ProcessMessages;

    // presetting qs-STAT modul
    // Voreinstellung qs-STAT Modul
    qs_modul := 20;
    LA_Module.Caption := 'Module: ' + inttostr(qs_modul);

    // presetting qs-STAT language
    // Voreinstellung qs-STAT Sprache
    qs_language := 49;
    LA_Language.Caption := 'Lang: ' + inttostr(qs_language);

    // Voreinstellung qs-STAT Sprache
    qs_Strat := 0; // Sonderfall: Default

    // Connect the Client to qs-STAT, get the qs-STAT handle
    IQsSTAT.ClientConnect(qsstatHandle,qs_modul,qs_language,'Superuser','Superuser');

    // Get qs-STAT Version
    IQsSTAT.QsstatVersion(qsstatHandle,VersionStr);

    Panel1.Caption := 'Connected to qs-STAT Version ' + VersionStr;
    Label6.caption := inttostr(qsstatHandle);

    EnableButtons;
    BB_Connect.Enabled := False;


    // initailize combobox for available modules
    InitializeCOBModule;

    // initailize combobox for available Languages
    InitializeCOBLanguage;

    // initailize combobox for available Strategies
    InitializeCOBStrat;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Initialization
  IQsSTAT      := nil;// ITQsstatRemoteControl;
  EventSink    := nil;
  qsstatHandle := 0;  // qs-STAT Handle
  RemoteServer := False;

  // size of Grafic
  SpinEdit5.Value := Image1.Width;
  SpinEdit6.Value := Image1.Height;

  ExportKeys:= TStringList.Create;

    Param1 := 10;
    Param2 := 0.1;
    Param3 := 0;
    Param4 := 0;
    Param5 := 0;
    Param6 := 0;
    Param7 := 0;
    Param8 := 0;
    Param9 := 0;
    Param10 := 0;
    bUsl := 1;
    bLsl := 1;
    usl  := 11;
    lsl  := 9;
    Decimals  := 2;
    NrOfValues  := 100;
    SampleSize  := 5;
    Distribution := 0;

    ExportFileName :='c:\temp\1000';
    ExportKeys.Add('1000');
    NrOfRuns := 5;
    Timeout  := 5000;

    StopTest := False;

  TransmittedFileName := '';
  TransmittedFilePos  := 0;
  TransmissionInProgress := False;
  DisableButtons;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if ExportKeys = nil then
  begin
    ExportKeys.Clear;
    ExportKeys.Free;
  end;



  // release the sink object
  if EventSink <> nil then
  begin
    EventSink.Destroy;
    EventSink := nil;
  end;

  // release the server
  IQsSTAT      := nil;// ITQsstatRemoteControl;
end;

procedure TForm1.BB_OpenFileClick(Sender: TObject);
var
  Filename : WideString;
begin
  if IQsSTAT <> nil then
  begin
    // Open a File
    if OpenDialog1.Execute then          { Dialog zum Dateiffnen anzeigen }
    begin
      FileName := OpenDialog1.FileName;
      Panel1.Caption := 'loading in progress: ' + FileName;
      NumOfCharcteristics := 0;
      Application.processMessages;// Repaint the window

      // load the selected file
      IQsSTAT.OpenFile(qsstatHandle,Filename);

      // Wait until data is loaded -> Event OnDataAvail

    end;
  end;
end;

procedure TForm1.BB_EvaluateAllClick(Sender: TObject);
begin
  if IQsSTAT <> nil then
  begin
    Panel1.Caption := 'evaluation in progress: ';
    Application.processMessages;// Repaint the window
    // reset Nr of evaluations
    EventSink.EvalCount := 0;
    // evaluate all the characteristics which are currently loaded

    IQsSTAT.EvaluateAllChars(qsstatHandle);


     // wait at maximum 20 seconds for evaluation
    if WaitForSingleObject(EventSink.hEvaluationEvent,20000(*INFINITE*)) = WAIT_TIMEOUT then
    begin
      Panel1.Caption := 'Timeout while evaluating';
    end;
    ResetEvent(EventSink.hEvaluationEvent);

    // Wait until data is evaluated.... -> Event OnEvaluationDone
  end;
end;

procedure TForm1.BB_ResultClick(Sender: TObject);
var
  PartNr,
  CharNr,
  GroupNr : integer;
  Key, SubKey    : integer;
  SValue1, SValue2, SValue3, SValue4, Svalue5  : WideString;
  DValue1, DValue2, DValue3, DValue4,DValue5 : double;
  ValueCount : longint;
begin
  if IQsSTAT <> nil then
  begin
    PartNr  := SpinEdit1.Value;
    CharNr  := SpinEdit2.Value;
    GroupNr := 0;
    Key     := SpinEdit4.value;
    Subkey  := SpinEdit7.value;

    // Get the statistical result (Key) for specified part/characteristic
    if IQsSTAT.GetStatResultEx(qsstatHandle,
                               PartNr, CharNr,GroupNr,
                               Key, Subkey,
                               4, //OutputType // AA_CONTENT_C
                               0, // not transformed
                               0, 0, // reserved
                               SValue1, SValue2, SValue3, SValue4,SValue5,
                               ValueCount,
                               DValue1,
                               DValue2,
                               DValue3,
                               DValue4,
                               DValue5) = S_OK then
    begin
      Panel1.Color := clWhite;
      Panel1.Caption := Svalue1;
    end else
    begin
      // error occurered, maybe nothing loaded or nothing evaluated
      Panel1.Color := clRed;
      Panel1.Caption := '---';
    end;
  end;
end;



function TForm1.OnGetAliveState(  Sender : TObject;out state : integer): HRESULT;
begin
  state := 1;
//  messagedlg('got state ' + inttostr(state), mtinformation,[mbok],0);
  Result := 0;  // was auch immer das soll
end;

function TForm1.OnDataAvail( Sender : TObject; NumOfChars: Integer): HRESULT;
begin
  // assigning Nr. of characteristics loaded
  NumOfCharcteristics :=  NumOfChars;

  // Setting the Min and max values of the SpinEdit fields
  SetSpinEdits;

  Panel1.Caption := 'characteristics loaded: ' + Inttostr(NumOfCharcteristics);

  // Redraw graphic in case of filetransmission (mode append)
  if TransmissionInProgress then
  begin
    // Getting a Graphic since Data was updated
    BB_GrafikClick(self);
    TransmissionInProgress := False;
  end;

  Result := 0;  // was auch immer das soll
end;

function TForm1.OnQSSTATInitialize( Sender : TObject): HRESULT;
begin
  Panel1.Caption := 'qs-STAT initialized';
  BB_StartServer.Enabled := False;
  BB_Connect.Enabled := True;
  Result := 0;  // was auch immer das soll
end;

function TForm1.OnEvaluationDone(Sender : TObject): HRESULT;
var
  NrOfChar : integer;
begin
  IQsSTAT.GetGlobalInfo(qsstatHandle,0,0,2,NrOfChar);// get current nr of characteristics

  Panel1.Caption := inttostr(NrOfChar) +' characteristics evaluated ' + inttostr(EventSink.EvalCount) + ' times';
  Result := 0;  // was auch immer das soll
end;

function TForm1.OnErrorEvent(Sender : TObject; ErrorCode: Integer): HRESULT;
begin
  messagedlg('Error occurred ' + inttostr(ErrorCode), mtinformation,[mbok],0);
  Result := 0;  // was auch immer das soll
end;


function TForm1.OnSystemAlarm(Sender : TObject; AlarmCode: LongWord): HRESULT;
begin
  messagedlg('SystemAlarm occurred ' + inttostr(AlarmCode), mtinformation,[mbok],0);
  Result := 0;  // was auch immer das soll
end;

function TForm1.OnStatisticalAlarm( Sender       : TObject;
                                     Alarm_EW_1   : LongWord;
                                     Alarm_EW_2   : LongWord;
                                     Alarm_QRK_L  : LongWord;
                                     Alarm_QRK_S  : LongWord;
                                     Alarm_CP     : LongWord;
                                     Alarm_NO_SPC : LongWord;
                                     Part_Nr      : Integer;
                                     Char_Nr      : Integer;
                                     Value_Nr     : Integer;
                                     Sample_Nr    : Integer): HRESULT;
begin
  messagedlg('StatisticAlarm occurred ', mtinformation,[mbok],0);
  Result := 0;  // was auch immer das soll
end;

procedure TForm1.BB_GrafikClick(Sender: TObject);
type parray = array[0..1024] of char;
     pparray = ^parray;
var
  TempStream : TMemoryStream;
  dim        ,
  groesse    : longint;
  va         : OleVariant;
  buffer     ,
  P          : pointer;
  bitmap     : TBitmap;
  hr         : HRESULT;
  s             : string;
  width, height : integer;
  Save_Cursor:TCursor;
begin          // TCursor
  if IQsSTAT <> nil then
  begin
    Save_Cursor := Screen.Cursor;
    Screen.Cursor := crHourglass;
    try
      if Spinedit4.Value < 3100 then Spinedit4.Value := 3100;
      // Loading the Bitmap to the OleVariant
{
      hr := IQsSTAT.GetGraphic(qsstatHandle,
                         Spinedit4.Value,//GraphicNr
                         Spinedit1.Value,//PartNr
                         Spinedit2.Value,//CharNr
                         Spinedit5.Value,//Width
                         Spinedit6.Value,//Height
                         va);
}

      hr := IQsSTAT.GetGraphicExt(qsstatHandle,
                                  Spinedit4.Value, //GraphicNr
                                  0,               //GraphicSubNr
                                  Spinedit1.Value, //PartNr_x: OleVariant;
                                  Spinedit2.Value, //CharNr_x: OleVariant
                                  0,               //ValueNr_x: OleVariant
                                  0,               //NrOfValues_x: OleVariant;
                                  0,               //Group_x: OleVariant;
                                  Spinedit1.Value, //PartNr_y: OleVariant;
                                  Spinedit2.Value+1,//CharNr_y: OleVariant
                                  0,                //ValueNr_y: OleVariant;
                                  0,                //NrOfValues_y: OleVariant;
                                  0,                //Group_y: OleVariant;
                                  Spinedit5.Value,  //Width
                                  Spinedit6.Value,  //Height
                                  1,                //NrOfColumns: Integer;
                                  1,                //NrOfRows: Integer;
                                  0,                //ConfigID: Integer
                                  0,                //OutputFormat
                                  va);
    except
      exit;
    end;
    Screen.Cursor := Save_Cursor;
     if not SUCCEEDED(hr) then
     begin
        Image1.Canvas.Pen.Width := 2;
        Image1.Canvas.Font.Size := 12;
        s := 'No graphic available';
        width  := Image1.Canvas.TextWidth(s);
        height := Image1.Canvas.TextHeight(s);
        Image1.Canvas.TextOut( (Image1.Width  div 2)-(width div 2),
                               (Image1.Height div 2)-(height div 2),s);
        Image1.Canvas.MoveTo( 0,0);
        Image1.Canvas.LineTo(Image1.Width,Image1.Height);
        Image1.Canvas.MoveTo(Image1.Width,0);
        Image1.Canvas.LineTo(0,Image1.Height);
        MessageBeep(1);
        exit;
     end;

     // Copying the bitmmap from the variant to a internal buffer
     dim     := VarArrayDimCount(va);
     groesse := (VarArrayLowBound(va,dim) + VarArrayHighBound(va,dim));
     buffer  := AllocMem(groesse);
     P       := VarArrayLock(va);
     try
       Move(P^,buffer^,groesse-1);
     finally
       VarArrayUnlock(va);
     end;

     // moving from the buffer to a stream
     Image1.Stretch := False;
     TempStream := TMemoryStream.Create;
     TempStream.SetSize(groesse);
     TempStream.WriteBuffer(buffer^,groesse);
     TempStream.Seek(0,soFromBeginning);
     FreeMem(buffer,groesse);

     // Painting the bitmap from the stream  to the image
     bitmap := TBitmap.Create;
     bitmap.LoadFromStream(TempStream);
     Image1.Picture.Bitmap.Handle := bitmap.Handle;
     TempStream.Free;
  end;
end;

procedure TForm1.BB_SimulationClick(Sender: TObject);
var
  SimuationDialog: TSimuationDialog;
  // qs-STAT Object
  IQsSTATDistribution : IQsSTATSimulation;
  simulation : boolean;
  i,j        : integer;
  append     : boolean;
  ResultList : TStringList;
  ResultKey  : longint;
  ResultSubKey : longint;
  DValue     : double;
  SValue     : WideString;
  STmp       : string;
  decsep : char;
begin
  decsep := DecimalSeparator;
  DecimalSeparator := '.';
  simulation := False;
  // Simulation of values
    SimuationDialog := TSimuationDialog.Create(Self);

    SimuationDialog.bUsl        := boolean(busl);
    SimuationDialog.bLsl        := boolean(bLsl);
    SimuationDialog.usl         := usl;
    SimuationDialog.lsl         := lsl;
    SimuationDialog.Decimals    := Decimals;
    SimuationDialog.NrOfValues  := NrOfValues;
    SimuationDialog.SampleSize  := SampleSize;
    SimuationDialog.Distribution := Distribution;

    SimuationDialog.Param1      := Param1;
    SimuationDialog.Param2      := Param2;
    SimuationDialog.Param3      := Param3;
    SimuationDialog.Param4      := Param4;
    SimuationDialog.Param5      := Param5;
    SimuationDialog.Param6      := Param6;
    SimuationDialog.Param7      := Param7;
    SimuationDialog.Param8      := Param8;
    SimuationDialog.Param9      := Param9;
    SimuationDialog.Param10     := Param10;

    SimuationDialog.ExportFile :=  ExportFileName;
    SimuationDialog.NrOfRuns   := NrOfRuns;
    SimuationDialog.ExportKeys.Clear;
    SimuationDialog.Timeout  := Timeout;

    for i := 0 to ExportKeys.Count-1 do
    begin
      SimuationDialog.ExportKeys.Add(ExportKeys.Strings[i]);
    end;

  if SimuationDialog.ShowModal = mrOK then
  begin
    bUsl        := Byte(SimuationDialog.bUsl);
    bLsl        := Byte(SimuationDialog.bLsl);
    usl         := SimuationDialog.usl;
    lsl         := SimuationDialog.lsl;
    Decimals    := SimuationDialog.Decimals;
    NrOfValues  := SimuationDialog.NrOfValues;
    SampleSize  := SimuationDialog.SampleSize;
    Distribution := SimuationDialog.Distribution;



    Param1  := SimuationDialog.Param1;
    Param2  := SimuationDialog.Param2;
    Param3  := SimuationDialog.Param3;
    Param4  := SimuationDialog.Param4;
    Param5  := SimuationDialog.Param5;
    Param6  := SimuationDialog.Param6;
    Param7  := SimuationDialog.Param7;
    Param8  := SimuationDialog.Param8;
    Param9  := SimuationDialog.Param9;
    Param10 := SimuationDialog.Param10;


    ExportFileName := SimuationDialog.ExportFile;
    NrOfRuns       := SimuationDialog.NrOfRuns;
    Timeout        := SimuationDialog.timeout;
    ExportKeys.Clear;
    for i := 0 to SimuationDialog.ExportKeys.Count-1 do
    begin
      ExportKeys.add(SimuationDialog.ExportKeys.strings[i]);
    end;

    Simulation := True;
  end;
  SimuationDialog.Free;

  if (Simulation) and (IQsSTAT <> nil)then
  begin
    ResultList := TStringList.Create;
    ProgressBar1.Min := 0;
    ProgressBar1.Max := NrOfRuns;
    ProgressBar1.Position := 0;


    append := False;

    // reset Nr of evaluations
    EventSink.EvalCount := 0;

    IQsSTATDistribution := IQsSTAT as IQsSTATSimulation;

       // Performance Test
    for i := 0 to NrOfRuns-1 do
    begin
      IQsSTATDistribution.SimulateDistributionModel(qsSTATHandle,Distribution,NrOfValues,
                 SampleSize,busl,usl,blsl,lsl,decimals,param1,param2,param3,param4,param5,param6,param7,
                 param8,param9,param10);

      NumOfCharcteristics := 1;

      IQsSTAT.EvaluateAllChars(qsSTATHandle);

      if WaitForSingleObject(EventSink.hEvaluationEvent,Timeout(*INFINITE*)) = WAIT_TIMEOUT then
      begin
// AutoReset of the Event
//        ResetEvent(EventSink.hEvaluationEvent);
        if MessageDlg('WAIT_TIMEOUT',mtinformation,[mbok,mbCancel],0)=mrCancel then
        begin
          break;
        end;
      end else
      begin
// AutoReset of the Event
//        ResetEvent(EventSink.hEvaluationEvent);

        // Ergebnis(se) abholen
        for j := 0 to ExportKeys.Count-1 do
        begin
          if pos(',', ExportKeys.Strings[j]) > 0 then
          begin
            // Testergebnis
            Stmp := Copy(ExportKeys.Strings[j],1,pos(',', ExportKeys.Strings[j])-1);
            ResultKey := StrToInt(STmp);
            Stmp := Copy(ExportKeys.Strings[j],
                         pos(',', ExportKeys.Strings[j])+1,
                         Length(ExportKeys.Strings[j]) - pos(',', ExportKeys.Strings[j]));
            ResultSubKey := StrToInt(STmp);
            IQsSTAT.GetTestResult(qsStatHandle,
                                  1,//PartNr,
                                  1,// CharNr,
                                  ResultKey,
                                  ResultSubkey,
                                  SValue,
                                  DValue);//
            SValue := FloatToStr(DValue);
          end else
          begin
            // normales Auswerteergbenis
            try
              ResultKey := StrToInt(ExportKeys.Strings[j]);
            except
              ResultKey := 1000;
              SValue := '-1';
            end;

              if IQsSTAT.GetStatResult(qsstatHandle,
                                       ResultKey,//Key,
                                       1,//PartNr,
                                       1,// CharNr,
                                       0, // not transformed
                                       Svalue,
                                       DValue) = S_OK then
              begin
                SValue := FloatToStr(DValue);
              end else
              begin
                SValue := '-1';
              end;
          end;
          ResultList.Add(SValue);
        end; // for j

        // Ergebnis in DFQ-Datei schreiben
        WriteResultDFQ( ExportFileName,
                        ExportKeys,
                        ResultList,
                        Append,
                        False);
        if not append then
        begin
          append := True;
        end;
        ResultList.Clear;

        // Grafik anzeigen / Anzeige aktualisieren
        Panel1.Caption := inttostr(NumOfCharcteristics) +' characteristics evaluated ' + inttostr(EventSink.EvalCount) + ' times';
        Panel1.Repaint;
        ProgressBar1.Position := i+1;
      end; (*wait for Evaluation*)
    end;(*for*)
    ResultList.Free;
  end;
  DecimalSeparator := decsep;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  //
end;

procedure TForm1.FormResize(Sender: TObject);
begin

  Image1.Width  := Panel3.Width;
  Image1.Height := Panel3.Height;

  SpinEdit5.Value := Image1.Width;
  SpinEdit6.Value := Image1.Height;

  // Refresh the graphic
  BB_GrafikClick(self);
end;

procedure TForm1.BB_TestresultClick(Sender: TObject);
var
  i : integer;
  LocalqsstatHandle : longint;
begin
  // Test
  StopTest := False;
  for i := 0 to SE_NrOfTestRun.Value-1 do
  begin
//    IQsSTAT.SetModule(qsStatHandle,modul);
    IQsSTAT.ClientConnect(LocalqsstatHandle,20,49,'Superuser','Superuser');

    IQsSTAT.ClientDisconnect(LocalqsstatHandle);

    Panel1.Caption := inttostr(i) + '. run';
    Panel1.Repaint;
    Application.processMessages;
    if StopTest then break;
  end;
end;

procedure TForm1.B_BreakClick(Sender: TObject);
begin
  //
  StopTest := true;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Edit1.enabled := CheckBox1.Checked;
  RemoteServer  := CheckBox1.Checked;
end;

procedure TForm1.TransmitFileClick(Sender: TObject);
var
  MyFile   : file of Byte;
  FilePtr  : PCHAR;
  FSize    : longint;
  memsize  : longint;
begin

  //
  if IQsSTAT <> nil then
  begin
    // Open a File
    if OpenDialog1.Execute then          { Dialog zum Dateiffnen anzeigen }
    begin
      TransmittedFileName := OpenDialog1.FileName;

      Panel1.Caption := 'transmitting in progress: ' + TransmittedFileName;
      NumOfCharcteristics := 0;
      Application.processMessages;// Repaint the window

      Assignfile(MyFile,TransmittedFileName);
      try
        reset(MyFile);
        FSize := Filesize(myFile);

        memsize := FSize;
        GetMem( FilePtr,memsize+1 );

        // Load the File to the temporary Buffer
        Blockread(MyFile,FilePtr^, MemSize);
        closefile(MyFile);

        // transmit the stream to the server
        transmit(FilePtr, memsize,False);

        TransmittedFilePos  := FSize;

        Freemem(FilePtr,memsize+1 );
     except
     end;
    end;
  end;
end;

procedure TForm1.Transmit( buffer : PCHAR; size: longint; Append : boolean);
var
  va : OleVariant;
  P  : pointer;
begin
  if IQsSTAT <> nil then
  begin
    va := VarArrayCreate([0,size], varByte);
    P := VarArrayLock(va);
    Move(buffer^,P^,size);
    VarArrayUnLock(va);
    if append then IQsSTAT.TransmitFileExt(qsstatHandle,va,1,0)
              else IQsSTAT.TransmitFileExt(qsstatHandle,va,0,0)
  end;
end;

procedure TForm1.TransmitAppendClick(Sender: TObject);
var
  MyFile   : file of Byte;
  FilePtr  : PCHAR;
  FSize    : longint;
  memsize  : longint;
begin
  //
  if (IQsSTAT <> nil) and (TransmittedFileName <> '') then
  begin
    Panel1.Caption := 'Updating: ' + TransmittedFileName;

    Application.processMessages;// Repaint the window

    Assignfile(MyFile,TransmittedFileName);
    try
      reset(MyFile);
      FSize := Filesize(myFile);
      if FSize > TransmittedFilePos then
      begin

        Memsize := FSize - TransmittedFilePos;

        GetMem( FilePtr,memsize+1 );

        // Load the File to the temporary Buffer
        Seek(MyFile,TransmittedFilePos);  // jump to the previous file position
        Blockread(MyFile,FilePtr^, MemSize);
        closefile(MyFile);

        // Transmit the stream & append to the loaded data
        transmit(FilePtr, memsize,True);

        TransmissionInProgress := True;
        TransmittedFilePos  := FSize; // store the # of transmitted Bytes

        Freemem(FilePtr,memsize+1 );
      end;
   except
   end;
  end;
end;

procedure TForm1.SetSpinEdits;
var
  value    : integer;
begin
  // Nr of loaded parts
  // Anzahl geladener Teile
  IQsSTAT.GetGlobalInfo(qsstatHandle,0,0,1,value);
  spinedit1.MaxValue := value;
  spinedit1.MinValue := 1;
  if Value > 1 then SpinEdit1.Enabled := True
               else SpinEdit1.Enabled := False;
  if Value > 0 then
  begin
    // nr of loaded characteristics
    // Anzahl geladener Merkmale
    spinedit1.Value := 1;
    IQsSTAT.GetGlobalInfo(qsstatHandle,1,0,3,value);
    spinedit2.MaxValue := value;
    spinedit2.MinValue := 0;
    if Value > 1 then SpinEdit2.Enabled := True
                 else SpinEdit2.Enabled := False;
    if Value > 0 then
    begin
      // Nr of values for specific characteristic
      // Anzahl Werte fr angegebenes Merkmal
      spinedit2.Value := 1;
      IQsSTAT.GetGlobalInfo(qsstatHandle,1,1,4,value);
      spinedit3.MaxValue := value;
      spinedit3.MinValue := 1;
      if Value > 1 then SpinEdit3.Enabled := True
      else SpinEdit3.Enabled := False;
      if Value > 0 then
      begin
        spinedit3.Value := 1;
      end else
      begin
        spinedit3.Value := 0;
      end;
    end else
    begin
      spinedit2.Value := 1;
    end;
  end else
  begin
    spinedit1.Value := 0;
  end;
end;


// Setting available modules
procedure TForm1.InitializeCOBModule;
var
  IQsSTATModules : IEnumModule;
  moduleKey      : integer;
  moduleName     : WideString;
  rc             : integer;
//  iStatResult : IEnumStatResults;
//  IGraphics : IEnumGraphic;
begin
  if IQsSTAT <> nil then
  begin
{
    COB_Module.Clear;
    IGraphics := IQsSTAT as IEnumGraphic;
    moduleKey := 0;
    moduleName := '';
    rc := IGraphics.GetFirstGraphic(qsstatHandle,20,modulekey,moduleName);
    while rc = 0 do
    begin
      COB_Module.Items.Add(Inttostr(moduleKey) + ' - ' + moduleName);
      rc := IGraphics.GetNextGraphic(qsstatHandle,20,modulekey,moduleName);
    end;
}
{
    COB_Module.Clear;
    iStatResult := IQsSTAT as IEnumStatResults;
    moduleKey := 0;
    moduleName := '';
    rc := iStatResult.GetFirstStatResult(qsstatHandle,20,modulekey,moduleName);
    while rc = 0 do
    begin
      COB_Module.Items.Add(Inttostr(moduleKey) + ' - ' + moduleName);
      rc := iStatResult.GetNextStatResult(qsstatHandle,20,modulekey,moduleName);
    end;
}

    COB_Module.Clear;
    IQsSTATModules := IQsSTAT as IEnumModule;
    moduleKey := 0;
    moduleName := '';
    rc := IQsSTATModules.GetFirstModule(qsstatHandle,moduleKey,moduleName);
    while rc = 0 do
    begin
      COB_Module.Items.Add(Inttostr(moduleKey) + ' - ' + moduleName);
      rc := IQsSTATModules.GetNextModule(qsstatHandle,moduleKey,moduleName);
    end;

  end;
end;


// Setting available Languages
procedure TForm1.InitializeCOBLanguage;
var
  IQsSTATLang    : IEnumLanguage;
  LangKey        : integer;
  LangShortName  : WideString;
  LangName       : WideString;
  rc             : integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_Language.Clear;
    IQsSTATLang := IQsSTAT as IEnumLanguage;
    LangKey        := 0;
    LangShortName  := '';
    LangName       := '';

    rc := IQsSTATLang.GetFirstLanguage(qsstatHandle,LangName,LangShortName,LangKey);
    while rc = 0 do
    begin
      COB_Language.Items.Add(Inttostr(LangKey) + ' - ' + LangName);
      rc := IQsSTATLang.GetNextLanguage(qsstatHandle,LangName,LangShortName,LangKey);
    end;
  end;
end;

// Setting available Languages
procedure TForm1.InitializeCOBStrat;
var
  IQsSTATStrat    : IEnumEvaluationStrategy;
  StratKey        : integer;
  StratName       : WideString;
  rc              : integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_Strat.Clear;
    IQsSTATStrat := IQsSTAT as IEnumEvaluationStrategy;
    StratKey        := 0;
    StratName       := '';

    rc := IQsSTATStrat.GetFirstEvaluationStrategy(qsstatHandle,qs_modul,0,StratKey,StratName);
    while rc = 0 do
    begin
      COB_Strat.Items.Add(Inttostr(StratKey) + ' - ' + StratName);
      rc := IQsSTATStrat.GetNextEvaluationStrategy(qsstatHandle,qs_modul,0,StratKey,StratName);
    end;
  end;
end;

// disabling some buttons
// Buttons abschalten, whrend server startet
procedure TForm1.DisableButtons;
begin
  BB_StartServer.Enabled  := True;

  BB_Disconnect.Enabled   :=  False;
  BB_Connect.Enabled      :=  False;
  BB_OpenFile.Enabled     :=  False;
  BB_EvaluateAll.Enabled  :=  False;
  BB_Result.Enabled       :=  False;
  BB_Grafik.Enabled       :=  False;
  SpinEdit1.Enabled       :=  False;
  SpinEdit2.Enabled       :=  False;
  SpinEdit3.Enabled       :=  False;
  SpinEdit4.Enabled       :=  False;
  SpinEdit5.Enabled       :=  False;
  SpinEdit6.Enabled       :=  False;
  SpinEdit7.Enabled       :=  False;
  BB_Simulation.Enabled   :=  False;
  BB_Testresult.Enabled   :=  False;
  B_Break.Enabled         :=  False;
  SE_NrOfTestRun.Enabled  :=  False;
//  Edit1.Enabled           :=  False;
//  CheckBox1.Enabled       :=  False;
  TransmitFile.Enabled    :=  False;
  TransmitAppend.Enabled  :=  False;
  BB_DATABASE.Enabled     :=  False;
  BB_Evaluate_1.Enabled   :=  False;
  BB_Modul.Enabled        :=  False;
  COB_Module.Enabled      :=  False;
  BB_Language.Enabled     :=  False;
  COB_Language.Enabled    :=  False;
  BB_Strat.Enabled        :=  False;
end;

// enabling some buttons, after server is initialized
// Buttons anschalten, wenn Server initialisiert
procedure TForm1.EnableButtons;
begin
  BB_StartServer.Enabled  :=  False;
  BB_Disconnect.Enabled   :=  True;
  BB_Connect.Enabled      :=  True;
  BB_OpenFile.Enabled     :=  True;
  BB_EvaluateAll.Enabled  :=  True;
  BB_Result.Enabled       :=  True;
  BB_Grafik.Enabled       :=  True;
  SpinEdit1.Enabled       :=  True;
  SpinEdit2.Enabled       :=  True;
  SpinEdit3.Enabled       :=  True;
  SpinEdit4.Enabled       :=  True;
  SpinEdit5.Enabled       :=  True;
  SpinEdit6.Enabled       :=  True;
  SpinEdit7.Enabled       :=  True;
  BB_Simulation.Enabled   :=  True;
  BB_Testresult.Enabled   :=  True;
  B_Break.Enabled         :=  True;
  SE_NrOfTestRun.Enabled  :=  True;
  Edit1.Enabled           :=  True;
  CheckBox1.Enabled       :=  True;
  TransmitFile.Enabled    :=  True;
  TransmitAppend.Enabled  :=  True;
  BB_DATABASE.Enabled     :=  True;
  BB_Evaluate_1.Enabled   :=  True;
  BB_Modul.Enabled        :=  True;
  COB_Module.Enabled      :=  True;
  BB_Language.Enabled     :=  True;
  COB_Language.Enabled    :=  True;
  BB_Strat.Enabled        :=  True;
  COB_Strat.Enabled       :=  True;
end;


procedure TForm1.BB_DATABASEClick(Sender: TObject);
var
  DB_FORM: TDB_FORM;
begin
  DB_FORM := TDB_FORM.Create(self);
    DB_FORM.qsstatHandle := qsstatHandle;
    DB_FORM.hThreadEnde := hThreadEnde;
    DB_FORM.IQsSTAT := IQsSTAT;
    DB_FORM.IQsSTATDb := IQsSTATDb;
    DB_FORM.RemoteServer := RemoteServer;
    DB_FORM.EventSink := EventSink;
    DB_FORM.NumOfCharcteristics := NumOfCharcteristics;
  DB_FORM.ShowModal;
  DB_FORM.Free;
  SetSpinEdits;
end;

procedure TForm1.BB_ModulClick(Sender: TObject);
var
  ModuleStr : WideString;
  s1        : WideString;
  NewModule : integer;
begin
  if IQsSTAT <> nil then
  begin
    ModuleStr := COB_Module.Text;
    if ModuleStr <> '' then
    begin
      s1 := Copy(ModuleStr,1,Pos(' - ',ModuleStr)-1);
      try
        NewModule := StrToInt(s1);
        if NewModule <> qs_modul then
        begin

          IQsSTAT.SetModule(qsStatHandle, NewModule);
          qs_modul := NewModule;
          LA_Module.Caption := 'Module: ' + inttostr(qs_modul);
        end;
      except
      end;
    end;
  end;
end;


procedure TForm1.BB_LanguageClick(Sender: TObject);
var
  LangStr   : WideString;
  s1        : WideString;
  NewLang   : integer;
begin
  if IQsSTAT <> nil then
  begin
    LangStr := COB_Language.Text;
    if LangStr <> '' then
    begin
      s1 := Copy(LangStr,1,Pos(' - ',LangStr)-1);
      try
        NewLang := StrToInt(s1);
        if NewLang <> qs_language then
        begin
          IQsSTAT.SetLanguage(qsStatHandle, NewLang,s1);
          qs_language := NewLang;
          LA_Language.Caption := 'Lang: ' + inttostr(qs_language);
        end;
      except
      end;
    end;
  end;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
var
  Value    : Integer;
begin
  IQsSTAT.GetGlobalInfo(qsstatHandle,SpinEdit1.Value,0,3,value);
  spinedit2.MaxValue := value;
  spinedit2.MinValue := 0;
  if Value > 1 then SpinEdit2.Enabled := True
  else SpinEdit2.Enabled := False;
  if Value > 0 then
  begin
    spinedit2.Value := 1;
  end else
  begin
    spinedit2.Value := 0;
  end;
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
var
  Value    : Integer;
begin
  IQsSTAT.GetGlobalInfo(qsstatHandle,SpinEdit1.Value,SpinEdit2.Value,4,value);
  spinedit3.MaxValue := value;
  spinedit3.MinValue := 1;
  if Value > 1 then SpinEdit2.Enabled := True
  else SpinEdit3.Enabled := False;
  if Value > 0 then
  begin
    spinedit3.Value := 1;
  end else
  begin
    spinedit3.Value := 0;
  end;
end;

procedure TForm1.BB_Evaluate_1Click(Sender: TObject);
begin
  if IQsSTAT <> nil then
  begin
    Panel1.Caption := 'evaluation in progress: ';
    Application.processMessages;// Repaint the window
    // reset Nr of evaluations
    EventSink.EvalCount := 0;
    // evaluate 1 characteristic which is currently loaded, identified by SpinEdit1 and SpinEdit2

    IQsSTAT.EvaluateChar(qsstatHandle, SpinEdit1.Value, SpinEdit2.Value);

     // wait at maximum 20 seconds for evaluation
    if WaitForSingleObject(EventSink.hEvaluationEvent,20000(*INFINITE*)) = WAIT_TIMEOUT then
    begin
      Panel1.Caption := 'Timeout while evaluating';
    end;
    ResetEvent(EventSink.hEvaluationEvent);

    // Wait until data is evaluated.... -> Event OnEvaluationDone
  end;
end;


procedure TForm1.BB_StratClick(Sender: TObject);
var
  StratStr   : WideString;
  s1        : WideString;
  NewStrat   : integer;
begin
  if IQsSTAT <> nil then
  begin
    StratStr := COB_Strat.Text;
    if StratStr <> '' then
    begin
      s1 := Copy(StratStr,1,Pos(' - ',StratStr)-1);
      try
        NewStrat := StrToInt(s1);
        if NewStrat <> qs_Strat then
        begin
          IQsSTAT.SetEvaluationStrategy(qsStatHandle, 0, NewStrat);
          qs_Strat := NewStrat;
          LA_Strat.Caption := 'Evaluation Strategy: ' + inttostr(qs_Strat);
        end;
      except
      end;
    end;
  end;
end;

end.
