unit f_dbtest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,
  qs_stat_tlb,
  qs_statevents,
  //Definitions,
  com_common_consts,
  f_dbtest2,
  Spin, ExtCtrls;

type
  TDB_FORM = class(TForm)
    BB_PARTKEYS: TBitBtn;
    LB_PARTLIST: TListBox;
    ME_RESULT: TMemo;
    LB_CHARLIST: TListBox;
    BB_CHARKEYS: TBitBtn;
    LB_VALUELIST: TListBox;
    BB_VALUEKEYS: TBitBtn;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label2: TLabel;
    SpinEdit3: TSpinEdit;
    Label3: TLabel;
    LA_MAXPART: TLabel;
    LA_MAXCHAR: TLabel;
    LA_MAXVALUE: TLabel;
    BBFilter: TBitBtn;
    BB_Andere: TBitBtn;
    BB_LastN: TBitBtn;
    BB_Part1_All: TBitBtn;
    BB_First100: TBitBtn;
    SpinEdit4: TSpinEdit;
    Label4: TLabel;
    LB_ResList: TListBox;
    Label5: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ED_Maschine: TEdit;
    Bevel1: TBevel;
    Label6: TLabel;
    ED_From: TEdit;
    ED_To: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    BB_Filter_1202: TBitBtn;
    BB_Execute: TBitBtn;
    BB_mehrere: TBitBtn;
    CB_Desc: TCheckBox;
    BB_Test: TBitBtn;
    procedure BB_PARTKEYSClick(Sender: TObject);
    procedure BB_CHARKEYSClick(Sender: TObject);
    procedure BB_VALUEKEYSClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure BBFilterClick(Sender: TObject);
    procedure BB_AndereClick(Sender: TObject);
    procedure BB_LastNClick(Sender: TObject);
    procedure BB_Part1_AllClick(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BB_Filter_1202Click(Sender: TObject);
    procedure BB_ExecuteClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BB_mehrereClick(Sender: TObject);
    procedure BB_TestClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    // Handle for accessing qs-STAT functionalities
    qsstatHandle : longint;
    hThreadEnde  : THandle;

    // qs-STAT Object
    IQsSTAT : ITQsstatRemoteControl;
    IQsStatDb : IDataBase;
    RemoteServer : boolean;

    // Object for connection point IQsEvents
    EventSink : TIQsEvents;

    // Nr. of characteristics loaded
    NumOfCharcteristics : integer;
  end;

var
  DB_FORM: TDB_FORM;

implementation

{$R *.DFM}

procedure TDB_FORM.BB_PARTKEYSClick(Sender: TObject);
var
 i : Integer;
 PartKey : Integer;
 str : String;
 resultstr : WideString;
// MA rc : HRESULT;
begin
  if IQsSTAT <> NIL then
  begin
    ME_RESULT.Clear;
    for i:= 0 to LB_PARTLIST.Items.Count-1 do
    begin
      PartKey := StrToInt(LB_PARTLIST.Items[i]);
      str := IntToStr(PartKey)+  ' = ';
// MA      rc := IQsSTAT.GetPartInfo(qsstatHandle,
      IQsSTAT.GetPartInfo(qsstatHandle,
                          PartKey,
                          Spinedit1.Value,
                          0,
                          resultstr);
      str := str + resultstr;
      ME_Result.Lines.Add(str);
    end;
  end;
end;

procedure TDB_FORM.BB_CHARKEYSClick(Sender: TObject);
var
 i         : Integer;
 CharKey   : Integer;
 str       : String;
 resultstr : WideString;
 resultdbl : Double;
// MA rc        : HRESULT;
begin
  if IQsSTAT <> NIL then
  begin
    ME_RESULT.Clear;
    for i:= 0 to LB_CHARLIST.Items.Count-1 do
    begin
      CharKey := StrToInt(LB_CHARLIST.Items[i]);
      str := IntToStr(CharKey)+  ' = ';
// MA      rc := IQsSTAT.GetCharInfo(qsstatHandle,
      IQsSTAT.GetCharInfo(qsstatHandle,
                          CharKey,
                          Spinedit1.Value,
                          Spinedit2.Value,
                          resultstr);
      str := str + resultstr;
      ME_Result.Lines.Add(str);
    end;
    ME_Result.Lines.Add('');
    ME_Result.Lines.Add('Results:');
    for i:= 0 to LB_ResList.Items.Count-1 do
    begin
      CharKey := StrToInt(LB_ResList.Items[i]);
      str := IntToStr(CharKey)+  ' = ';
// MA      rc := IQsSTAT.GetStatResult(qsstatHandle,
      IQsSTAT.GetStatResult(qsstatHandle,
                          CharKey,
                          Spinedit1.Value,
                          Spinedit2.Value,
                          0, // not transformed
                          resultstr,
                          resultdbl);
      str := str + resultstr;
      ME_Result.Lines.Add(str);
    end;
  end;
end;

procedure TDB_FORM.BB_VALUEKEYSClick(Sender: TObject);
var
 i : Integer;
 ValKey : Integer;
 str : String;
 resultstr : WideString;
// MA rc : HRESULT;
begin
  if IQsSTAT <> NIL then
  begin
    ME_RESULT.Clear;
    for i:= 0 to LB_VALUELIST.Items.Count-1 do
    begin
      ValKey := StrToInt(LB_VALUELIST.Items[i]);
      str := IntToStr(ValKey)+  ' = ';
// MA      rc := IQsSTAT.GetValueInfo(qsstatHandle,
      IQsSTAT.GetValueInfo(qsstatHandle,
                          ValKey,
                          Spinedit1.Value,
                          Spinedit2.Value,
                          Spinedit3.Value,
                          NOTRANSFORM_C,
                          resultstr);
      str := str + resultstr;
      ME_Result.Lines.Add(str);
    end;
  end;
end;

procedure TDB_FORM.FormShow(Sender: TObject);
var
// MA   rc : HResult;
   dummyi : Integer;
begin
  Spinedit1.MinValue := 1;
// MA  rc:= IQsSTAT.GetGlobalInfo(qsstatHandle,0,0,1,dummyi);
  IQsSTAT.GetGlobalInfo(qsstatHandle,0,0,1,dummyi);
  //Spinedit1.MaxValue := dummyi;
  LA_MAXPART.Caption := Inttostr(dummyi);
// MA  rc:= IQsSTAT.GetGlobalInfo(qsstatHandle,0,0,2,dummyi);
  IQsSTAT.GetGlobalInfo(qsstatHandle,0,0,2,dummyi);
  Spinedit2.MinValue := 1;
  Spinedit2.MaxValue := dummyi;
  LA_MAXCHAR.Caption := Inttostr(dummyi);
// MA  rc:= IQsSTAT.GetGlobalInfo(qsstatHandle,1,1,4,dummyi);
  IQsSTAT.GetGlobalInfo(qsstatHandle,1,1,4,dummyi);
  Spinedit3.MinValue := 1;
  Spinedit3.MaxValue := dummyi;
  LA_MAXValue.Caption := Inttostr(dummyi);

end;

procedure TDB_FORM.SpinEdit1Change(Sender: TObject);
var
// MA   rc     : HResult;
// MA   dummyi : Integer;
   value  : Integer;
begin
  IQsSTAT.GetGlobalInfo(qsstatHandle,SpinEdit1.Value,0,3,value);
  SpinEdit2.MaxValue := Value;
  LA_MAXCHAR.Caption := IntToStr(Value);
  SpinEdit2.Value := 1;
  IQsSTAT.GetGlobalInfo(qsstatHandle,SpinEdit1.Value,SpinEdit2.Value,4,value);
  SpinEdit3.MaxValue := Value;
end;

procedure TDB_FORM.SpinEdit2Change(Sender: TObject);
var
   //rc     : HResult;
   //dummyi : Integer;
   value  : Integer;
begin
  IQsSTAT.GetGlobalInfo(qsstatHandle,SpinEdit1.Value,SpinEdit2.Value,4,value);
  SpinEdit3.MaxValue := Value;
  LA_MAXVALUE.Caption := IntToStr(Value);
  SpinEdit3.Value := 1;
end;

procedure TDB_FORM.BBFilterClick(Sender: TObject);
var
  rc            : HResult;
  HFilter       : Integer;
  HFilter2      : Integer;
  HGlobalFilter : Integer;
  HQuery        : Integer;
  value         : Integer;
  FilterList    : OleVariant;
begin
  Screen.Cursor := crHourGlass;
  rc := IQsStatDb.CreateQuery(qsstatHandle, HQuery);
  rc := rc or IQsStatDb.CreateFilterFromSQL( qsstatHandle,
                                             'TETEIL = ' + IntToStr(Spinedit4.Value),
                                             HFilter);
  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HFilter, PART_LEVEL_C, 0, 0);
  rc := rc or IQsStatDb.CreateFilter( qsstatHandle,
                                      K_FIELDS_C,
                                      4,
                                      ED_To.Text, //'1992/05/07 14:00:00',
                                      COMP_OP_SMALLER_C,
                                      HFilter);
  //rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HFilter, VALUE_LEVEL_C, 0, 0);

  rc := rc or IQsStatDb.CreateFilter( qsstatHandle,
                                      K_FIELDS_C,
                                      4,
                                      ED_From.Text, //'1992/05/07 13:59:40',
                                      COMP_OP_GREATER_C,
                                      HFilter2);

  FilterList := VarArrayCreate([0,1],varInteger);
  FilterList[0] := HFilter;
  FilterList[1] := HFilter2;
  rc := rc or IQsStatDb.CreateFilterFromFilters(qsstathandle, 0 {aoAND}, FilterList, HGlobalFilter);
  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HGlobalFilter, VALUE_LEVEL_C, 0, 0);
  if rc = 0 then
  begin
    IQsStatDb.SaveQuery(qsstatHandle, 'TestQuery', HQuery);
    rc := IQsStatDb.ExecuteQuery(qsstatHandle, HQuery, NULL);
  end;
  IQsStatDb.FreeQuery(qsstatHandle, HQuery);
  if rc = 0 then
  begin
    IQsSTAT.GetGlobalInfo(qsstatHandle,0,0,1,value);
    SpinEdit1.MaxValue := Value;
    LA_MAXPART.Caption := IntToStr(Value);
    SpinEdit1.Value := 0;
    SpinEdit1.Value := 1;
  end;
  Screen.Cursor := crDefault;
end;

procedure TDB_FORM.BB_AndereClick(Sender: TObject);
var
  Test2 : TForm_Bench_OL;
begin
  Test2 := TForm_Bench_OL.Create(Self);
  Test2.qsstatHandle := qsstatHandle;
  Test2.hThreadEnde := hThreadEnde;
  Test2.IQsSTAT := IQsSTAT;
  Test2.IQsSTATDb := IQsSTATDb;
  Test2.RemoteServer := RemoteServer;
  Test2.EventSink := EventSink;
  Test2.NumOfCharcteristics := NumOfCharcteristics;
  Test2.ShowModal;
  Test2.Free;
end;

procedure TDB_FORM.BB_LastNClick(Sender: TObject);
var
// MA   rc        : HResult;
   HFilter   : Integer;
   HQuery    : Integer;
   value     : Integer;
begin
  Screen.Cursor := crHourGlass;
// MA  rc := IQsStatDb.CreateQuery(qsstatHandle, HQuery);
  IQsStatDb.CreateQuery(qsstatHandle, HQuery);
// MA  rc := rc or IQsStatDb.CreateFilterFromSQL( qsstatHandle,
  IQsStatDb.CreateFilterFromSQL( qsstatHandle,
                                             'TETEIL = ' + IntToStr(Spinedit4.Value),
                                             HFilter);
// MA  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HFilter, PART_LEVEL_C, 0, 0);
  IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HFilter, PART_LEVEL_C, 0, 0);
  if Sender = BB_LastN then
  begin
// MA    rc := rc or IQsStatDb.CreateFilter( qsstatHandle,
    IQsStatDb.CreateFilter( qsstatHandle,
                                        K_FIELDS_C,
                                        0,
                                        '100',
                                        OP_GET_LAST_N_VALUES_C,
                                        HFilter);
  end else
  begin
// MA    rc := rc or IQsStatDb.CreateFilter( qsstatHandle,
    IQsStatDb.CreateFilter( qsstatHandle,
                                        K_FIELDS_C,
                                        0,
                                        '100',
                                        OP_GET_FIRST_N_VALUES_C,
                                        HFilter);
  end;
// MA  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HFilter, VALUE_LEVEL_C, 0, 0);
  IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HFilter, VALUE_LEVEL_C, 0, 0);
// MA  rc := rc or IQsStatDb.ExecuteQuery(qsstatHandle, HQuery, NULL);
  IQsStatDb.ExecuteQuery(qsstatHandle, HQuery, NULL);
  IQsStatDb.FreeQuery(qsstatHandle, HQuery);
  IQsSTAT.GetGlobalInfo(qsstatHandle,0,0,1,value);
  SpinEdit1.MaxValue := Value;
  LA_MAXPART.Caption := IntToStr(Value);
  SpinEdit1.Value := 0;
  SpinEdit1.Value := 1;
  Screen.Cursor := crDefault;
end;

procedure TDB_FORM.BB_Part1_AllClick(Sender: TObject);
var
// MA   rc        : HResult;
// MA   HFilter   : Integer;
// MA   HFilter2  : Integer;
// MA   HFilter3  : Integer;
// MA   HFilter4  : Integer;
   HQuery    : Integer;
   value     : Integer;
   PartKeys  : OleVariant;
// MA   FilterList: OLEVariant;
begin
  Screen.Cursor := crHourGlass;
  PartKeys := VarArrayCreate([0,0], VarInteger);
  PartKeys[0] := Spinedit4.Value;
// MA  rc := IQsStatDb.CreateQuery(qsstatHandle, HQuery);
  IQsStatDb.CreateQuery(qsstatHandle, HQuery);
  {
  rc := rc or IQsStatDb.CreateFilterFromSQL( qsstatHandle,
                                             'TETEIL = ' + IntToStr(Spinedit4.Value),
                                             HFilter);
  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HFilter, PART_LEVEL_C, 0, 0);
  }
  {
  rc := rc or IQsStatDb.CreateFilter(qsstatHandle, 1, 2001,'L6FF865' , COMPARE_LIKE_C, HFILTER2);
  rc := rc or IQsStatDb.AddFilterToQuery( qsstatHandle, HQuery, HFilter2, CHARACTERISTIC_LEVEL_C, 0, 0);
  }
  //IQsStatDb.AddSortToQuery(qsstatHandle, HQuery, 2101,0); // SORT_ASCENDING_C;
  //IQsStatDb.AddSortToQuery(qsstatHandle, HQuery, 2101,1); // SORT_DESCENDING_C;

  (*
  rc := rc or IQsStatDb.CreateFilter(qsstatHandle, 1, 0,'5' , GET_LAST_N_VALUES, HFilter);
  FilterList := VarArrayCreate([0,2],varInteger);
  FilterList[0] := HFilter;
  rc := rc or IQsStatDb.CreateFilterFromFilters(qsstathandle, 0 {aoAND}, FilterList, HFilter2);
  rc := rc or IQsStatDb.CreateFilterFromFilters(qsstathandle, 0 {aoAND}, FilterList, HFilter3);
  rc := rc or IQsStatDb.CreateFilterFromFilters(qsstathandle, 0 {aoAND}, FilterList, HFilter4);

  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HFilter2, PART_LEVEL_C, 0, 0);
  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HFilter2, CHARACTERISTIC_LEVEL_C, 0, 0);
  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HFilter2, VALUE_LEVEL_C, 0, 0);
  *)

  if CB_Desc.Checked then
  begin
    IQsStatDb.AddSortToQuery(qsstatHandle, HQuery, 4,1); // SORT_DESCENDING_C;
  end else
  begin
    IQsStatDb.AddSortToQuery(qsstatHandle, HQuery, 4,0); // SORT_ASCENDING_C;
  end;

// MA  rc := rc or IQsStatDb.ExecuteQuery(qsstatHandle, HQuery, PartKeys);//NULL);
  IQsStatDb.ExecuteQuery(qsstatHandle, HQuery, PartKeys);//NULL);
  WaitForSingleObject(EventSink.hDataAvailEvent,INFINITE);
  IQsStatDb.FreeQuery(qsstatHandle, HQuery);
  IQsSTAT.GetGlobalInfo(qsstatHandle,0,0,1,value);
  SpinEdit1.MaxValue := Value;
  LA_MAXPART.Caption := IntToStr(Value);
  SpinEdit1.Value := 0;
  SpinEdit1.Value := 1;
  Screen.Cursor := crDefault;
end;

procedure TDB_FORM.SpinEdit4Change(Sender: TObject);
begin
  BB_Part1_All.Caption := 'Part ' + IntToStr(Spinedit4.Value) + ' All';
end;

procedure TDB_FORM.BitBtn1Click(Sender: TObject);
var
  KPartFieldList,
  FilterList,
  KResList      : OleVariant;
  rc            : Integer;
  PartKey       : Integer;
  HFilter       : Integer;
  HFilter2      : Integer;
  HFilter3      : Integer;
  HGlobalFilter : Integer;
  HQuery        : Integer;
// MA  value         : Integer;
begin
  KPartFieldList := VarArrayCreate([0,1],varInteger);
  KPartFieldList[0] := 1001;
  KPartFieldList[1] := 1002;

  rc := IQsStatDb.CreateQuery(qsstatHandle, HQuery);

  rc := rc or IQsStatDb.CreateFilter( qsstatHandle,
                                      K_FIELDS_C,
                                      1001,
                                      '',
                                      COMP_OP_LIKE_C,
                                      HFilter);
  if Sender = BitBtn1 then
  begin
    rc := rc or IQsStatDb.CreateFilter( qsstatHandle,
                                        K_FIELDS_C,
                                        10,
                                        ED_Maschine.Text,//'3',
                                        COMP_OP_EQUAL_C,
                                        HFilter2);
    FilterList := VarArrayCreate([0,1],varInteger);
    FilterList[0] := HFilter;
    FilterList[1] := HFilter2;
  end else
  begin
    rc := rc or IQsStatDb.CreateFilter( qsstatHandle,
                                        K_FIELDS_C,
                                        4,
                                        ED_To.Text,//'1992/05/07 14:10:00',
                                        COMP_OP_SMALLER_EQUAL_C,
                                        HFilter2);

    rc := rc or IQsStatDb.CreateFilter( qsstatHandle,
                                        K_FIELDS_C,
                                        4,
                                        ED_From.Text,//'1992/05/07 14:00:00',
                                        COMP_OP_GREATER_EQUAL_C,
                                        HFilter3);
    FilterList := VarArrayCreate([0,1{2}],varInteger);
    {
    FilterList[0] := HFilter;
    FilterList[1] := HFilter2;
    FilterList[2] := HFilter3;
    }
    FilterList[0] := HFilter2;
    FilterList[1] := HFilter3;
  end;
  rc := rc or IQsStatDb.CreateFilterFromFilters(qsstathandle, 0 {aoAND}, FilterList, HGlobalFilter);
  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HGlobalFilter, PART_LEVEL_C, 0, 0);
  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HGlobalFilter, CHARACTERISTIC_LEVEL_C, 0, 0);
  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HGlobalFilter, VALUE_LEVEL_C, 0, 0);
  if rc = 0 then
  begin
    ME_RESULT.LINES.Clear;
    rc := IQsStatDb.GetFirstPartQuery( qsstatHandle,HQuery, KPartFieldList, PartKey, KResList);
    while rc = 0 do
    begin
      ME_RESULT.LINES.Add(IntToStr(PartKey)+' -- '+KResList[0]+' -- '+KResList[1]);
      rc := IQsStatDb.GetNextPartQuery( qsstatHandle,HQuery, PartKey, KResList);
    end;
  end;
  BB_Execute.Tag := HQuery;
  //IQsStatDb.FreeQuery(qsstatHandle, HQuery);
end;

procedure TDB_FORM.BB_Filter_1202Click(Sender: TObject);
var
  KPartFieldList,
  FilterList,
  FilterList2,
  KResList      : OleVariant;
  rc            : Integer;
  PartKey       : Integer;
  HFilter       : Integer;
  HFilter2      : Integer;
  HFilter3      : Integer;
  HKombiFilter  : Integer;
  HGlobalFilter : Integer;
  HQuery        : Integer;
// MA  value         : Integer;
begin
  KPartFieldList := VarArrayCreate([0,1],varInteger);
  KPartFieldList[0] := 1001;
  KPartFieldList[1] := 1002;

  rc := IQsStatDb.CreateQuery(qsstatHandle, HQuery);

  rc := rc or IQsStatDb.CreateFilter( qsstatHandle,
                                      K_FIELDS_C,
                                      1002,
                                      //'BODEM_KPL_SEDAN',
                                      //'71',
                                      '',
                                      COMP_OP_LIKE_C,
                                      //COMPARE_EQUAL_C,
                                      HFilter);

  rc := rc or IQsStatDb.CreateFilter( qsstatHandle,
                                      K_FIELDS_C,
                                      2001,
                                      //'LG6F911',
                                      '3.',
                                      COMP_OP_LIKE_C,
                                      //COMPARE_EQUAL_C,
                                      HFilter2);
  rc := rc or IQsStatDb.CreateFilter( qsstatHandle,
                                      K_FIELDS_C,
                                      2001,
                                      //'CG6F022',
                                      '78',
                                      COMP_OP_LIKE_C,
                                      //COMPARE_EQUAL_C,
                                      HFilter3);

  FilterList := VarArrayCreate([0,1],varInteger);
  FilterList[0] := HFilter2;
  FilterList[1] := HFilter3;
  rc := rc or IQsStatDb.CreateFilterFromFilters(qsstathandle, 1 {aoOR}, FilterList, HKombiFilter);
  FilterList2 := VarArrayCreate([0,1],varInteger);
  FilterList2[0] := HFilter;
  FilterList2[1] := HKombiFilter;
  rc := rc or IQsStatDb.CreateFilterFromFilters(qsstathandle, 0 {aoAND}, FilterList2, HGlobalFilter);
  //rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HGlobalFilter, PART_LEVEL_C, 0, 0);
  rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HKombiFilter, PART_LEVEL_C, 0, 0);
  //rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HKombiFilter, CHARACTERISTIC_LEVEL_C, 0, 0);
  ////rc := rc or IQsStatDb.AddFilterToQuery(qsstatHandle, HQuery, HGlobalFilter, VALUE_LEVEL_C, 0, 0);
  if rc = 0 then
  begin
    ME_RESULT.LINES.Clear;
    rc := IQsStatDb.GetFirstPartQuery( qsstatHandle,HQuery, KPartFieldList, PartKey, KResList);
    while rc = 0 do
    begin
      ME_RESULT.LINES.Add(IntToStr(PartKey)+' -- '+KResList[0]+' -- '+KResList[1]);
      rc := IQsStatDb.GetNextPartQuery( qsstatHandle,HQuery, PartKey, KResList);
    end;
  end;
  BB_Execute.Tag := HQuery;
end;

procedure TDB_FORM.BB_ExecuteClick(Sender: TObject);
var
  PartKey       : Integer;
  OK            : Integer;
  HQuery        : Integer;
  KPartKeyList  : OLEVariant;
  Dummyi        : Integer;
begin
  Screen.Cursor := crHourglass;
  HQuery := BB_Execute.Tag;
  Val( Copy(ME_RESULT.SelText, 1, AnsiPos(' ', ME_RESULT.SelText) - 1), PartKey, OK);
  {
  OK := 0;
  PartKey := 14;
  }
  if (OK = 0) and (HQuery > 0) then
  begin
    KPartKeyList := VarArrayCreate([0,0],varInteger);
    KPartKeyList[0] := PartKey;
    IQsStatDb.ExecuteQuery(qsstatHandle, HQuery, KPartKeyList);
    WaitForSingleObject(EventSink.hDataAvailEvent,INFINITE);
  end;
  IQsStatDb.FreeQuery(qsstatHandle, HQuery);
  BB_Execute.Tag := 0;
  IQsSTAT.EvaluateAllChars(qsstatHandle);

  WaitForSingleObject(EventSink.hEvaluationEvent,INFINITE);

  Spinedit1.MinValue := 1;
  IQsSTAT.GetGlobalInfo(qsstatHandle,0,0,1,dummyi);
  LA_MAXPART.Caption := Inttostr(dummyi);
  //Spinedit1.MaxValue := dummyi;
  SpinEdit1.Value := 1;
  SpinEdit1Change(Sender);
  Screen.Cursor := crDefault;
end;

procedure TDB_FORM.FormClose(Sender: TObject; var Action: TCloseAction);
var
  HQuery        : Integer;
begin
  HQuery := BB_Execute.Tag;
  if (HQuery > 0) then
  begin
    IQsStatDb.FreeQuery(qsstatHandle, HQuery);
  end;
end;

procedure TDB_FORM.BB_mehrereClick(Sender: TObject);
var
// MA   rc        : HResult;
   HQuery    : Integer;
   value     : Integer;
   PartKeys  : OleVariant;
begin
  Screen.Cursor := crHourGlass;
  PartKeys := VarArrayCreate([0,3], VarInteger);
  PartKeys[0] := 14;
  PartKeys[1] := 1;
  PartKeys[2] := 2;
  PartKeys[3] := 3;
// MA  rc := IQsStatDb.CreateQuery(qsstatHandle, HQuery);
  IQsStatDb.CreateQuery(qsstatHandle, HQuery);
// MA  rc := rc or IQsStatDb.ExecuteQuery(-qsstatHandle, HQuery, PartKeys);//NULL);
  IQsStatDb.ExecuteQuery(-qsstatHandle, HQuery, PartKeys);//NULL);
  IQsStatDb.FreeQuery(qsstatHandle, HQuery);
  IQsSTAT.GetGlobalInfo(qsstatHandle,0,0,1,value);
  SpinEdit1.MaxValue := Value;
  LA_MAXPART.Caption := IntToStr(Value);
  SpinEdit1.Value := 0;
  SpinEdit1.Value := 1;
  Screen.Cursor := crDefault;
end;

procedure TDB_FORM.BB_TestClick(Sender: TObject);
var
  HQuery    : Integer;
begin
  IQsStatDb.LoadQuery(qsstatHandle, 'TestQuery', HQuery);
  IQsStatDb.ExecuteQuery(qsstatHandle, HQuery, NULL);
end;

end.

