unit sd_simulation;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Spin, ExtCtrls;

type
  TSimuationDialog = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    ED_USL: TEdit;
    ED_LSL: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    SE_NrOfValues: TSpinEdit;
    SE_SampleSize: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    GroupBox2: TGroupBox;
    COB_Distribution: TComboBox;
    ED_Param1: TEdit;
    ED_Param2: TEdit;
    ED_Param3: TEdit;
    ED_Param4: TEdit;
    ED_Param5: TEdit;
    ED_Param6: TEdit;
    ED_Param7: TEdit;
    ED_Param8: TEdit;
    ED_Param9: TEdit;
    ED_Param10: TEdit;
    BitBtn1: TBitBtn;
    Label5: TLabel;
    SE_Decimals: TSpinEdit;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    SE_NrOfRuns: TSpinEdit;
    Label7: TLabel;
    ED_ExportFile: TEdit;
    Label8: TLabel;
    MEMO_ExportKeys: TMemo;
    SE_Timeout: TSpinEdit;
    Label9: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ED_USLKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure COB_DistributionChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Param1,
    Param2,
    Param3,
    Param4,
    Param5,
    Param6,
    Param7,
    Param8,
    Param9,
    Param10 : double;
    bUsl,
    bLsl    : boolean;
    usl,
    lsl     : double;
    Decimals : integer;
    NrOfValues  : integer;
    SampleSize  : integer;
    Distribution : integer;
    // Output
    NrOfRuns   : longint;
    ExportFile : string;
    ExportKeys : TStringList;
    Timeout    : longint;
  end;

function WriteResultDFQ( ExportFileName : string;
                         KeyList    : TStringList;
                         ResultList : TStringList;
                         Append     : boolean;
                         IsDfd      : boolean): integer;

var
  SimuationDialog: TSimuationDialog;

implementation

{$R *.DFM}

function WriteResultDFQ( ExportFileName : string;
                         KeyList    : TStringList;
                         ResultList : TStringList;
                         Append     : boolean;
                         IsDfd      : boolean): integer;
var
  aFile : System.Text;
  i     : integer;
begin
  result := -1;
  if (ResultList <> nil) and (KeyList <> nil)then
  begin
    if (ResultList.count > 0) and
       (KeyList.Count > 0) and
       (KeyList.Count = ResultList.count) and
       (ExportFilename <> '')then
    begin
      result := 0;
      if (not IsDFD) then
      begin
        Assignfile(AFile, ExportFilename + '.DFQ');
      end else
      begin
        Assignfile(AFile, ExportFilename + '.DFD');
      end;

      if append then
      begin
        System.Append(AFile);
      end else
      begin
        // Kopfdaten
        System.Rewrite(AFile);
        Writeln(AFile,'K0100 ' + inttostr(KeyList.Count));
        Writeln(AFile, 'K1001 1');
        Writeln(AFile, 'K1002 Simulation');
        // Simulationsparameter anfgen
        for i := 0 to ResultList.Count -1 do
        begin
          Writeln(AFile, 'K2001/' + inttostr(i+1) + ' ' + inttostr(i+1));
          Writeln(AFile, 'K2002/' + inttostr(i+1) + ' ' + KeyList.Strings[i]);
          Writeln(AFile, 'K2004/' + inttostr(i+1) + ' ' + '0');
          // Name d. Ausgabepunktes anfgen
        end;
      end;

      // Werte
      if (isDFD) then
      begin
        closefile(AFile);
        Assignfile(AFile, ExportFilename + '.DFX');
        if Append then
        begin
          System.Append(AFile);
        end else
        begin
          System.Rewrite(AFile);
        end;
      end;

      for i := 0 to ResultList.Count-1 do
      begin
        Writeln(Afile, 'K0001/' + inttostr(i+1) + ' ' + ResultList.Strings[i]);
        Writeln(Afile, 'K0004/' + inttostr(i+1) + ' ' + DateTimeToStr(Now));
      end;
      Closefile(AFile);
    end;
  end;
end;


procedure InitCOBDistribution( ACOB : TComboBox);
begin
  if ACOB <> nil then
  begin
    ACOB.Clear;
    ACOB.Items.Add('1,NV');
//      result := read_text(p_db_text,4,6001,1,SINGULAR);
    ACOB.Items.Add('2,Log NV');
//      result := read_text(p_db_text,4,6002,1,SINGULAR);
    ACOB.Items.Add('3,Erw. NV');
//      result := read_text(p_db_text,4,6003,1,SINGULAR);
    ACOB.Items.Add('4,Wurzel NV');
//      result := read_text(p_db_text,4,6004,1,1);
    ACOB.Items.Add('11,BV1');
//      result := read_text(p_db_text,4,6011,1,1);
    ACOB.Items.Add('12,BV2');
//      result := read_text(p_db_text,4,6012,1,1);
    ACOB.Items.Add('21,BV1 (<>0)');
//      result := read_text(p_db_text,4,6021,1,1);
    ACOB.Items.Add('22,BV2 (<>0)');
//      result := read_text(p_db_text,4,6022,1,1);
    ACOB.Items.Add('30,Weibull');
//      result := read_text(p_db_text,4,6030,1,1);
    ACOB.Items.Add('31,Exponetial');
//      result := '???';//read_text(p_db_text,4,,1,1);
    ACOB.Items.Add('41,Rechteck');
//      result := read_text(p_db_text,4,6040,1,1);
    ACOB.Items.Add('42,Dreieck');
//      result := read_text(p_db_text,4,6042,1,1);
    ACOB.Items.Add('51,t');
//      result := '???';//read_text(p_db_text,4,1,1,1);
    ACOB.Items.Add('52,Chi^2');
//      result := '???';//read_text(p_db_text,4,1,1,1);
    ACOB.Items.Add('53,Range');
//      result := '???';//read_text(p_db_text,4,1,1,1);
    ACOB.Items.Add('54,F');
//      result := '???';//read_text(p_db_text,4,1,1,1);
    ACOB.Items.Add('91,Johnson');
//      result := read_text(p_db_text,4,6092,2,1);
    ACOB.Items.Add('92,Misch');
//      result := read_text(p_db_text,4,6092,1,1);
    ACOB.Items.Add('93,Misch WBV');
//      result := '???';//read_text(p_db_text,4,1,1,1);
    ACOB.Items.Add('99,Pearson');
//      result := read_text(p_db_text,4,6099,2,1);
    ACOB.Items.Add('100,Binomial');
//      result := read_text(p_db_text,4,6070,1,1);
    ACOB.Items.Add('101,hypergeometrisch');
//      result := '???';//read_text(p_db_text,4,1,1,1);
    ACOB.Items.Add('200,Poisson');
//      result := read_text(p_db_text,4,6080,1,1);
    ACOB.Items.Add('301,NV abg');
//      result := read_text(p_db_text,4,6051,1,1);
    ACOB.Items.Add('302,MV 2');
//      result := '???';//read_text(p_db_text,4,1,1,1);
    ACOB.Items.Add('302,MV 2 abg.');
//      result := read_text(p_db_text,4,6053,1,1);
    ACOB.Items.Add('302,MV stetig');
//      result := read_text(p_db_text,4,6054,1,1);
  end;
end;

function getCOBDistribution( ACOB : TComboBox): integer;
var
  STmp : string;
begin
  result := 1;
  if ACOB <> nil then
  begin
    STmp := ACOB.Items[ACOB.itemindex];
    try
      result := StrToint(copy(STmp,1, Pos(',',STmp)-1));
    except
      result := 1;
    end;
  end;
end;


procedure  SetCobDistribution( ACOB : TComboBox ; Distribution : integer);
var
  i : integer;
  STmp : string;
  d : integer;
begin
  if ACOB <> nil then
  begin
    for i := 0 to ACOB.Items.Count-1 do
    begin
      STmp := ACOB.Items[i];
      try
        d := StrToint(copy(STmp,1, Pos(',',STmp)-1));
        if d = Distribution then
        begin
          ACOB.ItemIndex := i;
          break;
        end;
      except
        break;
      end;
    end;
  end;
end;


procedure TSimuationDialog.FormCreate(Sender: TObject);
begin
  Param1 := 0;
  Param2 := 0;
  Param3 := 0;
  Param4 := 0;
  Param5 := 0;
  Param6 := 0;
  Param7 := 0;
  Param8 := 0;
  Param9 := 0;
  Param10 := 0;
  bUsl    := False;
  bLsl    := False;
  usl     := 0;
  lsl     := 0;
  Decimals := 0;
  NrOfValues  := 0;
  SampleSize  := 0;
  Distribution := 0;

  NrOfRuns   := 100;
  ExportFile := '';
  ExportKeys := TStringList.Create;
  Timeout    := 10000;
  InitCOBDistribution(COB_Distribution);
  COB_Distribution.ItemIndex := 0;
end;

procedure TSimuationDialog.BitBtn1Click(Sender: TObject);
var
  err : boolean;
  i   : integer;
begin
  err := False;
  //
  bUsl := False;
  if ED_Usl.Text <> '' then
  begin
    try
      Usl := StrToFloat(ED_Usl.Text);
      bUsl := True;
    except
      err := True;
      usl := 0;
      ED_Usl.Color := clRed;
    end;
  end;

  bLsl    := False;
  if ED_Lsl.Text <> '' then
  begin
    try
      Lsl := StrToFloat(ED_Lsl.Text);
      bLsl := True;
    except
      err := True;
      lsl := 0;
      ED_Lsl.Color := clRed;
    end;
  end;

  Decimals    := SE_Decimals.Value;
  NrOfValues  := SE_NrOfValues.Value;
  SampleSize  := SE_SampleSize.Value;
  Distribution := 1;//NV

  Param2 := 0;
  if ED_Param1.Text <> '' then
  begin
    try
      Param1 := StrToFloat(ED_Param1.Text)
    except
      err := True;
      Param1 := 0;
      ED_Param1.Color := clRed;
    end;
  end;

  Param2 := 0;
  if ED_Param2.Text <> '' then
  begin
    try
      Param2 := StrToFloat(ED_Param2.Text)
    except
      err := True;
      Param2 := 0;
      ED_Param2.Color := clRed;
    end;
  end;

  Param3 := 0;
  if ED_Param3.Text <> '' then
  begin
    try
      Param3 := StrToFloat(ED_Param3.Text)
    except
      err := True;
      Param3 := 0;
      ED_Param3.Color := clRed;
    end;
  end;

  Param4 := 0;
  if ED_Param4.Text <> '' then
  begin
    try
      Param4 := StrToFloat(ED_Param4.Text)
    except
      err := True;
      Param4 := 0;
      ED_Param4.Color := clRed;
    end;
  end;

  Param5 := 0;
  if ED_Param5.Text <> '' then
  begin
    try
      Param5 := StrToFloat(ED_Param5.Text)
    except
      err := True;
      Param5 := 0;
      ED_Param5.Color := clRed;
    end;
  end;

  Param6 := 0;
  if ED_Param6.Text <> '' then
  begin
    try
      Param6 := StrToFloat(ED_Param6.Text)
    except
      err := True;
      Param6 := 0;
      ED_Param6.Color := clRed;
    end;
  end;

  Param7 := 0;
  if ED_Param7.Text <> '' then
  begin
    try
      Param7 := StrToFloat(ED_Param7.Text)
    except
      err := True;
      Param7 := 0;
      ED_Param7.Color := clRed;
    end;
  end;

  Param8 := 0;
  if ED_Param8.Text <> '' then
  begin
    try
      Param8 := StrToFloat(ED_Param8.Text)
    except
      err := True;
      Param8 := 0;
      ED_Param8.Color := clRed;
    end;
  end;

  Param9 := 0;
  if ED_Param9.Text <> '' then
  begin
    try
      Param9 := StrToFloat(ED_Param9.Text)
    except
      err := True;
      Param9 := 0;
      ED_Param9.Color := clRed;
    end;
  end;

  Param10 := 0;
  if ED_Param10.Text <> '' then
  begin
    try
      Param10 := StrToFloat(ED_Param10.Text)
    except
      err := True;
      Param10 := 0;
      ED_Param10.Color := clRed;
    end;
  end;

  NrOfRuns   := SE_NrOfRuns.Value;
  ExportFile := ED_ExportFile.Text;
  ExportKeys.Clear;
  for i := 0 to MEMO_ExportKeys.Lines.Count-1 do
  begin
    if ExportKeys <> nil then
    begin
      ExportKeys.Add(MEMO_ExportKeys.Lines[i]);
    end;
  end;

  Distribution := getCOBDistribution(COB_Distribution);

  Timeout := SE_Timeout.Value;
  if err then
  begin
    ModalResult := mrNone;
  end else
  begin
    ModalResult := mrOK;
  end;
end;

procedure TSimuationDialog.ED_USLKeyPress(Sender: TObject; var Key: Char);
begin
  if Sender is TEdit then TEdit(Sender).Color := clWhite;
end;

procedure TSimuationDialog.FormShow(Sender: TObject);
var
  i : integer;
begin
    if bUsl then ED_USL.Text := FloatToStr(usl)
            else ED_USL.Text := '';
    if BLsl then ED_LSL.Text := FloatToStr(lsl)
            else ED_LSL.Text := '';
    SE_NrOfValues.Value := NrOfValues;
    SE_SampleSize.Value := Samplesize;
    SE_Decimals.Value   := Decimals;
//    COB_Distribution: TComboBox;
    ED_Param1.Text := FloatToStr(param1);
    ED_Param2.Text := FloatToStr(param2);
    ED_Param3.Text := FloatToStr(param3);
    ED_Param4.Text := FloatToStr(param4);
    ED_Param5.Text := FloatToStr(param5);
    ED_Param6.Text := FloatToStr(param6);
    ED_Param7.Text := FloatToStr(param7);
    ED_Param8.Text := FloatToStr(param8);
    ED_Param9.Text := FloatToStr(param9);
    ED_Param10.Text := FloatToStr(param10);
    // output
    SE_NrOfRuns.Value  := NrOfRuns;
    ED_ExportFile.Text := ExportFile;

    MEMO_ExportKeys.Clear;
    if ExportKeys <> nil then
    begin
      for i := 0 to ExportKeys.Count-1 do
      begin
        MEMO_ExportKeys.Lines.Add(ExportKeys.Strings[i]);
      end;
    end;
    SE_Timeout.Value := Timeout;
    SetCobDistribution( COB_Distribution,Distribution);
end;

procedure TSimuationDialog.FormDestroy(Sender: TObject);
begin
  if ExportKeys <> nil then
  begin
    ExportKeys.Clear;
    ExportKeys.Free;
    ExportKeys := nil;
  end;
end;

procedure TSimuationDialog.COB_DistributionChange(Sender: TObject);
// MAvar
// MA  i : integer;
begin
// MA  i := GetCobDistribution(COB_Distribution);
  GetCobDistribution(COB_Distribution);
end;

end.
