//==============================================================================
//                      >>> CatalogueDlg.pas <<<
//
//
//    Inhalt      : qs-STAT Catalogues and Subcatalogues dialog
//
//    Autor       : OL
//    Erstellt am : 6.2004
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//==============================================================================
unit CatalogueDlg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  qs_stat_tlb, ComCtrls;

type
  TF_CatalogueDlg = class(TForm)
    P_BB: TPanel;
    BB_OK: TButton;
    BB_Cancel: TButton;
    P_Head: TPanel;
    GB_Head: TGroupBox;
    COB_ENUMSubCatalogue: TComboBox;
    LA_SubCatalogue: TLabel;
    LA_Catalogue: TLabel;
    COB_ENUMCatalogue: TComboBox;
    LView_Catalogue: TListView;
    procedure COB_ENUMCatalogueChange(Sender: TObject);
    procedure COB_ENUMSubCatalogueChange(Sender: TObject);
  private
    IQsStat      : ITQsstatRemoteControl;
    qsstatHandle : LongInt;
    procedure InitializeCOB_ENumCatalogue;
    procedure InitializeCOB_ENumSubCatalogue;
    procedure ShowCatalogueList;
  public
    procedure SetParameters( SvrObj    : ITQsstatRemoteControl;
                             SvrHandle : LongInt;
                             ShowList  : Boolean);
    procedure GetParameters( CatNum      : Integer;
                             SubCatNum   : Integer;
                             EventNumStr : WideString);
  end;


var
  F_CatalogueDlg: TF_CatalogueDlg;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
// Set Parameters
//------------------------------------------------------------------------------
procedure TF_CatalogueDlg.SetParameters( SvrObj    : ITQsstatRemoteControl;
                                         SvrHandle : LongInt;
                                         ShowList  : Boolean);
begin
  IQsStat      := SvrObj;
  qsstatHandle := SvrHandle;

  InitializeCOB_ENumCatalogue;
  InitializeCOB_ENumSubCatalogue;

  if ShowList then
  begin
    ShowCatalogueList;
  end;
end;

//------------------------------------------------------------------------------
// Get Parameters
//------------------------------------------------------------------------------
procedure TF_CatalogueDlg.GetParameters( CatNum      : Integer;
                                         SubCatNum   : Integer;
                                         EventNumStr : WideString);
begin
  //
end;

//------------------------------------------------------------------------------
// ENUM Interface -> Catalogue
//------------------------------------------------------------------------------
procedure TF_CatalogueDlg.InitializeCOB_ENumCatalogue;
var
  IqsSTATCatalogue : IEnumCatalogue;
  CatalogueKey     : Integer;
  ColumnKeyList    : OleVariant;
  SubCatalogues    : Integer;
  CatalogueName    : WideString;
  rc               : Integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_ENUMSubCatalogue.Clear;

    IqsSTATCatalogue := IQsSTAT as IEnumCatalogue;

    CatalogueKey  := 0;
    ColumnKeyList := 0;
    SubCatalogues := 0;
    CatalogueName := '';

    rc := IqsSTATCatalogue.GetFirstCatalog(qsstatHandle,
                                           CatalogueKey,
                                           ColumnKeyList,
                                           SubCatalogues,
                                           CatalogueName);
    while rc = 0 do
    begin
      COB_ENumCatalogue.Items.Add(CatalogueName + '(' + IntToStr(CatalogueKey) + ')');
      rc := IqsSTATCatalogue.GetNextCatalog(qsstatHandle,
                                            CatalogueKey,
                                            ColumnKeyList,
                                            SubCatalogues,
                                            CatalogueName);

    end;
    //set focus on first item
    if COB_ENUMCatalogue.Items.Count > 0 then COB_ENUMCatalogue.ItemIndex := 0;
  end;
end;

//------------------------------------------------------------------------------
// ENUM Interface -> SubCatalogue
//------------------------------------------------------------------------------
procedure TF_CatalogueDlg.InitializeCOB_ENumSubCatalogue;
var
  IqsSTATSubCatalogue : IEnumCatalogue;
  SubCatalogueKey     : Integer;
  SubCatalogueName    : WideString;
  CurCatalogueKey     : Integer;
  str                 : WideString;
  rc                  : Integer;
begin
  if IQsSTAT <> nil then
  begin

    COB_ENUMSubCatalogue.Clear;

    IqsSTATSubCatalogue := IQsSTAT as IEnumCatalogue;

    if COB_ENUMCatalogue.ItemIndex >= 0 then
    begin
      str := COB_ENUMCatalogue.Items[COB_ENUMCatalogue.ItemIndex];
      str := Copy(str,Pos('(',str)+1,Length(str)-Pos('(', str)-1);
    end;
    CurCatalogueKey := StrToIntDef(str, 0);
    SubCatalogueKey  := 0;
    SubCatalogueName := '';

    rc := IqsSTATSubCatalogue.GetFirstSubCatalog(qsstatHandle,
                                                 CurCatalogueKey,
                                                 SubCatalogueKey,
                                                 SubCatalogueName);
    while rc = 0 do
    begin
      COB_ENumSubCatalogue.Items.Add(SubCatalogueName + '(' + IntToStr(SubCatalogueKey) + ')');
      rc := IqsSTATSubCatalogue.GetNextSubCatalog(qsstatHandle,
                                                  CurCatalogueKey,
                                                  SubCatalogueKey,
                                                  SubCatalogueName);
    end;
    //set focus on first item
    if COB_ENUMSubCatalogue.Items.Count > 0 then COB_ENUMSubCatalogue.ItemIndex := 0;
  end;
end;

procedure TF_CatalogueDlg.COB_ENUMCatalogueChange(Sender: TObject);
begin
  InitializeCOB_ENumSubCatalogue;

  ShowCatalogueList;
end;

procedure TF_CatalogueDlg.COB_ENUMSubCatalogueChange(Sender: TObject);
begin
  ShowCatalogueList;
end;

//------------------------------------------------------------------------------
// Show selected catalogue
//------------------------------------------------------------------------------
procedure TF_CatalogueDlg.ShowCatalogueList;
var
  IqsSTATCatalogue   : IEnumCatalogue;
  CurCatalogueKey    : Integer;
  CurSubCatalogueKey : Integer;
  EntryKey           : LongInt;
  NumberStr          : WideString;
  NameStr            : WideString;
  str, Str3, Str4    : WideString;
  LItem              : TListItem;
  rc                 : Integer;
begin
  if IQsSTAT <> nil then
  begin

    IqsSTATCatalogue := IQsSTAT as IEnumCatalogue;

    LView_Catalogue.Items.Clear;

    //find current catalogue key
    if COB_ENUMCatalogue.ItemIndex >= 0 then
    begin
      str := COB_ENUMCatalogue.Items[COB_ENUMCatalogue.ItemIndex];
      str := Copy(str,Pos('(',str)+1,Length(str)-Pos('(', str)-1);
    end;
    CurCatalogueKey := StrToIntDef(str, 0);
    str := '';
    if COB_ENUMSubCatalogue.ItemIndex >= 0 then
    begin
      str := COB_ENUMSubCatalogue.Items[COB_ENUMSubCatalogue.ItemIndex];
      str := Copy(str,Pos('(',str)+1,Length(str)-Pos('(', str)-1);
    end;
    CurSubCatalogueKey := StrToIntDef(str, 0);

    EntryKey    := 0;
    NumberStr   := '';
    NameStr     := '';
    Str3        := '';
    Str4        := '';

    rc := IqsSTATCatalogue.GetFirstCatalogEntryComplete(qsstatHandle,
                                                        CurCatalogueKey,
                                                        CurSubCatalogueKey,
                                                        EntryKey,
                                                        NumberStr,
                                                        NameStr,
                                                        Str3,
                                                        Str4);
    while rc = 0 do
    begin
      LItem := LView_Catalogue.Items.Add;
      LItem.Caption := IntToStr(EntryKey);
      LItem.SubItems.Add(NumberStr);
      LItem.SubItems.Add(NameStr);

      rc := IqsSTATCatalogue.GetNextCatalogEntryComplete(qsstatHandle,
                                                         EntryKey,
                                                         NumberStr,
                                                         NameStr,
                                                         Str3,
                                                         Str4);
    end;
  end;
end;

end.
