unit CharDlg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  com_common_consts,
  qs_stat_tlb;

type
  TF_CharDlg = class(TForm)
    P_BB: TPanel;
    BB_OK: TButton;
    BB_Cancel: TButton;
    P_Head: TPanel;
    GB_ENum: TGroupBox;
    COB_ENUMChar: TComboBox;
    GB_Keys: TGroupBox;
    LA_Key: TLabel;
    LA_SubKey: TLabel;
    ED_Key: TEdit;
    ED_SubKey: TEdit;
    GB_PartChar: TGroupBox;
    LA_Part: TLabel;
    Label1: TLabel;
    ED_Part: TEdit;
    ED_Char: TEdit;
    GroupBox3: TGroupBox;
    LA_Value: TLabel;
    BB_GetValue: TButton;
    ED_ValueOut: TEdit;
    procedure BB_GetValueClick(Sender: TObject);
  private
    IQsStat      : ITQsstatRemoteControl;
    qsstatHandle : LongInt;
    procedure InitializeCOB_ENumChar;
  public
    procedure SetParameters( SvrObj    : ITQsstatRemoteControl;
                             SvrHandle : LongInt);
  end;

var
  F_CharDlg: TF_CharDlg;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
// Set Parameters
//------------------------------------------------------------------------------
procedure TF_CharDlg.SetParameters( SvrObj    : ITQsstatRemoteControl;
                                    SvrHandle : LongInt);
begin
  IQsStat      := SvrObj;
  qsstatHandle := SvrHandle;

  InitializeCOB_ENumChar;
end;

//------------------------------------------------------------------------------
// ENUM Interface -> Report
//------------------------------------------------------------------------------
procedure TF_CharDlg.InitializeCOB_ENumChar;
var
  IqsSTATKField    : IEnumFieldKeyName;
  KFieldKey        : Integer;
  KFieldSubKey     : Integer;
  KFieldName       : WideString;
  rc               : Integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_ENUMChar.Clear;

    IqsSTATKField := IQsSTAT as IEnumFieldKeyName;

    KFieldKey      := 0;
    KFieldSubKey   := 0;
    KFieldName     := '';

    rc := IqsSTATKField.GetFirstCharacteristicField(qsstatHandle,
                                                    KFieldKey,
                                                    KFieldSubKey,
                                                    KFieldName);
    while rc = 0 do
    begin
      COB_ENUMChar.Items.Add(KFieldName + ' (' + IntToStr(KFieldKey) + ')');
      rc := IqsSTATKField.GetNextCharacteristicField( qsstatHandle,
                                                      KFieldKey,
                                                      KFieldSubKey,
                                                      KFieldName);

    end;
    //set focus on first item
    if COB_ENUMChar.Items.Count > 0 then COB_ENUMChar.ItemIndex := 0;
  end;
end;

procedure TF_CharDlg.BB_GetValueClick(Sender: TObject);
var
  ValueText : WideString;
  Key       : Integer;
  Part      : Integer;
  Char      : Integer;
  rc        : integer;
begin
  if IQsSTAT <> nil then
  begin
    ED_ValueOut.Text := '';

    Key  := StrToIntDef(ED_Key.Text, 0);
    Part := StrToIntDef(ED_Part.Text, 0);
    Char := StrToIntDef(ED_Char.Text, 0);

    rc := IQsSTAT.GetCharInfo(qsstatHandle,
                              Key,
                              Part,
                              Char,
                              ValueText);
    if rc = 0 then
    begin
      ED_ValueOut.Text := ValueText;
    end;
  end;
end;

end.
