//==============================================================================
//                      >>> DelphiCOMClient2form.pas <<<
//
//
//    Inhalt      : Headform of Delphi COM Client 2
//
//    Autor       : OL
//    Erstellt am : 6.2004
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//==============================================================================

unit DelphiCOMClient2form;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Menus,
  ComCtrls,
  ExtCtrls,
  StdCtrls,
  ComObj,
  jpeg,
  qs_stat_tlb,
  qs_statevents,
  LoginDlg,
  FilterDlg,
  ENumInterfaceDlg,
  GraphicDlg,
  ReportDlg,
  StatResultDlg,
  CatalogueDlg,
  PartDlg,
  CharDlg,
  ValueDlg,
  TransmitDlg,
  AboutDlg;

type
  TF_ClientForm = class(TForm)
    MMenu: TMainMenu;
    MM_File: TMenuItem;
    MM_Open: TMenuItem;
    MM_Transmit: TMenuItem;
    MM_Server: TMenuItem;
    MM_Start: TMenuItem;
    MM_Connect: TMenuItem;
    MM_Disconnect: TMenuItem;
    MM_Commands: TMenuItem;
    MM_OnlineServer: TMenuItem;
    MM_About: TMenuItem;
    Panel_Head: TPanel;
    Image: TImage;
    LB_EventList: TListBox;
    SB_ClientStatusInfo: TStatusBar;
    N1: TMenuItem;
    MM_DB: TMenuItem;
    MM_ExecuteQuery: TMenuItem;
    N2: TMenuItem;
    MM_Print: TMenuItem;
    N3: TMenuItem;
    MM_Exit: TMenuItem;
    MM_Evaluate: TMenuItem;
    MM_Get: TMenuItem;
    MM_Graphic: TMenuItem;
    MM_Report: TMenuItem;
    MM_Result: TMenuItem;
    MM_Catalogue: TMenuItem;
    MM_Part: TMenuItem;
    MM_Char: TMenuItem;
    MM_Value: TMenuItem;
    MM_Set: TMenuItem;
    MM_Module: TMenuItem;
    MM_Language: TMenuItem;
    MM_Strategy: TMenuItem;
    MM_Printer: TMenuItem;
    MM_Transmission: TMenuItem;
    MM_SPC_Evaluation: TMenuItem;
    MM_OnlineEvaluation: TMenuItem;
    FileOpenDialog: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MM_StartServerClick(Sender: TObject);
    procedure MM_ConnectServerClick(Sender: TObject);
    procedure MM_DisconnectServerClick(Sender: TObject);
    procedure MM_OpenFileClick(Sender: TObject);
    procedure MM_TransmitFileClick(Sender: TObject);
    procedure MM_EvaluateAllClick(Sender: TObject);
    procedure MM_DBOpenClick(Sender: TObject);
    procedure MM_ExecuteQueryClick(Sender: TObject);
    procedure MM_ModuleClick(Sender: TObject);
    procedure MM_LanguageClick(Sender: TObject);
    procedure MM_StrategyClick(Sender: TObject);
    procedure MM_PrinterClick(Sender: TObject);
    procedure MM_GraphicClick(Sender: TObject);
    procedure MM_ReportClick(Sender: TObject);
    procedure MM_ResultClick(Sender: TObject);
    procedure MM_CatalogueClick(Sender: TObject);
    procedure MM_PartClick(Sender: TObject);
    procedure MM_CharClick(Sender: TObject);
    procedure MM_ValueClick(Sender: TObject);
    procedure MM_TransmissionClick(Sender: TObject);
    procedure MM_OnlineEvaluationClick(Sender: TObject);
    procedure MM_SPC_EvaluationClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MM_AboutClick(Sender: TObject);
    procedure MM_PrintClick(Sender: TObject);
    procedure MM_ExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    qsstatHandle : LongInt;
    hThreadEnde  : THandle;
    qs_modul     : Integer;
    qs_language  : Integer;
    qs_strategy  : Integer;
    qs_printer   : Integer;

    // qs-STAT Object
    IQsSTAT : ITQsstatRemoteControl;
    IQsStatDb : IDataBase;
    RemoteServer : boolean;
    qs_ServerVersion : WideString;
    
    //Graphic var
    qs_Graph_Key     : Integer;
    qs_Graph_SubKey  : Integer;
    qs_Graph_Part_X  : Integer;
    qs_Graph_Char_X  : Integer;
    qs_Graph_Value_X : Integer;
    qs_Graph_Part_Y  : Integer;
    qs_Graph_Char_Y  : Integer;
    qs_Graph_Value_Y : Integer;
    qs_Graph_CurPage : Integer;

    //Report var
    qs_Report_FileName : AnsiString;
    qs_Report_Part_X   : Integer;
    qs_Report_Char_X   : Integer;
    qs_Report_Value_X  : Integer;
    qs_Report_Part_Y   : Integer;
    qs_Report_Char_Y   : Integer;
    qs_Report_Value_Y  : Integer;
    qs_Report_CurPage  : Integer;

    //stat result var
    qs_Stat_Key     : Integer;
    qs_Stat_SubKey  : Integer;
    qs_bTransform   : Integer;
    qs_Stat_Part    : Integer;
    qs_Stat_Char    : Integer;

    // Object for connection point IQsEvents
    EventSink : TIQsEvents;

    FileName : WideString;

    ImageSwitch : Integer;
    // 1 - Graphic
    // 2 - Report

    ONLINEMode : Boolean;

    // Events from Server
    function OnGetAliveState(    Sender : TObject;
                             out State  : integer): HResult;
    function OnQSSTATInitialize( Sender : TObject): HResult;
    function OnDataAvail( Sender     : TObject;
                          NumOfChars : Integer): HResult;
    function OnDataAvailExt( Sender     : TObject;
                             Handle     : Integer;
                             NumOfChars : Integer): HResult;
    function OnEvaluationDone(Sender : TObject): HResult;
    function OnEvaluationDoneExt(Sender : TObject;
                                 Handle : Integer): HResult;
    function OnErrorEvent( Sender    : TObject;
                           ErrorCode : Integer): HResult;
    function OnSystemAlarm( Sender    : TObject;
                            AlarmCode : LongWord): HResult;
    function OnStatisticalAlarm( Sender       : TObject;
                                  Alarm_EW_1   : LongWord;
                                  Alarm_EW_2   : LongWord;
                                  Alarm_QRK_L  : LongWord;
                                  Alarm_QRK_S  : LongWord;
                                  Alarm_CP     : LongWord;
                                  Alarm_NO_SPC : LongWord;
                                  Part_Nr      : Integer;
                                  Char_Nr      : Integer;
                                  Value_Nr     : Integer;
                                  Sample_Nr    : Integer): HResult;
    function OnStatisticalAlarmExt( Sender       : TObject;
                                    Handle       : longint;
                                    Alarm_EW_1   : LongWord;
                                    Alarm_EW_2   : LongWord;
                                    Alarm_QRK_L  : LongWord;
                                    Alarm_QRK_S  : LongWord;
                                    Alarm_CP     : LongWord;
                                    Alarm_NO_SPC : LongWord;
                                    Part_Nr      : Integer;
                                    Char_Nr      : Integer;
                                    Value_Nr     : Integer;
                                    Sample_Nr    : Integer): HResult;
    //--------------------------------------------------------------------------

    function GetVarArrayFromFile(FileName : AnsiString) : OleVariant;
    function GetVarArrayFromString(Str : AnsiString) : OleVariant;
    procedure VarArrayToScreen( va     : OleVariant;
                                Format : byte);
    procedure SetModule(NewModule  : Integer;
                        ModuleName : WideString);
    procedure SetLanguage(NewLanguage : Integer;
                          LanguageName  : WideString);
    procedure SetStrategy(NewStrategy  : Integer;
                        StrategyName : WideString);
    procedure SetPrinter(NewPrinter  : Integer;
                         PrinterName : WideString);
    procedure Evaluate(Mode : Boolean);
  public
    procedure TransmitFileToServer(FileName     : AnsiString;
                                   DataStr      : WideString;
                                   Mode         : Integer;
                                   Online       : Boolean);
    procedure GetGraphicFromServer(Key          : Integer;
                                   SubKey       : Integer;
                                   Part_X       : Integer;
                                   Char_X       : Integer;
                                   Value_X      : Integer;
                                   Part_Y       : Integer;
                                   Char_Y       : Integer;
                                   Value_Y      : Integer;
                                   CurPage      : Integer;
                                   NrOfCols     : Integer;
                                   NrOfRows     : Integer;
                                   Page_X_Start : Integer;
                                   Page_Y_Start : Integer;
                                   NrOfPage_X   : Integer;
                                   NrOfPage_Y   : Integer;
                                   Format       : Integer);
    procedure GetReportFromServer( ReportName   : AnsiString;
                                   Part_X       : Integer;
                                   Char_X       : Integer;
                                   Value_X      : Integer;
                                   Part_Y       : Integer;
                                   Char_Y       : Integer;
                                   Value_Y      : Integer;
                                   CurPage      : Integer;
                                   Format       : Integer);
  //  destructor Destroy;override;
  end;

const
  MODULE_C   = 1;
  LANGUAGE_C = 2;
  STRATEGY_C = 3;
  PRINTER_C  = 4;
  DBOPEN_C   = 5;

var
  F_ClientForm : TF_ClientForm;

implementation

{$R *.DFM}

procedure TF_ClientForm.FormCreate(Sender: TObject);
begin
  ONLINEMode := False;

  qs_Graph_Key     := 3100;
  qs_Graph_SubKey  := 0;
  qs_Graph_Part_X  := 0;
  qs_Graph_Char_X  := 0;
  qs_Graph_Value_X := 0;
  qs_Graph_Part_Y  := 0;
  qs_Graph_Char_Y  := 0;
  qs_Graph_Value_Y := 0;
  qs_Graph_CurPage := 1;

  //Report var
  qs_Report_FileName := '';
  qs_Report_Part_X   := 0;
  qs_Report_Char_X   := 0;
  qs_Report_Value_X  := 0;
  qs_Report_Part_Y   := 0;
  qs_Report_Char_Y   := 0;
  qs_Report_Value_Y  := 0;
  qs_Report_CurPage  := 1;

  //stat result var
  qs_Stat_Key    := 1000;
  qs_Stat_SubKey := 0;
  qs_bTransform  := 0;
  qs_Stat_Part   := 1;
  qs_Stat_Char   := 1;

  qs_modul     := 0;
  qs_language  := 0;
  qs_strategy  := 0;
  qs_printer   := 0;

  qs_ServerVersion := '';


  FileName := '';
  ImageSwitch := 0;
  
  //-----------------------------------------------------------------
  qsstatHandle := 0;

  //-----------------------------------------------------------------
  hThreadEnde := 0;
  IQsSTAT := nil;
  IQsStatDb := nil;
  EventSink := nil;
  RemoteServer := false;
  
end;

procedure TF_ClientForm.FormDestroy(Sender: TObject);
begin
  // Disconnect&Stop server / Verbindungsabbauu und Server beenden
  MM_DisconnectServerClick(self);
end;

procedure TF_ClientForm.FormResize(Sender: TObject);
begin
  case ImageSwitch of
    1 :
    begin
      GetGraphicFromServer(qs_Graph_Key,
                           qs_Graph_SubKey,
                           qs_Graph_Part_X,
                           qs_Graph_Char_X,
                           qs_Graph_Value_X,
                           qs_Graph_Part_Y,
                           qs_Graph_Char_Y,
                           qs_Graph_Value_Y,
                           qs_Graph_CurPage,
                           0,
                           0,
                           0,
                           0,
                           1,
                           1,
                           0);
    end;
    2 :
    begin
      GetReportFromServer(qs_Report_FileName,
                          qs_Report_Part_X,
                          qs_Report_Char_X,
                          qs_Report_Value_X,
                          qs_Report_Part_Y,
                          qs_Report_Char_Y,
                          qs_Report_Value_Y,
                          qs_Report_CurPage,
                          0);
    end;
  end;  
end;

//------------------------------------------------------------------------------
// OnGetAliveState Event
//------------------------------------------------------------------------------
function TF_ClientForm.OnGetAliveState(  Sender : TObject; out state : integer): HRESULT;
begin
  state := 1;
  result := 1;
end;

//------------------------------------------------------------------------------
// OnQSSTATInitialize Event
//------------------------------------------------------------------------------
function TF_ClientForm.OnQSSTATInitialize( Sender : TObject): HRESULT;
begin
  LB_EventList.Items.Add(TimeToStr(now) + ' -> OnQSSTATInitialize.');
  result := 0;
end;

//------------------------------------------------------------------------------
// OnDataAvail Event
//------------------------------------------------------------------------------
function TF_ClientForm.OnDataAvail( Sender : TObject; NumOfChars: Integer): HRESULT;
begin
  LB_EventList.Items.Add(TimeToStr(Now) + ' -> OnDataAvail.');
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    NumofChar : '
                                        + IntToStr(NumOfChars));
  if ONLINEMode then
  begin
    ImageSwitch := 1; //Graphic
    self.FormResize(self);
  end;
  result := 0;
end;

//------------------------------------------------------------------------------
// OnDataAvailExt Event
//------------------------------------------------------------------------------
function TF_ClientForm.OnDataAvailExt( Sender     : TObject;
                                       Handle     : Integer;
                                       NumOfChars : Integer): HRESULT;
begin
  LB_EventList.Items.Add(TimeToStr(Now) + ' -> OnDataAvailExt.');
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Handle: '
                                        + IntToStr(Handle));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    NumofChar : '
                                        + IntToStr(NumOfChars));
  if ONLINEMode then
  begin
    ImageSwitch := 1; //Graphic
    self.FormResize(self);
  end;
  result := 0;
end;

//------------------------------------------------------------------------------
// OnEvaluationDone Event
//------------------------------------------------------------------------------
function TF_ClientForm.OnEvaluationDone(Sender : TObject): HRESULT;
begin
  LB_EventList.Items.Add(TimeToStr(Now) + ' -> OnEvaluationDone.');
  result := 0;
end;

//------------------------------------------------------------------------------
// OnEvaluationDoneExt Event
//------------------------------------------------------------------------------
function TF_ClientForm.OnEvaluationDoneExt(Sender : TObject;
                                           Handle : Integer): HRESULT;
begin
  LB_EventList.Items.Add(TimeToStr(Now) + ' -> OnEvaluationDoneExt.');
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Handle: '
                                        + IntToStr(Handle));
  result := 0;
end;

//------------------------------------------------------------------------------
// OnErrorEvent Event
//------------------------------------------------------------------------------
function TF_ClientForm.OnErrorEvent(Sender : TObject; ErrorCode: Integer): HResult;
begin
  LB_EventList.Items.Add(TimeToStr(Now) + ' -> OnErrorEvent.');
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Error : '
                                        + IntToStr(ErrorCode));
  result := 0;
end;

//------------------------------------------------------------------------------
// OnSystemAlarm Event
//------------------------------------------------------------------------------
function TF_ClientForm.OnSystemAlarm(Sender : TObject; AlarmCode: LongWord): HResult;
begin
  LB_EventList.Items.Add(TimeToStr(Now) + ' -> OnSystemAlarm.');
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm : '
                                        + IntToStr(AlarmCode));
  result := 0;
end;

//------------------------------------------------------------------------------
// OnStatisticalAlarm Event
//------------------------------------------------------------------------------
function TF_ClientForm.OnStatisticalAlarm( Sender       : TObject;
                                           Alarm_EW_1   : LongWord;
                                           Alarm_EW_2   : LongWord;
                                           Alarm_QRK_L  : LongWord;
                                           Alarm_QRK_S  : LongWord;
                                           Alarm_CP     : LongWord;
                                           Alarm_NO_SPC : LongWord;
                                           Part_Nr      : Integer;
                                           Char_Nr      : Integer;
                                           Value_Nr     : Integer;
                                           Sample_Nr    : Integer): HResult;
begin
  result := 0;
  LB_EventList.Items.Add(TimeToStr(Now) + ' -> OnStatisticalAlarm.');
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_EW_1 '
                                        + IntToStr(Alarm_EW_1));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_EW_2 '
                                        + IntToStr(Alarm_EW_2));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_QRK_L '
                                        + IntToStr(Alarm_QRK_L));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_QRK_S '
                                        + IntToStr(Alarm_QRK_S));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_CP '
                                        + IntToStr(Alarm_CP));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_NO_SPC '
                                        + IntToStr(Alarm_NO_SPC));
end;

//------------------------------------------------------------------------------
// OnStatisticalAlarmExt Event
//------------------------------------------------------------------------------
function TF_ClientForm.OnStatisticalAlarmExt( Sender       : TObject;
                                              Handle       : longint;
                                              Alarm_EW_1   : LongWord;
                                              Alarm_EW_2   : LongWord;
                                              Alarm_QRK_L  : LongWord;
                                              Alarm_QRK_S  : LongWord;
                                              Alarm_CP     : LongWord;
                                              Alarm_NO_SPC : LongWord;
                                              Part_Nr      : Integer;
                                              Char_Nr      : Integer;
                                              Value_Nr     : Integer;
                                              Sample_Nr    : Integer): HResult;
begin
  result := 0;
  LB_EventList.Items.Add(TimeToStr(Now) + ' -> OnStatisticalAlarmExt.');
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Handle: '
                                        + IntToStr(Handle));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_EW_1 '
                                        + IntToStr(Alarm_EW_1));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_EW_2 '
                                        + IntToStr(Alarm_EW_2));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_QRK_L '
                                        + IntToStr(Alarm_QRK_L));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_QRK_S '
                                        + IntToStr(Alarm_QRK_S));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_CP '
                                        + IntToStr(Alarm_CP));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Alarm_NO_SPC '
                                        + IntToStr(Alarm_NO_SPC));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Part_Nr '
                                        + IntToStr(Part_Nr));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Char_Nr '
                                        + IntToStr(Char_Nr));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Value_Nr '
                                        + IntToStr(Value_Nr));
  LB_EventList.Items.Add(TimeToStr(Now) + ' ->    Sample_Nr '
                                        + IntToStr(Sample_Nr));
end;

function lpStartServerProc( ptr : pointer ) : longint; stdcall;
var
  p_Form : TF_ClientForm;
begin
  Result := 0;
  p_Form := TF_ClientForm(ptr);

  // Create the object
  if p_Form.IQsSTAT = nil then
  begin

    // Create the object
    try
      if p_Form.RemoteServer then
      begin
        p_Form.IQsSTAT := CoTQsstatRemoteControl.CreateRemote('Remote mashine');
        p_Form.IQsSTAT.QueryInterface( IID_IDataBase,p_Form.IQsStatDb);
      end else
      begin
        p_Form.IQsSTAT := CoTQsstatRemoteControl.Create;
        p_Form.IQsSTAT.QueryInterface( IID_IDataBase,p_Form.IQsStatDb);
      end;
    except
      p_Form.IQsSTAT := nil;
    end;  

    // Show Info
    if p_Form.IQsSTAT <> nil then
    begin
      p_Form.SB_ClientStatusInfo.Panels[0].Text := 'Starting server... Done.';
    end else
    begin
      p_Form.SB_ClientStatusInfo.Panels[0].Text := 'Starting server... Failed!';
      exitThread(1);
    end;

    Application.ProcessMessages;

    // Set the Connection Points for IQsEvents state
    p_Form.EventSink                       := TIQsEvents.Create(p_Form);
    p_Form.EventSink.OnGetAliveState       := p_Form.OnGetAliveState;
    p_Form.EventSink.OnQSSTATInitialized   := p_Form.OnQSSTATInitialize;
    p_Form.EventSink.OnDataAvail           := p_Form.OnDataAvail;
    p_Form.EventSink.OnDataAvailExt        := p_Form.OnDataAvailExt;
    p_Form.EventSink.OnEvaluationDone      := p_Form.OnEvaluationDone;
    p_Form.EventSink.OnEvaluationDoneExt   := p_Form.OnEvaluationDoneExt;
    p_Form.EventSink.OnError               := p_Form.OnErrorEvent;
    p_Form.EventSink.OnSystemAlarm         := p_Form.OnSystemAlarm;
    p_Form.EventSink.OnStatisticalAlarm    := p_Form.OnStatisticalAlarm;
    p_Form.EventSink.OnStatisticalAlarmExt := p_Form.OnStatisticalAlarmExt;

    p_Form.EventSink.Connect(p_Form.IQsStat);

    p_Form.hThreadEnde := CreateEvent(nil,FALSE,FALSE,nil);
    WaitForSingleObject(p_Form.hThreadEnde,INFINITE);
    CloseHandle(p_Form.hThreadEnde);
  end;
end;


procedure TF_ClientForm.MM_StartServerClick(Sender: TObject);
var dwID : DWORD;
begin

  // Show Info
  SB_ClientStatusInfo.Panels[0].Text := 'Starting server...';

  Application.processMessages;

  if IQsSTAT = nil then
  begin
    CreateThread(nil,
                 0,
                 @lpStartServerProc,
                 self,
                 0,
                 dwID);
  end;
end;

//------------------------------------------------------------------------------
// Connect Server
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_ConnectServerClick(Sender: TObject);
var
  VersionStr     : Widestring;
  hr             : HResult;
  LoginDialog    : TF_Login;
  User, Pwd      : AnsiString;
begin
  if IQsStat <> nil then
  begin
    LoginDialog  := TF_Login.Create(self);
    LoginDialog.SetServerObj(IQsSTAT);

    if LoginDialog.ShowModal = mrok then
    begin
      LoginDialog.GetParameters(User,
                                Pwd,
                                qs_modul,
                                qs_language);
    end else
    begin
      // presetting qs-STAT modul
      // Voreinstellung qs-STAT Modul
      if qs_modul = 0 then qs_modul := 20;

      // presetting qs-STAT language
      // Voreinstellung qs-STAT Sprache
      if qs_language = 0 then qs_language := 49;

      // presetting qs-STAT Strategy
      // Voreinstellung Auswertestrategie
      qs_Strategy := 0; // Default

      User := 'Superuser';
      Pwd  := 'Superuser';
    end;
    LoginDialog.Free;

    SB_ClientStatusInfo.Panels[0].Text := 'Connecting to qs-STAT...';

    Application.ProcessMessages;

    // Connect the Client to qs-STAT, get the qs-STAT handle
    hr := IQsSTAT.ClientConnect(qsstatHandle,
                                qs_modul,
                                qs_language,
                                User,
                                Pwd);

    if succeeded(hr) then
    begin
      // Get qs-STAT Version
      hr := IQsSTAT.QsstatVersion(qsstatHandle,
                                  VersionStr);
      if hr = S_OK then
      begin
        qs_ServerVersion := VersionStr;
      end;

      SB_ClientStatusInfo.Panels[0].Text := 'Connecting to qs-STAT... Done.' +
                                         'Ver: ' + VersionStr;
      LB_EventList.Items.Add(TimeToStr(now) + ' -> Connected to qs-STAT');
    end else
    begin
      SB_ClientStatusInfo.Panels[0].Text := 'Connecting to qs-STAT... Failed.';
    end;
  end else
  begin
    SB_ClientStatusInfo.Panels[0].Text := 'qs-STAT Server not started';
  end;
end;

//------------------------------------------------------------------------------
// Disconnect Server
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_DisconnectServerClick(Sender: TObject);
begin
  // release the sink object / Sink Objetk freigeben
  if EventSink <> nil then
  begin
    EventSink.Destroy;
    EventSink := nil;
  end;
  
  if IQsSTAT <> nil then
  begin
    // Disconnect the client / Verbindungsabbau
    if qsstatHandle <> 0 then
    begin
      IQsSTAT.ClientDisconnect(qsstatHandle);
    end;
    
    // release the server / Serverobjekt freigeben
    IQsSTAT := nil;
    qsstatHandle := 0;

    // Terminate Server thread / Server thread beenden
    if hThreadEnde <> 0 then
    begin
      SetEvent(hThreadEnde);
    end;
    
  end;
  SB_ClientStatusInfo.Panels[0].Text := 'Disconnected / server stopped';
  LB_EventList.Items.Add(TimeToStr(now) + ' -> Disconnected from qs-STAT');
end;

//------------------------------------------------------------------------------
// Open File
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_OpenFileClick(Sender: TObject);
var
  hr : HResult;
  rc : integer;
begin
  if IQsSTAT <> nil then
  begin
    FileOpenDialog.Filter := 'ASCII DFD (*.DFD)|*.dfd|ASCII DFQ (*.DFQ)|*.dfq';
    FileOpenDialog.DefaultExt := 'dfq';
    FileOpenDialog.Title := 'Open qs-STAT file';
    FileOpenDialog.InitialDir := ExtractFilePath(ParamStr(0));
    // Show file open dialog
    if FileOpenDialog.Execute then
    begin
      //hide image
      Image.Hide;

      FileName := FileOpenDialog.FileName;
      SB_ClientStatusInfo.Panels[0].Text := 'Open: ' + FileName + ' ...';

      Application.processMessages;

      hr := IQsSTAT.OpenFile(qsstatHandle,
                             FileName);
      while hr = E_PENDING do
      begin
        Sleep(1000);
        // retry open file
        hr := IQsSTAT.OpenFile(qsstatHandle,
                               FileName);
      end;
      if hr = S_OK then
      begin
        rc := WaitForSingleObject(EventSink.hDataAvailEvent, INFINITE);
        case rc of
          WAIT_TIMEOUT:
          begin
            SB_ClientStatusInfo.Panels[0].Text := 'Open: ' + FileName + ' ... Failed.';
          end;

          WAIT_OBJECT_0:
          begin
            SB_ClientStatusInfo.Panels[0].Text := 'Open: ' + FileName + ' ... Done.';

            Application.processMessages;

            //call evalution function
            MM_EvaluateAllClick(self);
          end;
        end;
      end;
    end;
  end;
end;

//------------------------------------------------------------------------------
// Transmit File
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_TransmitFileClick(Sender: TObject);
begin
  if IQsSTAT <> nil then
  begin
    FileOpenDialog.Filter := 'ASCII DFD (*.DFD)|*.dfd|ASCII DFQ (*.DFQ)|*.dfq';
    FileOpenDialog.DefaultExt := 'dfq';
    FileOpenDialog.Title := 'Transmit qs-STAT file';
    FileOpenDialog.InitialDir := ExtractFilePath(ParamStr(0));
    // Show file open dialog
    if FileOpenDialog.Execute then
    begin
      //hide image
      Image.Hide;

      FileName := FileOpenDialog.FileName;
      TransmitFileToServer(FileName,
                           '',
                           0,
                           False);

    end;
  end;
end;

//------------------------------------------------------------------------------
// Transmit File
//------------------------------------------------------------------------------
procedure TF_ClientForm.TransmitFileToServer(FileName : AnsiString;
                                             DataStr  : WideString;
                                             Mode     : integer;
                                             Online   : Boolean);
var
  hr : HResult;
  va : OleVariant;
  rc : Integer;
begin
  if IQsSTAT <> nil then
  begin
    SB_ClientStatusInfo.Panels[0].Text := 'Transmit: ' + FileName + ' ...';

    Application.processMessages;

    if DataStr = '' then
    begin
      va := GetVarArrayFromFile(FileName)
    end else
    begin
      va := GetVarArrayFromString(DataStr);
    end;

    ONLINEMode := Online;

    hr := IQsSTAT.TransmitFileExt(qsstatHandle,
                                  va,
                                  Mode,
                                  0);
    while hr = E_PENDING do
    begin
      Sleep(1000);
      // retry transmiting file
      hr := IQsSTAT.TransmitFileExt(qsstatHandle,
                                    va,
                                    Mode,
                                    0);
    end;
    if hr = S_OK then
    begin
      rc := WaitForSingleObject(EventSink.hDataAvailEvent, INFINITE);
      case rc of
        WAIT_TIMEOUT:
        begin
          SB_ClientStatusInfo.Panels[0].Text := 'Transmit: ' + FileName + ' ... Failed.';
        end;

        WAIT_OBJECT_0:
        begin
          SB_ClientStatusInfo.Panels[0].Text := 'Transmit: ' + FileName + ' ... Done.';

          Application.processMessages;

          //call evalution function
          MM_EvaluateAllClick(self);
        end;
      end;
    end;
  end;
end;

//------------------------------------------------------------------------------
// DB Open
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_DBOpenClick(Sender: TObject);
var
  hr      : HResult;
  EnumDlg : TF_ENUMInterfaceDlg;
begin
  if IQsStat <> nil then
  begin
    EnumDlg  := TF_ENUMInterfaceDlg.Create(self);
    EnumDlg.SetEnumDlg(IQsSTAT,
                       qsstatHandle,
                       qs_modul,
                       DBOPEN_C);

    if EnumDlg.ShowModal = mrOK then
    begin
      SB_ClientStatusInfo.Panels[1].Text := 'DB open in progress ...';

      Application.ProcessMessages;

      hr := IQsSTAT.DBOpen(qsstatHandle,
                           EnumDlg.GetSelection);
      if succeeded(hr) then
      begin
        SB_ClientStatusInfo.Panels[1].Text := 'DB open in progress ... Done.';
      end else
      begin
        SB_ClientStatusInfo.Panels[1].Text := 'DB open in progress ... Failed.';
      end;
    end;
  end;
end;

//------------------------------------------------------------------------------
// Execute Query
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_ExecuteQueryClick(Sender: TObject);
var
  rc : Integer;
begin
  if IQsSTAT <> nil then
  begin
    rc := FilterSettingsDialog(self,
                               IQsSTAT,
                               qsstatHandle,
                               qs_modul);
    if rc = 0 then
    begin
      SB_ClientStatusInfo.Panels[1].Text := 'Execute query complete.';
    end;
  end;
end;

//------------------------------------------------------------------------------
// Print Report
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_PrintClick(Sender: TObject);
var
  hr : HResult;
begin
  if IQsSTAT <> nil then
  begin
    hr := IQsSTAT.PrintReportExt(qsstatHandle,
                                 qs_Report_Part_X,
                                 qs_Report_FileName,
                                 qs_printer,
                                 IntToStr(qs_Report_CurPage),
                                 33, //Print mode: 31 - Meta file, 32- BMP file, 33 - Direct output
                                 1,  //Color mode: 1 - Color, 2 - B&W, 3 - RevColor
                                 0); //Orientation: 0 - default, 1 - Portrait, 2 - Landscape

    if Succeeded(hr) then
    begin
      if qs_Report_FileName <> '' then
      begin
        SB_ClientStatusInfo.Panels[0].Text := 'Print report: ' + qs_Report_FileName + '...Done';
        SB_ClientStatusInfo.Panels[1].Text := 'Print page: ' + IntToStr(qs_Report_CurPage) + '...Done';
      end;
    end;
  end;
end;

//------------------------------------------------------------------------------
// Exit Client
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_ExitClick(Sender: TObject);
begin
  FormDestroy(self);
  close;
end;

//------------------------------------------------------------------------------
// Evaluation
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_EvaluateAllClick(Sender: TObject);
var
  hr : HResult;
  rc : integer;
begin
  if IQsSTAT <> nil then
  begin
    SB_ClientStatusInfo.Panels[1].Text := 'Evaluation in progress ...';

    Application.ProcessMessages;

    hr := IQsSTAT.EvaluateAllChars(qsstatHandle);
    while hr = E_PENDING do
    begin
      Sleep(1000);
      hr := IQsSTAT.EvaluateAllChars(qsstatHandle);
    end;
    if hr = S_OK then
    begin
      rc := WaitForSingleObject(EventSink.hEvaluationEvent,INFINITE);
      case rc of
        WAIT_TIMEOUT:
        begin
          SB_ClientStatusInfo.Panels[1].Text := 'Evaluation in progress ... Failed.';
        end;

        WAIT_OBJECT_0:
        begin
          SB_ClientStatusInfo.Panels[1].Text := 'Evaluation in progress ... Done.';
        end;
      end;
    end;
  end;
end;

//------------------------------------------------------------------------------
// Graphic Dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_GraphicClick(Sender: TObject);
var
  GraphicDlg : TF_GraphicDlg;
begin
  if IQsStat <> nil then
  begin
    GraphicDlg  := TF_GraphicDlg.Create(self);
    GraphicDlg.SetParameters(self,
                             IQsSTAT,
                             qsstatHandle,
                             qs_modul,
                             qs_Graph_Key,
                             qs_Graph_SubKey,
                             qs_Graph_Part_X,
                             qs_Graph_Char_X,
                             qs_Graph_Value_X,
                             qs_Graph_Part_Y,
                             qs_Graph_Char_Y,
                             qs_Graph_Value_Y,
                             qs_Graph_CurPage);

    if GraphicDlg.ShowModal = mrOK then
    begin
      GraphicDlg.GetParameters(qs_Graph_Key,
                               qs_Graph_SubKey,
                               qs_Graph_Part_X,
                               qs_Graph_Char_X,
                               qs_Graph_Value_X,
                               qs_Graph_Part_Y,
                               qs_Graph_Char_Y,
                               qs_Graph_Value_Y,
                               qs_Graph_CurPage);
      GetGraphicFromServer(qs_Graph_Key,
                           qs_Graph_SubKey,
                           qs_Graph_Part_X,
                           qs_Graph_Char_X,
                           qs_Graph_Value_X,
                           qs_Graph_Part_Y,
                           qs_Graph_Char_Y,
                           qs_Graph_Value_Y,
                           qs_Graph_CurPage,
                           0,0,0,0,
                           1,
                           1,
                           0);
    end;
    GraphicDlg.Free;
  end;
end;

//------------------------------------------------------------------------------
// Report Dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_ReportClick(Sender: TObject);
var
  ReportDlg : TF_ReportDlg;
begin
  if IQsStat <> nil then
  begin
    ReportDlg  := TF_ReportDlg.Create(self);
    ReportDlg.SetParameters(IQsSTAT,
                            qsstatHandle,
                            qs_Report_Part_X,
                            qs_Report_Char_X,
                            qs_Report_Value_X,
                            qs_Report_Part_Y,
                            qs_Report_Char_Y,
                            qs_Report_Value_Y,
                            qs_Report_CurPage);
    if ReportDlg.ShowModal = mrOK then
    begin
      ReportDlg.GetParameters(qs_Report_FileName,
                              qs_Report_Part_X,
                              qs_Report_Char_X,
                              qs_Report_Value_X,
                              qs_Report_Part_Y,
                              qs_Report_Char_Y,
                              qs_Report_Value_Y,
                              qs_Report_CurPage);
      GetReportFromServer(qs_Report_FileName,
                          qs_Report_Part_X,
                          qs_Report_Char_X,
                          qs_Report_Value_X,
                          qs_Report_Part_Y,
                          qs_Report_Char_Y,
                          qs_Report_Value_Y,
                          qs_Report_CurPage,
                          0);

    end;
    ReportDlg.Free;
  end;
end;

//------------------------------------------------------------------------------
// Stat Result Dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_ResultClick(Sender: TObject);
var
  StatResult : TF_StatResult;
begin
  if IQsStat <> nil then
  begin
    StatResult  := TF_StatResult.Create(self);
    StatResult.SetParameters(IQsSTAT,
                             qsstatHandle,
                             qs_modul,
                             qs_Stat_Key,
                             qs_Stat_SubKey,
                             qs_Stat_Part,
                             qs_Stat_Char);
    if StatResult.ShowModal = mrOK then
    begin
      //
    end;
    StatResult.Free;
  end;
end;

//------------------------------------------------------------------------------
// Catalogue Dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_CatalogueClick(Sender: TObject);
var
  CatalogueDlg : TF_CatalogueDlg;
begin
  if IQsStat <> nil then
  begin
    CatalogueDlg  := TF_CatalogueDlg.Create(self);
    CatalogueDlg.SetParameters(IQsSTAT,
                               qsstatHandle,
                               true);
    if CatalogueDlg.ShowModal = mrOK then
    begin
//      CatalogueDlg.GetParameters();
    end;
    CatalogueDlg.Free;
  end;
end;

//------------------------------------------------------------------------------
// Part Dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_PartClick(Sender: TObject);
var
  PartDlg : TF_PartDlg;
begin
  if IQsStat <> nil then
  begin
    PartDlg  := TF_PartDlg.Create(self);
    PartDlg.SetParameters(IQsSTAT,
                          qsstatHandle);
    if PartDlg.ShowModal = mrOK then
    begin
      //nothing
    end;
    PartDlg.Free;
  end;
end;

//------------------------------------------------------------------------------
// Char Dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_CharClick(Sender: TObject);
var
  CharDlg : TF_CharDlg;
begin
  if IQsStat <> nil then
  begin
    CharDlg  := TF_CharDlg.Create(self);
    CharDlg.SetParameters(IQsSTAT,
                          qsstatHandle);
    if CharDlg.ShowModal = mrOK then
    begin
      //nothing
    end;
    CharDlg.Free;
  end;
end;

//------------------------------------------------------------------------------
// Value Dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_ValueClick(Sender: TObject);
var
  ValueDlg : TF_ValueDlg;
begin
  if IQsStat <> nil then
  begin
    ValueDlg  := TF_ValueDlg.Create(self);
    ValueDlg.SetParameters(IQsSTAT,
                           qsstatHandle);
    if ValueDlg.ShowModal = mrOK then
    begin
      //nothing
    end;
    ValueDlg.Free;
  end;
end;

//------------------------------------------------------------------------------
// Module dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_ModuleClick(Sender: TObject);
var
  Str, s1 : Widestring;
  Module  : Integer;
  EnumDlg : TF_ENUMInterfaceDlg;
begin
  if IQsStat <> nil then
  begin
    EnumDlg  := TF_ENUMInterfaceDlg.Create(self);
    EnumDlg.SetEnumDlg(IQsSTAT,
                       qsstatHandle,
                       qs_modul,
                       MODULE_C);

    if EnumDlg.ShowModal = mrOK then
    begin
      str := EnumDlg.GetSelection;
      Module := StrToIntDef(str, 0);
      s1 := Copy(str,1,Pos(' - ',str)-1);
      if s1 <> '' then
      begin
        Module := StrToIntDef(s1, 0)
      end;
      SetModule(Module, str);
    end;
  end;
end;

//------------------------------------------------------------------------------
// Set Module
//------------------------------------------------------------------------------
procedure TF_ClientForm.SetModule(NewModule  : Integer;
                                  ModuleName : WideString);
var
  hr      : HResult;
begin
  if IQsStat <> nil then
  begin
    hr := IQsSTAT.SetModule(qsstatHandle,
                            NewModule);
    if succeeded(hr) then
    begin
      qs_modul := NewModule;
      qs_strategy := 0; //must be reselected
      SB_ClientStatusInfo.Panels[1].Text := 'Module: ' + ModuleName;
    end;
  end;
end;

//------------------------------------------------------------------------------
// Language dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_LanguageClick(Sender: TObject);
var
  str, s1 : WideString;
  Lang    : Integer;
  EnumDlg : TF_ENUMInterfaceDlg;
begin
  if IQsStat <> nil then
  begin
    EnumDlg  := TF_ENUMInterfaceDlg.Create(self);
    EnumDlg.SetEnumDlg(IQsSTAT,
                       qsstatHandle,
                       qs_modul,
                       LANGUAGE_C);

    if EnumDlg.ShowModal = mrOK then
    begin
      str := EnumDlg.GetSelection;
      Lang := StrToIntDef(str, 0);
      s1 := Copy(str,1,Pos(' - ',str)-1);
      if s1 <> '' then
      begin
        Lang := StrToIntDef(s1, 0)
      end;
      SetLanguage(Lang, str);
    end;
  end;
end;

//------------------------------------------------------------------------------
// Set language
//------------------------------------------------------------------------------
procedure TF_ClientForm.SetLanguage(NewLanguage  : Integer;
                                    LanguageName : WideString);
var
  hr      : HResult;
  str     : WideString;
begin
  if IQsStat <> nil then
  begin
    hr := IQsSTAT.SetLanguage(qsstatHandle,
                              NewLanguage,
                              str);
    if succeeded(hr) then
    begin
      qs_language := NewLanguage;
      SB_ClientStatusInfo.Panels[1].Text := 'Language: ' + LanguageName;
    end;
  end;
end;

//------------------------------------------------------------------------------
// Strategy dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_StrategyClick(Sender: TObject);
var
  str, s1 : WideString;
  Strat   : Integer;
  EnumDlg : TF_ENUMInterfaceDlg;
begin
  if IQsStat <> nil then
  begin
    EnumDlg  := TF_ENUMInterfaceDlg.Create(self);
    EnumDlg.SetEnumDlg(IQsSTAT,
                       qsstatHandle,
                       qs_modul,
                       STRATEGY_C);

    if EnumDlg.ShowModal = mrOK then
    begin
      str := EnumDlg.GetSelection;
      Strat := StrToIntDef(str, 0);
      s1 := Copy(str,1,Pos(' - ',str)-1);
      if s1 <> '' then
      begin
        Strat := StrToIntDef(s1, 0)
      end;
      SetStrategy(Strat, str);
    end;
  end;
end;

//------------------------------------------------------------------------------
// Set strategy
//------------------------------------------------------------------------------
procedure TF_ClientForm.SetStrategy(NewStrategy  : Integer;
                                    StrategyName : WideString);
var
  hr      : HResult;
begin
  if IQsStat <> nil then
  begin
    hr := IQsSTAT.SetEvaluationStrategy(qsstatHandle,
                                        0,
                                        NewStrategy);
    if succeeded(hr) then
    begin
      qs_strategy := NewStrategy;
      SB_ClientStatusInfo.Panels[1].Text := 'Strategy: ' + StrategyName;
    end;
  end;
end;

//------------------------------------------------------------------------------
// Printer dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_PrinterClick(Sender: TObject);
var
  str, s1 : WideString;
  Printer : Integer;
  EnumDlg : TF_ENUMInterfaceDlg;
begin
  if IQsStat <> nil then
  begin
    EnumDlg  := TF_ENUMInterfaceDlg.Create(self);
    EnumDlg.SetEnumDlg(IQsSTAT,
                       qsstatHandle,
                       qs_modul,
                       PRINTER_C);

    if EnumDlg.ShowModal = mrOK then
    begin
      str := EnumDlg.GetSelection;
      Printer := StrToIntDef(str, -1);
      s1 := Copy(str,1,Pos(' - ',str)-1);
      if s1 <> '' then
      begin
        Printer := StrToIntDef(s1, -1)
      end;
      SetPrinter(Printer, str);
    end;
  end;
end;

//------------------------------------------------------------------------------
// Set printer
//------------------------------------------------------------------------------
procedure TF_ClientForm.SetPrinter(NewPrinter   : Integer;
                                   PrinterName : WideString);
begin
  if IQsStat <> nil then
  begin
    qs_printer := NewPrinter;
    SB_ClientStatusInfo.Panels[1].Text := 'Printer: ' + PrinterName;
  end;
end;

//------------------------------------------------------------------------------
// Transmition dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_TransmissionClick(Sender: TObject);
var
  TransmitDlg : TF_TransmitDlg;
begin
  if IQsStat <> nil then
  begin
    //'<- first set Module to 26 - Online monitoring ->
    SetModule(26, 'Procella');

    TransmitDlg  := TF_TransmitDlg.Create(self);
    TransmitDlg.SetParameters(IQsSTAT,
                              qsstatHandle);
    if TransmitDlg.ShowModal = mrOK then
    begin
      //Show transmit dialog
    end;
  End;
end;

//------------------------------------------------------------------------------
// Online evaluation
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_OnlineEvaluationClick(Sender: TObject);
begin
   Evaluate(True);
end;

//------------------------------------------------------------------------------
// SPC evaluation
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_SPC_EvaluationClick(Sender: TObject);
begin
  Evaluate(False);
end;

//------------------------------------------------------------------------------
// Evaluation
//------------------------------------------------------------------------------
procedure TF_ClientForm.Evaluate(Mode : Boolean);
var
  hr      : HResult;
begin
  if IQsStat <> nil then
  begin
    hr := IQsSTAT.EvaluateCharExt( qsstatHandle,
                                   Mode,
                                   0,
                                   0,
                                   0,
                                   0,
                                   0);
    if Succeeded(hr) then
    begin
      //ok
    end;
  end;
end;

//------------------------------------------------------------------------------
// About dialog
//------------------------------------------------------------------------------
procedure TF_ClientForm.MM_AboutClick(Sender: TObject);
var
  AboutDlg : TF_AboutDlg;
begin
  if IQsStat <> nil then
  begin
    AboutDlg  := TF_AboutDlg.Create(self);
    AboutDlg.SetParameters('2.0',
                           qs_ServerVersion);

    if AboutDlg.ShowModal = mrOK then
    begin
      // nothing to do
    end;
  end;
end;

//------------------------------------------------------------------------------
// Get graphic from server
//------------------------------------------------------------------------------
procedure TF_ClientForm.GetGraphicFromServer(Key          : Integer;
                                             SubKey       : Integer;
                                             Part_X       : Integer;
                                             Char_X       : Integer;
                                             Value_X      : Integer;
                                             Part_Y       : Integer;
                                             Char_Y       : Integer;
                                             Value_Y      : Integer;
                                             CurPage      : Integer;
                                             NrOfCols     : Integer;
                                             NrOfRows     : Integer;
                                             Page_X_Start : Integer;
                                             Page_Y_Start : Integer;
                                             NrOfPage_X   : Integer;
                                             NrOfPage_Y   : Integer;
                                             Format       : Integer);
var
  va         : OleVariant;
  hr         : HResult;
//  NextPage_x : integer;
//  NextPage_y : integer;
begin
//  NextPage_x := 0;
//  NextPage_y := 0;

  if IQsStat <> nil then
  begin
    // Loading the Bitmap to the OleVariant
    hr := IQsSTAT.GetGraphicExt(qsstatHandle,
                                Key,
                                SubKey,
                                Part_X,
                                Char_X,
                                Value_X,
                                0,
                                0,
                                Part_Y,
                                Char_Y+1,
                                Value_Y,
                                0,
                                0,
                                Image.Width,
                                Image.Height,
                                NrOfCols,
                                NrOfRows,
                                0,
                                Format,
                                va);
   {
    hr := IQsSTAT.GetGraphicExt2( qsstatHandle,
                                  Key,
                                  SubKey,
                                  Part_X,
                                  Group_X,
                                  Char_X,
                                  Value_X,
                                  0,
                                  Part_Y,
                                  Group_Y,
                                  Char_Y+1,
                                  Value_Y,
                                  0,
                                  -1, //Part_MStart,
                                  -1, //Group_MStart,
                                  -1, //Char_MStart,
                                  -1, //Value_MStart,
                                  -1, //Part_MEnd,
                                  -1, //Group_MEnd,
                                  -1, //Char_MEnd,
                                  -1, //Value_MEnd,
                                  1, //NrOfCols,
                                  1, //NrOfRows,
                                  Image.Width,
                                  Image.Height,
                                  0,
                                  Page_X_Start,
                                  Page_Y_Start,
                                  NrOfPage_X,
                                  NrOfPage_Y,
                                  Format,
                                  va);
                                        }
    if hr = 0 then
    begin
      VarArrayToScreen(va, 0);
      ImageSwitch := 1;
    end;
  end;
end;

//------------------------------------------------------------------------------
// Get report from server
//------------------------------------------------------------------------------
procedure TF_ClientForm.GetReportFromServer( ReportName : AnsiString;
                                             Part_X     : Integer;
                                             Char_X     : Integer;
                                             Value_X    : Integer;
                                             Part_Y     : Integer;
                                             Char_Y     : Integer;
                                             Value_Y    : Integer;
                                             CurPage    : Integer;
                                             Format     : Integer);
var
  va          : OleVariant;
  hr          : HResult;
begin
  if IQsStat <> nil then
  begin
    if ReportName <> '' then
    begin
      // Loading the Bitmap to the OleVariant
      hr := IQsSTAT.GetReportExt(qsstatHandle,
                                 ReportName,
                                 Part_X,
                                 Char_X,
                                 Value_X,
                                 0,
                                 Part_Y,
                                 Char_Y,
                                 Value_Y,
                                 0,
                                 CurPage,
                                 Image.Width,
                                 Image.Height,
                                 0,
                                 Format,
                                 va);
      if hr = 0 then
      begin
        VarArrayToScreen(va, 0);
        ImageSwitch := 2;
      end;
    end else
    begin
      SB_ClientStatusInfo.Panels[1].Text := 'Wrong reportname!';
    end;
  end;
end;

//------------------------------------------------------------------------------
// Show image
//------------------------------------------------------------------------------
procedure TF_ClientForm.VarArrayToScreen( va     : OleVariant;
                                          Format : byte);
var
  buffer     ,
  P          : pointer;
  TempStream : TMemoryStream;
  dim        ,
  size    : longint;
  JPEGGraphic : TJpegImage;
begin
  try
    // Copying the bitmmap from the variant to a internal buffer
    dim     := VarArrayDimCount(va);
    size := (VarArrayLowBound(va,dim) + VarArrayHighBound(va,dim));
    buffer  := AllocMem(size);
    P       := VarArrayLock(va);
    try
      Move(P^,buffer^,size-1);
    finally
      VarArrayUnlock(va);
    end;

    // moving from the buffer to a stream
    Image.Stretch := False;
    TempStream := TMemoryStream.Create;
    TempStream.SetSize(size);
    TempStream.WriteBuffer(buffer^,size);
    TempStream.Seek(0,soFromBeginning);
    FreeMem(buffer,size);

    // Painting the bitmap / jpeg from the stream  to the image
    case Format of
      1: // jpg
      begin
        JPEGGraphic := TJpegImage.Create;
        JPEGGraphic.LoadFromStream(TempStream);
        image.Picture.Bitmap.Assign(JPEGGraphic);
        JPEGGraphic.free;
      end;
      else
      begin // BMP
        image.Picture.Bitmap.LoadFromStream(TempStream);
      end;
    end;
    TempStream.Free;

    Image.Show;
  except
  end;
end;

//------------------------------------------------------------------------------
// get variant array from file
//------------------------------------------------------------------------------
function TF_ClientForm.GetVarArrayFromFile(FileName : AnsiString) : OleVariant;
var
  F : file of Byte;
  FilePtr  : PCHAR;
  FSize    : longint;
  MemSize  : longint;
  va       : OleVariant;
  P        : pointer;
begin
  try
    AssignFile(F, FileName);
    Reset(F);
    FSize := FileSize(F);
    MemSize := FSize;
    GetMem(FilePtr, MemSize + 1);
    BlockRead(F,FilePtr^, MemSize);
    CloseFile(F);

    va := VarArrayCreate([0,MemSize], varByte);
    P := VarArrayLock(va);
    Move(FilePtr^,P^,MemSize);
    VarArrayUnLock(va);
  except
  end;
  result := va;
end;

//------------------------------------------------------------------------------
// get variant array from string
//------------------------------------------------------------------------------
function TF_ClientForm.GetVarArrayFromString(Str : AnsiString) : OleVariant;
var
  FilePtr   : pointer;
  MemSize   : longint;
  MemStream : TMemoryStream;
  va        : OleVariant;
  P         : pointer;
begin
  try
    MemStream :=  TMemoryStream.Create;

    // Load the content of the memo to the temporary Buffer
    MemStream.WriteBuffer(Pointer(Str)^, Length(Str));
    MemSize := MemStream.Size;

    FilePtr := AllocMem( MemSize + 1);
    FillChar(FilePtr^, MemSize + 1, #0);
    MemStream.Seek(0,soFromBeginning);
    MemStream.Read(FilePtr^,MemSize);

    va := VarArrayCreate([0,MemSize], varByte);
    P := VarArrayLock(va);
    Move(FilePtr^,P^,MemSize);
    VarArrayUnLock(va);

    Freemem(FilePtr,memsize+1 );
    MemStream.Free;
  except
  end;
  result := va;
end;

procedure TF_ClientForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

end.
