//==============================================================================
//                      >>> ENumInterfaceDlg.pas <<<
//
//
//    Inhalt      : ENUM Interface dialog of Delphi COM Client 2
//
//    Autor       : OL
//    Erstellt am : 6.2004
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//==============================================================================
unit ENumInterfaceDlg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  qs_stat_tlb;

type
  TF_ENUMInterfaceDlg = class(TForm)
    P_BB: TPanel;
    BB_OK: TButton;
    BB_Cancel: TButton;
    P_Head: TPanel;
    GroupBox: TGroupBox;
    LA_Enum: TLabel;
    COB_ENum: TComboBox;
  private
    IQsStat : ITQsstatRemoteControl;
    qsstatHandle : LongInt;
    qs_module : Integer;
    procedure InitializeModule;
    procedure InitializeLanguage;
    procedure InitializeStrategy;
    procedure InitializePrinter;
    procedure InitializeDB;
  public
    // ENUM Interface
    // 1 - Module
    // 2 - Language
    // 3 - Strategy
    // 4 - Printer
    // 5 - DB
    procedure SetEnumDlg(SvrObj        : ITQsstatRemoteControl;
                         SvrHandle     : LongInt;
                         qsmodule      : integer;
                         ENumInterface : integer);
    function GetSelection : WideString;
  end;

var
  F_ENUMInterfaceDlg: TF_ENUMInterfaceDlg;

implementation

{$R *.DFM}

// Setting available modules
procedure TF_ENUMInterfaceDlg.InitializeModule;
var
  IQsSTATModules : IEnumModule;
  moduleKey      : integer;
  moduleName     : WideString;
  rc             : integer;
begin
  if IQsSTAT <> nil then
  begin
    // Get the available modules from the server
    COB_ENum.Clear;
    COB_ENum.Style := csDropDown;
    IQsSTATModules := IQsSTAT as IEnumModule;
    moduleKey := 0;
    moduleName := '';
    rc := IQsSTATModules.GetFirstModule(qsstatHandle,
                                        moduleKey,
                                        moduleName);
    while rc = 0 do
    begin
      COB_ENum.Items.Add(IntToStr(ModuleKey) + ' - ' + moduleName);
      rc := IQsSTATModules.GetNextModule(qsstatHandle,
                                         moduleKey,
                                         moduleName);
    end;
    if COB_ENum.Items.Count > 0 then
    begin
      COB_ENum.ItemIndex := 0;
    end;
  end;
end;

procedure TF_ENUMInterfaceDlg.InitializeLanguage;
var
  IQsSTATLang    : IEnumLanguage;
  LangKey        : integer;
  LangShortName  : WideString;
  LangName       : WideString;
  rc             : integer;
begin
  if IQsSTAT <> nil then
  begin
    // Get the available languages from the server
    COB_ENum.Clear;
    IQsSTATLang := IQsSTAT as IEnumLanguage;
    LangKey        := 0;
    LangShortName  := '';
    LangName       := '';

    rc := IQsSTATLang.GetFirstLanguage(qsstatHandle,
                                       LangName,
                                       LangShortName,
                                       LangKey);
    while rc = 0 do
    begin
      COB_ENum.Items.Add(IntToStr(LangKey) + ' - ' + LangName);
      rc := IQsSTATLang.GetNextLanguage(qsstatHandle,
                                        LangName,
                                        LangShortName,
                                        LangKey);
    end;
    if COB_ENum.Items.Count > 0 then
    begin
      COB_ENum.ItemIndex := 0;
    end;
  end;
end;

procedure TF_ENUMInterfaceDlg.InitializeStrategy;
var
  IQsSTATStrat    : IEnumEvaluationStrategy;
  StratKey        : integer;
  StratName       : WideString;
  rc              : integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_ENum.Clear;
    IQsSTATStrat := IQsSTAT as IEnumEvaluationStrategy;
    StratKey        := 0;
    StratName       := '';

    rc := IQsSTATStrat.GetFirstEvaluationStrategy(qsstatHandle,
                                                  qs_module,
                                                  0,
                                                  StratKey,
                                                  StratName);
    while rc = 0 do
    begin
      COB_ENum.Items.Add(IntToStr(StratKey) + ' - ' + StratName);
      rc := IQsSTATStrat.GetNextEvaluationStrategy(qsstatHandle,
                                                   qs_module,
                                                   0,
                                                   StratKey,
                                                   StratName);
    end;
    if COB_ENum.Items.Count > 0 then
    begin
      COB_ENum.ItemIndex := 0;
    end;
  end;
end;

procedure TF_ENUMInterfaceDlg.InitializePrinter;
var
  IQsSTATPrinter : IEnumPrinter;
  PrinterKey     : integer;
  PrinterName    : WideString;
  rc             : integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_ENum.Clear;
    IQsSTATPrinter := IQsSTAT as IEnumPrinter;
    PrinterKey   := 0;
    PrinterName  := '';

    rc := IQsSTATPrinter.GetFirstPrinter(qsStatHandle,
                                         PrinterKey,
                                         PrinterName);
    while rc = 0 do
    begin
      COB_ENum.Items.Add(IntToStr(PrinterKey) + ' - ' + PrinterName);
      rc := IQsSTATPrinter.GetNextPrinter(qsStatHandle,
                                          PrinterKey,
                                          PrinterName);
    end;
    if COB_ENum.Items.Count > 0 then
    begin
      COB_ENum.ItemIndex := 0;
    end;
  end;
end;

procedure TF_ENUMInterfaceDlg.InitializeDB;
var
  IqsSTATDBSelName : IEnumDBSelectionName;
  DBSelName        : WideString;
  rc               : integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_ENum.Clear;
    IqsSTATDBSelName := IQsSTAT as IEnumDBSelectionName;
    DBSelName  := '';

    rc := IqsSTATDBSelName.GetFirstDBSelection(qsStatHandle,
                                               DBSelName);
    while rc = 0 do
    begin
      COB_ENum.Items.Add(DBSelName);
      rc := IqsSTATDBSelName.GetNextDBSelection(qsStatHandle,
                                                DBSelName);
    end;
    if COB_ENum.Items.Count > 0 then
    begin
      COB_ENum.ItemIndex := 0;
    end;
  end;
end;

procedure TF_ENUMInterfaceDlg.SetEnumDlg(SvrObj        : ITQsstatRemoteControl;
                                         SvrHandle     : LongInt;
                                         qsmodule      : integer;
                                         ENumInterface : integer);
begin
  IQsStat      := SvrObj;
  qsstatHandle := SvrHandle;
  qs_module    := qsmodule;
  case ENumInterface of
    1 :
    begin
      Caption := 'Select Module';
      LA_Enum.Caption := 'Module:';
      InitializeModule;
    end;
    2 :
    begin
      Caption := 'Select Language';
      LA_Enum.Caption := 'Language:';
      InitializeLanguage;
    end;
    3 :
    begin
      Caption := 'Select Strategy';
      LA_Enum.Caption := 'Strategy:';
      InitializeStrategy;
    end;
    4 :
    begin
      Caption := 'Select Printer';
      LA_Enum.Caption := 'Printer:';
      InitializePrinter;
    end;
    5 :
    begin
      Caption := 'Data Base - Select Query';
      LA_Enum.Caption := 'DB:';
      InitializeDB;
    end;
  end;
end;

function TF_ENUMInterfaceDlg.GetSelection : WideString;
begin
  Result := COB_ENum.Text;
end;

end.
