//==============================================================================
//                      >>> FilterDlg.pas <<<
//
//
//    Inhalt      : qs-STAT Filters dialog
//
//    Autor       : OL
//    Erstellt am : 6.2004
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//==============================================================================

unit FilterDlg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  com_common_consts,
  qs_stat_tlb;

type
  TF_FilterDlg = class(TForm)
    P_BB: TPanel;
    BB_OK: TButton;
    BB_Cancel: TButton;
    P_Head: TPanel;
    GB_Part: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ED_Key_1: TEdit;
    ED_Key_2: TEdit;
    ED_Key_3: TEdit;
    BB_Show_3: TButton;
    BB_Show_2: TButton;
    BB_Show_1: TButton;
    CB_Field_1: TCheckBox;
    CB_Field_2: TCheckBox;
    CB_Field_3: TCheckBox;
    ED_Filter_3: TEdit;
    ED_Filter_2: TEdit;
    ED_Filter_1: TEdit;
    BB_Filter_1: TButton;
    BB_Filter_2: TButton;
    BB_Filter_3: TButton;
    GB_Char: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ED_Key_4: TEdit;
    ED_Key_5: TEdit;
    ED_Key_6: TEdit;
    BB_Show_6: TButton;
    BB_Show_5: TButton;
    BB_Show_4: TButton;
    CB_Field_5: TCheckBox;
    CB_Field_4: TCheckBox;
    CB_Field_6: TCheckBox;
    ED_Filter_6: TEdit;
    ED_Filter_5: TEdit;
    ED_Filter_4: TEdit;
    BB_Filter_4: TButton;
    BB_Filter_5: TButton;
    BB_Filter_6: TButton;
    LB_Parts: TListBox;
    LB_Chars: TListBox;
    procedure BB_Filter_1Click(Sender: TObject);
    procedure CB_Field_Click(Sender: TObject);
  private
    IQSSTAT : TQsstatRemoteControl;
    connectionHandle : integer;
    qsstatmodule : integer;
    QueryHandle  : integer;

    KFieldListPart : OleVariant;   // PART Filterliste
    KFieldListChar : OleVariant;   // CHAR Filterliste

    // procedure SetAllDBSelections;
    function GetKFieldNamePart(KFieldKey : integer) : WideString;
    function GetKFieldNameChar(KFieldKey : integer) : WideString;
    function CreateQuery : LongInt;
    function ExecuteQuery : LongInt;
    procedure FreeQuery(QueryHandle : integer);
    function CreateFilter(KFieldList : OleVariant;
                          Item       : Integer;
                          Condition  : WideString) : LongInt;
    function AddFilter( QueryHandle  : integer;
                        FilterHandle : integer;
                        QueryLevel   : integer) : LongInt;
//    procedure FreeFilter(HFilter : Integer);
    procedure KeyToLB( Key         : integer;
                       KResultList : OleVariant;
                       DistList    : Integer);
    procedure SetPartsLB;
    procedure SetCharsLB(SelItem : Integer);

  public
    procedure SetQsStatServer(QSSTAT     : TQsstatRemoteControl;
                              connection : integer;
                              module     : integer);
  end;

var
  F_FilterDlg: TF_FilterDlg;

function FilterSettingsDialog( aOwner     : TComponent;
                               IQSSTAT    : TQsstatRemoteControl;
                               connection : integer;
                               module     : integer) : Integer;

implementation

{$R *.DFM}

function FilterSettingsDialog( aOwner     : TComponent;
                               IQSSTAT    : TQsstatRemoteControl;
                               connection : integer;
                               module     : integer) : Integer;
var
  FilterDialog : TF_FilterDlg;
begin
  result := -1;
  FilterDialog := TF_FilterDlg.Create(aOwner);
  FilterDialog.SetQsStatServer(IQSSTAT, connection, module);
  if FilterDialog.ShowModal = mrOK then
  begin
    result := FilterDialog.ExecuteQuery;
    FilterDialog.FreeQuery(FilterDialog.QueryHandle);
  end;
  FilterDialog.Free;
end;

procedure TF_FilterDlg.SetQsStatServer( QSSTAT : TQsstatRemoteControl;
                                              connection : integer;
                                              module : integer);
begin
  IQSSTAT := QSSTAT;
  connectionHandle := connection;
  qsstatmodule := module;
  KFieldListPart := VarArrayCreate([0,4],varInteger);
  KFieldListChar := VarArrayCreate([0,4],varInteger);
end;

procedure TF_FilterDlg.BB_Filter_1Click(Sender: TObject);
var
  KFieldName : WideString;
begin
  if Sender is TButton then
  begin
    case TButton(Sender).Tag of
      1 :
      begin
        KFieldName := GetKFieldNamePart(StrToIntDef(ED_Key_1.Text, 0));
        if KFieldName <> '' then
        begin
          CB_Field_1.Caption := KFieldName;
          CB_Field_1.Enabled := True;
          ED_Filter_1.Enabled := True;
          BB_Filter_1.Enabled := True;
        end;
      end;
      2 :
      begin
        KFieldName := GetKFieldNamePart(StrToIntDef(ED_Key_2.Text, 0));
        if KFieldName <> '' then
        begin
          CB_Field_2.Caption := KFieldName;
          CB_Field_2.Enabled := True;
          ED_Filter_2.Enabled := True;
          BB_Filter_2.Enabled := True;
        end;
      end;
      3 :
      begin
        KFieldName := GetKFieldNamePart(StrToIntDef(ED_Key_3.Text, 0));
        if KFieldName <> '' then
        begin
          CB_Field_3.Caption := KFieldName;
          CB_Field_3.Enabled := True;
          ED_Filter_3.Enabled := True;
          BB_Filter_3.Enabled := True;
        end;
      end;
      4 :
      begin
        KFieldName := GetKFieldNameChar(StrToIntDef(ED_Key_4.Text, 0));
        if KFieldName <> '' then
        begin
          CB_Field_4.Caption := KFieldName;
          CB_Field_4.Enabled := True;
          ED_Filter_4.Enabled := True;
          BB_Filter_4.Enabled := True;
        end;
      end;
      5 :
      begin
        KFieldName := GetKFieldNameChar(StrToIntDef(ED_Key_5.Text, 0));
        if KFieldName <> '' then
        begin
          CB_Field_5.Caption := KFieldName;
          CB_Field_5.Enabled := True;
          ED_Filter_5.Enabled := True;
          BB_Filter_5.Enabled := True;
        end;
      end;
      6 :
      begin
        KFieldName := GetKFieldNameChar(StrToIntDef(ED_Key_6.Text, 0));
        if KFieldName <> '' then
        begin
          CB_Field_6.Caption := KFieldName;
          CB_Field_6.Enabled := True;
          ED_Filter_6.Enabled := True;
          BB_Filter_6.Enabled := True;
        end;
      end;
    end;
  end;
end;

procedure TF_FilterDlg.CB_Field_Click(Sender: TObject);
var
  rc : integer;
  HFilter,
  HQuery  : LongInt;
begin
  if Sender is TCheckBox then
  begin
    case TCheckBox(Sender).Tag of
      1 :
      begin
        BB_Filter_1.Enabled := CB_Field_1.Checked;
        if not BB_Filter_1.Enabled then KFieldListPart[0] := 0;
      end;
      2 :
      begin
        BB_Filter_2.Enabled := CB_Field_2.Checked;
        if not BB_Filter_2.Enabled then KFieldListPart[1] := 0;
      end;
      3 :
      begin
        BB_Filter_3.Enabled := CB_Field_3.Checked;
        if not BB_Filter_3.Enabled then KFieldListPart[2] := 0;
      end;
      4 :
      begin
        BB_Filter_4.Enabled := CB_Field_4.Checked;
        if not BB_Filter_4.Enabled then KFieldListChar[0] := 0;
      end;
      5 :
      begin
        BB_Filter_5.Enabled := CB_Field_5.Checked;
        if not BB_Filter_5.Enabled then KFieldListChar[1] := 0;
      end;
      6 :
      begin
        BB_Filter_6.Enabled := CB_Field_6.Checked;
        if not BB_Filter_6.Enabled then KFieldListChar[2] := 0;
      end;
    end;
  end;
  if Sender is TButton then
  begin
    HQuery := CreateQuery;
    if HQuery > 0 then
    begin
      if Sender is TButton then
      begin
        case TCheckBox(Sender).Tag of
          1 :
          begin
            if CB_Field_1.Checked then
            begin
              LB_Parts.Clear;
              KFieldListPart[0] := StrToIntDef(ED_Key_1.Text, 0);
              HFilter := CreateFilter(KFieldListPart, 0, ED_Filter_1.Text) ;
              if HFilter >= 0 then
              begin
                rc := AddFilter(HQuery, HFilter, 0);
                if rc > 0 then
                begin
                  SetPartsLB;
                end;
              end;
            end;
          end;
          2 :
          begin
            if CB_Field_2.Checked then
            begin
              LB_Parts.Clear;
              KFieldListPart[1] := StrToIntDef(ED_Key_2.Text, 0);
              HFilter := CreateFilter(KFieldListPart, 1, ED_Filter_2.Text) ;
              if HFilter >= 0 then
              begin
                rc := AddFilter(HQuery, HFilter, 0);
                if rc > 0 then
                begin
                  SetPartsLB;
                end;
              end;
            end;
          end;
          3 :
          begin
            if CB_Field_3.Checked then
            begin
              LB_Parts.Clear;
              KFieldListPart[2] := StrToIntDef(ED_Key_3.Text, 0);
              HFilter := CreateFilter(KFieldListPart, 2, ED_Filter_3.Text) ;
              if HFilter >= 0 then
              begin
                rc := AddFilter(HQuery,
                                HFilter,
                                0);
                if rc > 0 then
                begin
                  SetPartsLB;
                end;
              end;
            end;
          end;
          4 :
          begin
            if CB_Field_4.Checked then
            begin
              LB_Chars.Clear;
              KFieldListChar[0] := StrToIntDef(ED_Key_4.Text, 0);
              HFilter := CreateFilter(KFieldListChar, 0, ED_Filter_4.Text) ;
              if HFilter >= 0 then
              begin
                rc := AddFilter(HQuery, HFilter, 1);
                if rc > 0 then
                begin
                  if LB_Parts.ItemIndex >= 0 then
                  begin
                    SetCharsLB(Integer(LB_Parts.Items.Objects[LB_Parts.ItemIndex]));
                  end;
                end;
              end;
            end;
          end;
          5 :
          begin
            if CB_Field_5.Checked then
            begin
              LB_Chars.Clear;
              KFieldListChar[1] := StrToIntDef(ED_Key_5.Text, 0);
              HFilter := CreateFilter(KFieldListChar, 1, ED_Filter_5.Text) ;
              if HFilter >= 0 then
              begin
                rc := AddFilter(HQuery, HFilter, 1);
                if rc > 0 then
                begin
                  if LB_Parts.ItemIndex >= 0 then
                  begin
                    SetCharsLB(Integer(LB_Parts.Items.Objects[LB_Parts.ItemIndex]));
                  end;
                end;
              end;
            end;
          end;
          6 :
          begin
            if CB_Field_6.Checked then
            begin
              LB_Chars.Clear;
              KFieldListChar[2] := StrToIntDef(ED_Key_6.Text, 0);
              HFilter := CreateFilter(KFieldListChar, 2, ED_Filter_6.Text) ;
              if HFilter >= 0 then
              begin
                rc := AddFilter(HQuery, HFilter, 1);
                if rc > 0 then
                begin
                  if LB_Parts.ItemIndex >= 0 then
                  begin
                    SetCharsLB(Integer(LB_Parts.Items.Objects[LB_Parts.ItemIndex]));
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TF_FilterDlg.KeyToLB( Key         : Integer;
                                      KResultList : OleVariant;
                                      DistList    : integer);
var
 str   : String;
 i, dim : Integer;
begin
  dim := VarArrayDimCount(KResultList);
  if dim > 0 then
  begin
    str := '';
    VarArrayLock(KResultList);
    for i := VarArrayLowBound(KResultList,dim) to VarArrayHighBound(KResultList,dim) do
    begin
      case DistList of
        1 :
        begin
          if KFieldListPart[i] <> 0 then
          begin
            if str = '' then
            begin
              str := str + KResultList[i];
            end else
            begin
              if KResultList[i] <> '' then
              begin
                str := str + ' / ' + KResultList[i];
              end else
                str := str + ' / ' + '---';
              begin
              end;
            end;
          end;
        end;
        2 :
        begin
          if KFieldListChar[i] <> 0 then
          begin
            if str = '' then
            begin
              str := str + KResultList[i];
            end else
            begin
              if KResultList[i] <> '' then
              begin
                str := str + ' / ' + KResultList[i];
              end else
                str := str + ' / ' + '---';
              begin
              end;
            end;
          end;
        end
      end;
    end;
      case DistList of
        1 :
        begin
          LB_Parts.Items.AddObject(str,TObject(key));
        end;
        2 :
        begin
          LB_Chars.Items.AddObject(str,TObject(key));
        end;
      end;  
    VarArrayUnLock(KResultList);
  end;
end;

function TF_FilterDlg.GetKFieldNamePart(KFieldKey : integer) : WideString;
var
  EnumFieldKeyName : IEnumFieldKeyName;
  K_FieldName      : WideString;
  K_FieldKey,
  K_FieldSubKey    : integer;
  rc : integer;
begin
  result := '';
  if IQSSTAT <> nil then
  begin

    EnumFieldKeyName := IQsSTAT as IEnumFieldKeyName;

    K_FieldKey := 0;
    K_FieldSubKey := 0;
    K_FieldName := '';

    rc := EnumFieldKeyName.GetFirstPartField(connectionHandle,
                                             K_FieldKey,
                                             K_FieldSubKey,
                                             K_FieldName);
    while rc = 0 do
    begin
      if (KFieldKey > 0) and (KFieldKey = K_FieldKey) then
      begin
        result := K_FieldName;
        break;
      end;
      rc := EnumFieldKeyName.GetNextPartField(connectionHandle,
                                              K_FieldKey,
                                              K_FieldSubKey,
                                              K_FieldName);
    end;
  end;
end;

function TF_FilterDlg.GetKFieldNameChar(KFieldKey : integer) : WideString;
var
  EnumFieldKeyName : IEnumFieldKeyName;
  K_FieldName      : WideString;
  K_FieldKey,
  K_FieldSubKey    : integer;
  rc : integer;
begin
  result := '';
  if IQSSTAT <> nil then
  begin

    EnumFieldKeyName := IQsSTAT as IEnumFieldKeyName;

    K_FieldKey := 0;
    K_FieldSubKey := 0;
    K_FieldName := '';

    rc := EnumFieldKeyName.GetFirstCharacteristicField(connectionHandle,
                                                       K_FieldKey,
                                                       K_FieldSubKey,
                                                       K_FieldName);
    while rc = 0 do
    begin
      if (KFieldKey > 0) and (KFieldKey = K_FieldKey) then
      begin
        result := K_FieldName;
        break;
      end;
      rc := EnumFieldKeyName.GetNextCharacteristicField(connectionHandle,
                                                        K_FieldKey,
                                                        K_FieldSubKey,
                                                        K_FieldName);
    end;
  end;
end;

function TF_FilterDlg.CreateQuery : LongInt;
var
  IQsSTATQuery : IDataBase;
  rc : Integer;
begin
  result := 0;
  if IQsSTAT <> nil then
  begin
    IQsSTATQuery := IQsSTAT as IDataBase;
    QueryHandle := 0;
    rc := IQsSTATQuery.CreateQuery(connectionHandle, QueryHandle);
    if rc = 0 then
    begin
      result := QueryHandle;
    end;
  end;
end;

function TF_FilterDlg.ExecuteQuery : Integer;
var
  IQsSTATQuery : IDataBase;
  PartFilter   : OleVariant;
  i, rc        : Integer;
begin
  result := -1;
  if IQsSTAT <> nil then
  begin
    IQsSTATQuery := IQsSTAT as IDataBase;

    PartFilter := VarArrayCreate([0,0],varInteger);
    for i := 0 to LB_Parts.Items.Count - 1 do
    begin
      if LB_Parts.Selected[i] then
      begin
        PartFilter[VarArrayHighBound(PartFilter,1)] := Integer(LB_Parts.Items.Objects[i]);
        VarArrayRedim(PartFilter, VarArrayHighBound(PartFilter,1) + 1);
      end;
    end;
    VarArrayRedim(PartFilter, VarArrayHighBound(PartFilter,1) - 1);

    rc := IQsSTATQuery.ExecuteQuery( connectionHandle,
                                     QueryHandle,
                                     PartFilter);
    if rc = 0 then
    begin
      result := 0;
    end;
    FreeQuery(QueryHandle);
  end;
end;

procedure TF_FilterDlg.FreeQuery(QueryHandle : Integer);
var
  IQsSTATQuery : IDataBase;
  rc        : Integer;
begin
  if IQsSTAT <> nil then
  begin
    IQsSTATQuery := IQsSTAT as IDataBase;
    if QueryHandle <> 0 then
    begin
      rc := IQsSTATQuery.FreeQuery( connectionHandle,
                                    QueryHandle);
      if rc = 0 then
      begin
        //ok
      end;
    end;
  end;
end;

function TF_FilterDlg.CreateFilter(KFieldList : OleVariant;
                                         Item       : Integer;
                                         Condition  : WideString) : LongInt;
var
  IQsSTATQuery : IDataBase;
  HFilter, rc  : Integer;
  Cond         : WideString;
begin
  result := -1;
  if IQsSTAT <> nil then
  begin
    IQsSTATQuery := IQsSTAT as IDataBase;

    Cond := '' + Condition;
    rc := IQsSTATQuery.CreateFilter( connectionHandle,
                                     K_FIELDS_C,
                                     KFieldList[Item],
                                     Cond,
                                     COMP_OP_LIKE_C,
                                     HFilter);
    if rc = 0 then
    begin
      result := HFilter;
    end;
  end;
end;

function TF_FilterDlg.AddFilter(QueryHandle  : Integer;
                                      FilterHandle : Integer;
                                      QueryLevel   : Integer) : LongInt;
var
  IQsSTATQuery : IDataBase;
  rc : Integer;
begin
  result := 0;
  if IQsSTAT <> nil then
  begin

    IQsSTATQuery := IQsSTAT as IDataBase;
    if QueryHandle <> 0 then;
    begin
      IQsSTATQuery := IQsSTAT as IDataBase;
      rc := IQsSTATQuery.AddFilterToQuery( connectionHandle,
                                           QueryHandle,      // QueryHandle
                                           FilterHandle,     // FilterHandle
                                           QueryLevel,       // Part Key sequence
                                           0,                // Part Key
                                           0);               // Char Key
      if rc = 0 then
      begin
        result := QueryHandle;
      end;
    end;
  end;
end;
{
procedure TF_FilterDlg.FreeFilter(HFilter : Integer);
var
  IQsSTATQuery : IDataBase;
  rc           : Integer;
begin
  if IQsSTAT <> nil then
  begin
    IQsSTATQuery := IQsSTAT as IDataBase;
    if QueryHandle <> 0 then
    begin
      if HFilter >= 0 then
      begin
        rc := IQsSTATQuery.FreeFilter( connectionHandle,
                                       HFilter);
        if rc = 0 then
        begin
          //ok
        end;
      end;
    end;
  end;
end;
}
procedure TF_FilterDlg.SetPartsLB;
var
  IQsSTATQuery    : IDataBase;
  KPartResultList : OleVariant;
  Key, rc         : Integer;
begin
  if IQsSTAT <> nil then
  begin
    IQsSTATQuery := IQsSTAT as IDataBase;

    rc := IQsSTATQuery.GetFirstPartQuery( connectionHandle,                     
                                          QueryHandle,
                                          KFieldListPart,
                                          Key,
                                          KPartResultList);
    while rc = S_OK do
    begin
      if Key > 0 then
      begin
        KeyToLB(Key, KPartResultList, 1);
      end;
      rc := IQsSTATQuery.GetNextPartQuery(connectionHandle,
                                          QueryHandle,
                                          Key,
                                          KPartResultList);
    end;
  end;
end;

procedure TF_FilterDlg.SetCharsLB(SelItem : Integer);
var
  IQsSTATQuery    : IDataBase;
  KCharResultList : OleVariant;
  Key, rc         : Integer;
begin
  if IQsSTAT <> nil then
  begin
    IQsSTATQuery := IQsSTAT as IDataBase;

    rc := IQsSTATQuery.GetFirstCharQuery( connectionHandle,
                                          QueryHandle,
                                          KFieldListChar,
                                          SelItem,
                                          Key,
                                          KCharResultList);
    while rc = S_OK do
    begin
      if Key > 0 then
      begin
        KeyToLB(Key, KCharResultList, 2);
      end;
      rc := IQsSTATQuery.GetNextCharQuery( connectionHandle,
                                           QueryHandle,
                                           Key,
                                           KCharResultList);
    end;
  end;
end;

end.
