//==============================================================================
//                      >>> GraphicDlg.pas <<<
//
//
//    Inhalt      : qs-STAT Graphic dialog
//
//    Autor       : OL
//    Erstellt am : 6.2004
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//==============================================================================
unit GraphicDlg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  qs_stat_tlb;

type
  TF_GraphicDlg = class(TForm)
    P_BB: TPanel;
    BB_OK: TButton;
    BB_Cancel: TButton;
    P_Head: TPanel;
    GB_ENum: TGroupBox;
    COB_ENUMGraphic: TComboBox;
    GB_Keys: TGroupBox;
    LA_Key: TLabel;
    LA_SubKey: TLabel;
    ED_Key: TEdit;
    ED_SubKey: TEdit;
    GB_PartChar: TGroupBox;
    LA_PartNr: TLabel;
    LA_CharNr: TLabel;
    ED_Parts: TEdit;
    ED_Chars: TEdit;
    GroupBox3: TGroupBox;
    LA_Part: TLabel;
    LA_Char: TLabel;
    LA_Value: TLabel;
    LA_Page: TLabel;
    GB_X: TGroupBox;
    ED_Part_X: TEdit;
    ED_Char_X: TEdit;
    ED_Value_X: TEdit;
    GB_Y: TGroupBox;
    ED_Part_Y: TEdit;
    ED_Char_Y: TEdit;
    ED_Value_Y: TEdit;
    BB_PageBWD: TButton;
    BB_PageFWD: TButton;
    ED_PageNr: TEdit;
    BB_Apply: TButton;
    procedure BB_ApplyClick(Sender: TObject);
    procedure BB_PageFWDClick(Sender: TObject);
    procedure BB_PageBWDClick(Sender: TObject);
  private
    Owner        : TComponent;
    IQsStat      : ITQsstatRemoteControl;
    qsstatHandle : LongInt;
    qs_Module    : Integer;
    procedure InitializeCOB_ENumGraphic;
    procedure InitializeCOB_Parts;
    procedure InitializeCOB_Chars;
  public
    procedure SetParameters( aOwner    : TComponent;
                             SvrObj    : ITQsstatRemoteControl;
                             SvrHandle : LongInt;
                             CurModule : Integer;
                             Key       : Integer;
                             SubKey    : Integer;
                             Part_X    : Integer;
                             Char_X    : Integer;
                             Value_X   : Integer;
                             Part_Y    : Integer;
                             Char_Y    : Integer;
                             Value_Y   : Integer;
                             CurPage   : Integer);
    procedure GetParameters( var Key       : Integer;
                             var SubKey    : Integer;
                             var Part_X    : Integer;
                             var Char_X    : Integer;
                             var Value_X   : Integer;
                             var Part_Y    : Integer;
                             var Char_Y    : Integer;
                             var Value_Y   : Integer;
                             var CurPage   : Integer);
  end;

var
  F_GraphicDlg: TF_GraphicDlg;

implementation

{$R *.DFM}

uses
  DelphiCOMClient2form;

//------------------------------------------------------------------------------
// Set Parameters
//------------------------------------------------------------------------------
procedure TF_GraphicDlg.SetParameters( aOwner    : TComponent;
                                       SvrObj    : ITQsstatRemoteControl;
                                       SvrHandle : LongInt;
                                       CurModule : Integer;
                                       Key       : Integer;
                                       SubKey    : Integer;
                                       Part_X    : Integer;
                                       Char_X    : Integer;
                                       Value_X   : Integer;
                                       Part_Y    : Integer;
                                       Char_Y    : Integer;
                                       Value_Y   : Integer;
                                       CurPage   : Integer);
begin
  Owner        := aOwner;
  IQsStat      := SvrObj;
  qsstatHandle := SvrHandle;
  qs_Module    := CurModule;

  InitializeCOB_ENumGraphic;
  InitializeCOB_Parts;
  InitializeCOB_Chars;

  ED_Key.Text     := IntToStr(Key);
  ED_SubKey.Text  := IntToStr(SubKey);
  ED_Part_X.Text  := IntToStr(Part_X);
  ED_Char_X.Text  := IntToStr(Char_X);
  ED_Value_X.Text := IntToStr(Value_X);
  ED_Part_Y.Text  := IntToStr(Part_Y);
  ED_Char_Y.Text  := IntToStr(Char_Y);
  ED_Value_Y.Text := IntToStr(Value_Y);
  ED_PageNr.Text  := IntToStr(CurPage);
end;

//------------------------------------------------------------------------------
// Get Parameters
//------------------------------------------------------------------------------
procedure TF_GraphicDlg.GetParameters( var Key       : Integer;
                                       var SubKey    : Integer;
                                       var Part_X    : Integer;
                                       var Char_X    : Integer;
                                       var Value_X   : Integer;
                                       var Part_Y    : Integer;
                                       var Char_Y    : Integer;
                                       var Value_Y   : Integer;
                                       var CurPage   : Integer);
begin
  Key     := StrToIntDef(ED_Key.Text, 0);
  SubKey  := StrToIntDef(ED_SubKey.Text, 0);
  Part_X  := StrToIntDef(ED_Part_X.Text, 0);
  Char_X  := StrToIntDef(ED_Char_X.Text, 0);
  Value_X := StrToIntDef(ED_Value_X.Text, 0);
  Part_Y  := StrToIntDef(ED_Part_Y.Text, 0);
  Char_Y  := StrToIntDef(ED_Char_Y.Text, 0);
  Value_Y := StrToIntDef(ED_Value_Y.Text, 0);
  CurPage := StrToIntDef(ED_PageNr.Text, 0);
end;

//------------------------------------------------------------------------------
// ENUM Interface -> Graphic
//------------------------------------------------------------------------------
procedure TF_GraphicDlg.InitializeCOB_ENumGraphic;
var
  IQsSTATGraphic : IEnumGraphic;
  GraphicKey     : Integer;
  GraphicName    : WideString;
  rc             : integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_ENUMGraphic.Clear;

    IQsSTATGraphic := IQsSTAT as IEnumGraphic;

    GraphicKey := 0;
    GraphicName := '';

    rc := IQsSTATGraphic.GetFirstGraphic(qsstatHandle,
                                         qs_Module,
                                         GraphicKey,
                                         GraphicName);
    while rc = 0 do
    begin
      COB_ENumGraphic.Items.Add(GraphicName + ' (' + IntToStr(GraphicKey) + ')');
      rc := IQsSTATGraphic.GetNextGraphic(qsstatHandle,
                                          qs_Module,
                                          GraphicKey,
                                          GraphicName);

    end;
    //set focus on first item
    if COB_ENumGraphic.Items.Count > 0 then COB_ENumGraphic.ItemIndex := 0;
  end;
end;

//------------------------------------------------------------------------------
// Get parts
//------------------------------------------------------------------------------
procedure TF_GraphicDlg.InitializeCOB_Parts;
var
  rc, value      : integer;
begin
  if IQsSTAT <> nil then
  begin
    rc := IQsSTAT.GetGlobalInfo(qsstatHandle,
                                0,
                                0,
                                1,
                                value);
    if rc = 0 then
    begin
      ED_Parts.Text := IntToStr(value);
    end;
  end;
end;

//------------------------------------------------------------------------------
// Get Chars
//------------------------------------------------------------------------------
procedure TF_GraphicDlg.InitializeCOB_Chars;
var
  rc, value      : integer;
begin
  if IQsSTAT <> nil then
  begin
    rc := IQsSTAT.GetGlobalInfo(qsstatHandle,
                                1,
                                0,
                                3,
                                value);
    if rc = 0 then
    begin
      ED_Chars.Text := IntToStr(value);
    end;
  end;
end;

procedure TF_GraphicDlg.BB_ApplyClick(Sender: TObject);
begin
  F_ClientForm.GetGraphicFromServer(StrToIntDef(ED_Key.Text, 0),
                                    StrToIntDef(ED_SubKey.Text, 0),
                                    StrToIntDef(ED_Part_X.Text, 0),
                                    StrToIntDef(ED_Char_X.Text, 0),
                                    StrToIntDef(ED_Value_X.Text, 0),
                                    StrToIntDef(ED_Part_Y.Text, 0),
                                    StrToIntDef(ED_Char_Y.Text, 0),
                                    StrToIntDef(ED_Value_Y.Text, 0),
                                    StrToIntDef(ED_PageNr.Text, 0),
                                    0,0,0,0,
                                    1,
                                    1,
                                    0);
end;

procedure TF_GraphicDlg.BB_PageBWDClick(Sender: TObject);
var
  num : Integer;
begin
  if StrToIntDef(ED_PageNr.Text, 0) > 1 then
  begin
    num := StrToIntDef(ED_PageNr.Text, 0);
    ED_PageNr.Text := IntToStr(num - 1);
  end;
end;

procedure TF_GraphicDlg.BB_PageFWDClick(Sender: TObject);
var
  num : Integer;
begin
  num := StrToIntDef(ED_PageNr.Text, 0);
  ED_PageNr.Text := IntToStr(num + 1);
end;

end.
