//==============================================================================
//                      >>> LoginDlg.pas <<<
//
//
//    Inhalt      : Login dialog of Delphi COM Client 2
//
//    Autor       : OL
//    Erstellt am : 6.2004
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//==============================================================================
unit LoginDlg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  qs_stat_tlb;

type
  TF_Login = class(TForm)
    P_BB: TPanel;
    BB_OK: TButton;
    BB_Cancel: TButton;
    P_Head: TPanel;
    GroupBox: TGroupBox;
    LA_User: TLabel;
    LA_Pwd: TLabel;
    LA_Module: TLabel;
    LA_Language: TLabel;
    COB_User: TComboBox;
    ED_Pwd: TEdit;
    COB_Module: TComboBox;
    COB_Language: TComboBox;
  private
    IQsStat : ITQsstatRemoteControl;
    procedure InitializeCOBUser;
    procedure InitializeCOBLanguage;
    procedure InitializeCOBModule;
  public
    procedure SetServerObj( SvrObj : ITQsstatRemoteControl);
    procedure GetParameters( var User     : AnsiString;
                             var Pwd      : AnsiString;
                             var Module   : integer;
                             var Language : integer);

  end;

var
  F_Login: TF_Login;

implementation

{$R *.DFM}

procedure TF_Login.SetServerObj(SvrObj: ITQsstatRemoteControl);
begin
  IQsStat := SvrObj;
  InitializeCOBLanguage;
  InitializeCOBModule;
  InitializeCOBUser;
  ED_Pwd.Text  := 'Superuser';
end;

procedure TF_Login.InitializeCOBUser;
var
  IQsSTATUser    : IEnumUser;
  LangName       : WideString;
  rc             : integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_User.Clear;
    try
      IQsSTATUser := IQsSTAT as IEnumUser;
      LangName  := '';

      rc := IQsSTATUser.GetFirstUser(LangName);
      while rc = 0 do
      begin
        COB_User.Items.Add(LangName);
        rc := IQsSTATUser.GetNextUser(LangName);
      end;
      if COB_User.Items.Count > 0 then COB_User.ItemIndex := 0;    
    except
      // ltere Version des Server
      // older Server version
      COB_Language.Style := csDropDown;
    end;
  end;
end;

// Setting available modules
procedure TF_Login.InitializeCOBModule;
var
  IQsSTATModules : IEnumModule;
  moduleKey      : integer;
  moduleName     : WideString;
  rc             : integer;
begin
  if IQsSTAT <> nil then
  begin
    // Get the available modules from the server
    COB_Module.Clear;
    COB_Module.Style := csDropDown;
    IQsSTATModules := IQsSTAT as IEnumModule;
    moduleKey := 0;
    moduleName := '';
    rc := IQsSTATModules.GetFirstModule(0,moduleKey,moduleName);
    while rc = 0 do
    begin
      COB_Module.Items.Add(Inttostr(moduleKey) + ' - ' + moduleName);
      rc := IQsSTATModules.GetNextModule(0,moduleKey,moduleName);
    end;
    if COB_Module.Items.Count > 0 then
    begin
      COB_Module.ItemIndex := 0;
    end else
    begin
      COB_Module.Style := csDropDown;
    end;
  end;
end;

procedure TF_Login.InitializeCOBLanguage;
var
  IQsSTATLang    : IEnumLanguage;
  LangKey        : integer;
  LangShortName  : WideString;
  LangName       : WideString;
  rc             : integer;
begin
  if IQsSTAT <> nil then
  begin
      COB_Language.Style := csDropDown;
//    COB_Language.Style := csDropDownList;
    COB_Language.Clear;
    IQsSTATLang := IQsSTAT as IEnumLanguage;
    LangKey        := 0;
    LangShortName  := '';
    LangName       := '';

    rc := IQsSTATLang.GetFirstLanguage(0,LangName,LangShortName,LangKey);
    while rc = 0 do
    begin
      COB_Language.Items.Add(Inttostr(LangKey) + ' - ' + LangName);
      rc := IQsSTATLang.GetNextLanguage(0,LangName,LangShortName,LangKey);
    end;
    if COB_Language.Items.Count > 0 then
    begin
      COB_Language.ItemIndex := 0;
    end else
    begin
      COB_Language.Style := csDropDown;
    end;
  end;
end;

procedure TF_Login.GetParameters(var User, Pwd: AnsiString;
  var Module: integer; var Language: integer);
var
  CobStr : AnsiString;
  s1     : AnsiString;
begin
  //
  User := COB_User.Text;
  Pwd  := ED_Pwd.Text;

  CobStr := COB_Module.Text;
  if CobStr <> '' then
  begin
    s1 := Copy(CobStr,1,Pos(' - ',CobStr)-1);
    try
      Module := StrToInt(s1);
    except
      try
        Module := StrToInt(COB_Module.Text);
      except
        Module := 20;
      end;
    end;
  end;

  CobStr := COB_Language.Text;
  if CobStr <> '' then
  begin
    s1 := Copy(CobStr,1,Pos(' - ',CobStr)-1);
    try
      Language := StrToInt(s1);
    except
      try
        Language := StrToInt(COB_Language.Text);
      except
        Language := 49;
      end;
    end;
  end;
end;

end.
