//==============================================================================
//                      >>> PartDlg.pas <<<
//
//
//    Inhalt      : qs-STAT Parts dialog
//
//    Autor       : OL
//    Erstellt am : 6.2004
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//==============================================================================

unit PartDlg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  com_common_consts,
  qs_stat_tlb;

type
  TF_PartDlg = class(TForm)
    P_BB: TPanel;
    BB_OK: TButton;
    BB_Cancel: TButton;
    P_Head: TPanel;
    GB_ENum: TGroupBox;
    COB_ENUMPart: TComboBox;
    GB_Keys: TGroupBox;
    LA_Key: TLabel;
    LA_SubKey: TLabel;
    ED_Key: TEdit;
    ED_SubKey: TEdit;
    GB_PartChar: TGroupBox;
    LA_Part: TLabel;
    ED_Part: TEdit;
    GroupBox3: TGroupBox;
    LA_Value: TLabel;
    BB_GetValue: TButton;
    ED_ValueOut: TEdit;
    procedure BB_GetValueClick(Sender: TObject);
  private
    IQsStat      : ITQsstatRemoteControl;
    qsstatHandle : LongInt;
    procedure InitializeCOB_ENumPart;
  public
    procedure SetParameters( SvrObj    : ITQsstatRemoteControl;
                             SvrHandle : LongInt);
  end;

var
  F_PartDlg: TF_PartDlg;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
// Set Parameters
//------------------------------------------------------------------------------
procedure TF_PartDlg.SetParameters( SvrObj    : ITQsstatRemoteControl;
                                    SvrHandle : LongInt);
begin
  IQsStat      := SvrObj;
  qsstatHandle := SvrHandle;
  InitializeCOB_ENumPart;
end;

//------------------------------------------------------------------------------
// ENUM Interface -> Report
//------------------------------------------------------------------------------
procedure TF_PartDlg.InitializeCOB_ENumPart;
var
  IqsSTATKField    : IEnumFieldKeyName;
  KFieldKey        : Integer;
  KFieldSubKey     : Integer;
  KFieldName       : WideString;
  rc               : Integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_ENumPart.Clear;

    IqsSTATKField := IQsSTAT as IEnumFieldKeyName;

    KFieldKey      := 0;
    KFieldSubKey   := 0;
    KFieldName     := '';

    rc := IqsSTATKField.GetFirstPartField(qsstatHandle,
                                          KFieldKey,
                                          KFieldSubKey,
                                          KFieldName);
    while rc = 0 do
    begin
      COB_ENumPart.Items.Add(KFieldName + ' (' + IntToStr(KFieldKey) + ')');
      rc := IqsSTATKField.GetNextPartField( qsstatHandle,
                                            KFieldKey,
                                            KFieldSubKey,
                                            KFieldName);

    end;
    //set focus on first item
    if COB_ENumPart.Items.Count > 0 then COB_ENumPart.ItemIndex := 0;
  end;
end;

procedure TF_PartDlg.BB_GetValueClick(Sender: TObject);
var
  ValueText : WideString;
  Key       : Integer;
  Part      : Integer;
  rc        : integer;
begin
  if IQsSTAT <> nil then
  begin
    ED_ValueOut.Text := '';

    Key  :=  StrToIntDef(ED_Key.Text, 0);
    Part :=  StrToIntDef(ED_Part.Text, 0);

    rc := IQsSTAT.GetPartInfo(qsstatHandle,
                              Key,
                              Part,
                              0,
                              ValueText);
    if rc = 0 then
    begin
      ED_ValueOut.Text := ValueText;
    end;
  end;
end;


end.
