//==============================================================================
//                      >>> ReportDlg.pas <<<
//
//
//    Inhalt      : qs-STAT Report dialog
//
//    Autor       : OL
//    Erstellt am : 6.2004
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//==============================================================================
unit ReportDlg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  qs_stat_tlb;

type
  TF_ReportDlg = class(TForm)
    P_BB: TPanel;
    BB_OK: TButton;
    BB_Cancel: TButton;
    P_Head: TPanel;
    GB_ENum: TGroupBox;
    COB_ENUMReport: TComboBox;
    GroupBox3: TGroupBox;
    La_PageCount: TLabel;
    ED_PageCount: TEdit;
    BB_GetPages: TButton;
    GroupBox1: TGroupBox;
    LA_Part: TLabel;
    LA_Char: TLabel;
    LA_Value: TLabel;
    Label1: TLabel;
    GB_X: TGroupBox;
    ED_Part_X: TEdit;
    ED_Char_X: TEdit;
    ED_Value_X: TEdit;
    GB_Y: TGroupBox;
    ED_Part_Y: TEdit;
    ED_Char_Y: TEdit;
    ED_Value_Y: TEdit;
    ED_PageNr: TEdit;
    BB_PageBWD: TButton;
    BB_PageFWD: TButton;
    BB_Apply: TButton;
    procedure BB_GetPagesClick(Sender: TObject);
    procedure BB_PageFWDClick(Sender: TObject);
    procedure BB_PageBWDClick(Sender: TObject);
    procedure BB_ApplyClick(Sender: TObject);
  private
    IQsStat      : ITQsstatRemoteControl;
    qsstatHandle : LongInt;
    ReportFileNameList : TStringList;
    procedure InitializeCOB_ENumReport;
    function GetReportFileName : WideString;
  public
    procedure SetParameters( SvrObj    : ITQsstatRemoteControl;
                             SvrHandle : LongInt;
                             Part_X    : Integer;
                             Char_X    : Integer;
                             Value_X   : Integer;
                             Part_Y    : Integer;
                             Char_Y    : Integer;
                             Value_Y   : Integer;
                             CurPage   : Integer);
    procedure GetParameters( var ReportName : AnsiString;
                             var Part_X     : Integer;
                             var Char_X     : Integer;
                             var Value_X    : Integer;
                             var Part_Y     : Integer;
                             var Char_Y     : Integer;
                             var Value_Y    : Integer;
                             var CurPage    : Integer);
    destructor Destroy; override;
  end;

var
  F_ReportDlg: TF_ReportDlg;

implementation

{$R *.DFM}

uses
  DelphiCOMClient2form;


destructor TF_ReportDlg.Destroy;
begin
  if ReportFileNameList <> nil then
  begin
    ReportFileNameList.Free;
  end;  
  inherited;
end;

//------------------------------------------------------------------------------
// Set Parameters
//------------------------------------------------------------------------------
procedure TF_ReportDlg.SetParameters(SvrObj    : ITQsstatRemoteControl;
                                     SvrHandle : LongInt;
                                     Part_X    : Integer;
                                     Char_X    : Integer;
                                     Value_X   : Integer;
                                     Part_Y    : Integer;
                                     Char_Y    : Integer;
                                     Value_Y   : Integer;
                                     CurPage   : Integer);
begin
  IQsStat      := SvrObj;
  qsstatHandle := SvrHandle;

  ED_Part_X.Text  := IntToStr(Part_X);
  ED_Char_X.Text  := IntToStr(Char_X);
  ED_Value_X.Text := IntToStr(Value_X);
  ED_Part_Y.Text  := IntToStr(Part_Y);
  ED_Char_Y.Text  := IntToStr(Char_Y);
  ED_Value_Y.Text := IntToStr(Value_Y);
  ED_PageNr.Text  := IntToStr(CurPage);

  InitializeCOB_ENumReport;
end;

//------------------------------------------------------------------------------
// Get Parameters
//------------------------------------------------------------------------------
procedure TF_ReportDlg.GetParameters( var ReportName : AnsiString;
                                      var Part_X     : Integer;
                                      var Char_X     : Integer;
                                      var Value_X    : Integer;
                                      var Part_Y     : Integer;
                                      var Char_Y     : Integer;
                                      var Value_Y    : Integer;
                                      var CurPage    : Integer);
begin
  Part_X  := StrToIntDef(ED_Part_X.Text, 0);
  Char_X  := StrToIntDef(ED_Char_X.Text, 0);
  Value_X := StrToIntDef(ED_Value_X.Text, 0);
  Part_Y  := StrToIntDef(ED_Part_Y.Text, 0);
  Char_Y  := StrToIntDef(ED_Char_Y.Text, 0);
  Value_Y := StrToIntDef(ED_Value_Y.Text, 0);
  CurPage := StrToIntDef(ED_PageNr.Text, 0);
  ReportName := GetReportFileName;
end;

//------------------------------------------------------------------------------
// ENUM Interface -> Report
//------------------------------------------------------------------------------
procedure TF_ReportDlg.InitializeCOB_ENumReport;
var
  IQsSTATReport  : IEnumReport;
  ReportKey      : Integer;
  ReportName     : WideString;
  ReportFileName : WideString;
  rc             : integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_ENUMReport.Clear;

    IQsSTATReport := IQsSTAT as IEnumReport;

    ReportKey      := 0;
    ReportName     := '';
    ReportFileName := '';
    ReportFileNameList := TStringList.Create;
    ReportFileNameList.Clear;

    rc := IQsSTATReport.GetFirstReport(qsstatHandle,
                                       ReportKey,
                                       ReportName,
                                       ReportFileName);
    while rc = 0 do
    begin
      COB_ENumReport.Items.Add(ReportName + '/' +
                               ReportFileName + ' (' + IntToStr(ReportKey) + ')');
      ReportFileNameList.Add(ReportFileName);
      rc := IQsSTATreport.GetNextReport(qsstatHandle,
                                        ReportKey,
                                        ReportName,
                                        ReportFileName);
    end;
    //set focus on first item
    if COB_ENumReport.Items.Count > 0 then COB_ENumReport.ItemIndex := 0;
  end;
end;

procedure TF_ReportDlg.BB_GetPagesClick(Sender: TObject);
var
  PageCount : LongInt;
  ReportFName, str : WideString;
begin
  if IQsSTAT <> nil then
  begin
    if COB_ENumReport.ItemIndex >= 0 then
    begin
      str := COB_ENumReport.Items.Strings[COB_ENumReport.ItemIndex];
      ReportFName := GetReportFileName;
      IQsSTAT.GetReportPages(qsstatHandle,
                             ReportFName,
                             PageCount);

      if IntToStr(PageCount) <> '' then
      begin
        ED_PageCount.Text := IntToStr(PageCount);
      end else
      begin
        ED_PageCount.Text := '';
      end;
    end;
  end;
end;

procedure TF_ReportDlg.BB_PageBWDClick(Sender: TObject);
var
  num : Integer;
begin
  if StrToIntDef(ED_PageNr.Text, 0) > 1 then
  begin
    num := StrToIntDef(ED_PageNr.Text, 0);
    ED_PageNr.Text := IntToStr(num - 1);
  end;
end;

procedure TF_ReportDlg.BB_PageFWDClick(Sender: TObject);
var
  num : Integer;
begin
  if StrToIntDef(ED_PageNr.Text, 0) < StrToIntDef(ED_PageCount.Text, 0) then
  begin
    num := StrToIntDef(ED_PageNr.Text, 0);
    ED_PageNr.Text := IntToStr(num + 1);
  end;
end;

procedure TF_ReportDlg.BB_ApplyClick(Sender: TObject);
var
  ReportName : AnsiString;
begin
  ReportName := GetReportFileName;

  F_ClientForm.GetReportFromServer( ReportName,
                                    StrToIntDef(ED_Part_X.Text, 0),
                                    StrToIntDef(ED_Char_X.Text, 0),
                                    StrToIntDef(ED_Value_X.Text, 0),
                                    StrToIntDef(ED_Part_Y.Text, 0),
                                    StrToIntDef(ED_Char_Y.Text, 0),
                                    StrToIntDef(ED_Value_Y.Text, 0),
                                    StrToIntDef(ED_PageNr.Text, 0),
                                    0);
end;

function TF_ReportDlg.GetReportFileName : WideString;
begin
  result := '';
  if ReportFileNameList.Count > 0 then
  begin
    if COB_ENumReport.ItemIndex >= 0 then
    begin
      result := ReportFileNameList.Strings[COB_ENumReport.ItemIndex];
    end;
  end;
end;

end.
