//==============================================================================
//                      >>> StatResultDlg.pas <<<
//
//
//    Inhalt      : qs-STAT Stat Result dialog
//
//    Autor       : OL
//    Erstellt am : 6.2004
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//==============================================================================

unit StatResultDlg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  qs_stat_tlb;

type
  TF_StatResult = class(TForm)
    P_BB: TPanel;
    BB_OK: TButton;
    BB_Cancel: TButton;
    P_Head: TPanel;
    GB_ENum: TGroupBox;
    COB_ENUMStatResult: TComboBox;
    GB_Keys: TGroupBox;
    LA_Key: TLabel;
    LA_SubKey: TLabel;
    ED_Key: TEdit;
    ED_SubKey: TEdit;
    GroupBox3: TGroupBox;
    LA_Part: TLabel;
    LA_Char: TLabel;
    LA_Page: TLabel;
    BB_Apply: TButton;
    ED_ValueOut: TEdit;
    GB_PartChar: TGroupBox;
    LA_PartNr: TLabel;
    LA_CharNr: TLabel;
    ED_Parts: TEdit;
    ED_Chars: TEdit;
    GB_Transform: TGroupBox;
    RB_NotTransform: TRadioButton;
    RB_Transformed: TRadioButton;
    RB_ReTransformed: TRadioButton;
    ED_Part: TEdit;
    ED_Char: TEdit;
    procedure BB_ApplyClick(Sender: TObject);
  private
    IQsStat      : ITQsstatRemoteControl;
    qsstatHandle : LongInt;
    qs_Module    : Integer;
    procedure InitializeCOB_ENumStatResult;
    procedure InitializeCOB_Parts;
    procedure InitializeCOB_Chars;
    procedure GetStatResultExt;
  public
    procedure SetParameters( SvrObj    : ITQsstatRemoteControl;
                             SvrHandle : LongInt;
                             CurModule : Integer;
                             Key       : Integer;
                             SubKey    : Integer;
                             Part      : Integer;
                             Char      : Integer);
  end;

var
  F_StatResult: TF_StatResult;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
// Set Parameters
//------------------------------------------------------------------------------
procedure TF_StatResult.SetParameters( SvrObj    : ITQsstatRemoteControl;
                                       SvrHandle : LongInt;
                                       CurModule : Integer;
                                       Key       : Integer;
                                       SubKey    : Integer;
                                       Part      : Integer;
                                       Char      : Integer);
begin
  IQsStat      := SvrObj;
  qsstatHandle := SvrHandle;
  qs_Module    := CurModule;

  InitializeCOB_ENumStatResult;
  InitializeCOB_Parts;
  InitializeCOB_Chars;

  ED_Key.Text     := IntToStr(Key);
  ED_SubKey.Text  := IntToStr(SubKey);
  ED_Part.Text  := IntToStr(Part);
  ED_Char.Text  := IntToStr(Char);
end;

//------------------------------------------------------------------------------
// ENUM Interface -> Graphic
//------------------------------------------------------------------------------
procedure TF_StatResult.InitializeCOB_ENumStatResult;
var
  IQsSTATStatistic : IEnumStatResults;
  StatKey          : Integer;
  StatName         : WideString;
  rc               : integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_ENUMStatResult.Clear;

    IQsSTATStatistic := IQsSTAT as IEnumStatResults;

    StatKey  := 0;
    StatName := '';

    rc := IQsSTATStatistic.GetFirstStatResult(qsstatHandle,
                                              qs_Module,
                                              StatKey,
                                              StatName);
    while rc = 0 do
    begin
      COB_ENumStatResult.Items.Add(StatName + ' (' + IntToStr(StatKey) + ')');
      rc := IQsSTATStatistic.GetNextStatResult(qsstatHandle,
                                               qs_Module,
                                               StatKey,
                                               StatName);
    end;
    //set focus on first item
    if COB_ENumStatResult.Items.Count > 0 then COB_ENumStatResult.ItemIndex := 0;
  end;
end;

//------------------------------------------------------------------------------
// Get parts
//------------------------------------------------------------------------------
procedure TF_StatResult.InitializeCOB_Parts;
var
  rc, value      : integer;
begin
  if IQsSTAT <> nil then
  begin
    rc := IQsSTAT.GetGlobalInfo(qsstatHandle,
                                0,
                                0,
                                1,
                                value);
    if rc = 0 then
    begin
      ED_Parts.Text := IntToStr(value);
    end;
  end;
end;

//------------------------------------------------------------------------------
// Get Chars
//------------------------------------------------------------------------------
procedure TF_StatResult.InitializeCOB_Chars;
var
  rc, value      : integer;
begin
  if IQsSTAT <> nil then
  begin
    rc := IQsSTAT.GetGlobalInfo(qsstatHandle,
                                1,
                                0,
                                3,
                                value);
    if rc = 0 then
    begin
      ED_Chars.Text := IntToStr(value);
    end;
  end;
end;

procedure TF_StatResult.BB_ApplyClick(Sender: TObject);
begin
  GetStatResultExt;
end;

procedure TF_StatResult.GetStatResultExt;
var
  TranformVal : Integer;
  StatResStr1 : WideString;
  StatResStr2 : WideString;
  StatResStr3 : WideString;
  StatResStr4 : WideString;
  StatResStr5 : WideString;
  StatResDbl1 : Double;
  StatResDbl2 : Double;
  StatResDbl3 : Double;
  StatResDbl4 : Double;
  StatResDbl5 : Double;
  ResCount    : Integer;
  OutputType  : Integer;
  rc          : integer;
begin
  OutputType := 4; // contents of stat. result

  TranformVal := 0; //non transformed
  //select transform value
  if RB_Transformed.Checked then
  begin
    TranformVal := 1;
  end;
  if RB_ReTransformed.Checked then
  begin
    TranformVal := 2;
  end;

  if IQsSTAT <> nil then
  begin
    rc := IQsStat.GetStatResultEx( qsstatHandle,
                                   StrToIntDef(ED_Part.Text, 0),
                                   StrToIntDef(ED_Char.Text, 0),
                                   0,
                                   StrToIntDef(ED_Key.Text, 0),
                                   StrToIntDef(ED_SubKey.Text, 0),
                                   OutputType,
                                   TranformVal,
                                   0, 0,
                                   StatResStr1,
                                   StatResStr2,
                                   StatResStr3,
                                   StatResStr4,
                                   StatResStr5,
                                   ResCount,
                                   StatResDbl1,
                                   StatResDbl2,
                                   StatResDbl3,
                                   StatResDbl4,
                                   StatResDbl5);

    if rc = 0 then
    begin
      ED_ValueOut.Text := StatResStr1;
    end;
  end;
end;

end.
