//==============================================================================
//                      >>> TransmitDlg.pas <<<
//
//
//    Inhalt      : qs-STAT Online Transmition dialog
//
//    Autor       : OL
//    Erstellt am : 6.2004
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//==============================================================================

unit TransmitDlg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  Dialogs,
  ExtCtrls,
  com_common_consts,
  qs_stat_tlb;

type
  TF_TransmitDlg = class(TForm)
    FileOpenDialog: TOpenDialog;
    P_BB: TPanel;
    BB_OK: TButton;
    BB_Cancel: TButton;
    Panel1: TPanel;
    GB_HeadDataFile: TGroupBox;
    ED_HeadDataFile: TEdit;
    BB_OpenHeadDataFile: TButton;
    GB_DataFile: TGroupBox;
    ED_DataFile: TEdit;
    BB_OpenDataFile: TButton;
    GB_DataText: TGroupBox;
    Memo_Data: TMemo;
    BB_Apply_DFD: TButton;
    BB_Apply_DFX: TButton;
    BB_Apply_TEXT: TButton;
    CB_Transmit: TCheckBox;
    procedure BB_OpenHeadDataFileClick(Sender: TObject);
    procedure BB_OpenDataFileClick(Sender: TObject);
    procedure BB_Apply_DFDClick(Sender: TObject);
    procedure BB_Apply_DFXClick(Sender: TObject);
    procedure BB_Apply_TEXTClick(Sender: TObject);    
  private
    IQsStat      : ITQsstatRemoteControl;
    qsstatHandle : LongInt;
  public
    procedure SetParameters( SvrObj    : ITQsstatRemoteControl;
                             SvrHandle : LongInt);
  end;

var
  F_TransmitDlg: TF_TransmitDlg;

implementation

{$R *.DFM}

uses
  DelphiCOMClient2form;

//------------------------------------------------------------------------------
// Set Parameters
//------------------------------------------------------------------------------
procedure TF_TransmitDlg.SetParameters( SvrObj    : ITQsstatRemoteControl;
                                        SvrHandle : LongInt);
begin
  IQsStat      := SvrObj;
  qsstatHandle := SvrHandle;
end;

//------------------------------------------------------------------------------
// Transmit head data file
//------------------------------------------------------------------------------
procedure TF_TransmitDlg.BB_OpenHeadDataFileClick(Sender: TObject);
begin
  if IQsSTAT <> nil then
  begin
    FileOpenDialog.Filter := 'ASCII DFD (*.DFD)|*.dfd';
    FileOpenDialog.DefaultExt := 'dfd';
    FileOpenDialog.Title := 'Open qs-STAT file';
    FileOpenDialog.InitialDir := ExtractFilePath(ParamStr(0));
    // Show file open dialog
    if FileOpenDialog.Execute then
    begin
      ED_HeadDataFile.Text := FileOpenDialog.FileName;
    end;
  end;
end;

//------------------------------------------------------------------------------
// Transmit data file
//------------------------------------------------------------------------------
procedure TF_TransmitDlg.BB_OpenDataFileClick(Sender: TObject);
begin
  if IQsSTAT <> nil then
  begin
    FileOpenDialog.Filter := 'ASCII DFX (*.DFX)|*.dfx';
    FileOpenDialog.DefaultExt := 'dfx';
    FileOpenDialog.Title := 'Open qs-STAT file';
    FileOpenDialog.InitialDir := ExtractFilePath(ParamStr(0));
    // Show file open dialog
    if FileOpenDialog.Execute then
    begin
      ED_DataFile.Text := FileOpenDialog.FileName;
    end;
  end;
end;

procedure TF_TransmitDlg.BB_Apply_DFDClick(Sender: TObject);
begin
  F_ClientForm.TransmitFileToServer(FileOpenDialog.FileName,
                                    '',
                                    0,
                                    True);
end;

procedure TF_TransmitDlg.BB_Apply_DFXClick(Sender: TObject);
var
  Param : integer;
begin
  Param := 2;
  If CB_Transmit.Checked then
  begin
    Param := 6;
  end;
  F_ClientForm.TransmitFileToServer(FileOpenDialog.FileName,
                                    '',
                                    Param,
                                    True);
end;

procedure TF_TransmitDlg.BB_Apply_TEXTClick(Sender: TObject);
var
  Param : integer;
begin
  Param := 2;
  If CB_Transmit.Checked then
  begin
    Param := 6;
  end;
  F_ClientForm.TransmitFileToServer('From Memo',
                                    Memo_Data.Lines.Text,
                                    Param,
                                    True);
end;

end.
