//==============================================================================
//                      >>> ValueDlg.pas <<<
//
//
//    Inhalt      : qs-STAT Values dialog
//
//    Autor       : OL
//    Erstellt am : 6.2004
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//
//==============================================================================

unit ValueDlg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  com_common_consts,
  qs_stat_tlb;

type
  TF_ValueDlg = class(TForm)
    P_BB: TPanel;
    BB_OK: TButton;
    BB_Cancel: TButton;
    P_Head: TPanel;
    GB_ENum: TGroupBox;
    COB_ENUMValue: TComboBox;
    GB_Keys: TGroupBox;
    LA_Key: TLabel;
    LA_SubKey: TLabel;
    ED_Key: TEdit;
    ED_SubKey: TEdit;
    GB_PartChar: TGroupBox;
    LA_Part: TLabel;
    Label1: TLabel;
    LA_Value: TLabel;
    ED_Part: TEdit;
    ED_Char: TEdit;
    ED_Value: TEdit;
    GroupBox3: TGroupBox;
    LA_ValueOut: TLabel;
    BB_GetValue: TButton;
    ED_ValueOut: TEdit;
    procedure BB_GetValueClick(Sender: TObject);
  private
    IQsStat      : ITQsstatRemoteControl;
    qsstatHandle : LongInt;
    procedure InitializeCOB_ENumValue;
  public
    procedure SetParameters( SvrObj    : ITQsstatRemoteControl;
                             SvrHandle : LongInt);
  end;

var
  F_ValueDlg: TF_ValueDlg;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
// Set Parameters
//------------------------------------------------------------------------------
procedure TF_ValueDlg.SetParameters( SvrObj    : ITQsstatRemoteControl;
                                     SvrHandle : LongInt);
begin
  IQsStat      := SvrObj;
  qsstatHandle := SvrHandle;

  InitializeCOB_ENumValue;
end;

//------------------------------------------------------------------------------
// ENUM Interface -> Report
//------------------------------------------------------------------------------
procedure TF_ValueDlg.InitializeCOB_ENumValue;
var
  IqsSTATKField    : IEnumFieldKeyName;
  KFieldKey        : Integer;
  KFieldSubKey     : Integer;
  KFieldName       : WideString;
  rc               : Integer;
begin
  if IQsSTAT <> nil then
  begin
    COB_ENUMValue.Clear;

    IqsSTATKField := IQsSTAT as IEnumFieldKeyName;

    KFieldKey      := 0;
    KFieldSubKey   := 0;
    KFieldName     := '';

    rc := IqsSTATKField.GetFirstValueField( qsstatHandle,
                                            KFieldKey,
                                            KFieldSubKey,
                                            KFieldName);
    while rc = 0 do
    begin
      COB_ENUMValue.Items.Add(KFieldName + ' (' + IntToStr(KFieldKey) + ')');
      rc := IqsSTATKField.GetNextValueField(qsstatHandle,
                                            KFieldKey,
                                            KFieldSubKey,
                                            KFieldName);
    end;
    //set focus on first item
    if COB_ENUMValue.Items.Count > 0 then COB_ENUMValue.ItemIndex := 0;
  end;
end;

procedure TF_ValueDlg.BB_GetValueClick(Sender: TObject);
var
  ValueText : WideString;
  Key       : Integer;
  Part      : Integer;
  Char      : Integer;
  Value     : Integer;
  rc        : integer;
begin
  if IQsSTAT <> nil then
  begin
    ED_ValueOut.Text := '';

    Key   := StrToIntDef(ED_Key.Text, 0);
    Part  := StrToIntDef(ED_Part.Text, 0);
    Char  := StrToIntDef(ED_Char.Text, 0);
    Value := StrToIntDef(ED_Value.Text, 0);

    rc := IQsSTAT.GetValueInfo(qsstatHandle,
                               Key,
                               Part,
                               Char,
                               Value,
                               0,
                               ValueText);
    if rc = 0 then
    begin
      ED_ValueOut.Text := ValueText;
    end;
  end;
end;

end.
