// ==========================================================================
//                       >>> com_common_consts.pas <<<
//
//    Inhalt      : Definitionen fuer COM-Schnittstelle (extern)
//                  Zusammengefasste Typen
//    Autor       : RJ
//    Erstellt am : 3/2003
//
//
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
//    Aenderung am     :
//    von              :
//    Kommentar zu Ae. :
// ==========================================================================
unit com_common_consts;

interface

const


//------------------------------------------------------------------------------
// Formate fr Grafikausgabe
//------------------------------------------------------------------------------
GF_BITMAP_C = 0; // Bitmap
GF_JPEG_C   = 1; // Jpg
GF_EMF_C    = 2; // Enhanced Metafile
GF_WMF_C    = 3; // Metafile
GF_PDF_C    = 4; // PDF
GF_SVG_C    = 5; // Scalable Vector Graphics
//GF_GIF_C    = 6; // GIF
GF_MAX_C    = 5;

//------------------------------------------------------------------------------
// Param. f getDataPosition
//------------------------------------------------------------------------------
GPO_DRAW_C       = $00;  // nur zeichnen
GPO_POSONLY_C    = $01;  // nur Positionsermittlung
GPO_POSANDDRAW_C = $02;  // Positionsermittlung und zeichnen

//------------------------------------------------------------------------------
// Param f. WriteKey
//------------------------------------------------------------------------------
WKCRM_NO_RANGE_C        = $00;
WKCRM_ALL_CHAR_C        = $01; // alle Merkmale aller Teile
WKCRM_ALL_CHAR_PART_C   = $02; // alle Merkmale eines angegeben Teils
WKCRM_LIST_C            = $04; // alle Merkmale in einer Liste
WKCRM_SINGLE_CHAR_C     = $10; // ein bestimmtes
WKCRM_LASTMEASUREMENT_C = $11; // letzte Messung (alle MM)

//------------------------------------------------------------------------------
// Param. fr GetGlobalInfo
//------------------------------------------------------------------------------
GGI_OPCODE_TOTALNROFPARTS_C       = 1;   // Gesamtanzahl geladener Teile
GGI_OPCODE_TOTALNROFCHARS_C       = 2;   // Gesamtanzahl geladener Merkmale
GGI_OPCODE_NROFCHARSPERPART_C     = 3;   // Anzahl Merkmale fr ein best. Teil
GGI_OPCODE_NROFVALUESPERCHAR_C    = 4;   // Anzahl Werte eines best. Merkmals
GGI_OPCODE_NROFALLCHARSPERPART_C  = 5;   // Anzahl Merkmale fr ein best. Teil(ohne bercksichtigung sel/desel)
GGI_OPCODE_TOTALNROFALLCHARS_C    = 6;   // dto wie 6
GGI_OPCODE_FIRST_EVALVALUE_C      = 10;  // 1. Ausgewerter Wert (n_anf)
GGI_OPCODE_LAST_EVALVALUE_C       = 11;  // letzter Ausgewerter Wert (n_end)
GGI_OPCODE_FIRST_EVALSUBGROUP_C   = 12;  // 1. Ausgewerte Stichprobe  (m_anf)
GGI_OPCODE_LAST_EVALSUBGROUP_C    = 13;  // letzte Ausgewerte Stichprobe (m_end)
GCI_OPCODE_GETFIFOSIZE_C          = 101; // Gre des FIFO-Puffers
GCI_OPCODE_GETONLINESIZE_C        = 111; // Anz. ausgewerteter Stichproben in pv
GGI_OPCODE_GETACTIVEMODULE        = 200; // Aktuelles Modul zurckgeben
GGI_OPCODE_GETLICENCECOUNT        = 201; // Anzahl erlaubter Zugriffe auf Webservice
GGI_OPCODE_GETTLDAYSLEFT          = 202; // Anzahl verbleibender Tage bei Zeitfreischaltung (15.11.07)
GGI_OPCODE_GETCURRENTUSER         = 300; // Angemeldeten Benutzer zurckgeben
GGI_OPCODE_GETCURRENTUSERGROUP    = 301; // Gruppe des angemeldeten Benutzers zurckgeben


//------------------------------------------------------------------------------
// Param. fr OpenFile / TransmitFile RJ, 14.1.05
//------------------------------------------------------------------------------
// Parameter AllwoToSave
OF_ATS_NOSAVE_C  = 0; // Speichern nicht erlaubt
OF_ATS_SAVE_C    = 1; // Speichern unter Orginalnamen erlaubt
OF_ATS_SAVE_AS_C = 2; // Speichern unter Orginalnamen nicht erlaubt, Speichern unter erlaubt

// Parameter SHOWMESelect
OF_MESEL_NO_C     = 0; // Merkmalsauswahl nach einlesen nie anzeigen
OF_MESEL_YES_C    = 1; // Merkmalsauswahl nach einlesen immer anzeigen
OF_MESEL_SYSTEM_C = 2; // Merkmalsauswahl nach einlesen entspr. Syste.Einstellung anzeigen


//------------------------------------------------------------------------------
// Append- Parameter bei TransmitfileExt
//------------------------------------------------------------------------------
TF_APPENDPARAM_RESETALL_C                      = $0000; // Daten-Reset
TF_APPENDPARAM_APPEND_CONTROLPLAN_C            = $0001; // Prfplan einlesen ohne Reset des geladenen
TF_APPENDPARAM_APPEND_VALUES_C                 = $0002; // DFX anhngen / AppendWerte
TF_APPENDPARAM_APPEND_VALUESFIRST_C            = $0004; // DFX anhngen / AppendWerte bei Abschlu des Hochfahrens Initial-Auswertung nach Datenlesen
TF_APPENDPARAM_APPEND_RELATIVE_ADRESSINGMODE_C = $0008; // Adressierungsmodus Datenformat fr DFX-Dateien bezogen auf jew. DFX-Datei



//------------------------------------------------------------------------------
// Reserve1 Parameter bei TransmitfileExt
//------------------------------------------------------------------------------
TF_RESERVEPARAM_DB_SYNC_OFF_C         = $0000; // Keine Synchronisation mit Moni-DB bei TransmitFile
TF_RESERVEPARAM_DB_SYNC_PARTS_C       = $0001; // Abgleich der Teiledaten mit globaler Teiltabelle
TF_RESERVEPARAM_DB_SYNC_CHARS_C       = $0002; // Abgleich der Merkmalsdaten mit globaler Merkmalstabelle
TF_RESERVEPARAM_DB_SYNC_CONTROLPLAN_C = $0004; // Abgleich der Prfplanbezogenen Teile-Merkmalsdaten

TF_RESERVEPARAM_SKIP_EVALUATION_C     = $0100; // nicht sofort auswerten bei bertragung in Modul PV
TF_RESERVEPARAM_DO_CALC_FORMULA_C     = $0200; // Verknpfungsformeln durchrechnen
TF_RESERVEPARAM_FORCE_TAKEOVER_QCC_C  = $0400; // im Modul 26 die gespeicherte QRK bernehmen als Online QRK



//------------------------------------------------------------------------------
// Reserve1 Parameter bei EvaluateCharExt
//------------------------------------------------------------------------------
ECE_RESERVEPARAM1_SKIP_TAKEOVER_QCC_C = $0001; // bei PV-SPC-Auswertung bisherige Online QRK beibehalten

//------------------------------------------------------------------------------
// Druckersteuerung PrintReportExt
//------------------------------------------------------------------------------
// Printmode / Zwischenformate
PR_PM_SYSTEM_C      = 0;  // qs-STAT Systemeinstellung
PR_PM_WMF_C         = 31; // Zwischenformat WMF
PR_PM_BMP_C         = 32; // Zwischenformat BMP
PR_PM_DIRECTPRINT_C = 33; // Direkter Druckt

// ColorMode / Farbdruckoptionen
PR_CM_SYSTEM_C     = 0; // qs-STAT Systemeinstellung
PR_CM_COLORPRINT_C = 1; // Farbdruck
PR_CM_BLOW_C       = 2; // Schwarz auf wei
PR_CM_WOBL_C       = 3; // Wei auf Schwarz
PR_COLORPRINT_NOBK = 4; // Farbdruck ohne farbigen Grafikhintergrund



//------------------------------------------------------------------------------
// Benutzerrechte
//------------------------------------------------------------------------------
EU_CUA_VALUES_ENTER_C                =  1;
EU_CUA_VALUES_CHANGE_C               =  2;
EU_CUA_CONTROLPLAN_ENTER_C           =  3;
EU_CUA_CONTROLPLAN_CHANGE_C          =  4;
EU_CUA_USE_QUERIES_C                 =  5;
EU_CUA_CATALOGUE_EDIT_C              =  6;
EU_CUA_DB_SAVE_C                     =  7;
EU_CUA_CHANGE_STRATEGY_C             =  8;
EU_CUA_SYSTEM_CONFIGURATION_C        =  9;
EU_CUA_PROTECT_SELECT_STRATEGY_C     = 10;  // andere Auswerte-Strategie auswhlen
EU_CUA_PROTECT_DELETE_PARTS_DB_C     = 11;  // Teil aus Datenbank lschen
EU_CUA_PROTECT_SELEKTION_INGRAFIK_C  = 12;  // Selektion von Messwerten in Grafiken durchfhren
EU_CUA_PROTECT_REMOVE_OUTLIERS_C     = 13;  // Ausreisser nach Tests eliminieren
EU_CUA_PROTECT_CHANGE_DISTRIBUTION_C = 14;  // Verteilungsmodell ndern
EU_CUA_PROTECT_CHANGE_ANALYSIS_QCC_C = 15;  // Analyse-QRK ndern
EU_CUA_PROTECT_CHANGE_SPC_QCC_C      = 16;  // SPC-QRK ndern
EU_CUA_PROTECT_EDIT_OUTPUTPOINT_C    = 17;  // Ausgabepunkte ndern (Formbltter)
EU_CUA_DB_ADMINISTRATION_C           = 18;  // K0009, K0011 einrichten, Indizes ...
EU_CUA_PROTECT_SIGNATUR_VIEW_C       = 19;  // Signaturen anschauen
EU_CUA_PROTECT_SIGNATUR_CREATE_C     = 20;  // Signaturen erzeugen
EU_CUA_PROTECT_ENTER_OPERATOR_C      = 21;  // Prfername in Datenerfassung vor Handheingabe schtzen
EU_CUA_EXTENDED_MMSELECT_C           = 22;  // erweiterte Merkmalsauswahl
EU_CUA_PROTECT_SEEALLPARTS_C         = 23;  // Nicht alle Prfplne am AP anzeigen
EU_CUA_PROTECT_SEE_CHANGE_HISTORY_C  = 24;  // nderungshistorie anschauen


//------------------------------------------------------------------------------
// Param. fr DatenbankSelect
//------------------------------------------------------------------------------
  RESULT_LEVEL_C         = 3;
  VALUE_LEVEL_C          = 2;
  CHARACTERISTIC_LEVEL_C = 1;
  PART_LEVEL_C           = 0;
  ALL_PARTS_LEVEL_C      = -1;

  SORT_ASCENDING_C       = 0;
  SORT_DESCENDING_C      = 1;

//------------------------------------------------------------------------------
// Comparing operator on filter creation
//------------------------------------------------------------------------------
  COMP_OP_EQUAL_C           =   0;
  COMP_OP_LIKE_C            =   1;
  COMP_OP_GREATER_C         =   2;
  COMP_OP_SMALLER_C         =   3;
  COMP_OP_GREATER_EQUAL_C   =   4;
  COMP_OP_SMALLER_EQUAL_C   =   5;
  COMP_OP_FROM_TO_C         =   6;
  COMP_OP_BETWEEN_C         =   7;

  OP_AUTOMATIC_QUERY_C      =  16; // automatic Query

  OP_GET_FIRST_N_VALUES_C   = 128;
  OP_GET_LAST_N_VALUES_C    = 129;
  OP_GET_FIRST_N_SAMPLES_C  = 132;
  OP_GET_LAST_N_SAMPLES_C   = 133;

  OP_NONE_C                 = 255;

  // Time units on automatic query by date/time
  UNIT_YEAR_C               =   0;
  UNIT_MONTH_C              =   1;
  UNIT_WEEK_C               =   2;
  UNIT_DAY_C                =   3;
  UNIT_HOUR_C               =   4;
  UNIT_MINUTE_C             =   5;
  UNIT_SECOND_C             =   6;
  UNIT_VALUE_C              =   7;
  UNIT_SAMPLE_C             =   8;
  {$IFDEF V8_7}
  UNIT_QUARTER_C            =  11; // three months
  {$ENDIF}

  NOTRANSFORM_C             =   0;  // Output not transformed
  TRANSFORM_C               =   1;  // Output transformed if possible
  RETRANSFORM_C             =   2;  // Output re-transformed if possible

  // K_R_Key
  KRV_Controls_c            = -2; // Control element e.g. Button
  KRV_Backgrounds_C         = -1; // just background, no output
  K_FIELDS_C                =  1; // K-Fields (part + characteristic data)
  R_FIELDS_C                =  2; // Output R-Fields (results)
  V_FIELDS_C                =  3; // Output value fields
  T_FIELDS_C                =  4; // Output text fields
  RT_FIELDS_C               =  6; // Output text fields with descriptions of R-fields e.g. C-value etc.
  part_V_Fields_C           =  8; // Output part value fields AS 1.2004
  part_sum_list_Fields_C    =  9; // Output part Summary fields ( in list) AS 1.2004
  G_FIELDS_C                = 10; // Output Graphic
  M_FIELDS_C                = 11; // Output Module
  RP_FIELDS_C               = 12; // Output Reports
  DB_SPECIAL_INFO_FIELDS_C  = 13; // Output of info fields related to special DB functions
  KRV_Combi_FIELDS_C        = 30; // Value fields, combined with K-fields or R-fields
  KRR_Combi_FIELDS_C        = 40; // R-fields, combined with K-fields or R-fields
  R_Table_FIELDS_C          = 52; // Needed to create filters on additinal data fields in the result table
  GUM_Fields_C              = 60; // GUM output FP 2005
  mult_regression_Fields_C  = 70; // mult. regressiom output AS 2005
  //SYS_KONFIG_FIELDS_C       = 80; // Output Konfigurationseinstellungen MR 2006

  T_beschriftungs_string_C  = 200; // nur fuer inerne Ausgaben bei Legenden entsprechend der Skalenbeschriftung
  T_in_out_string_C         = 202; // nur intern zum durchreichen von text
  G_zusatz_FIELDS_C         = 210; // nur fuer inerne Ausgaben -> Output Graphic Zusaetze

  ZD_SEL_K0006_C            = $01;
  ZD_SEL_K0007_C            = $02;
  ZD_SEL_K0008_C            = $04;
  ZD_SEL_K0010_C            = $08;
  ZD_SEL_K0012_C            = $10;
  ZD_SEL_K0014_C            = $20;
  ZD_SEL_K0053_C            = $40;
  ZD_SEL_K0015_C            = $80;
  ZD_SEL_K0016_C            = $100;
  ZD_SEL_K0017_C            = $200;
  ZD_SEL_K0054_C            = $400;
  ZD_SEL_K0055_C            = $800;
  ZD_SEL_K0056_C            = $1000;
  ZD_SEL_K0057_C            = $2000;
  ZD_SEL_K0058_C            = $4000;
  ZD_SEL_K0059_C            = $8000;
  ZD_SEL_K0060_C            = $10000;
  ZD_SEL_K0061_C            = $20000;
  ZD_SEL_K0062_C            = $40000;
  ZD_SEL_K0063_C            = $80000;

  // Output points on filter creation with R_Table_FIELDS_C
  RTF_START_DATE_C        =   3;
  RTF_END_DATE_C          =   4;
  RTF_BATCHNO_C           =   6;
  RTF_NEST_C              =   7;
  RTF_OPERATOR_C          =   8;
  RTF_MACHINE_C           =  10;
  RTF_GAGE_C              =  12;
  RTF_ORDER_C             =  53;
  RTF_TEILEIDENT_C        =  14;
  RTF_UNTERSZWECK_C       =  15;
  RTF_PRODNUMMER_C        =  16;
  RTF_WERKSTUECK_C        =  17;
  RTF_K0054_C             =  54;
  RTF_K0055_C             =  55;
  RTF_K0056_C             =  56;
  RTF_K0057_C             =  57;
  RTF_K0058_C             =  58;
  RTF_K0059_C             =  59;
  RTF_K0060_C             =  60;
  RTF_K0061_C             =  61;
  RTF_K0062_C             =  62;
  RTF_K0063_C             =  63;
  RTF_MODULE_C            = 101;
  {$IFNDEF V8_3}   // V8_LT
  RTF_OUTPUT_PT_C         = 102;
  {$ENDIF}
  RTF_ADD_FIELDS_C        = 104;
  RTF_STRATEGY_C          = 105;

  NULL_GUID_C             = '{00000000-0000-0000-0000-000000000000}';

  EMPTY_GUID_C : TGUID = ( D1: 0;
                           D2: 0;
                           D3: 0;
                           D4: (0,0,0,0,0,0,0,0)
                          );


implementation


end.
