// DFQLimSettingsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "VCPPCOMClient1.h"
#include "DFQLimSettingsDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDFQLimSettingsDialog dialog


CDFQLimSettingsDialog::CDFQLimSettingsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CDFQLimSettingsDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDFQLimSettingsDialog)
	m_Lim = 10;
	m_Interval = 1;
	m_Attribute = 0;
	m_GageNum = 0;
	m_MachineNum = 0;
	m_NestNum = 0;
	m_OperatorNum = 0;
	m_CAttribute = FALSE;
	m_CBatch = FALSE;
	m_CGage = FALSE;
	m_CMachine = FALSE;
	m_CNest = FALSE;
	m_COperator = FALSE;
	m_COrder = FALSE;
	m_Batch = _T("");
	m_BatchValue = 0;
	m_OrderValue = 0;
	m_Order = _T("");
	//}}AFX_DATA_INIT
	//}}AFX_DATA_INIT
}


void CDFQLimSettingsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDFQLimSettingsDialog)
	DDX_Text(pDX, IDC_TLIMIT, m_Lim);
	DDX_Text(pDX, IDC_TINTERVAL, m_Interval);
	DDX_Text(pDX, IDC_TATTRIBUTE, m_Attribute);
	DDX_Text(pDX, IDC_TGAGE, m_GageNum);
	DDX_Text(pDX, IDC_TMACHINE, m_MachineNum);
	DDX_Text(pDX, IDC_TNEST, m_NestNum);
	DDX_Text(pDX, IDC_TOPERATOR, m_OperatorNum);
	DDX_Check(pDX, IDC_CHECKATTRIBUTE, m_CAttribute);
	DDX_Check(pDX, IDC_CHECKBATCHNUM, m_CBatch);

	DDX_Check(pDX, IDC_CHECKGAGENUM, m_CGage);
	DDX_Check(pDX, IDC_CHECKMACHINENUM, m_CMachine);
	DDX_Check(pDX, IDC_CHECKNESTNUM, m_CNest);
	DDX_Check(pDX, IDC_CHECKOPERATORNUM, m_COperator);
	DDX_Check(pDX, IDC_CHECKORDER, m_COrder);
	
	DDX_Text(pDX, IDC_TBATCHNUM, m_Batch);
	DDX_Text(pDX, IDC_TBATCHVALUE, m_BatchValue);
	DDX_Text(pDX, IDC_TORDERVALUE, m_OrderValue);
	DDX_Text(pDX, IDC_TORDERNUM, m_Order);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDFQLimSettingsDialog, CDialog)
	//{{AFX_MSG_MAP(CDFQLimSettingsDialog)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int	CDFQLimSettingsDialog::GetInterval()
{
	return m_Interval;
}
void CDFQLimSettingsDialog::SetInterval(int value)
{
	if (value > 0)
	{
		m_Interval = value;
	}
	else
	{
		m_Interval = 1;
	}
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int	CDFQLimSettingsDialog::GetLim()
{
	return m_Lim;
}
void CDFQLimSettingsDialog::SetLim(int value)
{
	if (value > 0)
	{
		m_Lim = value;
	}
	else
	{
		m_Lim = 1;
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int	CDFQLimSettingsDialog::GetAttribute()
{
	if(!m_CAttribute)
	{
		m_Attribute = 0;
	}
	return m_Attribute;
}

void CDFQLimSettingsDialog::SetAttribute( int value)
{
	if (value > 0)
	{
		m_Attribute = value;
	}
	else
	{
		m_Attribute = 0;
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
CString CDFQLimSettingsDialog::GetBatchNum()
{
	if(!m_CBatch)
	{
		m_Batch = "";
	}
	return m_Batch;
}

void CDFQLimSettingsDialog::SetBatchNum( CString string)
{
	if (string != "")
	{
		m_Batch = string;
	}
	else
	{
		m_Batch = "";
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int CDFQLimSettingsDialog::GetBatchNumValue()
{
	if(!m_CBatch)
	{
		m_BatchValue = 0;
	}
	return m_BatchValue;
}

void CDFQLimSettingsDialog::SetBatchNumValue( int value)
{
	if (value != 0)
	{
		m_BatchValue = value;
	}
	else
	{
		m_BatchValue = 0;
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int	CDFQLimSettingsDialog::GetNestNum()
{
	if(!m_CNest)
	{
		m_NestNum = 0;
	}
	return m_NestNum;
}

void CDFQLimSettingsDialog::SetNestNum( int value)
{
	if (value > 0)
	{
		m_NestNum = value;
	}
	else
	{
		m_NestNum = 0;
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int	CDFQLimSettingsDialog::GetOperatorNum()
{
	if(!m_COperator)
	{
		m_OperatorNum = 0;
	}	
	return m_OperatorNum;
}

void CDFQLimSettingsDialog::SetOperatorNum( int value)
{
	if (value > 0)
	{
		m_OperatorNum = value;
	}
	else
	{
		m_OperatorNum = 0;
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int	CDFQLimSettingsDialog::GetMachineNum()
{
	if(!m_CMachine)
	{
		m_MachineNum = 0;
	}	
	return m_MachineNum;
}

void CDFQLimSettingsDialog::SetMachineNum( int value)
{
	if (value > 0)
	{
		m_MachineNum = value;
	}
	else
	{
		m_MachineNum = 0;
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int	CDFQLimSettingsDialog::GetGageNum()
{
	if(!m_CGage)
	{
		m_GageNum = 0;
	}	
	return m_GageNum;
}

void CDFQLimSettingsDialog::SetGageNum( int value)
{
	if (value > 0)
	{
		m_GageNum = value;
	}
	else
	{
		m_GageNum = 0;
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
CString CDFQLimSettingsDialog::GetOrder()
{
	if(!m_COrder)
	{
		m_Order = "";
	}
	return m_Order;
}

void CDFQLimSettingsDialog::SetOrder( CString string)
{
	if (string != "")
	{
		m_Order = string;
	}
	else
	{
		m_Order = "";
	}
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int CDFQLimSettingsDialog::GetOrderValue()
{
	if(!m_COrder)
	{
		m_OrderValue = 0;
	}
	return m_OrderValue;
}

void CDFQLimSettingsDialog::SetOrderValue( int value)
{
	if (value != 0)
	{
		m_OrderValue = value;
	}
	else
	{
		m_OrderValue = 0;
	}
}
/////////////////////////////////////////////////////////////////////////////
// CDFQLimSettingsDialog message handlers


