// LoginDialog.cpp : implementation file
//

#include "stdafx.h"
#include "VCPPCOMClient1.h"
#include "LoginDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLoginDialog dialog


CLoginDialog::CLoginDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CLoginDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLoginDialog)
	m_PWD = _T("");
	//}}AFX_DATA_INIT
}


void CLoginDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoginDialog)
	DDX_Control(pDX, IDC_COB_User, m_COB_User);
	DDX_Control(pDX, IDC_COB_Mod, m_COB_Mod);
	DDX_Control(pDX, IDC_COB_Lang, m_COB_Lang);
	DDX_Text(pDX, IDC_ED_PWD, m_PWD);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLoginDialog, CDialog)
	//{{AFX_MSG_MAP(CLoginDialog)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoginDialog message handlers

CLoginDialog::~CLoginDialog()
{
	int i;
	UserStruct* pUser;

	for (i = 0; i < UserArray.GetSize();i++)
	{	
		pUser = UserArray.GetAt(i);
		delete pUser;
	}
	ModStruct* pModule;

	for (i = 0; i < ModuleArray.GetSize();i++)
	{	
		pModule = ModuleArray.GetAt(i);
		delete pModule;
	}
	LangStruct* pLanguage;

	for (i = 0; i < LanguageArray.GetSize();i++)
	{	
		pLanguage = LanguageArray.GetAt(i);
		delete pLanguage;
	}
} 


void CLoginDialog::OnOK() 
{
	UserStruct * pUI;
    int index = m_COB_User.GetCurSel();
	CString str;
	
	if (index >= 0)
	{
		pUI = UserArray.GetAt(index);
		if (pUI)
		{
			UserName = pUI->UserName;
		}
	}
	else
	{
		m_COB_User.GetWindowText(str.GetBuffer(0), m_COB_User.GetWindowTextLength()+1);
		UserName = str;
	}

	ModStruct * pMI;
    index = m_COB_Mod.GetCurSel();
	if (index >= 0)
	{
		pMI = ModuleArray.GetAt(index);
		if (pMI)
		{
			ModKey = pMI->ModKey;
		}
		else
		{
			ModKey = 20; 
		}
	}
	else
	{
		m_COB_Mod.GetWindowText(str.GetBuffer(0), m_COB_Mod.GetWindowTextLength()+1);
		ModKey = atoi(str.GetBuffer(0));
		if (ModKey == 0)
		{
			ModKey = 20;
		}
	}

	LangStruct * pLI;
    index = m_COB_Lang.GetCurSel();
	if (index >= 0)
	{
		pLI = LanguageArray.GetAt(index);
		if (pLI)
		{
			LangKey = pLI->LangKey;
		}
		else
		{
			LangKey = 49;
		}
	}
	else
	{
		m_COB_Lang.GetWindowText(str.GetBuffer(0), m_COB_Lang.GetWindowTextLength()+1);
		LangKey = atoi(str.GetBuffer(0));
		if (LangKey == 0)
		{
			LangKey = 49;
		}
	}
	CDialog::OnOK();
}

//------------------------------------------------------------------
//------------------------------------------------------------------

BOOL CLoginDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	
	BSTR	UserName;
	long	ModKey = 0;
	BSTR	ModName;
	long	LangKey = 0;
	BSTR	LangName;
	BSTR	LangStrName;
	CString Str;
	int	rc;
	int i = 0;
	int j = 0;
	
	if (SUCCEEDED(hr))
	{
		rc = pIqsSTATUser->GetFirstUser(&UserName);
		while (rc == 0)	
		{
			UserStruct* pUser = new UserStruct;
			pUser->UserName = UserName;
		
			Str = UserName;
			LPTSTR p = Str.GetBuffer(Str.GetLength());

			// add to combobox
			m_COB_User.SetExtendedUI(TRUE);
			m_COB_User.AddString(p);
			
			// Add to internal list
			UserArray.Add(pUser);
			rc = pIqsSTATUser->GetNextUser(&UserName);
		}
	}
	m_COB_User.SetCurSel(0);

	rc = pIqsSTATModule->GetFirstModule(0,&ModKey,&ModName);
	while (rc == 0)	
	{
		ModStruct* pModule = new ModStruct;
		pModule->ModKey = ModKey;
		Str = ModName;
		LPCTSTR p = Str.GetBuffer(Str.GetLength());
		strcpy(pModule->ModName, p);

		// add to combobox
		m_COB_Mod.AddString(p);
		// Add to internal list
		ModuleArray.Add(pModule);
		rc = pIqsSTATModule->GetNextModule(0,&ModKey,&ModName);
	}
	m_COB_Mod.SetCurSel(0);

	rc = pIqsSTATLanguage->GetFirstLanguage(0,&LangName,&LangStrName,&LangKey);
	while (rc == 0)	
	{
		LangStruct* pLanguage = new LangStruct;
		pLanguage->LangKey = LangKey;
		Str  = LangName;
		LPCTSTR p = Str.GetBuffer(Str.GetLength());
		strcpy(pLanguage->LangName, p);

		// add to combobox
		m_COB_Lang.AddString(p);
		// Add to internal list
		LanguageArray.Add(pLanguage);
		rc = pIqsSTATLanguage->GetNextLanguage(0,&LangName,&LangStrName,&LangKey);
	}
	m_COB_Lang.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//------------------------------------------------------------------
//------------------------------------------------------------------

void CLoginDialog::SetServerObject(IUnknown* pIUnknown)
{
	hr = pIUnknown->QueryInterface(IID_IEnumUser,(void**)&pIqsSTATUser);
	pIUnknown->QueryInterface(IID_IEnumModule,(void**)&pIqsSTATModule);
	pIUnknown->QueryInterface(IID_IEnumLanguage,(void**)&pIqsSTATLanguage);
}

//------------------------------------------------------------------
//------------------------------------------------------------------

CString CLoginDialog::GetUName()
{
	return UserName;
}

int	CLoginDialog::GetModKey()
{
	return ModKey;
}

int	CLoginDialog::GetLangKey()
{
	return LangKey;
}
