// CVCPPCOMClient1View.cpp : implementation of the CVCPPCOMClient1View class
//

#define _WIN32_DCOM

#include "stdafx.h"
#include <atlbase.h>
#include <afxtempl.h>
#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <time.h>

#define DFQ_LINE_SIZE	80*2
#ifndef	INVALID_SET_FILE_POINTER
#define INVALID_SET_FILE_POINTER	(DWORD)(-1)
#endif

#include "VCPPCOMClient1.h"

#include "VCPPCOMClient1Doc.h"
#include "VCPPCOMClient1View.h"

#include "SelektStatKey.h"
#include "SelektGrafKey.h"
#include "SelektReportKey.h"
#include "SelektPrintDialog.h"
#include "SetCustomKey.h"
#include "AboutDialog.h"
#include "LoginDialog.h"
#include "QueryFilterDialog.h"

#include "FileMonitorSettingDlg.h"
#include "DFQLIMSettingsDialog.h"
#include "AlarmSettingDlg.h"
#include "AlarmShowDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCPPCOMClient1View

IMPLEMENT_DYNCREATE(CVCPPCOMClient1View, CView)

BEGIN_MESSAGE_MAP(CVCPPCOMClient1View, CView)
	//{{AFX_MSG_MAP(CVCPPCOMClient1View)
	ON_COMMAND(ID_ALARMSETTINGS, OnAlarmsettings)
	ON_COMMAND(ID_Connect, OnConnect)
	ON_COMMAND(ID_Disconnect, OnDisconnect)
	ON_COMMAND(ID_FILE_FILETRANSMIT, OnFileFiletransmit)
	ON_COMMAND(ID_FileOpen, OnFileOpen)
	ON_COMMAND(ID_FILE_PRINTREPORT, OnFilePrintreport)
	ON_COMMAND(ID_GetGraphic, OnGetGraphic)
	ON_COMMAND(ID_GetReport, OnGetReport)
	ON_COMMAND(ID_GetResult, OnGetResult)
	ON_COMMAND(ID_GetValue, OnGetValue)
	ON_COMMAND(ID_ONLINETRANSMISSION_SIMULATEONELINE, OnOnlinetransmissionSimulateoneline)
	ON_COMMAND(ID_OPENBASEFILE, OnOpenbasefile)
	ON_COMMAND(ID_PROCESSCAPABILITY, OnProcesscapability)
	ON_COMMAND(ID_SetFilter, OnSetFilter)
	ON_COMMAND(ID_SetLanguage, OnSetLanguage)
	ON_COMMAND(ID_SetModule, OnSetModule)
	ON_COMMAND(ID_SetPrinter, OnSetPrinter)
	ON_COMMAND(ID_SetStrategy, OnSetStrategy)
	ON_COMMAND(ID_SHOWALARMS, OnShowalarms)
	ON_COMMAND(ID_SIMULATE_DFQ, OnSimulateDfq)
	ON_COMMAND(ID_STARTFILESCAN, OnStartfilescan)
	ON_COMMAND(ID_StartServer, OnStartServer)
	ON_COMMAND(ID_STOPFILESCAN, OnStopfilescan)
	ON_COMMAND(ID_STOPSIMULATE_DFQ, OnStopsimulateDfq)
	ON_WM_SIZE()
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//--------------------------------------------------------------------------
// creating an instance of the object (Thread procedure)
//--------------------------------------------------------------------------
DWORD WINAPI lpQsStatConversation( LPVOID ptr )
{

	HRESULT hr;
	//---------------------------------------------------------
	// Starting the qs-STAT Server and register ConnectionPoints
	// 1. CoInitialize
	// 2. Create COM Object
	// 3. SEtup ConnectionPoints
	// 4. Wait for termination of Server-Session (g_hTerminateQsSTATEvent)
	//---------------------------------------------------------
	CVCPPCOMClient1View * comclass = (CVCPPCOMClient1View * )ptr;
	if (!comclass->pqsSTAT)
	{
		IUnknown*	pUnknown;
		hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);
		if (FAILED(hr))
		{
			MessageBox(comclass->m_hWnd, "CoInitialize failed","DCOM Client",MB_OK);
		}
		else
		{
			hr = CoCreateInstance(  CLSID_TQsstatRemoteControl,NULL,CLSCTX_LOCAL_SERVER,
									IID_IUnknown,(void**)&pUnknown);
			if (FAILED(hr))
			{
				MessageBox(comclass->m_hWnd, "CoCreateInstance failed","DCOM Client",MB_OK);
			}
			else
			{
				hr = pUnknown->QueryInterface(IID_ITQsstatRemoteControl,(void**)&comclass->pqsSTAT);
				if (FAILED(hr))
				{
					MessageBox(comclass->m_hWnd, "QueryInterface failed","DCOM Client",MB_OK);
				}
				else
				{
					// createSink object(connection points)
					hr = comclass->pqsSTAT->QueryInterface(	IID_IConnectionPointContainer, 
															(void**)&comclass->pConnectionPointContainer);
					pUnknown->Release();	
					if(FAILED(hr))
					{
						MessageBox(comclass->m_hWnd, "cannot get IID_IConnectionPointContainer","DCOM Client",MB_OK);
					}
					else
					{
						hr = comclass->pConnectionPointContainer->FindConnectionPoint(	IID_IQsEvents, 
																						&comclass->pConnectionPoint);
						if (FAILED(hr))
						{
							MessageBox(comclass->m_hWnd, "FindConnectionPoint failed","DCOM Client",MB_OK);
						}
						else
						{
							comclass->mySink = new CSink;
							hr = comclass->pConnectionPoint->Advise((IUnknown*)comclass->mySink, &comclass->dwCookie);
							if (FAILED(hr))
							{
								MessageBox(comclass->m_hWnd, "pConnectionPoint->Advise failed","DCOM Client",MB_OK);
							}
							else
							{
								// wait until server is initialized (15 seconds)
								DWORD to = WaitForSingleObject(comclass->mySink->hServerInitializedEvent,15000);
								if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
								{
									MessageBox(comclass->m_hWnd, "timeout expired while starting server","DCOM Client",MB_OK);
								}
								else
								{
									MessageBox(comclass->m_hWnd, "Server ist initialized","DCOM Client",MB_OK);
								};
							}
						}
					}
				}
			}
		}
	}//(!pqsstat)
	else
	{
		hr = E_FAIL;//Force self-terminating the new thread, if one was already running
	}

	if SUCCEEDED(hr)
	{
		// Wait for termination of server session
		comclass->g_hTerminateQsSTATEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
		WaitForSingleObject(comclass->g_hTerminateQsSTATEvent,INFINITE);
		CloseHandle(comclass->g_hTerminateQsSTATEvent);

		comclass->pqsSTAT->Release();
		comclass->pqsSTAT = NULL;
	}

	return 0;
};



//--------------------------------------------------------------------------
// Wait for changes of the monitored file (Thread procedure)
//--------------------------------------------------------------------------
DWORD WINAPI lpMonitorFileChanges( LPVOID ptr )
// Demo for Online-Server
{

	//---------------------------------------------------------
	// Waiting loop, waits for:
	// 1. Changes of the BaseFile
	// 2. External termination
	// 3. Cycle intervall, if preseted
	//---------------------------------------------------------

	CVCPPCOMClient1View*	comclass = (CVCPPCOMClient1View * )ptr;
	DWORD					dwWaitStatus; 
	HANDLE				dwChangeHandles[2]; 
	UINT				Timeout = INFINITE;
	BOOL				terminateLoop = FALSE;
 
	// External termination Event
	dwChangeHandles[0] = comclass->g_StopFileScanEvent;

	// watch for changes in the size of the file
	dwChangeHandles[1] = FindFirstChangeNotification( 
								comclass ->sBaseFilePath,// "C:\\WINDOWS",                 // directory to watch 
								FALSE,                         // do not watch the subtree 
								FILE_NOTIFY_CHANGE_SIZE);	// watch file size changes 
 
	if (dwChangeHandles[0] == INVALID_HANDLE_VALUE) 
		ExitThread(GetLastError()); 

	// Check the cycle intervall
	if (comclass->m_FileMonitoringIntervall > 0)
	{
		Timeout = comclass->m_FileMonitoringIntervall;
		Timeout *= 1000; //update time format (sec)
	}
	else
	{
		Timeout = INFINITE;
	}

 
	// Change notification is set. Now wait on both notification 
	// handles and refresh aCordingly. 
	while (!terminateLoop) 
	{          
 
		// Wait for notification.
	    dwWaitStatus = WaitForMultipleObjects(2, dwChangeHandles, 
						                      FALSE, Timeout); 
 
		switch (dwWaitStatus) 
		{ 
			case WAIT_TIMEOUT:
			{
				//----------------------------------------------
				// try to refresh after a certain period of time
				//----------------------------------------------
				::PostMessage(comclass ->m_hWnd,RegisterWindowMessage("WM_FILESIZE_CHANGED"),0,0);				
				break;

			}
			case WAIT_OBJECT_0:
			{
				//----------------------------------------------
				// Wait-thread was terminated from the client application
				//----------------------------------------------
				terminateLoop = TRUE;
				ExitThread(GetLastError()); 
				break;
			}
			case WAIT_OBJECT_0+1: 
			{
				//----------------------------------------------------
				// FILE_NOTIFY_CHANGE_SIZE
				// A file size has changed
				// reload the file (added Bytes only) and restart the 
				// change notification. 
				// reload new data and send to server
				//----------------------------------------------------
				if (comclass ->m_FileChangeTriggered)
				{
					if (!comclass ->m_FileMonitoringIntervall)
					{
						::PostMessage(comclass ->m_hWnd,RegisterWindowMessage("WM_FILESIZE_CHANGED"),0,0);				
					}
				}
				if ( FindNextChangeNotification( 
					    dwChangeHandles[1]) == FALSE ) 
					ExitThread(GetLastError());
				break; 
			}
 			default: 
				ExitThread(GetLastError()); 
		} 
	} 

	return 0;
}



//--------------------------------------------------------------------------
// Warten auf Alarme vom qs-STAT Server
// Wait for Alarms from the qs-STAT Server (Thread procedure)
// Demo for Online-Server
//--------------------------------------------------------------------------
DWORD WINAPI lpScanAlarms( LPVOID ptr )
{

	//---------------------------------------------------------
	// Waiting loop, waits for:
	// 1. Alarms from server
	// 2. External termination
	//---------------------------------------------------------

	CVCPPCOMClient1View*	comclass = (CVCPPCOMClient1View * )ptr;
	DWORD				dwWaitStatus; 
	HANDLE				dwChangeHandles[2]; 
	UINT				Timeout = INFINITE;
	BOOL				terminateLoop = FALSE;
 
	// External termination Event
	dwChangeHandles[0] = comclass->g_StopAlarmEvent;

	// watch for Alarms (notified by qsEventSink)
	dwChangeHandles[1] = comclass->mySink->hRedAlertEvent;
 
	if (dwChangeHandles[0] == INVALID_HANDLE_VALUE) 
		ExitThread(GetLastError()); 
	if (dwChangeHandles[1] == INVALID_HANDLE_VALUE) 
		ExitThread(GetLastError()); 

	Timeout = INFINITE;// Intervall

	//----------------------------------------------------------------
	// Warten auf Events (Terminierung & Alarm)
	// Wait for Event (termination, alarm)
	//----------------------------------------------------------------
	while (!terminateLoop) 
	{          
 
	    dwWaitStatus = WaitForMultipleObjects(2, dwChangeHandles, 
						                      FALSE, Timeout); 
 
		switch (dwWaitStatus) 
		{ 
			case WAIT_TIMEOUT:
			{
				break;

			}
			case WAIT_OBJECT_0:
			{
				//----------------------------------------------------
				// Terminierung des Threads durch Client Applikation
				// Wait-thread was terminated from the client application
				//----------------------------------------------------
				terminateLoop = TRUE;
				ExitThread(GetLastError()); 
				break;
			}
			case WAIT_OBJECT_0+1: 
			{
				//----------------------------------------------------
				// Statistic-Alarm
				// statistical Alarm
				//----------------------------------------------------
				::PostMessage(comclass ->m_hWnd,RegisterWindowMessage("WM_STATISTIC_ALARM"),0,0);				
				
				break; 
			}
 			default: 
				ExitThread(GetLastError()); 
		} 
	} 

	return 0;
}



//----------------------------DFQ SIMULATION----------------------------- 
// Find end of last simulated result
int dfq_find_end(HANDLE h_file, DWORD* dw_pos)
{
	DWORD dw_end;

	if(h_file==NULL || !dw_pos)
	{
		return(-1);
	}
	
	dw_end=SetFilePointer(h_file, 0, NULL, FILE_END);
	if(dw_end==INVALID_SET_FILE_POINTER)
	{
		return(-1);
	}
	return(0);
}

//Close DFQ-File
int dfq_close(HANDLE h_file) 
{
	return(!CloseHandle(h_file) ? -1:0);
}




//-------------------------------------------------------------------
// Simulate data in a defined DFQ-File (Thread Procedure)
// Demo for Online-Server
//-------------------------------------------------------------------
DWORD WINAPI lpSimulateDFQFile( LPVOID ptr )
{
	CVCPPCOMClient1View*	comclass = (CVCPPCOMClient1View * )ptr;
	HANDLE	dwHandle	= 0;
	DWORD	dwWaitStatus = 0;
	long	Timeout		= INFINITE;
	BOOL	Terminated	= FALSE;


	dwHandle = comclass->g_StopDFQSimulateEvent;
	
		// Check the cycle intervall
	if (comclass->sim_interval > 0)
	{
		Timeout = comclass->sim_interval * 1000;
	}
	else
	{
		Timeout = 2000;
	}

	while(!Terminated)
	{

		dwWaitStatus = WaitForSingleObject(dwHandle, Timeout);
		
		switch (dwWaitStatus) 
		{ 
			case WAIT_TIMEOUT:
			{
				//-----------------------------------------------------------------
				// Simulate 1 DFX line aC. to loaded data set
				//-----------------------------------------------------------------
				comclass ->SimulateDFQ();
				break;

			}
			case WAIT_OBJECT_0:
			{
				//-----------------------------------------------------------------
				// Terminate Simulation
				//-----------------------------------------------------------------
				Terminated = TRUE;
				ExitThread(GetLastError()); 
				break;
			}
 			default: 
				ExitThread(GetLastError()); 
		}
		
	}
	return 0;
}

BOOL GetBinaryFromVariant(COleVariant & ovData, BYTE ** ppBuf,
                                unsigned long * pcBufLen)
{
     BOOL fRetVal = FALSE;

   //Binary data is stored in the variant as an array of unsigned char
     if(ovData.vt == (VT_ARRAY|VT_UI1))  // (OLE SAFEARRAY)
     {
       //Retrieve size of array
       *pcBufLen = ovData.parray->rgsabound[0].cElements;

       *ppBuf = new BYTE[*pcBufLen]; //Allocate a buffer to store the data
       if(*ppBuf != NULL)
       {
         void * pArrayData;

         //Obtain safe pointer to the array
         SafeArrayAccessData(ovData.parray,&pArrayData);

         //Copy the bitmap into our buffer
         memcpy(*ppBuf, pArrayData, *pcBufLen);

         //Unlock the variant data
         SafeArrayUnaccessData(ovData.parray);
         fRetVal = TRUE;
       }
     }
     return fRetVal;
}

BOOL PutBinaryIntoVariant(COleVariant * ovData, BYTE * pBuf,
                                unsigned long cBufLen)
{
     BOOL fRetVal = FALSE;

     VARIANT var;
     VariantInit(&var);  //Initialize our variant

     //Set the type to an array of unsigned chars (OLE SAFEARRAY)
     var.vt = VT_ARRAY | VT_UI1;

     //Set up the bounds structure
     SAFEARRAYBOUND  rgsabound[1];

     rgsabound[0].cElements = cBufLen;
     rgsabound[0].lLbound = 0;

     //Create an OLE SAFEARRAY
     var.parray = SafeArrayCreate(VT_UI1,1,rgsabound);

     if(var.parray != NULL)
     {
       void * pArrayData = NULL;

       //Get a safe pointer to the array
       SafeArrayAccessData(var.parray,&pArrayData);

       //Copy bitmap to it
       memcpy(pArrayData, pBuf, cBufLen);

       //Unlock the variant data
       SafeArrayUnaccessData(var.parray);

       *ovData = var;  // Create a COleVariant based on our variant
       VariantClear(&var);
       fRetVal = TRUE;
     }

     return fRetVal;
}

/////////////////////////////////////////////////////////////////////////////
// CVCPPCOMClient1View construction/destruction

CVCPPCOMClient1View::CVCPPCOMClient1View()
{
	pqsSTAT	= NULL;
	dib		= NULL;
    
	HRESULT hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);

	// Initialization for the Sink object
	pConnectionPointContainer = NULL;
	pConnectionPoint		  = NULL;	
	
	// IQSEventSink
	mySink			 = NULL;
	dwCookie		 = 0;
	
	//------------------------------------------------------------------
	// Server Thread Handling
	dwServerThreadId		= 0;
	h_ServerThread			= NULL;
	g_hTerminateQsSTATEvent = NULL; // Event for the StartServer Thread

	// internal variables for DATA
	ModuleID		= 0;
	NumOfChar = 0;
	K_Field_Up = 0;
	K_Field_Down = 0;
	PrinterNr = 0;
    
	// Parameters for dialogs
	PartNr_x = 1;
	CharNr_x = 1;
	PartNr_y = 1;
	CharNr_y = 1;
	Valuenr = 1;
	GrafKey = 3100;// value chart
	GrafSubKey = 0;
	StatKey	= 1000;// average (stat.result)
	StatSubKey = 0;
	Transformation = 0;// not transformed
	UseExtFunc	= FALSE;
	ReportPrn = FALSE;
	lim = 10;
	Attribute = 0; 
	BatchNum = "BatchNo";
	GageNum = 0;
	MachineNum = 0;
	NestNum = 0;
	BatchValue = 0;
	OrderValue = 0;
	OperatorNum = 0;
	Order = "OrderNo";
	//-----------------------------------------------------------------
	// Online Server Demo
	OnlineMode = FALSE;
	OnlineDib1 = NULL;
	OnlineDib2 = NULL;

	sBaseFilePath = "";
	sBaseFileName = "";// Base file for Online supervision
	LastReadFilePos = 0;//alread read Bytes from Base file
	MonitoringInProgress = FALSE;
	
	// settings for Online DEMO
	m_FileChangeTriggered		= FALSE;
	m_FileMonitoringIntervall	= 0;
	m_AlwaysShowAlarm			= FALSE;
	m_StoreAlarm				= FALSE;

	// file monitoring Sync
	g_StopFileScanEvent		= NULL;	// Terminate Thread-Event
	g_StopAlarmEvent		= NULL;
	g_StopDFQSimulateEvent	= NULL;

	h_MonitoringThread	= NULL;	// Thread for filemonitoring
	h_AlarmThread		= NULL;	// Thread for alarm scanning
	h_SimulationThread	= NULL; // Thread for DFX-Simulation 
}

CVCPPCOMClient1View::~CVCPPCOMClient1View()
{
	// diconnect and release COM object
	// Stop running threads
	OnDisconnect();

	if (OnlineDib1)
	{
		delete OnlineDib1;
	}
	if (OnlineDib2)
	{
		delete OnlineDib2;
	}
	if (dib)
	{
		delete dib;
	}
}

BOOL CVCPPCOMClient1View::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CVCPPCOMClient1View drawing

void CVCPPCOMClient1View::OnDraw(CDC* pDC)
{
	//CVCPPCOMClient1Doc* pDoc = GetDocument();
	//ASSERT_VALID(pDoc);
	CRect DrawRect, WndRect;

	// TODO: add draw code for native data here

	if (!OnlineMode)
	{
		//--------------------------------------------------------------
		// Offline Mode: nur eine Grafik zeichnen
		//               Draw 1 graphic only
		//--------------------------------------------------------------
		if (dib)
		{
			dib->Draw(*pDC);//,NULL,NULL,FALSE,NULL,FALSE);
		}
	}
	else
	{

		//--------------------------------------------------------------
		// Online Mode: 2 Grafiken nebeneinander zeichnen
		//              Draw 2 graphics next to each other
		//--------------------------------------------------------------
		GetWindowRect(&WndRect);

		DrawRect = WndRect;
		if (OnlineDib1)
		{
			DrawRect.top	= 0;
			DrawRect.left	= 0;
			DrawRect.bottom	= WndRect.Height() / 2;
			DrawRect.right	= this->Width;;
			OnlineDib1->Draw(*pDC,&DrawRect);
		}

		if (OnlineDib2)
		{
			DrawRect.top    = WndRect.Height() / 2 + 1;
			DrawRect.left	= 0;
			DrawRect.bottom	= WndRect.Height()-1;
			DrawRect.right	= this->Width;;
			OnlineDib2->Draw(*pDC,&DrawRect);
		}

	}
}

/////////////////////////////////////////////////////////////////////////////
// CVCPPCOMClient1View diagnostics

#ifdef _DEBUG
void CVCPPCOMClient1View::AssertValid() const
{
	CView::AssertValid();
}

void CVCPPCOMClient1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CVCPPCOMClient1Doc* CVCPPCOMClient1View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVCPPCOMClient1Doc)));
	return (CVCPPCOMClient1Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVCPPCOMClient1View message handlers

void CVCPPCOMClient1View::OnAlarmsettings() 
{
	//---------------------------------------------------------------------------
	// setup for AlarmHandling in the Online system
	// AlwaysShowAlarm: Shows the oCured statistical alarms immediately
	// StoreAlarm:		Stores the oCured alarms in a list
	//---------------------------------------------------------------------------

	CAlarmSettingDlg*	AlarmSettingsDlg = new CAlarmSettingDlg(this);
	AlarmSettingsDlg->SetAlwaysShowAlarm(m_AlwaysShowAlarm);
	AlarmSettingsDlg->SetStoreAlarms(m_StoreAlarm);

	if (AlarmSettingsDlg->DoModal() == IDOK)
	{
		m_AlwaysShowAlarm	= AlarmSettingsDlg->GetAlwaysShowAlarm();
		m_StoreAlarm		= AlarmSettingsDlg->GetStoreAlarm();
		mySink->StoreAlarms = m_StoreAlarm;
	}
	delete AlarmSettingsDlg;
}

void CVCPPCOMClient1View::OnConnect() 
{
	HRESULT hr = S_OK;
	if (pqsSTAT)
	{
		CLoginDialog*	pLoginDialog = new CLoginDialog(this);
		pLoginDialog->SetServerObject(pqsSTAT);
		pLoginDialog->m_PWD = "Superuser";

		if (pLoginDialog->DoModal() == IDOK)
		{
			CComBSTR	user;
			CComBSTR	password;
			int			NewModuleID;
			int			NewLAnguageID;
			user			= pLoginDialog->GetUName();
			password		= pLoginDialog->m_PWD;
			NewModuleID		= pLoginDialog->GetModKey();
			NewLAnguageID	= pLoginDialog->GetLangKey();
			hr = pqsSTAT->ClientConnect(&qsSTATHandle,
										NewModuleID,
										NewLAnguageID,  
										user.m_str,
										password.m_str);
			switch(hr)
			{
				case S_OK:
				{
					ModuleID	= NewModuleID;
					LanguageID	= NewLAnguageID;
					break;
				}
				case E_PENDING:
				{
					::MessageBox(m_hWnd, "Server is pending","DCOM Client",MB_OK);
					break;
				}
				case E_ACCESSDENIED:
					{
						::MessageBox(m_hWnd, "Login failed, Access denied","DCOM Client",MB_OK);
						break;
					}
				default:
				{
					char s[255];
					sprintf(s,"%s %d","ClientConnect failed, errorcode", hr);
					::MessageBox(m_hWnd, s,"DCOM Client",MB_OK);
				}
			}
		}
		delete pLoginDialog;
	}
}

void CVCPPCOMClient1View::OnDisconnect() 
{
	HRESULT hr = S_OK;
	if ((pqsSTAT)&&(qsSTATHandle))
	{
		
		//--------------------------------------------------------------------
		// Stop running threads
		//--------------------------------------------------------------------
		OnStopfilescan();
		OnStopsimulateDfq();

		//--------------------------------------------------------------------
		// unregister your application
		//--------------------------------------------------------------------
		pqsSTAT->ClientDisconnect(qsSTATHandle);
		qsSTATHandle	= 0;
		ModuleID		= 0;
	

		//--------------------------------------------------------------------
		// Release connection point
		//--------------------------------------------------------------------
		pConnectionPoint->Unadvise(dwCookie);
		pConnectionPoint->Release();
		pConnectionPoint = NULL;
		
		pConnectionPointContainer->Release();
		pConnectionPointContainer = NULL;

		if (mySink) 
		{
			//delete mySink;//already realeased by unadvise
			mySink = NULL;
		}

		//--------------------------------------------------------------------
		// Stop the Thread
		//--------------------------------------------------------------------
		SetEvent(g_hTerminateQsSTATEvent);
		if (h_ServerThread)
		{
			WaitForSingleObject(h_ServerThread, INFINITE);
		};

		if (pqsSTAT)
		{
			pqsSTAT->Release();
			pqsSTAT=NULL;
			CoUninitialize();

		}

	}
	
}

void CVCPPCOMClient1View::OnFileFiletransmit() 
{
	HRESULT hr = S_OK;
	//---------------------------------------------------------
	// Transmit file to qs_STAT Server
	//---------------------------------------------------------
	if (pqsSTAT)
	{
		// Get the file name
		CComBSTR FileName(sTransmitFileName);
		CFileDialog dlg(TRUE);
		if (dlg.DoModal() == IDOK)
		{
			sTransmitFileName = dlg.GetPathName();
		}
		else
		{
			return;
		}

		//---------------------------------------------------------
		// write transmitted file to temporary local buffer
		//---------------------------------------------------------
		BYTE*		pBuffer;		
		long		BufLen;
		COleVariant vaData;
		DWORD		to;
		CFile f1(sTransmitFileName,CFile::modeRead | CFile::shareDenyNone);
		LastReadFilePos = f1.GetLength();

		BufLen = LastReadFilePos;
		pBuffer = (BYTE*)malloc(BufLen);
		if (pBuffer)
		{
			f1.ReadHuge(pBuffer,LastReadFilePos);
			// prepare the buffer for transmission
			PutBinaryIntoVariant(&vaData,pBuffer,BufLen);

			//---------------------------------------------------------
			// Transmit the data to server and reset data previously loaded data
			//---------------------------------------------------------
			hr = pqsSTAT->TransmitFileExt(qsSTATHandle,
									 vaData,
									 0,//mode = load new
									 0 //reserve
									 );
			switch(hr)
			{
				//------------------------------------------------------------------
				// Transmission started
				//------------------------------------------------------------------
				case S_OK:
				{
					to = WaitForSingleObject(mySink->hDataAvailEvent,15000);
					if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
					{
						MessageBox("timeout expired while loading data","DCOM Client",MB_OK);
						NumOfChar = 0;
					}
					else
					{
						NumOfChar = mySink->NumOfChar;
						::MessageBox(m_hWnd, "File Transmitted","DCOM Client",MB_OK);
						hr = pqsSTAT->EvaluateAllChars(qsSTATHandle);
						switch(hr)
						{
							//------------------------------------------------------------------
							//  evalution started
							//------------------------------------------------------------------
							case S_OK:
								{
									// wait until evaluation is done
									to = WaitForSingleObject(mySink->hEvaluationDoneEvent,15000);
									if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
									{
										::MessageBox(m_hWnd, "timeout expired while evaluating data","DCOM Client",MB_OK);
									}
									else
									{
										::MessageBox(m_hWnd, "File Transmitted and evaluated","DCOM Client",MB_OK);
									};
									break;
								}
							case E_ACCESSDENIED:
								{
									::MessageBox(m_hWnd, "Access denied","DCOM Client",MB_OK);
									break;
								}
							default:
							{
								char s[255];
								sprintf(s,"%s %d","EvaluateAllChars failed, errorcode", hr);
								::MessageBox(m_hWnd, "","DCOM Client",MB_OK);
							}
						}

					};					
					break;
				}
				//------------------------------------------------------------------
				// Server is busy
				//------------------------------------------------------------------
				case E_PENDING:
				{
					::MessageBox(m_hWnd, "Server is pending","DCOM Client",MB_OK);
					break;
				}
				//------------------------------------------------------------------
				//------------------------------------------------------------------
				case E_ACCESSDENIED:
					{
						::MessageBox(m_hWnd, "Access denied","DCOM Client",MB_OK);
						break;
					}
				//------------------------------------------------------------------
				//------------------------------------------------------------------
				default:
				{
					char s[255];
					sprintf(s,"%s %d","TransmitFileExt failed, errorcode", hr);
					::MessageBox(m_hWnd, "","DCOM Client",MB_OK);
				}
			}
			free(pBuffer);
		}
		f1.Close();
	}
}

void CVCPPCOMClient1View::OnFileOpen() 
{
	HRESULT hr = S_OK;
	if ((pqsSTAT)&& (qsSTATHandle))
	{
		// TODO: Add your command handler code here
		CString str;
		CFileDialog dlg(TRUE);
		if (dlg.DoModal() == IDOK)
		{
			str= dlg.GetPathName();
		}
		else
		{
			return;
		}

		
		if (str == "")
		{
			return;
		}
		
		CComBSTR FileName(str);
		//--------------------------------------------------------------------
		// Opening a file directly
		//--------------------------------------------------------------------
		hr = pqsSTAT->OpenFile(qsSTATHandle,FileName.m_str);
		switch(hr)
		{
			//----------------------------------------------------------------
			// Laoding of the file started
			//----------------------------------------------------------------
			case S_OK:
			{
				// wait until data is loaded
				//DWORD to = WaitForSingleObject(mySink->hDataAvailEvent,INFINITE);
				DWORD to = WaitForSingleObject(mySink->hDataAvailEvent,15000);
				if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
				{
					::MessageBox(m_hWnd, "timeout expired while loading data","DCOM Client",MB_OK);
					NumOfChar = 0;
				}
				else
				{
					NumOfChar = mySink->NumOfChar;
					//---------------------------------------------------------------
					// Evaluating the loaded data
					//---------------------------------------------------------------
					HRESULT hr = pqsSTAT->EvaluateAllChars(qsSTATHandle);
					switch(hr)
					{
						//-----------------------------------------------------------
						// evaluation is started
						//-----------------------------------------------------------
						case S_OK:
						{
							// wait until evaluation is done
							to = WaitForSingleObject(mySink->hEvaluationDoneEvent,15000);
							if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
							{
								::MessageBox(m_hWnd, "timeout expired while evaluating data","DCOM Client",MB_OK);
							}
							else
							{
								::MessageBox(m_hWnd, "data is loaded and evaluated","DCOM Client",MB_OK);
							};
							break;
						}
						//-----------------------------------------------------------
						//-----------------------------------------------------------
						case E_PENDING:
						{
							::MessageBox(m_hWnd, "Server is pending","DCOM Client",MB_OK);
							break;
						}
						//-----------------------------------------------------------
						//-----------------------------------------------------------
						default:
						{
							char s[255];
							sprintf(s,"%s %d","EvaluateAllChars failed, errorcode", hr);
							::MessageBox(m_hWnd, "Server error","DCOM Client",MB_OK);
						}
					}
				};
				break;
			}
			//----------------------------------------------------------------
			// server is busy
			//----------------------------------------------------------------
			case E_PENDING:
			{
				::MessageBox(m_hWnd, "Server is pending","DCOM Client",MB_OK);
				break;
			}
			//----------------------------------------------------------------
			//----------------------------------------------------------------
			case E_ACCESSDENIED:
				{
					::MessageBox(m_hWnd, "Access denied","DCOM Client",MB_OK);
					break;
				}
			//----------------------------------------------------------------
			//----------------------------------------------------------------
			default:
			{
				char s[255];
				sprintf(s,"%s %d","OpenFile failed, errorcode", hr);
				::MessageBox(m_hWnd, "","DCOM Client",MB_OK);
			}
		}
	}
}

void CVCPPCOMClient1View::OnFilePrintreport() 
{
	if ((pqsSTAT)&&(qsSTATHandle))
	{	
		CString sReportFileName = "";
		int		hr = S_OK;
		CString Str="1";
		CComBSTR NumOfCopys = (CComBSTR)Str;

		//--------------------------------------------------------------------
		// Print selected report with qs_Stat print function
		// to the predefined printer
		//--------------------------------------------------------------------
		hr = pqsSTAT->PrintReportExt(qsSTATHandle,
	       							ReportNr,		// Report Number
									ReportFileName,	// Report File Name
									PrinterNr,		// Printer ID (by default)
									NumOfCopys,		// Number of copyes	(set to print all pages)
									33,				// Print mode (set to print direct)
									2,				// Color mode (Black and White)
									0);				// Orientation (by default)
	
		if (FAILED(hr))
		{
			::MessageBox(m_hWnd, "Operation failed","Print Report",MB_OK);
		}
	}
}

void CVCPPCOMClient1View::OnGetGraphic() 
{
	//------------------------------------------------------------------------
	// 1. Ask the desired graphic
	// 2. Request Graphic from qs-STAT server
	// 3. Refresh View
	//------------------------------------------------------------------------

	int	rc;
	CSelektGrafKey* SelektGrafKey = new(CSelektGrafKey);

	// init dialog
	SelektGrafKey->SetPartNr_x(PartNr_x);
	SelektGrafKey->SetCharNr_x(CharNr_x);
	SelektGrafKey->SetPartNr_y(PartNr_y);
	SelektGrafKey->SetCharNr_y(CharNr_y);

	SelektGrafKey->SetGraphicKey(GrafKey);
	SelektGrafKey->SetGraphicSubkey(GrafSubKey);
	SelektGrafKey->SetUseExtFunc(UseExtFunc);

	if (SelektGrafKey->DoModal() == IDOK)
	{
		// retrieve adress
		PartNr_x	= SelektGrafKey->GetPartNr_x();
		CharNr_x	= SelektGrafKey->GetCharNr_x();
		PartNr_y	= SelektGrafKey->GetPartNr_y();
		CharNr_y	= SelektGrafKey->GetCharNr_y();

		GrafKey		= SelektGrafKey->GetGraphicKey();
		GrafSubKey	= SelektGrafKey->GetGraphicSubkey();
		UseExtFunc	= SelektGrafKey->GetUseExtFunc();

		// requesting the graphic from the server
		GIndex = 1;
		rc = GetGraphic(GIndex);
		if (!rc)
		{
			// Painting the graphic onto the view
			OnDraw(this->GetDC());
		}
		else
		{
			::MessageBox(m_hWnd, "GetGrahic failed","DCOM Client",MB_OK);
		}
	}
	else
	{
		// cancel dialog
	}
	delete SelektGrafKey;
}

void CVCPPCOMClient1View::OnGetReport() 
{
	if (pqsSTAT)
	{
		int		rc;
		COleVariant va;
		CString Str="1";
		CString sReportFileName = "";
		CComBSTR NumOfCopys = (CComBSTR)Str;
		
		//--------------------------------------------------------------------
		// set all parameters in new window by default
		//--------------------------------------------------------------------
		CSelektReportKey*	SelektReportKey = new CSelektReportKey(this);

		SelektReportKey->SetPartNr_x(PartNr_x);
		SelektReportKey->SetCharNr_x(CharNr_x);
		SelektReportKey->SetValueNr_x(ValueNr_x);
		SelektReportKey->SetPartNr_y(PartNr_y);
		SelektReportKey->SetCharNr_y(CharNr_y);
		SelektReportKey->SetValueNr_y(ValueNr_y);
		SelektReportKey->SetWidth(Width);
		SelektReportKey->SetHeight(Height);
		SelektReportKey->SetCheckPrn(ReportPrn);
		SelektReportKey->SetServerObject(pqsSTAT, qsSTATHandle);

		//--------------------------------------------------------------------
		// query new parameters and paint or print report
		//--------------------------------------------------------------------
		if (SelektReportKey->DoModal() == IDOK)
		{
			PartNr_x	    = SelektReportKey->GetPartNr_x();
			CharNr_x		= SelektReportKey->GetCharNr_x();
			ValueNr_x		= SelektReportKey->GetValueNr_x();
			PartNr_y	    = SelektReportKey->GetPartNr_y();
			CharNr_y		= SelektReportKey->GetCharNr_y();
			ValueNr_y		= SelektReportKey->GetValueNr_y();
			Width			= SelektReportKey->GetWidth();
			Height			= SelektReportKey->GetHeight();
			ReportPrn		= SelektReportKey->GetCheckPrn();
			ReportNr		= SelektReportKey->SelItem;
			sReportFileName = SelektReportKey->GetReportFileName();
			ReportFileName	= (CComBSTR)sReportFileName;

			//--------------------------------------------------------------------
			// requesting the report for the addressed chararcteristic
			//--------------------------------------------------------------------
			if (ReportFileName == "-1")
			{
				::MessageBox(m_hWnd, "No Report selected","DCOM Client",MB_OK);
			}
			else
			{
				//--------------------------------------------------------------------
				// Painting report on screan
				//--------------------------------------------------------------------
				GIndex = 2;
				rc = GetGraphic(GIndex);				
				if (!rc)
				{
				// Painting the graphic onto the view
				OnDraw(this->GetDC());
				}
				if (ReportPrn) // If print options checked
				{
					//--------------------------------------------------------------------
					// Print selected report with qs_Stat print function
					// to the predefined printer
					//--------------------------------------------------------------------
					rc = pqsSTAT->PrintReportExt(qsSTATHandle,
	               							ReportNr,		// Report Number
											ReportFileName,	// Report File Name
											PrinterNr,		// Printer ID
											NumOfCopys,		// Number of copyes	(set to print all pages)
											33,				// Print mode (set to print direct)
											2,				// Color mode (Black and White)
											0);				// Orientation (by default)
				}
				if (rc)
				{
					::MessageBox(m_hWnd, "Operation failed","Print Report",MB_OK);
				}
			}
		}
		delete SelektReportKey;
	}
}

void CVCPPCOMClient1View::OnGetResult() 
{
	//------------------------------------------------------------------------
	// 1. Ask the desired statistical result
	// 2  Request the result from the server
	// 3. Show the result in a messagebox
	//------------------------------------------------------------------------
	if (pqsSTAT)
	{
		BSTR	sWert=0;
		double  dWert=0;
		int		hr;
		long	OutputCount;
		BSTR	sValue1 = 0;
		BSTR	sValue2 = 0;
		BSTR	sValue3 = 0;
		BSTR	sValue4 = 0;
		BSTR	sValue5 = 0;
		double	dValue1 = 0;
		double	dValue2 = 0;
		double	dValue3 = 0;
		double	dValue4 = 0;
		double	dValue5 = 0;


		CSelektStatKey*	SelektStatKey = new CSelektStatKey(this);

		SelektStatKey->SetPartNr_x(PartNr_x);
		SelektStatKey->SetCharNr_x(CharNr_x);
		SelektStatKey->SetStatResultKey(StatKey);
		SelektStatKey->SetStatResultSubkey(StatSubKey);
		SelektStatKey->SetTransformation(Transformation);
		SelektStatKey->SetUseExtFunc(UseExtFunc);

		if (SelektStatKey->DoModal() == IDOK)
		{
			PartNr_x	    = SelektStatKey->GetPartNr_x();
			CharNr_x		= SelektStatKey->GetCharNr_x();
			StatKey			= SelektStatKey->GetStatResultKey();
			StatSubKey		= SelektStatKey->GetStatResultSubkey();
			Transformation	= SelektStatKey->GetTransformation();
			UseExtFunc		= SelektStatKey->GetUseExtFunc();
			//--------------------------------------------------------------------
			// requesting the statistical result for the addressed chararcteristic
			//--------------------------------------------------------------------
			if (!UseExtFunc)
			{
  				hr = pqsSTAT->GetStatResult(qsSTATHandle,
			                            StatKey,// Key for result
										PartNr_x,   //Part
										CharNr_x,	//characteristic
										Transformation,	//transformation NO
										&sWert,&dWert);
			}
			else
			{
        
 				hr = pqsSTAT->GetStatResultEx(qsSTATHandle,
											  PartNr_x,   //Part
											  CharNr_x,	//characteristic
											  0,// GroupNr
											  StatKey, StatSubKey,
											  4,// OutputType: content of the field
											  Transformation,	//transformation NO
											  0,0,//reserve1 ,2
											  &sValue1,&sValue2,&sValue3,&sValue4,&sValue5,
											  &OutputCount,
											  &dValue1,&dValue2,&dValue3,&dValue4,&dValue5);
				sWert = sValue1;
			}
			if (SUCCEEDED(hr))
			{
				::MessageBox(m_hWnd, (CString)sWert,"DCOM Client",MB_OK);
			}
			else
			{
				::MessageBox(m_hWnd, "GetStatResult failed","DCOM Client",MB_OK);
			}
		}
		delete SelektStatKey;
	}
}

void CVCPPCOMClient1View::OnGetValue() 
{
	if ((pqsSTAT)&&(qsSTATHandle))
	{
		BSTR	Wert=0;
		HRESULT	hr;
		//--------------------------------------------------------------------
		// requesting the value (Key 1) for part 1 characteristic 1 value 1
		//--------------------------------------------------------------------
		hr = pqsSTAT->GetValueInfo(qsSTATHandle,1,1,1,1,0,&Wert);
		if (SUCCEEDED(hr))
		{
			::MessageBox(m_hWnd, (CString)Wert,"DCOM Client",MB_OK);
		}
		else
		{
			::MessageBox(m_hWnd, "GetValueInfo failed","DCOM Client",MB_OK);
		}
	}
}

void CVCPPCOMClient1View::OnOnlinetransmissionSimulateoneline() 
{
	SimulateDFQ();
}

void CVCPPCOMClient1View::OnOpenbasefile() 
{
	//---------------------------------------------------------
	// Open base file for monitoring
	// TODO: 
	// 0. Set the Online module
	// 1. Open file
	// 2. Transmit the file to the server
	// 3. Draw the previously defined graphic
	//---------------------------------------------------------

	HRESULT	hr = S_OK;

	sBaseFileName = "";// Base file for Online supervision
	sBaseFilePath = "";
	LastReadFilePos = 0;//alread read Bytes from Base file
	if (pqsSTAT)
	{
		//-----------------------------------------------------
		// set OnlineModule (26 == procella)
		//-----------------------------------------------------
		hr = pqsSTAT->SetModule(qsSTATHandle,26); 
		if (SUCCEEDED(hr))
		{
			OnlineMode	= TRUE;
			ModuleID	= 26;

			// Get the file name
			CComBSTR FileName(sBaseFileName);
			CFileDialog dlg(TRUE);
			if (dlg.DoModal() == IDOK)
			{
				sBaseFileName = dlg.GetPathName();
				sBaseFilePath = dlg.GetPathName();
			
			CString sTmp = dlg.GetFileName();

			CString sTmp1 = sBaseFilePath;
			int x = sTmp1.Find(sTmp);
			int l = sTmp1.GetLength();
			int l1 = sTmp.GetLength();

			sBaseFilePath.Delete(x,l-x);

			}
			else
			{
				// nothing to do!
				return;
			}
		


		    //---------------------------------------------------------
		    // read the file fo a local buffer
			//---------------------------------------------------------
			BYTE*		pBuffer;		
			long		BufLen;
			COleVariant vaData;
			CFile f1(sBaseFileName,CFile::modeRead | CFile::shareDenyNone);
			LastReadFilePos = f1.GetLength();

			BufLen = LastReadFilePos;
			pBuffer = (BYTE*)malloc(BufLen);
			if (pBuffer)
			{
				f1.ReadHuge(pBuffer,LastReadFilePos);
				// prepare the buffer for transmission
				PutBinaryIntoVariant(&vaData,pBuffer,BufLen);

				//---------------------------------------------------------
				// Transmit the data to server and reset data previously loaded data
				//---------------------------------------------------------
				hr = pqsSTAT->TransmitFileExt(qsSTATHandle,
										 vaData,
										 0,//mode = load new
										 0 //reserve
										 );
				if (SUCCEEDED(hr))
				{
					DWORD to = WaitForSingleObject(mySink->hDataAvailEvent,15000);
					if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
					{
						MessageBox("timeout expired while loading data","DCOM Client",MB_OK);
						NumOfChar = 0;
					}
					else
					{
						NumOfChar = mySink->NumOfChar;
						//---------------------------------------------------------
						// Get the graphic and drawIt 
						//---------------------------------------------------------
						GetOnlineGraphic(GrafKey/*presetted graphic*/, 6104/*SPC-QC*/);

						// refresh view
						OnDraw(this->GetDC());
					};
				}
				else
				{
					MessageBox("TransmitFileExt failed","DCOM Client",MB_OK);
				}

				free(pBuffer);
			}
			f1.Close();
		}
		else
		{
			if (hr == E_ACCESSDENIED )
			{
				::MessageBox(m_hWnd, "Set module failed, access denied","DCOM Client",MB_OK);
			}
			else
			{
				::MessageBox(m_hWnd, "Set module failed, unknown error!","DCOM Client",MB_OK);
			}
		}
	} 
}

void CVCPPCOMClient1View::OnProcesscapability() 
{
	//---------------------------------------------------------------------------
	// Prozeanalyse auf Anforderung
	// 1. Online Modus beenden
	// 2. Daten im FIFO Puffer in Prozeanalyse auswerten
	// 3. C-Wert Grafik abrufen
	// 4. Monitoring und Simulation neu starten
	// 
	// process capability on request
	// 1. stop the online mode / tranmission
	// 2. Evaluate data in the FIFO buffer
	// 3. Get C-Value plot
	// 4. restart monitoring and simulation
	//---------------------------------------------------------------------------
	int		to;
	HRESULT	hr;

	
	//---------------------------------------------------------------------------
	// Monitoring und Simulation  beenden
	// stop monitoring and simulation
	//---------------------------------------------------------------------------
	BOOL WasSimulating  = SimulationIsRunning;
	BOOL WasMonitoring	= MonitoringInProgress;
	BOOL WasOnlineMode	= OnlineMode;

	OnStopfilescan();
	OnStopsimulateDfq();

	OnlineMode = FALSE;


	//-------------------------------------------------------------------------
	// Auswerten
	// evaluate
	//-------------------------------------------------------------------------
	hr = pqsSTAT->EvaluateAllChars(qsSTATHandle);
	if (SUCCEEDED(hr))
	{
		// wait until evaluation is done
		to = WaitForSingleObject(mySink->hEvaluationDoneEvent,15000/*INFINITE*/);
		if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
		{
			::MessageBox(m_hWnd, "timeout expired while evaluating data","DCOM Client",MB_OK);
		}
		else
		{
			//--------------------------------------------------------------------
			// C-Wert Grafik abrufen (7200)
			// request C-value plot (7200)
			//--------------------------------------------------------------------
			GrafKey = 7200;
			GIndex = 1;
			int rc = GetGraphic(GIndex);
			if (rc == 0)
			{
				// Painting the graphic onto the view
				OnDraw(this->GetDC());
			}
		}	

		//-----------------------------------------------------------------
		// Monitoring und Simulation neu starten
		// restart monitoring and simulation process
		//-----------------------------------------------------------------
		if (WasMonitoring)
		{	
			OnlineMode = TRUE;
			GrafKey = 3100;// single value plot
			OnStartfilescan();
		}

		if (WasSimulating)
		{
			OnSimulateDfq();
		}
		else
		{
			if (hr == E_ACCESSDENIED )
			{
				::MessageBox(m_hWnd, "Evaluation failed, aCess denied!","DCOM Client",MB_OK);
			}
			else
			{
			::MessageBox(m_hWnd, "Evaluation failed, unknown error!","DCOM Client",MB_OK);
			}
		}
	}
}

void CVCPPCOMClient1View::OnSetFilter() 
{
	if (pqsSTAT)
	{
		QueryFilterDialog*	pQueryFilterDialog = new QueryFilterDialog(this);
		//--------------------------------------------------------------------
		// Transfer QS_STAT and Handle to Printer select unit
		//--------------------------------------------------------------------
		pQueryFilterDialog->SetServerObject(pqsSTAT, qsSTATHandle);
		if (pQueryFilterDialog->DoModal() == IDOK)
		{
		}
		delete pQueryFilterDialog;
	}
}

void CVCPPCOMClient1View::OnSetLanguage() 
{
	if (pqsSTAT)
	{
		HRESULT	hr = S_OK;
		CString Str;
		CString StrName;
		BSTR	sLanguageName = 0;// return value
		int		NewLangId = 0;

		CSetCustomKey*	SelectLanguageDlg = new CSetCustomKey(this);
		SelectLanguageDlg->SetServerObject(pqsSTAT, qsSTATHandle);
		SelectLanguageDlg->SetItemType(2); // use dialog for selecting languages
		//--------------------------------------------------------------------
		// set new Language
		//--------------------------------------------------------------------
		if (SelectLanguageDlg->DoModal() == IDOK)
		{
			Str = SelectLanguageDlg->GetTypeKey();
			LPTSTR p = Str.GetBuffer(Str.GetLength());
			NewLangId = atoi(p);
			hr = pqsSTAT->SetLanguage( qsSTATHandle, NewLangId, &sLanguageName);	
			switch(hr)
			{
				//------------------------------------------------------------
				//------------------------------------------------------------
				case S_OK:
				{
					LanguageID = NewLangId;
					break;
				}
				//------------------------------------------------------------
				//------------------------------------------------------------
				case E_ACCESSDENIED:
				{
					::MessageBox(m_hWnd, "Set language failed, access denied","DCOM Client",MB_OK);
					break;
				}
				//------------------------------------------------------------
				//------------------------------------------------------------
				default:
				{
					char s[255];
					sprintf(s,"%s %d","Set language failed, errorcode", hr);
					::MessageBox(m_hWnd, s,"DCOM Client",MB_OK);
					break;
				}
			}
		}
		delete SelectLanguageDlg;
	}
}

void CVCPPCOMClient1View::OnSetModule() 
{
	if (pqsSTAT)
	{
		CString Str;
		HRESULT	hr = S_OK;
		CSetCustomKey*	SelectModuleDlg = new CSetCustomKey(this);

		// passing server handle to a dialog box
		SelectModuleDlg->SetServerObject(pqsSTAT, qsSTATHandle);
		// use dialog for selecting modules = (1) 
		SelectModuleDlg->SetItemType(1);

		//--------------------------------------------------------------------
		// set new Module
		//--------------------------------------------------------------------
		if (SelectModuleDlg->DoModal() == IDOK)
		{
			Str = SelectModuleDlg->GetTypeKey();
			LPTSTR p = Str.GetBuffer(Str.GetLength());
			int NewModuleId = atoi(p);

			// setting the selected module inside the server
			hr = pqsSTAT->SetModule(qsSTATHandle, NewModuleId);
			switch(hr)
			{
				//------------------------------------------------------------
				//------------------------------------------------------------
				case S_OK:
				{
					ModuleID	= NewModuleId;
					if (ModuleID == 26)
					{
						OnlineMode = TRUE;
					}
					else
					{
						OnlineMode = FALSE;
					}
					ModuleID = NewModuleId;
					break;
				}
				//------------------------------------------------------------
				//------------------------------------------------------------
				case E_ACCESSDENIED:
				{
					::MessageBox(m_hWnd, "Set module failed, access denied","DCOM Client",MB_OK);
					break;
				}
				//------------------------------------------------------------
				//------------------------------------------------------------
				default:
				{
					char s[255];
					sprintf(s,"%s %d","Set module failed, errorcode", hr);
					::MessageBox(m_hWnd, s,"DCOM Client",MB_OK);
					break;
				}
			}
		}
		delete SelectModuleDlg;
	}
}

void CVCPPCOMClient1View::OnSetPrinter() 
{
	if (pqsSTAT)
	{
		CSelektPrintDialog*	pSelektPrintDialog = new CSelektPrintDialog(this);
		//--------------------------------------------------------------------
		// Transfer QS_STAT and Handle to Printer select unit
		//--------------------------------------------------------------------
		pSelektPrintDialog->SetServerObject(pqsSTAT, qsSTATHandle);
		if (pSelektPrintDialog->DoModal() == IDOK)
		{
			//--------------------------------------------------------------------
			// Set new available printer
			//--------------------------------------------------------------------
			PrinterNr = pSelektPrintDialog->GetPrinterNr();
			::MessageBox(m_hWnd, "Printer selected","DCOM Client",MB_OK);
		}
		delete pSelektPrintDialog;
	}
}

void CVCPPCOMClient1View::OnSetStrategy() 
{
	HRESULT	hr = S_OK;
	if (pqsSTAT)
	{
		CSetCustomKey*	SelectStrategyDlg = new CSetCustomKey(this);
		SelectStrategyDlg->SetServerObject(pqsSTAT, qsSTATHandle);
		SelectStrategyDlg->SetItemType(3);
		SelectStrategyDlg->SetModule(ModuleID);
		//--------------------------------------------------------------------
		// set new Strategy
		//--------------------------------------------------------------------
		if (SelectStrategyDlg->DoModal() == IDOK)
		{
			int NewStrategyID = SelectStrategyDlg->SelItem;		
			hr	= pqsSTAT->SetEvaluationStrategy(qsSTATHandle,0,NewStrategyID);	
			switch(hr)
			{
				//------------------------------------------------------------
				//------------------------------------------------------------
				case S_OK:
				{
					StrategyID = NewStrategyID;
					break;
				}
				//------------------------------------------------------------
				//------------------------------------------------------------
				case E_ACCESSDENIED:
				{
					::MessageBox(m_hWnd, "Set SetEvaluationStrategy failed, access denied","DCOM Client",MB_OK);
					break;
				}
				//------------------------------------------------------------
				//------------------------------------------------------------
				default:
				{
					char s[255];
					sprintf(s,"%s %d","Set SetEvaluationStrategy failed, errorcode", hr);
					::MessageBox(m_hWnd, s,"DCOM Client",MB_OK);
					break;
				}
			}

		}
		delete SelectStrategyDlg;
	}
}

void CVCPPCOMClient1View::OnShowalarms() 
{
	//---------------------------------------------------------------
	// aufgelaufene Alarme anzeigen
	// Display the recently stored alarms
	//---------------------------------------------------------------
	CAlarmShowDlg* 		AlarmShowDlg = new CAlarmShowDlg(this);
	AlarmShowDlg->SetAlarmList(&Alarms);
	if (AlarmShowDlg->DoModal() == IDOK)
	{
		// Alarmliste lschen
		// delete list of alarms
		Alarms.RemoveAll();
	}

	delete AlarmShowDlg;
}

void CVCPPCOMClient1View::OnSimulateDfq() 
{
	//----------------------------------------------------------------
	// Simulate the creation of a DFQ-File in a separate Thread
	// 1. Enter Informations about the file (# of characteristics, filename, fileformat)
	// 2. Create the header informations (part/characteristics)
	// 3. start a thread, that simulates values and append them to the DFQ/DFX file
	//----------------------------------------------------------------

	DWORD dwId;

	CDFQLimSettingsDialog*	pDFQLIMSettingsDialog = new CDFQLimSettingsDialog(this);

	pDFQLIMSettingsDialog->SetLim(lim);

	pDFQLIMSettingsDialog->SetInterval(sim_interval);
	pDFQLIMSettingsDialog->SetAttribute(Attribute);
	pDFQLIMSettingsDialog->SetBatchNum(BatchNum);
	pDFQLIMSettingsDialog->SetBatchNumValue(BatchValue);
	pDFQLIMSettingsDialog->SetGageNum(GageNum);
	pDFQLIMSettingsDialog->SetMachineNum(MachineNum);
	pDFQLIMSettingsDialog->SetNestNum(NestNum);
	pDFQLIMSettingsDialog->SetOperatorNum(OperatorNum);
	pDFQLIMSettingsDialog->SetOrder(Order);
	pDFQLIMSettingsDialog->SetOrderValue(OrderValue);

	if (pDFQLIMSettingsDialog->DoModal() == IDOK)
	{
		lim			 = pDFQLIMSettingsDialog->GetLim();
		sim_interval = pDFQLIMSettingsDialog->GetInterval();
		BatchNum	 = pDFQLIMSettingsDialog->GetBatchNum();
		BatchValue   = pDFQLIMSettingsDialog->GetBatchNumValue();
		GageNum		 = pDFQLIMSettingsDialog->GetGageNum();
		MachineNum	 = pDFQLIMSettingsDialog->GetMachineNum();
		NestNum		 = pDFQLIMSettingsDialog->GetNestNum();
		OperatorNum  = pDFQLIMSettingsDialog->GetOperatorNum();
		Order		 = pDFQLIMSettingsDialog->GetOrder();
		OrderValue	 = pDFQLIMSettingsDialog->GetOrderValue();
	}
	
	delete pDFQLIMSettingsDialog;
	// getting info about current Base-File
	if (sBaseFileName == "")
	{
		::MessageBox(m_hWnd, "No Base File loaded","DCOM Client",MB_OK);
		return;
	}
	else
	{

		int rc;
		HANDLE h_file;	// file
		h_file = CreateFile(sBaseFileName, 
							GENERIC_READ | GENERIC_WRITE, // open for reading/writing 
							0,                            // do not share 
							NULL,                         // no security 
							OPEN_ALWAYS,                  // open or create 
							FILE_ATTRIBUTE_NORMAL,        // normal file 
							NULL);                        // no attr. template 

		if (h_file == INVALID_HANDLE_VALUE) 
		{ 
			rc = 1;
			::MessageBox(m_hWnd, "Cannot access file","DCOM Client",MB_OK);
		}	
		else
		{
			rc = 0;
			CloseHandle(h_file);
		}
		
		if (rc ==0)
		{
			// getting current number of char
			pqsSTAT->GetGlobalInfo(qsSTATHandle,0,0,2,&NumOfChar);
			g_StopDFQSimulateEvent = CreateEvent(NULL, FALSE,FALSE,"Test");
			srand( (unsigned)time( NULL ) );
			h_SimulationThread = CreateThread(NULL,0,&lpSimulateDFQFile, (LPVOID )this , 0, &dwId); 
		}
	};
}

void CVCPPCOMClient1View::OnStartfilescan() 
{
	//----------------------------------------------------------------
	// supervision of the previously transmitted file
	// 1. watch for new data inside the DFX file
	// 2. read the new data
	// 3. transmit the new data to the server (append to previously loaded data)
	// 4. refresh the graphic
	//----------------------------------------------------------------


	DWORD dwId;
	CFileMonitorSettingDlg FileMonitorSettingDlg;
	
	if (MonitoringInProgress) return;

	if (sBaseFileName == "")
	{
		::MessageBox(m_hWnd, "No Base File loaded","DCOM Client",MB_OK);
		return;
	}

	FileMonitorSettingDlg.m_FileChangeTriggered = m_FileChangeTriggered;
	FileMonitorSettingDlg.m_MonitoringIntervall = m_FileMonitoringIntervall;
	if (FileMonitorSettingDlg.DoModal())
	{
		m_FileChangeTriggered     = FileMonitorSettingDlg.m_FileChangeTriggered;
		m_FileMonitoringIntervall = FileMonitorSettingDlg.m_MonitoringIntervall;

		//-------------------------------------------------------------------------
		// Thread erzeugen, um Datei zu berwachen
		// create a thread for scanning the file, which has to be monitored
		//-------------------------------------------------------------------------
		g_StopFileScanEvent = CreateEvent(NULL, FALSE,FALSE,"Paul");
		h_MonitoringThread = CreateThread(NULL,0,&lpMonitorFileChanges, (LPVOID )this , 0, &dwId); 


		//-------------------------------------------------------------------------
		// Thread erzeugen, um Alarme abzufangen
		// Create a thread for catching the alarms
		//-------------------------------------------------------------------------
		g_StopAlarmEvent = CreateEvent(NULL, FALSE,FALSE,"Ingo");
		h_AlarmThread = CreateThread(NULL,0,&lpScanAlarms, (LPVOID )this , 0, &dwId); 

		MonitoringInProgress = TRUE;
	}
}

void CVCPPCOMClient1View::OnStartServer() 
{
	// Start the server in a separate Thread
	h_ServerThread = CreateThread(NULL,
								  0,
								  &lpQsStatConversation, 
								  (LPVOID )this , 
								  0, 
								  &dwServerThreadId); 
	
}

void CVCPPCOMClient1View::OnStopfilescan() 
{
	// stop the file monitoring thread
	if ((h_MonitoringThread)&&(g_StopFileScanEvent))
	{
		SetEvent(g_StopFileScanEvent);
		WaitForSingleObject(h_MonitoringThread,INFINITE);
		
		CloseHandle(g_StopFileScanEvent);
		g_StopFileScanEvent = NULL;

		CloseHandle(h_MonitoringThread);
		h_MonitoringThread = NULL;
	}

	// Stop the alarm thread
	if ((h_AlarmThread)&&(g_StopAlarmEvent))
	{
		SetEvent(g_StopAlarmEvent);
		WaitForSingleObject(h_AlarmThread, INFINITE);

		CloseHandle(g_StopAlarmEvent);
		g_StopAlarmEvent = NULL;

		CloseHandle(h_AlarmThread);
		h_AlarmThread = NULL;
	}

	MonitoringInProgress = FALSE;
}

void CVCPPCOMClient1View::OnStopsimulateDfq() 
{
	// stop the simulation thread
	if ((h_SimulationThread) && (g_StopDFQSimulateEvent))
	{
		SetEvent(g_StopDFQSimulateEvent);
		WaitForSingleObject(h_SimulationThread,INFINITE);
		
		CloseHandle(g_StopDFQSimulateEvent);
		g_StopDFQSimulateEvent = NULL;

		CloseHandle(h_SimulationThread);
		h_SimulationThread = NULL;
	}
}

//--------------------------------------------------------------------
// Load 2 graphics for Online-Simulation
//--------------------------------------------------------------------
int CVCPPCOMClient1View::GetOnlineGraphic( int GraphicKey1, 
										   int GraphicKey2)
{

	if (pqsSTAT)
	{
		
		COleVariant va1;
		COleVariant va2;
		BYTE*	pBuffer;
		unsigned long buflen;
		int		rc;
		CRect	DrawRect;
		int		GraphicWidth;
		int		GraphicHeight;
		int		GraphicKeyInt;

		COleVariant vaPartNr_x;
		COleVariant vaCharNr_x;
		COleVariant vaValueNr_x;
		COleVariant vaNrOfValues_x;
		COleVariant vaGroupNr_x;

		COleVariant vaPartNr_y;
		COleVariant vaCharNr_y;
		COleVariant vaValueNr_y;
		COleVariant vaNrOfValues_y;
		COleVariant vaGroupNr_y;


		VariantInit(&vaPartNr_x);  //
		vaPartNr_x[0].vt	= VT_I4;
		vaPartNr_x[0].lVal	= PartNr_x;

		VariantInit(&vaCharNr_x);  //
		vaCharNr_x[0].vt	= VT_I4;
		vaCharNr_x[0].lVal	= CharNr_x;

		VariantInit(&vaValueNr_x);  //
		vaValueNr_x[0].vt	= VT_I4;
		vaValueNr_x[0].lVal	= 0;

		VariantInit(&vaNrOfValues_x);  //
		vaNrOfValues_x[0].vt	= VT_I4;
		vaNrOfValues_x[0].lVal	= 0;

		VariantInit(&vaGroupNr_x);  //
		vaGroupNr_x[0].vt	= VT_I4;
		vaGroupNr_x[0].lVal	= 0;

		VariantInit(&vaPartNr_y);  //
		vaPartNr_y[0].vt	= VT_I4;
		vaPartNr_y[0].lVal	= PartNr_y;

		VariantInit(&vaCharNr_y);  //
		vaCharNr_y[0].vt	= VT_I4;
		vaCharNr_y[0].lVal	= CharNr_y;

		VariantInit(&vaValueNr_y);  //
		vaValueNr_y[0].vt	= VT_I4;
		vaValueNr_y[0].lVal	= 0;

		VariantInit(&vaNrOfValues_y);  //
		vaNrOfValues_y[0].vt	= VT_I4;
		vaNrOfValues_y[0].lVal	= 0;
		
		VariantInit(&vaGroupNr_y);  //
		vaGroupNr_y[0].vt	= VT_I4;
		vaGroupNr_y[0].lVal	= 0;

		rc = 0;
		
		//--------------------------------------------------------------------
		// select between GetGraphic and GetGraphicExt and draw it onto the screen
		//--------------------------------------------------------------------

		GetWindowRect(&DrawRect);
		for (int i = 0; i < 2; i++)
		{
			if (i==0)
			{

				// Graphic dimensions and adress
				GraphicKeyInt	= GraphicKey1;
				GraphicWidth	= DrawRect.Width();
				GraphicHeight	= DrawRect.Height()/2;
				
				pBuffer = NULL;

				rc = pqsSTAT->GetGraphicExt(qsSTATHandle,
										GraphicKeyInt,
										GrafSubKey,
										vaPartNr_x, //PartNr_x
										vaCharNr_x, //CharNr_x
										vaValueNr_x,//0
										vaNrOfValues_x,//0
										vaGroupNr_x,//0
										vaPartNr_y,//PartNr_y
										vaCharNr_y,//CharNr_y
										vaValueNr_y,//0
										vaNrOfValues_y,//0
										vaGroupNr_y,//0
										GraphicWidth,//rect.Width(),
										GraphicHeight,
										1,
										1,
										0,
										0,
										&va1);


				if (GetBinaryFromVariant(va1,&pBuffer,&buflen) == TRUE)

				{
				
					CFile f1("C:\\test1.bmp",CFile::modeCreate | CFile::modeReadWrite );
					f1.Write(pBuffer,buflen);
					f1.Close();

					if (OnlineDib1)
					{
						delete OnlineDib1;
					}
					OnlineDib1 = new CDib();
					OnlineDib1->Load("C:\\test1.bmp");

				}

				if (pBuffer) 
					delete pBuffer;
			}
			else
			{
				GraphicKeyInt	= GraphicKey2;
				GraphicWidth	= DrawRect.Width();
				GraphicHeight	= DrawRect.Height()/2;
				
				pBuffer = NULL;

				rc = pqsSTAT->GetGraphicExt(qsSTATHandle,
										GraphicKeyInt,
										GrafSubKey,
										vaPartNr_x, //PartNr_x
										vaCharNr_x, //CharNr_x
										vaValueNr_x,//0
										vaNrOfValues_x,//0
										vaGroupNr_x,//0
										vaPartNr_y,//PartNr_y
										vaCharNr_y,//CharNr_y
										vaValueNr_y,//0
										vaNrOfValues_y,//0
										vaGroupNr_y,//0
										GraphicWidth,//rect.Width(),
										GraphicHeight,
										1,
										1,
										0,
										0,
										&va2);

				if (GetBinaryFromVariant(va2,&pBuffer,&buflen) == TRUE)
				{
					CFile f1("C:\\test2.bmp",CFile::modeCreate | CFile::modeReadWrite );
					f1.Write(pBuffer,buflen);
					f1.Close();
					if (OnlineDib2)
					{
						delete OnlineDib2;
					}
					OnlineDib2 = new CDib();
					OnlineDib2->Load("C:\\test2.bmp");
				}
				if (pBuffer) 
					delete pBuffer;
			}// else (i==1)
		}// for

		return rc;
	}// (pqsstat)
	else
	{
		return -1;
	}

}

//--------------------------------------------------------------------
// Draw screen with GetGraphic or GetReport
//--------------------------------------------------------------------
int CVCPPCOMClient1View::GetGraphic(int whattodo)
{
	if (pqsSTAT)
	{
		
		COleVariant va;
		long	lbound,hbound;
		UINT	dim;
		void*	pBuffer;
		HRESULT hr;
		CRect	DrawRect;
		int		rc;

		GetWindowRect(&DrawRect);

		COleVariant vaPartNr_x;
		COleVariant vaCharNr_x;
		COleVariant vaValueNr_x;
		COleVariant vaNrOfValues_x;
		COleVariant vaGroupNr_x;

		COleVariant vaPartNr_y;
		COleVariant vaCharNr_y;
		COleVariant vaValueNr_y;
		COleVariant vaNrOfValues_y;
		COleVariant vaGroupNr_y;

		VariantInit(&vaPartNr_x);  //
		vaPartNr_x[0].vt	= VT_I4;
		vaPartNr_x[0].lVal	= PartNr_x;

		VariantInit(&vaCharNr_x);  //
		vaCharNr_x[0].vt	= VT_I4;
		vaCharNr_x[0].lVal	= CharNr_x;

		VariantInit(&vaValueNr_x);  //
		vaValueNr_x[0].vt	= VT_I4;
		vaValueNr_x[0].lVal	= 0;

		VariantInit(&vaNrOfValues_x);  //
		vaNrOfValues_x[0].vt	= VT_I4;
		vaNrOfValues_x[0].lVal	= 0;

		VariantInit(&vaGroupNr_x);  //
		vaGroupNr_x[0].vt	= VT_I4;
		vaGroupNr_x[0].lVal	= 0;

		VariantInit(&vaPartNr_y);  //
		vaPartNr_y[0].vt	= VT_I4;
		vaPartNr_y[0].lVal	= PartNr_y;

		VariantInit(&vaCharNr_y);  //
		vaCharNr_y[0].vt	= VT_I4;
		vaCharNr_y[0].lVal	= CharNr_y;

		VariantInit(&vaValueNr_y);  //
		vaValueNr_y[0].vt	= VT_I4;
		vaValueNr_y[0].lVal	= 0;

		VariantInit(&vaNrOfValues_y);  //
		vaNrOfValues_y[0].vt	= VT_I4;
		vaNrOfValues_y[0].lVal	= 0;
		
		VariantInit(&vaGroupNr_y);  //
		vaGroupNr_y[0].vt	= VT_I4;
		vaGroupNr_y[0].lVal	= 0;

		//--------------------------------------------------------------------
		// select between Graphic and Report
		//--------------------------------------------------------------------
		
		switch (GIndex)
		{
			case 1:
			{
				//--------------------------------------------------------------------
				// select between GetGraphic and GetGraphicExt and draw it onto the screen
				//--------------------------------------------------------------------
				
				if (UseExtFunc)
				{
					rc = pqsSTAT->GetGraphicExt(qsSTATHandle,
											GrafKey,
											GrafSubKey,
											vaPartNr_x/*PartNr_x*/,
											vaCharNr_x/*CharNr_x*/,
											vaValueNr_x/*0*/,
											vaNrOfValues_x/*0*/,
											vaGroupNr_x/*0*/,
											vaPartNr_y/*PartNr_y*/,
											vaCharNr_y/*CharNr_y*/,
											vaValueNr_y/*0*/,
											vaNrOfValues_y/*0*/,
											vaGroupNr_y/*0*/,
											DrawRect.Width(),
											DrawRect.Height(),
											1,
											1,
											0,
											0,
											&va);
				}
				else
				{
			
					rc = pqsSTAT->GetGraphic(qsSTATHandle,
										 GrafKey,
										 PartNr_x,
										 CharNr_x,
										 DrawRect.Width(),
										 DrawRect.Height(),
										 &va);
				}
				break;
			}
			case 2:
			{
				//--------------------------------------------------------------------
				// Get a report and draw it onto the screen
				//--------------------------------------------------------------------
				rc = pqsSTAT->GetReport(qsSTATHandle,
										ReportFileName,	//Report File Name
										PartNr_x,		//partnr_x: olevariant;
										CharNr_x,		//charnr_x: olevariant
										0,				//valuenr_x: olevariant
										0,				//nrofvalues_x: olevariant;
										PartNr_y,       //partnr_y: olevariant;
										CharNr_y,		//charnr_y: olevariant
										0,				//valuenr_y: olevariant;
										0,				//nrofvalues_y: olevariant;
										0,				//pagenr: olevariant;
										DrawRect.Width(),//width
										DrawRect.Width(),//height
										0,				//configid: integer
										&va);				
			break;
			}
			// 
			case 3:
			{
				break;
			}
		}
		
		if (!rc)
		{
			dim = SafeArrayGetDim(((LPCVARIANT)va)->parray);
			hr	= SafeArrayGetLBound(((LPCVARIANT)va)->parray,dim,&lbound);
			hr	= SafeArrayGetUBound(((LPCVARIANT)va)->parray,dim,&hbound);
	
			hr	= SafeArrayLock(((LPCVARIANT)va)->parray);
			hr	= SafeArrayAccessData(((LPCVARIANT)va)->parray,&pBuffer);

			CFile f1("C:\\test.bmp",CFile::modeCreate | CFile::modeReadWrite );
			f1.Write(pBuffer,lbound+hbound);
			f1.Close();

			hr	= SafeArrayUnlock(((LPCVARIANT)va)->parray);
			hr	= SafeArrayUnaccessData(((LPCVARIANT)va)->parray);
			

			if (dib)
			{
				delete dib;
			}
			dib = new CDib();
			dib->Load("C:\\test.bmp");

		}
		return rc;
	}// (pqsstat)
	else
	{
		return -1;
	}
}

void CVCPPCOMClient1View::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	if (!OnlineMode)
	{
		GetGraphic(GIndex);
	}
	else
	{
		GetOnlineGraphic(GrafKey/*presetted graphic*/, 6104/*SPC-QC*/);
	}
	
}

void CVCPPCOMClient1View::ReloadFile()
{
	//----------------------------------------------------------------
	// 1. scan the filesize and read the recently added bytes
	// 2. Transmit the previously added data to the server
	// 3. refresh the displayed graphic
	//----------------------------------------------------------------

	if ((pqsSTAT)&& (sBaseFileName != ""))
	{

		long		CurrentFileLength;
		BYTE*		pBuffer;		
		long		BufLen;
		COleVariant vaData;
		int			rc;

		// read the file fo a local buffer
		CFile f1(sBaseFileName,CFile::modeRead | CFile::shareDenyWrite);
		CurrentFileLength = f1.GetLength();

		BufLen = CurrentFileLength - LastReadFilePos + 1;
		if (BufLen > 0)
		{
			pBuffer = (BYTE*)malloc(BufLen);
			if (pBuffer)
			{
				f1.Seek(LastReadFilePos,CFile::begin);
				f1.ReadHuge(pBuffer,BufLen);
				PutBinaryIntoVariant(&vaData,pBuffer,BufLen);
				LastReadFilePos = CurrentFileLength;

			
				// Transmit the data to server and reset data previously loaded data
				ResetEvent(mySink->hDataAvailEvent); // to be sure

				pqsSTAT->TransmitFileExt(qsSTATHandle,
										 vaData,
										 2,//mode = append Values
										 0 //reserve
										 );
				DWORD to = WaitForSingleObject(mySink->hDataAvailEvent,15000);
				if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
				{
					MessageBox("timeout expired while loading data","DCOM Client",MB_OK);
					NumOfChar = 0;
				}
				else
				{
					rc = GetOnlineGraphic(	GrafKey,// presetted graphic 
											6104	// Online-QC
										  );
					if (!rc)
					{
						// Painting the graphic onto the view
						OnDraw(this->GetDC());
					}
					else
					{
						::MessageBox(m_hWnd, "GetGrahic failed","DCOM Client",MB_OK);
					}

				};

				free(pBuffer);
			}
		}
		f1.Close();
	}

}

void CVCPPCOMClient1View::OnAppAbout() 
{
	CAboutDialog*	pAboutDialog = new CAboutDialog(this);
	BSTR	Version=0;
	if (qsSTATHandle > 0)
    {
	   pqsSTAT->QsstatVersion(qsSTATHandle,&Version);

	}
	pAboutDialog->SetServerVer((CString)Version);
		
	// Show client info
	pAboutDialog->DoModal();

	delete pAboutDialog;
}


void CVCPPCOMClient1View::SimulateDFQ()
{

	// Simulation of a DFX line

	HANDLE h_file;	// file
	DWORD dw_pos;	// position
	DWORD dw_bytes_written;
	char s_new_line[1000] = "";
	char s_new_line_add[1000] = "";
	char s_char_add[1] = "";	
	int i_rand_num;
	double f_lim_up;
	double f_lim_down;
	CString UpLim;
	CString DownLim;
	char sep0X0F = 0x0F;
	char sep0X14 = 0x14;
	int i = 1;
	CString  CurrentTime = "";

	h_file = CreateFile(sBaseFileName, 
						GENERIC_READ | GENERIC_WRITE, // open for reading/writing 
						0,                            // do not share 
						NULL,                         // no security 
						OPEN_ALWAYS,                  // open or create 
						FILE_ATTRIBUTE_NORMAL,        // normal file 
						NULL);                        // no attr. template 

	if (h_file == INVALID_HANDLE_VALUE) 
	{ 
		dfq_close(h_file);
	}	

	if(dfq_find_end(h_file,&dw_pos)!=0)//,s_last_line,sizeof(s_last_line)-1)!=0)
	{
		dfq_close(h_file);
	}

	// generate random result
	
	i_rand_num = rand();
	i_rand_num = i_rand_num % 100;

	int CharCt = NumOfChar;// number of availbale characteristics
	while (CharCt--)
	{
		// getting graphic limits 
		pqsSTAT->GetCharInfo(qsSTATHandle,2111,1,i,&K_Field_Up);
		pqsSTAT->GetCharInfo(qsSTATHandle,2110,1,i,&K_Field_Down);	
		
		//converting graphic limits from char to float
		UpLim = K_Field_Up;
		DownLim = K_Field_Down;
		f_lim_up = atof(UpLim.GetBuffer(UpLim.GetLength()));
		f_lim_down = atof(DownLim.GetBuffer(DownLim.GetLength()));

		//operate with limits:
		// find medium, generate random number and add to lover limit
		f_lim_down += i_rand_num * (((f_lim_up + f_lim_up*(lim/10)) - 
						  (f_lim_down + f_lim_down*(lim/10)))/100);
		
		//relise temp variables
		UpLim.ReleaseBuffer();
		DownLim.ReleaseBuffer();				

		if (i == 1) //update string with first random value & all selected parametrs
		{
			CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
			sprintf(s_new_line_add,"%1.14E%c%d%c%s%s%c%c%s%s%d%c%d%c%d%c%d%c%c%d",
					f_lim_down,sep0X14,Attribute,sep0X14,"01.01.1970/",
					CurrentTime,sep0X14,sep0X14,"#",BatchNum,
					i_rand_num%(BatchValue+1),sep0X14,i_rand_num%(NestNum+1),
					sep0X14,i_rand_num%(OperatorNum+1),sep0X14,
					i_rand_num%(MachineNum+1),sep0X14,sep0X14,i_rand_num%(GageNum+1));
			strcat(s_new_line, s_new_line_add);
		}
		else //update string with second random generated value (only for CHAR > 1)
		{
			sprintf(s_new_line_add,"%c%1.14E", sep0X0F, f_lim_down);
			strcat(s_new_line, s_new_line_add);
		};
		i++;
	}

	sprintf(s_new_line_add,"%s\r\n%s%s%d%s\r\n", "","K0053/0 ",Order,i_rand_num%(OrderValue+1),"");	
	strcat(s_new_line, s_new_line_add);

	if(!WriteFile(h_file, s_new_line, strlen(s_new_line),&dw_bytes_written, NULL))
	{
		dfq_close(h_file);
	}
	dfq_close(h_file);
			
}

void CVCPPCOMClient1View::RedAlert()
{

	//--------------------------------------------------------------------
	// Reaktion auf Statistik-Alarme
	// reaction to statistcal alarms
	//--------------------------------------------------------------------

	unsigned long AlarmEW1;
	unsigned long AlarmEW2;
	unsigned long AlarmQRK_l;
	unsigned long AlarmQRK_s;
	unsigned long AlarmCP;
	unsigned long AlarmNOSPC;
	long AlarmPartNr;
	long AlarmCharNr;
	long AlarmValueNr;
	long AlarmSampleNr;


	// Alarme speichern bis zum Abruf
	// Alarmmeldung anzeigen
	// store alarms until request for display
	// Show alarm immediately in a message box
	if ((m_AlwaysShowAlarm)||(m_StoreAlarm))
	{
		BOOL rc = TRUE;
		while (rc) 
		{
			//---------------------------------------------------------------------
			// alle aufgelaufenen Alarme abholen
			// read all oCurred alarms
			//---------------------------------------------------------------------
			rc = mySink->GetAlarm(	AlarmEW1,
									AlarmEW2,
									AlarmQRK_l,
									AlarmQRK_s,
									AlarmCP,
									AlarmNOSPC,
									AlarmPartNr,
									AlarmCharNr,
									AlarmValueNr,
									AlarmSampleNr);
			if (rc)
			{
				//---------------------------------------------------------------------
				// sofort anzeigen
				// display the alarm immediately
				//---------------------------------------------------------------------
				if (m_AlwaysShowAlarm)
				{
					char buffer[255] = "";
					char buffer2[255] = "";
	
					sprintf(buffer, "Single Value Alarm: %d,\n location Alarm: %d,\n variation Alarm: %d\n", 
							AlarmEW1,
							AlarmQRK_l,
							AlarmQRK_s);
	
					strcat(buffer2,buffer);
					sprintf(buffer, "PartNo: %d,\n Char.No.: %d,\n ValueNo: %d,\n SampleNo.: %d", 
							AlarmPartNr,
							AlarmCharNr,
							AlarmValueNr,
							AlarmSampleNr);
					strcat(buffer2,buffer);

					::MessageBox(NULL,buffer2 , "QS Alarm Event",MB_OK);

				};//AlwaysShowAlarm

				//---------------------------------------------------------------------
				// in einer Liste bis zum Aufruf speichern
				// store the alarms in a list until being displayed
				//---------------------------------------------------------------------
				if (m_StoreAlarm)
				{
					CAlarm NewAlarm;
					NewAlarm.AlarmEW1	= AlarmEW1;
					NewAlarm.AlarmEW2	= AlarmEW2;
					NewAlarm.AlarmQRK_l = AlarmQRK_l;
					NewAlarm.AlarmQRK_s = AlarmQRK_s;
					NewAlarm.AlarmCP	= AlarmCP;
					NewAlarm.AlarmNOSPC = AlarmNOSPC;
					NewAlarm.PartNr		= AlarmPartNr;
					NewAlarm.CharNr		= AlarmCharNr;
					NewAlarm.ValueNr	= AlarmValueNr;
					NewAlarm.SampleNr	= AlarmSampleNr;
					Alarms.Add(NewAlarm);	
				}// StoreAlarm
			}// rc
		}//while
	}// AlwaysShowAlarm
}


LRESULT CVCPPCOMClient1View::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if (message== RegisterWindowMessage("WM_FILESIZE_CHANGED"))
	{
		ReloadFile();
	}
	if (message== RegisterWindowMessage("WM_STATISTIC_ALARM"))
	{
		RedAlert();
	}
	return CView::WindowProc(message, wParam, lParam);
}


