// VCPPCOMClient1View.h : interface of the CVCPPCOMClient1View class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_VCPPCOMCLIENT1VIEW_H__59B29CD8_1E3D_4DD1_BE7A_83F07CB0E96D__INCLUDED_)
#define AFX_VCPPCOMCLIENT1VIEW_H__59B29CD8_1E3D_4DD1_BE7A_83F07CB0E96D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "qsEventSink.h"
#include "dib.h"
#include "stdafx.h"
#include <atlbase.h>
#include <afxtempl.h>

class CVCPPCOMClient1View : public CView
{
protected: // create from serialization only
	CVCPPCOMClient1View();
	DECLARE_DYNCREATE(CVCPPCOMClient1View)

// Attributes
public:
	CVCPPCOMClient1Doc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVCPPCOMClient1View)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	int GetGraphic(int whattodo);
	int GetOnlineGraphic( int GraphicKey1, int GraphicKey2);

	int GIndex;
public:
	// Online Simualation - GraphicObjects
	CDib*	OnlineDib1;
	CDib*	OnlineDib2;
	BOOL	OnlineMode;


	ITQsstatRemoteControl*	pqsSTAT;
	long	qsSTATHandle;
	CDib*	dib;

	// connection point
	IConnectionPointContainer*	pConnectionPointContainer;
	IConnectionPoint*			pConnectionPoint;
	IConnectionPoint*			pConnectionPointAlarm;
	//-------------------------------------------------------------------------
	// Sink Object
	CSink*  mySink;
	DWORD	dwCookie;

	//-------------------------------------------------------------------------
	DWORD  dwServerThreadId;
    HANDLE h_ServerThread; // handle for thread, that runs the qs-STAT Server
	HANDLE g_hTerminateQsSTATEvent;// Event for termination server thread

	// number of charactaristics loaded
	long NumOfChar;
	BSTR K_Field_Up;
	BSTR K_Field_Down;

	// Parameters for requests of results and reports
	int		PartNr_x;
	int		CharNr_x;
	int		PartNr_y;
	int		CharNr_y;
	int		ValueNr_x;
	int		ValueNr_y;
	int		Width;
	int		Height;
	long	Valuenr;
	BOOL	ReportPrn;
	int		GrafKey;
	int		GrafSubKey;
	int		StatKey;
	int		StatSubKey;
	int		Transformation;
	long	ReportNr;

	int		lim;
	int		sim_interval;
	int		Attribute;
	CString	BatchNum;
	int		BatchValue;
	int		GageNum;
	int		MachineNum;
	int		NestNum;
	int		OperatorNum;
	CString	Order;
	int		OrderValue;
	
    long	ModuleID;
	long	LanguageID;
	long	StrategyID;

	BSTR	ReportName;
	CComBSTR ReportFileName;
	int		PrinterNr;

	BOOL	UseExtFunc;


	// Online Server DEMO
	// HANDLE  hFileMonitor;			//
	CString sBaseFileName;			// Base file for Online supervision
	CString sBaseFilePath;			// path of the monitored file
	long	LastReadFilePos;		// alread read Bytes from Base file
	CString sTransmitFileName;		// Transmitted file for Online monitoring
	CString sTransmitFilePath;		// Path of transmitted file
	BOOL	MonitoringInProgress;	// 
	BOOL	SimulationIsRunning;	//

	// Online Simualation - Settings
	BOOL	m_FileChangeTriggered;	// Monitoring is filechange Triggered
	UINT	m_FileMonitoringIntervall;// Cycle time for cyclic monitoring
	BOOL	m_AlwaysShowAlarm;		// Shows an occurred Alarm immediately
	BOOL	m_StoreAlarm;			// Store the occured alamrs in a list

	CArray<CAlarm,CAlarm> Alarms;	// List for occurred alarms

	// Thread based simulation of the Online Server
	HANDLE	h_MonitoringThread;		// Thread for filemonitoring
	HANDLE	h_AlarmThread;			// Thread for alarm scanning
	HANDLE	h_SimulationThread;		// thread for DFX-Simulation
	// Events for termination of online-DEMO threads
	HANDLE	g_StopFileScanEvent;	 
	HANDLE	g_StopDFQSimulateEvent;
	HANDLE	g_StopAlarmEvent;

	virtual ~CVCPPCOMClient1View();


	// Online-DEMO
	void ReloadFile();	// FileMonitoring
	void SimulateDFQ();	// Simulation of DFX-Lines
	void RedAlert();	// Alarm handling
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CVCPPCOMClient1View)
	afx_msg void OnAlarmsettings();
	afx_msg void OnConnect();
	afx_msg void OnDisconnect();
	afx_msg void OnFileFiletransmit();
	afx_msg void OnFileOpen();
	afx_msg void OnFilePrintreport();
	afx_msg void OnGetGraphic();
	afx_msg void OnGetReport();
	afx_msg void OnGetResult();
	afx_msg void OnGetValue();
	afx_msg void OnOnlinetransmissionSimulateoneline();
	afx_msg void OnOpenbasefile();
	afx_msg void OnProcesscapability();
	afx_msg void OnSetFilter();
	afx_msg void OnSetLanguage();
	afx_msg void OnSetModule();
	afx_msg void OnSetPrinter();
	afx_msg void OnSetStrategy();
	afx_msg void OnShowalarms();
	afx_msg void OnSimulateDfq();
	afx_msg void OnStartfilescan();
	afx_msg void OnStartServer();
	afx_msg void OnStopfilescan();
	afx_msg void OnStopsimulateDfq();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnAppAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in VCPPCOMClient1View.cpp
inline CVCPPCOMClient1Doc* CVCPPCOMClient1View::GetDocument()
   { return (CVCPPCOMClient1Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VCPPCOMCLIENT1VIEW_H__59B29CD8_1E3D_4DD1_BE7A_83F07CB0E96D__INCLUDED_)
