// ENumSelectDialog.cpp : implementation file
//

#include "stdafx.h"
#include "vcppcomclient2.h"
#include "ENumSelectDialog.h"
#include "afxtempl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelektDialog dialog


CSelektDialog::CSelektDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CSelektDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelektDialog)
	//}}AFX_DATA_INIT
}


void CSelektDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelektDialog)
	DDX_Control(pDX, IDC_COB_ENUM, m_COB_ENUM);
	DDX_Control(pDX, IDC_LA_ENUM, m_LA_ENUM);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSelektDialog, CDialog)
	//{{AFX_MSG_MAP(CSelektDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelektDialog message handlers

CSelektDialog::~CSelektDialog()
{
	int i;

	ModuleStruct* pModule;
	for (i = 0; i < ModuleArray.GetSize();i++)
	{	
		pModule = ModuleArray.GetAt(i);
		delete pModule;
	}
	
	LanguageStruct* pLanguage;
	for (i = 0; i < LanguageArray.GetSize();i++)
	{	
		pLanguage = LanguageArray.GetAt(i);
		delete pLanguage;
	}

	StrategyStruct* pStrategy;
	for (i = 0; i < StrategyArray.GetSize();i++)
	{	
		pStrategy = StrategyArray.GetAt(i);
		delete pStrategy;
	}
	
	PrinterStruct* pPrinter;
	for (i = 0; i < PrinterArray.GetSize();i++)
	{	
		pPrinter = PrinterArray.GetAt(i);
		delete pPrinter;
	}

	DATABASEStruct* pDB;
	for (i = 0; i < DBArray.GetSize();i++)
	{	
		pDB = DBArray.GetAt(i);
		delete pDB;
	}
} 


void CSelektDialog::OnOK() 
{	
    
	if (Type == 1) 
	{
		ModuleStruct * pMI;
	    int index = m_COB_ENUM.GetCurSel();
		pMI = ModuleArray.GetAt(index);
		ModKey = pMI->ModKey;
		CDialog::OnOK();
	}

	if (Type == 2) 
	{
		LanguageStruct * pLI;
	    int index = m_COB_ENUM.GetCurSel();
		pLI = LanguageArray.GetAt(index);
		LangKey = pLI->LangKey;
		CDialog::OnOK();
	}

	if (Type == 3) 
	{
		StrategyStruct * pSI;
	    int index = m_COB_ENUM.GetCurSel();
		pSI = StrategyArray.GetAt(index);
		StratKey = pSI->StratKey;
		CDialog::OnOK();
	}
	
	if (Type == 4) 
	{
		PrinterStruct * pPI;
	    int index = m_COB_ENUM.GetCurSel();
		pPI = PrinterArray.GetAt(index);
		PrinterNr = pPI->PrnID;
		CDialog::OnOK();
	}

	if (Type == 5) 
	{
		DATABASEStruct * pDBI;
	    int index = m_COB_ENUM.GetCurSel();
		pDBI = DBArray.GetAt(index);
		int i = pDBI->DBKey;
		DBName = CString(pDBI->DBName);
		CDialog::OnOK();
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------

BOOL CSelektDialog::OnInitDialog() 
{

	CDialog::OnInitDialog();
	
	
	long	ModuleKey;
	BSTR	ModuleName;

	long	LanguageKey;
	BSTR	LanguageStrName;
	BSTR	LanguageName;

	long	StrategyKey;
	BSTR	StrategyName;

	long	PrinterNr;
	BSTR	PrinterName;

	BSTR	DBName;

	HRESULT	hr;
	int		i;
	char	s_str[40];
	char	s_str_add[255] = "";
	CString Str;	

	if (Type == 1) 
	{
		
		this->SetWindowText("Select Module");
		SetDlgItemText(IDC_LA_ENUM, "Module: ");

		CDataExchange dx(this, 1);
		DoDataExchange(&dx);

		hr = pIqsSTATModule->GetFirstModule(pqsSTATHandle,
											&ModuleKey,
											&ModuleName);
		while (hr == S_OK)	
		{
			ModuleStruct* pModule = new ModuleStruct;
			pModule->ModKey = ModuleKey;
	
	 		Str = ModuleName;
			sprintf(s_str, "%s %s%d%s", Str, "(", ModuleKey, ")");

			// add to combobox
			m_COB_ENUM.AddString(s_str);
			
			// Add to internal list
			ModuleArray.Add(pModule);
			
			hr = pIqsSTATModule->GetNextModule(pqsSTATHandle,
											   &ModuleKey,
											   &ModuleName);
		}
	}
	if (Type == 2) 
	{
		this->SetWindowText("Select Language");
		SetDlgItemText(IDC_LA_ENUM, "Language: ");
		
		hr = pIqsSTATLanguage->GetFirstLanguage(pqsSTATHandle,&LanguageName,&LanguageStrName,&LanguageKey);
		while (hr == S_OK)	
		{
			LanguageStruct* pLanguage = new LanguageStruct;
			pLanguage->LangKey = LanguageKey;
			
			Str  = LanguageName;
			sprintf(s_str, "%s %s%d%s", Str, "(", LanguageKey, ")");

			// add to combobox
			m_COB_ENUM.AddString(s_str);
			
			// Add to internal list
			LanguageArray.Add(pLanguage);
			hr = pIqsSTATLanguage->GetNextLanguage( pqsSTATHandle,
												    &LanguageName,
												    &LanguageStrName,
												    &LanguageKey);
//			rc = pIqsSTATLanguage->GetNextLanguage(pqsSTATHandle,&LanguageName,&LanguageStrName,&LanguageKey);
		}
	}
	if (Type == 3)
	{
		this->SetWindowText("Select Strategy");
		SetDlgItemText(IDC_LA_ENUM, "Strategy: ");
		
		hr = pIqsSTATStrategy->GetFirstEvaluationStrategy(pqsSTATHandle,
														  qs_Module,
														  0,
														  &StrategyKey,
														  &StrategyName);
		while (hr == S_OK)	
		{
			StrategyStruct* pStrategy = new StrategyStruct;
			pStrategy->StratKey = StrategyKey;
			
			Str  = StrategyName;
			sprintf(s_str, "%s %s%d%s", Str, "(", StrategyKey, ")");

			// add to combobox
			m_COB_ENUM.AddString(s_str);
			
			// Add to internal list
			StrategyArray.Add(pStrategy);
			hr = pIqsSTATStrategy->GetNextEvaluationStrategy(pqsSTATHandle,
															 qs_Module,
															 0,
															 &StrategyKey,
															 &StrategyName);
		}
	}
	if (Type == 4)
	{
		this->SetWindowText("Select Printer");
		SetDlgItemText(IDC_LA_ENUM, "Printer: ");
		
		hr = pIqsSTATPrinter->GetFirstPrinter(pqsSTATHandle,
											  &PrinterNr,
											  &PrinterName);
		while (hr == S_OK)	
		{
			PrinterStruct* pPrinter = new PrinterStruct;
			pPrinter->PrnID = PrinterNr;
	
			Str  = PrinterName;
			sprintf(s_str, "%s %s%d%s", Str, "(", PrinterNr, ")");

			// add to combobox
			m_COB_ENUM.AddString(s_str);

			// Add to internal list
			PrinterArray.Add(pPrinter);
			hr = pIqsSTATPrinter->GetNextPrinter(pqsSTATHandle,
												 &PrinterNr,
												 &PrinterName);
		}
	}
	if (Type == 5)
	{
		
		this->SetWindowText("Data Base - Select Query");
		SetDlgItemText(IDC_LA_ENUM, "DB: ");
		
		i = 0;
		hr = pIqsSTATDB->GetFirstDBSelection(pqsSTATHandle,
											 &DBName);
		while (hr == S_OK)	
		{
			DATABASEStruct* pDB = new DATABASEStruct;
			pDB->DBKey = i;
			pDB->DBName = DBName;

			Str  = DBName;
			sprintf(s_str, "%s %s%d%s", Str, "(", i, ")");

			// add to combobox
			m_COB_ENUM.AddString(s_str);

			// Add to internal list
			DBArray.Add(pDB);
			i = i + 1;
			
			hr = pIqsSTATDB->GetNextDBSelection(pqsSTATHandle, &DBName);
		}
	}
	
	m_COB_ENUM.SetCurSel(0);

	return TRUE;
}

//------------------------------------------------------------------
//------------------------------------------------------------------

void CSelektDialog::SetServerObject(IUnknown* pIUnknown, long qsSTATHandle, long Module)
{
	pIUnknown->QueryInterface(IID_IEnumModule,(void**)&pIqsSTATModule);
	pIUnknown->QueryInterface(IID_IEnumLanguage,(void**)&pIqsSTATLanguage);
	pIUnknown->QueryInterface(IID_IEnumEvaluationStrategy,(void**)&pIqsSTATStrategy);
	pIUnknown->QueryInterface(IID_IEnumPrinter,(void**)&pIqsSTATPrinter);
	pIUnknown->QueryInterface(IID_IEnumDBSelectionName,(void**)&pIqsSTATDB);

	pqsSTATHandle = qsSTATHandle;

	qs_Module = Module;
}


void CSelektDialog::SetItemType(int Tag)
{
	Type = Tag;
}

//------------------------------------------------------------------
//------------------------------------------------------------------

int	CSelektDialog::GetModKey()
{
	return ModKey;
}

int	CSelektDialog::GetLangKey()
{
	return LangKey;
}

int	CSelektDialog::GetStratKey()
{
	return StratKey;
}

int	CSelektDialog::GetPrinterNr()
{
	return PrinterNr;
}

CString CSelektDialog::GetDBName()
{
	return DBName;
}