// OnlineTransmition.cpp : implementation file
//


#include "stdafx.h"
#include "VCPPCOMClient2.h"
#include "OnlineTransmition.h"
#include "qsEventSink.h"
//#include "VCPPCOMClient2View.h"

#include <atlbase.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COnlineTransmition dialog


COnlineTransmition::COnlineTransmition(CWnd* pParent /*=NULL*/)
	: CDialog(COnlineTransmition::IDD, pParent)
{
	//{{AFX_DATA_INIT(COnlineTransmition)
	m_Head = _T("");
	m_Data = _T("");
	m_ExtMode = FALSE;
	//}}AFX_DATA_INIT
	;
}


void COnlineTransmition::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(COnlineTransmition)
	DDX_Text(pDX, IDC_EDIT_HEAD, m_Head);
	DDX_Text(pDX, IDC_EDIT_DATA, m_Data);
	DDX_Control(pDX, IDC_TRANSMIT_LIST, m_Text);
	DDX_Check(pDX, IDC_CHECK_TRANSMIT, m_ExtMode);
	//}}AFX_DATA_MAP
	//m_Text.SetWindowText(Str);
}


BEGIN_MESSAGE_MAP(COnlineTransmition, CDialog)
	//{{AFX_MSG_MAP(COnlineTransmition)
	ON_BN_CLICKED(IDC_BB_HEAD, OnBBHead)
	ON_BN_CLICKED(IDC_BB_DATA, OnBBData)
	ON_BN_CLICKED(IDC_BB_APPLY_HEAD, OnBBGetHead)
	ON_BN_CLICKED(IDC_BB_APPLY_DATA, OnBBGetData)
	ON_BN_CLICKED(IDC_BB_APPLY_TEXT, OnBBGetText)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COnlineTransmition message handlers


BOOL PutBinaryIntoVar(COleVariant * ovData, BYTE * pBuf, unsigned long cBufLen)
{
	BOOL fRetVal = FALSE;

    VARIANT var;
    VariantInit(&var);  //Initialize our variant

    //Set the type to an array of unsigned chars (OLE SAFEARRAY)
    var.vt = VT_ARRAY | VT_UI1;

    //Set up the bounds structure
    SAFEARRAYBOUND  rgsabound[1];

    rgsabound[0].cElements = cBufLen;
    rgsabound[0].lLbound = 0;

    //Create an OLE SAFEARRAY
    var.parray = SafeArrayCreate(VT_UI1,1,rgsabound);

    if(var.parray != NULL)
    {
		void * pArrayData = NULL;

		//Get a safe pointer to the array
		SafeArrayAccessData(var.parray,&pArrayData);

		//Copy bitmap to it
		memcpy(pArrayData, pBuf, cBufLen);

		//Unlock the variant data
		SafeArrayUnaccessData(var.parray);

		*ovData = var;  // Create a COleVariant based on our variant
		VariantClear(&var);
		fRetVal = TRUE;
	}
    return fRetVal;
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void COnlineTransmition::SetServerObject(CUpdateView* view,
										 IUnknown* pIUnknown, 
										 long qsSTATHandle,
										 CSink* mySink)
{
    pIUnknown->QueryInterface(IID_ITQsstatRemoteControl,(void**)&pqsSTAT);
	pqsSTATHandle = qsSTATHandle;
	SinkObj = mySink;
	pView = view;
}

void COnlineTransmition::OnOK() 
{
	CDialog::OnOK();
}


BOOL COnlineTransmition::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_Text.SetWindowText("");
	return TRUE;
}

void COnlineTransmition::OnBBHead() 
{
	// select file for control plan / Prfplandatei auswhlen
	CFileDialog dlg(TRUE);
	if (dlg.DoModal() == IDOK)
	{
		m_Head = dlg.GetPathName();
		SetDlgItemText(IDC_EDIT_HEAD, m_Head);
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);

	}
	else
	{
		return;
	}
}

void COnlineTransmition::OnBBData() 
{
	// select file for measurements / Mewertdatei auswhlen
	CFileDialog dlg(TRUE);
	if (dlg.DoModal() == IDOK)
	{
		m_Data = dlg.GetPathName();
		SetDlgItemText(IDC_EDIT_DATA, m_Data);
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);	
	}
	else
	{
		return;
	}
}

void COnlineTransmition::OnBBGetHead() 
{
	// transmit control-plan data / Prfplandatei bertragen
	CDataExchange dx(this, 1);
	DoDataExchange(&dx);
	if (m_Head != "-1")
	{
		TransmitOnline(0);	
	}
}

void COnlineTransmition::OnBBGetData() 
{
	// transmit value file (append!) / Mewertdatei bertragen (anhngen!)
	CDataExchange dx(this, 1);
	DoDataExchange(&dx);
	if (m_Data != "-1")
	{
		TransmitOnline(2);
	}
}

void COnlineTransmition::OnBBGetText() 
{
	// transmit Edit Control content / Mewert aus Edit feld bertragen (anhngen!)
	CDataExchange dx(this, 1);
	TransmitOnline(3);
}

void COnlineTransmition::TransmitOnline(int Mode)
{
	char		s_str[255];
	CString		Str = "";
	int			TransmitMode = 0;
	HRESULT		hr = S_OK;

	switch (Mode)
	{
	case 0:
		{
			// transmit header file / Prfplandatei bertragen
			Str			= m_Head;
			TransmitMode = 0x00; // reset
			break;
		}
	case 2:
		{
			// Transmit file containig measruments /  Mewertedatei bertragen
			Str			= m_Data;
			if (m_ExtMode) 
			{
				TransmitMode = 0x02 + 0x04; // append initial
			}
			else
			{
				TransmitMode = 0x02; // append continuous
			}
			break;
		}
	case 3:
		{
			// transmit single values from Edit control / Einzelwerte bertragen aus Edit-Feld
			int lc = m_Text.GetLineCount();
			int l;
			int ll;
			char crlf[3];
			crlf[0] = 0x0d;
			crlf[1] = 0x0a;
			crlf[2] = 0x00;


			char buffer[255];
			for (l=0; l < lc;l++){
				ll = m_Text.LineLength(m_Text.LineIndex(l));
				if (ll < 255)
				{
					m_Text.GetLine(m_Text.LineIndex(l),buffer);
					buffer[ll] = 0;
					strcat(buffer,crlf);
					Str = Str + buffer;
				}
			}
			if (m_ExtMode) 
			{
				TransmitMode = 0x02 + 0x04; // append
			}
			else
			{
				TransmitMode = 0x02; // append
			}
			break;
		}
	default:
		{
			return; // invalid arg / falscher Aufruf
		}
	}
	

	//---------------------------------------------------------
	// Transmit the selected data / Daten bertragen
	//---------------------------------------------------------
	BYTE*		pBuffer;		
	long		BufLen;
	COleVariant vaData;
	if (Mode == 3)
	{
		// Transmit content of Edit field / Inhalt des Eingabefelds bertragen
		char* pTransmitt;
		BufLen		=  Str.GetLength()+1;
		pBuffer		= (BYTE*)malloc(BufLen);
		pTransmitt	= Str.GetBuffer(Str.GetLength());
		memcpy(pBuffer,pTransmitt,BufLen);
	}
	else
	{
		// Transmit conent of selected file / angegebene Datei bertragen
		CComBSTR	FileName(Str);
		CFile		f1(Str,CFile::modeRead | CFile::shareDenyWrite);

		BufLen = f1.GetLength();
		pBuffer = (BYTE*)malloc(BufLen);
		
		f1.ReadHuge(pBuffer,BufLen);
		f1.Close();
	}

	if (pBuffer)
	{
		sprintf(s_str, "%s", "Transmittion in progress...");

		pView->UpdateStatusBar(1,s_str);
		pView->UpdateStatusBar(2,"");
		
		//---------------------------------------------------------
		// prepare the buffer for transmission /
		// Daten aus Puffer in Variant bertragen
		//---------------------------------------------------------
		PutBinaryIntoVar(&vaData,pBuffer,BufLen);

		//---------------------------------------------------------
		// Transmit the data to server and reset or maintain previously loaded data /
		// Daten an Server bertragen, ggf. Reset alter Daten oder anhngen an geladene Daten
		// (-> TransmitMode)
		//---------------------------------------------------------
		hr = pqsSTAT->TransmitFileExt(	pqsSTATHandle,
										vaData,
										TransmitMode,//mode = reset/appen initial/ append
										0 //reserve
										);
		if (SUCCEEDED(hr))
		{
			DWORD to = WaitForSingleObject(SinkObj->hDataAvailEvent,15000);
			if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
			{
				sprintf(s_str, "%s", "Transmission in progress...Timeout.");
				pView->UpdateStatusBar(2,s_str);
			}
			else
			{
				if (Mode == 3)
				{
					Str = "";
				}

				sprintf(s_str, "%s %s", "Transmitted", Str);
				pView->UpdateStatusBar(1,s_str);
				pView->GetGraphicOrReport(3,1);
			};
		}
		else
		{
			sprintf(s_str, "%s %d", "Transmission error", hr);
			pView->UpdateStatusBar(2,s_str);
		}
		free(pBuffer);
	}
}
