// QueryFilterDialog.cpp : implementation file
//

#include "stdafx.h"
#include "atlbase.h"
#include "VCPPCOMClient2.h"
#include "QueryFilterDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// QueryFilterDialog dialog


QueryFilterDialog::QueryFilterDialog(CWnd* pParent /*=NULL*/)
	: CDialog(QueryFilterDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(QueryFilterDialog)
	m_List1 = _T("");
	m_List2 = _T("");
	m_Edit10 = _T("");
	m_Edit11 = _T("");
	m_Edit12 = _T("");
	m_Edit3 = 0;
	m_Edit4 = _T("");
	m_Edit5 = _T("");
	m_Edit6 = _T("");
	m_Edit7 = 2001;
	m_Edit8 = 2002;
	m_Edit9 = 0;
	m_Edit1 = 1001;
	m_Edit2 = 1002;
	//}}AFX_DATA_INIT
}

BEGIN_MESSAGE_MAP(QueryFilterDialog, CDialog)
	//{{AFX_MSG_MAP(QueryFilterDialog)
	ON_BN_CLICKED(IDC_BB_Filter1, OnBBFilter1)
	ON_BN_CLICKED(IDC_BB_Filter2, OnBBFilter2)
	ON_BN_CLICKED(IDC_BB_Filter3, OnBBFilter3)
	ON_BN_CLICKED(IDC_BB_Filter4, OnBBFilter4)
	ON_BN_CLICKED(IDC_BB_Filter5, OnBBFilter5)
	ON_BN_CLICKED(IDC_BB_Filter6, OnBBFilter6)
	ON_BN_CLICKED(IDC_BB_FilterExe1, OnBBFilterExe1)
	ON_BN_CLICKED(IDC_BB_FilterExe2, OnBBFilterExe2)
	ON_BN_CLICKED(IDC_BB_FilterExe3, OnBBFilterExe3)
	ON_BN_CLICKED(IDC_BB_FilterExe4, OnBBFilterExe4)
	ON_BN_CLICKED(IDC_BB_FilterExe5, OnBBFilterExe5)
	ON_BN_CLICKED(IDC_BB_FilterExe6, OnBBFilterExe6)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// QueryFilterDialog message handlers
void QueryFilterDialog::SetServerObject(IUnknown* pIUnknown, long qsSTATHandle)
{
	pIUnknown->QueryInterface(IID_IEnumFieldKeyName,(void**)&pIqsSTATFieldKeyName);
    
	pIUnknown->QueryInterface(IID_IDataBase,(void**)&pIqsSTATDataBase);
	
	pqsSTATHandle = qsSTATHandle;
}


BOOL QueryFilterDialog::OnInitDialog() 
{
	
	CDialog::OnInitDialog();

	KFieldListArr.CreateOneDim ( VT_I4, 3 );

	long	arr[] = { 0, 1, 2 } ;
	long	p[ ]  = {0, 0, 0};

	Edit1 = 0;
	Edit2 = 0;
	Edit3 = 0;
	Edit7 = 0;
	Edit8 = 0;
	Edit9 = 0;

	p[0] = Edit1;
	p[1] = Edit2;
	p[2] = Edit3;	

	KFieldsArr.CreateOneDim ( VT_I4, 3 );
	
	KFieldsArr.PutElement(&arr[0], &p[0]);
	KFieldsArr.PutElement(&arr[1], &p[1]);
	KFieldsArr.PutElement(&arr[2], &p[2]);

	m_PartsListControl.InsertColumn(0, "", LVS_REPORT, 150);
	m_CharsListControl.InsertColumn(0, "", LVS_REPORT, 150);

	return TRUE; 
}

long QueryFilterDialog::CreateQuery()
{
	int  rc;

	rc = pIqsSTATDataBase->CreateQuery(pqsSTATHandle, &QueryHandle);
    
    if (rc == 0)
    {
		return QueryHandle;
	}
	else
	{
		return 0;
	}
}

long QueryFilterDialog::ExecuteQuery(int SelItem)
{
	COleVariant vaFilter;
	int	        rc;
  
	VariantInit(&vaFilter);

    vaFilter[0].vt		= VT_I4;
	vaFilter[0].lVal	= SelItem;

	    
	rc = pIqsSTATDataBase->ExecuteQuery( pqsSTATHandle, QueryHandle, vaFilter);

	if (rc == 0)
	{
		pIqsSTATDataBase->FreeQuery( pqsSTATHandle, QueryHandle);
		return 0;
	}

    pIqsSTATDataBase->FreeQuery( pqsSTATHandle, QueryHandle);
	return -1;
}

CString QueryFilterDialog::GetKFieldNamePart(long KField_Key)
{
	long		KFieldKey = 0;
	long		KFieldSubKey = 0;
	CComBSTR	KFieldName = 0;
	int			rc;
	int			i;
	
    i = 0;
	
	rc = pIqsSTATFieldKeyName->GetFirstPartField(pqsSTATHandle,&KFieldKey,KFieldSubKey,&KFieldName);
	while (rc == 0)	
	{
  		if (KFieldKey == KField_Key)
		{
			return KFieldName; 
		}
	    i++;
		pIqsSTATFieldKeyName->GetNextPartField(pqsSTATHandle,&KFieldKey,KFieldSubKey,&KFieldName);
	}
	return	"";
}

CString QueryFilterDialog::GetKFieldNameChar(long KField_Key)
{
	long		KFieldKey = 0;
	long		KFieldSubKey = 0;
	CComBSTR	KFieldName = 0;
	int			rc;
	int			i;
	
    i = 0;
	
	rc = pIqsSTATFieldKeyName->GetFirstCharacteristicField(pqsSTATHandle,&KFieldKey,KFieldSubKey,&KFieldName);
	while (rc == 0)	
	{
  		if (KFieldKey == KField_Key)
		{
			return KFieldName; 
		}
	    i++;
		pIqsSTATFieldKeyName->GetNextCharacteristicField(pqsSTATHandle,&KFieldKey,KFieldSubKey,&KFieldName);
	}
	return	"";
}

long QueryFilterDialog::CreateFilter(int KField, int Item, CString Condition)
{
	long	HF = 0;
	int		rc;
	CComBSTR Cond;

	Cond = "" + Condition;

    rc = pIqsSTATDataBase->CreateFilter( pqsSTATHandle, 1, KField, Cond, 1, &HF);
    if (rc == 0)
	{
		return HF;
	}
	else
	{
		return -1;
	}
}

long QueryFilterDialog::AddNewFilter(long QH, long FH, unsigned char QL)
{
	int rc;
      
	rc = pIqsSTATDataBase->AddFilterToQuery( pqsSTATHandle, QH, FH, QL, 0, 0);
                                          
    if (rc == 0)
	{
		return 1;
	}
	else
	{
		return -1;
	}
}
    
void QueryFilterDialog::FreeFilter(long FH)
{

}

void QueryFilterDialog::SetPartsLB(long QH)
{
	COleVariant	KPartResultList;
	long		Key;
	int			rc;
	int			i = 0;
	char		s_str[40];
	BSTR		RetStr1;
	BSTR		RetStr2;
	BSTR		RetStr3;
	CString		s;
	CString		s1;
	CString		s2;
	CString		s3;
	long		arr[] = {0, 1, 2};
	long		p[ ]  = {0, 0, 0};
	p[0] = Edit1;
	p[1] = Edit2;
	p[2] = Edit3;

	KFieldsArr.PutElement(&arr[0], &p[0]);
	KFieldsArr.PutElement(&arr[1], &p[1]);
	KFieldsArr.PutElement(&arr[2], &p[2]);

	KFieldListPart = KFieldsArr;

	rc = pIqsSTATDataBase->GetFirstPartQuery(pqsSTATHandle, QH, KFieldListPart, &Key, &KFieldListArr);

	while (rc == 0)	
	{
  		if (Key > 0)
		{
			KFieldListArr.GetElement ( &arr[0], &RetStr1);
			KFieldListArr.GetElement ( &arr[1], &RetStr2);
			KFieldListArr.GetElement ( &arr[2], &RetStr3);
			s1 = RetStr1;
			s2 = RetStr2;
			s3 = RetStr3;
			
		//	s = s1 + "/" + s2 + "/" + s3;

			if (s1 == "")
			{
				if (s2 != "")
				{
					s = s2;
					if (s3 != "")
					{
						s = s2 + "/" + s3;
					}
					
				}
				else
				{
					if (s3 != "")
					{
						s = s3;
						if (s2 != "")
						{
							s = s2 + "/" + s3;
						}
					}
				}
			}
			else
			{
				s = s1;
				if (s2 == "")
				{
					if (s3 != "")
					{
						s = s1 + "/" + s3;
					};
				}
				else
				{
					
					if (s3 != "")
					{
						s = s1 + "/" + s2 + "/" + s3;
					}
					else
					{
						s = s1 + "/" + s2;
					}
				};
			}
						
			sprintf(s_str, "%s", s);		
			m_PartsListControl.InsertItem(i, s_str);
			m_PartsListControl.SetItem(i, 0, LVS_REPORT, s_str, 0,0,0,0);
		}
	    i++;
		rc = pIqsSTATDataBase->GetNextPartQuery( pqsSTATHandle, QH, &Key, &KFieldListArr);
    }
}

void QueryFilterDialog::SetCharsLB(long QH)
{
	COleVariant	KPartResultList;
	long		Key = 0;
	int			rc;
	int			i = 0;
	char		s_str[40];
	BSTR		RetStr1;
	BSTR		RetStr2;
	BSTR		RetStr3;
	CString		s;
	CString		s1;
	CString		s2;
	CString		s3;
	long		arr[] = {0, 1, 2};
	long		p[ ]  = {0, 0, 0};
	long		SelItem;

	p[0] = Edit7;
	p[1] = Edit8;
	p[2] = Edit9;

	int rc1;

	KFieldsArr.PutElement(&arr[0], &p[0]);
	KFieldsArr.PutElement(&arr[1], &p[1]);
	KFieldsArr.PutElement(&arr[2], &p[2]);

	KFieldListPart = KFieldsArr;
   
	SelItem = m_PartsListControl.GetNextItem(-1, LVNI_SELECTED) + 1;

	rc = pIqsSTATDataBase->GetFirstCharQuery(pqsSTATHandle, QH, KFieldListPart, SelItem, &Key, &KFieldListArr);

	while (rc == 0)	
	{
  		if (Key > 0)
		{
			KFieldListArr.GetElement ( &arr[0], &RetStr1);
			KFieldListArr.GetElement ( &arr[1], &RetStr2);
			KFieldListArr.GetElement ( &arr[2], &RetStr3);
			
			rc1 = m_Check4.GetCheck();
			if (rc1 == 1)
			{
				s1 = RetStr1;
			};

			rc1 = m_Check5.GetCheck();
			if (rc1 == 1)
			{
				s2 = RetStr2;
			};

			rc1 = m_Check6.GetCheck();
			if (rc1 == 1)
			{
				s3 = RetStr3;
			};

			if (s1 == "")
			{
				if (s2 != "")
				{
					s = s2;
					if (s3 != "")
					{
						s = s2 + "/" + s3;
					}
					
				}
				else
				{
					if (s3 != "")
					{
						s = s3;
						if (s2 != "")
						{
							s = s2 + "/" + s3;
						}
					}
				}
			}
			else
			{
				s = s1;
				if (s2 == "")
				{
					if (s3 != "")
					{
						s = s1 + "/" + s3;
					};
				}
				else
				{
					
					if (s3 != "")
					{
						s = s1 + "/" + s2 + "/" + s3;
					}
					else
					{
						s = s1 + "/" + s2;
					}
				};
			}

			sprintf(s_str, "%s", s);
		
			m_CharsListControl.InsertItem(i, s_str);
			m_CharsListControl.SetItem(i, 0, LVS_REPORT, s_str, 0,0,0,0);
		}
	    i++;
		rc = pIqsSTATDataBase->GetNextCharQuery( pqsSTATHandle, QH, &Key, &KFieldListArr);
    }
}

void QueryFilterDialog::DoDataExchange(CDataExchange* pDX) 
{
	CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(QueryFilterDialog)
	DDX_Control(pDX, IDC_LISTPARTS, m_PartsListControl);
	DDX_Control(pDX, IDC_LISTCHARS, m_CharsListControl);
	DDX_Control(pDX, IDC_CHECK6, m_Check6);
	DDX_Control(pDX, IDC_CHECK5, m_Check5);
	DDX_Control(pDX, IDC_CHECK4, m_Check4);
	DDX_Control(pDX, IDC_CHECK3, m_Check3);
	DDX_Control(pDX, IDC_CHECK1, m_Check1);
	DDX_Control(pDX, IDC_BB_FilterExe6, m_FilterExe6);
	DDX_Control(pDX, IDC_BB_FilterExe5, m_FilterExe5);
	DDX_Control(pDX, IDC_BB_FilterExe4, m_FilterExe4);
	DDX_Control(pDX, IDC_BB_FilterExe3, m_FilterExe3);
	DDX_Control(pDX, IDC_BB_FilterExe1, m_FilterExe1);
	DDX_Control(pDX, IDC_BB_Filter6, m_Filter6);
	DDX_Control(pDX, IDC_BB_Filter5, m_Filter5);
	DDX_Control(pDX, IDC_BB_Filter4, m_Filter4);
	DDX_Control(pDX, IDC_BB_Filter3, m_Filter3);
	DDX_Control(pDX, IDC_BB_Filter2, m_Filter2);
	DDX_Control(pDX, IDC_CHECK2, m_Check2);
	DDX_Control(pDX, IDC_BB_FilterExe2, m_FilterExe2);
	DDX_Control(pDX, IDC_BB_Filter1, m_Filter1);
	DDX_Text(pDX, IDC_EDIT10, m_Edit10);
	DDX_Text(pDX, IDC_EDIT11, m_Edit11);
	DDX_Text(pDX, IDC_EDIT12, m_Edit12);
	DDX_Text(pDX, IDC_EDIT3, m_Edit3);
	DDX_Text(pDX, IDC_EDIT4, m_Edit4);
	DDX_Text(pDX, IDC_EDIT5, m_Edit5);
	DDX_Text(pDX, IDC_EDIT6, m_Edit6);
	DDX_Text(pDX, IDC_EDIT7, m_Edit7);
	DDX_Text(pDX, IDC_EDIT8, m_Edit8);
	DDX_Text(pDX, IDC_EDIT9, m_Edit9);
	DDX_Text(pDX, IDC_EDIT1, m_Edit1);
	DDX_Text(pDX, IDC_EDIT2, m_Edit2);
	//}}AFX_DATA_MAP
}

void QueryFilterDialog::OnBBFilter1() 
{
	CDataExchange dx(this, 1);
	DoDataExchange(&dx);
	SetDlgItemText(IDC_CHECK1, GetKFieldNamePart(m_Edit1));
	Edit1 = m_Edit1;	
}

void QueryFilterDialog::OnBBFilter2() 
{
	CDataExchange dx(this, 1);
	DoDataExchange(&dx);
	SetDlgItemText(IDC_CHECK2, GetKFieldNamePart(m_Edit2));
	Edit2 = m_Edit2;
}

void QueryFilterDialog::OnBBFilter3() 
{
	CDataExchange dx(this, 1);
	DoDataExchange(&dx);
	SetDlgItemText(IDC_CHECK3, GetKFieldNamePart(m_Edit3));
	Edit3 = m_Edit3;
}

void QueryFilterDialog::OnBBFilter4() 
{
	CDataExchange dx(this, 1);
	DoDataExchange(&dx);
	SetDlgItemText(IDC_CHECK4, GetKFieldNameChar(m_Edit7));
	Edit7 = m_Edit7;
}

void QueryFilterDialog::OnBBFilter5() 
{
	CDataExchange dx(this, 1);
	DoDataExchange(&dx);	
	SetDlgItemText(IDC_CHECK5, GetKFieldNameChar(m_Edit8));
	Edit8 = m_Edit8;
}

void QueryFilterDialog::OnBBFilter6() 
{
	CDataExchange dx(this, 1);
	DoDataExchange(&dx);	
	SetDlgItemText(IDC_CHECK6, GetKFieldNameChar(m_Edit9));
	Edit9 = m_Edit9;
}

void QueryFilterDialog::OnBBFilterExe1() 
{
	long QH;
	long FH;
	long rc;
	CString Str;

	//Create new query with qeury handle - QH
	QH = CreateQuery();
	if (QH > 0)
	{
		rc = m_Check1.GetCheck();
		if (rc == 1)
		{
			//clear part list
			m_PartsListControl.DeleteAllItems();
			//create new filter with filter handle - FH
			CDataExchange dx(this, 1);
			DoDataExchange(&dx);
			FH = CreateFilter(m_Edit1, 1, m_Edit4);
			if (FH > -1)
			{
				//add filter to query
				rc = AddNewFilter(QH, FH, 0);
	            if (rc > 0)
                {
					SetPartsLB(QH);
                }
			}
		}
	}	
}

void QueryFilterDialog::OnBBFilterExe2() 
{
	long QH;
	long FH;
	long rc;
	CString Str;

	//Create new query with qeury handle - QH
	QH = CreateQuery();
	if (QH > 0)
	{
		rc = m_Check2.GetCheck();
		if (rc == 1)
		{
			//clear parts list
			m_PartsListControl.DeleteAllItems();
			//create new filter with filter handle - FH
			CDataExchange dx(this, 1);
			DoDataExchange(&dx);
			FH = CreateFilter(m_Edit2, 1, m_Edit5);
			if (FH > -1)
			{
				//add filter to query
				rc = AddNewFilter(QH, FH, 0);
	            if (rc > 0)
                {
					SetPartsLB(QH);
                }
			}
		}
	}		
}

void QueryFilterDialog::OnBBFilterExe3() 
{
	long QH;
	long FH;
	long rc;
	CString Str;

	//Create new query with qeury handle - QH
	QH = CreateQuery();
	if (QH > 0)
	{
		rc = m_Check3.GetCheck();
		if (rc == 1)
		{
			//clear partv list
			m_PartsListControl.DeleteAllItems();
			//create new filter with filter handle - FH
			CDataExchange dx(this, 1);
			DoDataExchange(&dx);
			FH = CreateFilter(m_Edit3, 1, m_Edit6);
			if (FH > -1)
			{
				//add filter to query
				rc = AddNewFilter(QH, FH, 0);
	            if (rc > 0)
                {
					SetPartsLB(QH);
                }
			}
		}
	}		
}

void QueryFilterDialog::OnBBFilterExe4() 
{
	long QH;
	long FH;
	long rc;
	CString Str;

	//Create new query with qeury handle - QH
	QH = CreateQuery();
	if (QH > 0)
	{
		rc = m_Check4.GetCheck();
		if (rc == 1)
		{
			//clear partv list
			m_CharsListControl.DeleteAllItems();
			//create new filter with filter handle - FH
			CDataExchange dx(this, 1);
			DoDataExchange(&dx);
			FH = CreateFilter(m_Edit7, 1, m_Edit10);
			if (FH > -1)
			{
				//add filter to query
				rc = AddNewFilter(QH, FH, 1);
	            if (rc > 0)
                {
					SetCharsLB(QH);
                }
			}
		}
	}		
}

void QueryFilterDialog::OnBBFilterExe5() 
{
long QH;
	long FH;
	long rc;
	CString Str;

	//Create new query with qeury handle - QH
	QH = CreateQuery();
	if (QH > 0)
	{
		rc = m_Check5.GetCheck();
		if (rc == 1)
		{
			//clear partv list
			m_CharsListControl.DeleteAllItems();
			//create new filter with filter handle - FH
			CDataExchange dx(this, 1);
			DoDataExchange(&dx);
			FH = CreateFilter(m_Edit8, 1, m_Edit11);
			if (FH > -1)
			{
				//add filter to query
				rc = AddNewFilter(QH, FH, 1);
	            if (rc > 0)
                {
					SetCharsLB(QH);
                }
			}
		}
	}	
}

void QueryFilterDialog::OnBBFilterExe6() 
{
	long QH;
	long FH;
	long rc;
	CString Str;

	//Create new query with qeury handle - QH
	QH = CreateQuery();
	if (QH > 0)
	{
		rc = m_Check6.GetCheck();
		if (rc == 1)
		{
			//clear partv list
			m_CharsListControl.DeleteAllItems();
			//create new filter with filter handle - FH
			CDataExchange dx(this, 1);
			DoDataExchange(&dx);
			FH = CreateFilter(m_Edit9, 1, m_Edit12);
			if (FH > -1)
			{
				//add filter to query
				rc = AddNewFilter(QH, FH, 1);
	            if (rc > 0)
                {
					SetCharsLB(QH);
                }
			}
		}
	}	
}

void QueryFilterDialog::OnCheck1() 
{
	int rc;
    rc = m_Check1.GetCheck();
	if (rc == 1)
	{
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);
		Edit1 = m_Edit1;
	}
	else
	{
		Edit1 = 0;
	}	
}

void QueryFilterDialog::OnCheck2() 
{
	int rc;
    rc = m_Check2.GetCheck();
	if (rc == 1)
	{
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);
		Edit2 = m_Edit2;
	}
	else
	{
		Edit2 = 0;
	}
}

void QueryFilterDialog::OnCheck3() 
{
	int rc;
    rc = m_Check3.GetCheck();
	if (rc == 1)
	{
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);
		Edit3 = m_Edit3;
	}
	else
	{
		Edit3 = 0;
	}
}

void QueryFilterDialog::OnCheck4() 
{
	int rc;
    rc = m_Check4.GetCheck();
	if (rc == 1)
	{
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);
		Edit7 = m_Edit7;
	}
	else
	{
		Edit7 = 0;
	}
}

void QueryFilterDialog::OnCheck5() 
{
	int rc;
    rc = m_Check5.GetCheck();
	if (rc == 1)
	{
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);
		Edit8 = m_Edit8;
	}
	else
	{
		Edit8 = 0;
	}
}

void QueryFilterDialog::OnCheck6() 
{
	int rc;
    rc = m_Check6.GetCheck();
	if (rc == 1)
	{
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);
		Edit9 = m_Edit9;
	}
	else
	{
		Edit9 = 0;
	}
}

void QueryFilterDialog::OnOK() 
{
	CDialog::OnOK();
	SelItem = -1;
	SelItem = m_PartsListControl.GetNextItem(-1, LVNI_SELECTED) + 1;
	//SelItem = m_CharsListControl.GetNextItem(-1, LVNI_SELECTED) + 1;
	if (SelItem < 0)
	{
		m_PartsListControl.GetCheck(SelItem);
	}
}


long QueryFilterDialog::GetQuery()
{
	return QueryHandle;
}

long QueryFilterDialog::GetFilter()
{
	return SelItem;
}
