// SelektCatalogue.cpp : implementation file
//

#include "stdafx.h"
#include "VCPPCOMClient2.h"
#include "SelektCatalogue.h"
#include "atlbase.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SelektCatalogue dialog


SelektCatalogue::SelektCatalogue(CWnd* pParent /*=NULL*/)
	: CDialog(SelektCatalogue::IDD, pParent)
{
	//{{AFX_DATA_INIT(SelektCatalogue)
	//}}AFX_DATA_INIT
}


void SelektCatalogue::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SelektCatalogue)
	DDX_Control(pDX, IDC_COB_Catalogue, m_COBCatalogue);
	DDX_Control(pDX, IDC_COB_SubCatalogue, m_COBSubCatalogue);
	DDX_Control(pDX, IDC_Catalogue, m_ListCatalogue);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(SelektCatalogue, CDialog)
	//{{AFX_MSG_MAP(SelektCatalogue)
	ON_CBN_SELCHANGE(IDC_COB_Catalogue, OnSelchangeCatalogue)
	ON_CBN_SELCHANGE(IDC_COB_SubCatalogue, OnSelchangeSubCatalogue)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SelektCatalogue message handlers

void SelektCatalogue::SetServerObject(IUnknown* pIUnknown, long qsSTATHandle)
{
    pIUnknown->QueryInterface(IID_IEnumCatalogue,(void**)&pIqsSTATCatalogue);

	pqsSTATHandle = qsSTATHandle;
}

BOOL SelektCatalogue::OnInitDialog() 
{
	
	CDialog::OnInitDialog();

	SetCatalogue();
	OnSelchangeCatalogue();
	SetSubCatalogue();

	m_ListCatalogue.InsertColumn(0, "#", LVS_REPORT, 30);
	m_ListCatalogue.InsertColumn(1, "Number", LVS_REPORT, 100);
	m_ListCatalogue.InsertColumn(2, "Mark", LVS_REPORT, 100);

	return TRUE; 
}

SelektCatalogue::~SelektCatalogue()
{
	int i;

	CatStruct* pCat;
	for (i = 0; i < CatArray.GetSize();i++)
	{	
		pCat = CatArray.GetAt(i);
		delete pCat;
	}
	
	SubCatStruct* pSubCat;
	for (i = 0; i < SubCatArray.GetSize();i++)
	{	
		pSubCat = SubCatArray.GetAt(i);
		delete pSubCat;
	}

} 

//------------------------------------------------------------------
//------------------------------------------------------------------
void SelektCatalogue::SetCatalogue()
{	
	long		CatKey = 0;
	COleVariant	ColumnKeyList;
	long		SubCatalogs = 0;
	CComBSTR	CatName;
	CString		Str;
	char		s_str[255];
	long		rc;

	rc = pIqsSTATCatalogue->GetFirstCatalog( pqsSTATHandle, 
										    &CatKey, 
											&ColumnKeyList, 
											&SubCatalogs,
											&CatName);
	while (rc == 0)	
	{
		CatStruct* pCat = new CatStruct;
		pCat->CatKey = CatKey;
		Str = CatName;

		sprintf(s_str, "%s %s%d%s", Str, "(", CatKey, ")");
		// Add to combobox
		m_COBCatalogue.AddString(s_str);
		// Add to internal list
		CatArray.Add(pCat);
		rc = pIqsSTATCatalogue->GetNextCatalog(pqsSTATHandle, 
											   &CatKey, 
											   &ColumnKeyList, 
											   &SubCatalogs,
											   &CatName);
	}
	m_COBCatalogue.SetCurSel(0);
}

void SelektCatalogue::SetSubCatalogue()
{	
	long		CatKey = 0;
	long		SubCatKey = 0;
	BSTR		SubCatName;
	CString		Str;
	char		s_str[255];
	long		rc;		

	CatStruct * pCI;
    int index = m_COBCatalogue.GetCurSel();
	if (index >= 0)
	{
		pCI = CatArray.GetAt(index);
		if (pCI)
		{
			CatKey = pCI->CatKey;
		}
		else
		{
			CatKey = 0; 
		}
	}

	if (CatKey > 0)
	{

		rc = pIqsSTATCatalogue->GetFirstSubCatalog( pqsSTATHandle, 
													CatKey, 
													&SubCatKey,
													&SubCatName);
		while (rc == 0)	
		{
			SubCatStruct* pSubCat = new SubCatStruct;
			pSubCat->SubCatKey = SubCatKey;
			Str = SubCatName;

			sprintf(s_str, "%s %s%d%s", Str, "(", SubCatKey, ")");
			// Add to combobox
			m_COBSubCatalogue.AddString(s_str);
			// Add to internal list
			SubCatArray.Add(pSubCat);
			rc = pIqsSTATCatalogue->GetNextSubCatalog( pqsSTATHandle, 
													   CatKey,
													   &SubCatKey,
													   &SubCatName);
		}
	}
	m_COBSubCatalogue.SetCurSel(0);
}

void SelektCatalogue::OnSelchangeCatalogue() 
{
	SetSubCatalogue();

	long		CatKey = 0;
	long		SubCatKey = 0;
	long		EntryKey = 0;
	BSTR		NumberStr;
	BSTR		NameStr;
	BSTR		str3;
	BSTR		str4;
	int			i = 0;
	char		buffer[255];
	CString		Str;
	HRESULT		hr;

	CatStruct * pCI;
    int index = m_COBCatalogue.GetCurSel();
	if (index >= 0)
	{
		pCI = CatArray.GetAt(index);
		if (pCI)
		{
			CatKey = pCI->CatKey;
		}
		else
		{
			CatKey = 0; 
		}
	}

	m_ListCatalogue.DeleteAllItems();
	if(pIqsSTATCatalogue)
	{
		hr = pIqsSTATCatalogue->GetFirstCatalogEntryComplete( pqsSTATHandle, 
															  CatKey, 
															  SubCatKey,
															  &EntryKey,
															  &NumberStr,
															  &NameStr,
															  &str3,
															  &str4);
		while (hr == S_OK)	
		{
			Str = NumberStr;
			LPTSTR p = Str.GetBuffer(Str.GetLength());
			_itoa(EntryKey, buffer, 10 );
			m_ListCatalogue.InsertItem(i, buffer);
			m_ListCatalogue.SetItem(i, 1, LVS_REPORT, p, 0,0,0,0);
			Str.ReleaseBuffer();
			Str  = NameStr;
			p = Str.GetBuffer(Str.GetLength());
			m_ListCatalogue.SetItem(i, 2, LVS_REPORT, p, 0,0,0,0);
			Str.ReleaseBuffer();
			i = i + 1;
			hr = pIqsSTATCatalogue->GetNextCatalogEntryComplete(pqsSTATHandle, 
																&EntryKey,
																&NumberStr,
																&NameStr,
																&str3,
																&str4);	
		}	
	}
}

void SelektCatalogue::OnSelchangeSubCatalogue() 
{
	long		CatKey = 0;
	long		SubCatKey = 0;
	long		EntryKey = 0;
	BSTR		NumberStr;
	BSTR		NameStr;
	BSTR		str3;
	BSTR		str4;
	int			i = 0;
	char		buffer[255];
	CString		Str;
	HRESULT		hr;
	
	CatStruct * pCI;
    int index = m_COBCatalogue.GetCurSel();
	if (index >= 0)
	{
		pCI = CatArray.GetAt(index);
		if (pCI)
		{
			CatKey = pCI->CatKey;
		}
		else
		{
			CatKey = 0; 
		}
	}

	SubCatStruct * dCI;
    index = m_COBSubCatalogue.GetCurSel();
	if (index >= 0)
	{
		dCI = SubCatArray.GetAt(index);
		if (dCI)
		{
			SubCatKey = dCI->SubCatKey;
		}
		else
		{
			SubCatKey = 0; 
		}
	}

	m_ListCatalogue.DeleteAllItems();

	if (pIqsSTATCatalogue)
	{
		hr = pIqsSTATCatalogue->GetFirstCatalogEntryComplete( pqsSTATHandle, 
															  CatKey, 
															  SubCatKey,
															  &EntryKey,
															  &NumberStr,
															  &NameStr,
															  &str3,
															  &str4);
		while (hr == S_OK)	
		{
			Str = NumberStr;
			LPTSTR p = Str.GetBuffer(Str.GetLength());
			_itoa(EntryKey, buffer, 10 );
			m_ListCatalogue.InsertItem(i, buffer);
			m_ListCatalogue.SetItem(i, 1, LVS_REPORT, p, 0,0,0,0);
			Str.ReleaseBuffer();
			Str  = NameStr;
			p = Str.GetBuffer(Str.GetLength());
			m_ListCatalogue.SetItem(i, 2, LVS_REPORT, p, 0,0,0,0);
			Str.ReleaseBuffer();
			i = i + 1;
			hr = pIqsSTATCatalogue->GetNextCatalogEntryComplete(pqsSTATHandle, 
																&EntryKey,
																&NumberStr,
																&NameStr,
																&str3,
																&str4);	
		}
	}
}

void SelektCatalogue::OnOK() 
{
	CDialog::OnOK();
}