// SelektGrafKey.cpp : implementation file
//
#include "stdafx.h"
#include "vcppcomclient2.h"
#include "SelektGrafKey.h"
#include "atlbase.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelektGrafKey dialog

CSelektGrafKey::CSelektGrafKey(CWnd* pParent /*=NULL*/)   // standard constructor
: CDialog(CSelektGrafKey::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelektGrafKey)
	m_GrafKey = 3100;
	m_GrafSubKey = 0;
	m_PartNr_x = 1;
	m_CharNr_x = 1;
	m_PartNr_y = 1;
	m_CharNr_y = 1;
	m_Graphic = -1;
	m_PageNr = 0;
	m_CharNr = 0;
	m_Char_x = 0;
	m_Char_y = 0;
	m_Part_x = 0;
	m_Part_y = 0;
	m_PartNr = 0;
	m_Value_x = 0;
	m_Value_y = 0;
	//}}AFX_DATA_INIT
}


void CSelektGrafKey::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelektGrafKey)
	DDX_Control(pDX, IDC_COB_Graphic, m_ENUMGraphic);
	DDX_Text(pDX, IDC_ED_Key, m_GrafKey);
	DDX_Text(pDX, IDC_ED_SubKey, m_GrafSubKey);
	DDX_CBIndex(pDX, IDC_COB_Graphic, m_Graphic);
	DDX_Text(pDX, IDC_ED_Page_Nr, m_PageNr);
	DDX_Text(pDX, IDC_ED_CharNr, m_CharNr);
	DDX_Text(pDX, IDC_ED_Char_x, m_Char_x);
	DDX_Text(pDX, IDC_ED_Char_y, m_Char_y);
	DDX_Text(pDX, IDC_ED_Part_x, m_Part_x);
	DDX_Text(pDX, IDC_ED_Part_y, m_Part_y);
	DDX_Text(pDX, IDC_ED_PartNr, m_PartNr);
	DDX_Text(pDX, IDC_ED_Value_x, m_Value_x);
	DDX_Text(pDX, IDC_ED_Value_y, m_Value_y);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelektGrafKey, CDialog)
	//{{AFX_MSG_MAP(CSelektGrafKey)
	ON_BN_CLICKED(ID_BB_Apply, OnBBApply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//------------------------------------------------------------------
//------------------------------------------------------------------
void CSelektGrafKey::SetServerObject(CUpdateView* view,
									 IUnknown* pIUnknown, 
									 long qsSTATHandle, 
									 long ModuleNr)
{
	pIUnknown->QueryInterface(IID_IEnumGraphic,(void**)&pIqsSTATGraphic);
    pIUnknown->QueryInterface(IID_ITQsstatRemoteControl,(void**)&pqsSTAT);

	pqsSTATHandle = qsSTATHandle;
	ModuleID	  = ModuleNr;
	pView		  = view;
}

void CSelektGrafKey::OnOK() 
{
	CDialog::OnOK();
}

void CSelektGrafKey::OnBBApply() 
{
	CDataExchange dx(this, 1);
	DoDataExchange(&dx);
	pView->SetGrafikKey(m_GrafKey);
	pView->SetGrafikSubKey(m_GrafSubKey);
	pView->SetGrafikPart_x(m_Part_x);
	pView->SetGrafikPart_y(m_Part_y);
	pView->SetGrafikChar_x(m_Char_x);
	pView->SetGrafikChar_y(m_Char_y);
	pView->SetGrafikValue_x(m_Value_x);
	pView->SetGrafikValue_y(m_Value_y);	
	pView->SetGrafikPageNr(m_PageNr);
	pView->GetGraphicOrReport(1,1);
}

//----------------------------------------------------------------------------
// ENum->Graphic
//----------------------------------------------------------------------------
BOOL CSelektGrafKey::OnInitDialog() 
{

	CDialog::OnInitDialog();
	long		GraphicKey = 0;
	CComBSTR	GraphicName;
	CString		Str;
	char		s_str[255];
	long		rc;
	
	rc = pIqsSTATGraphic->GetFirstGraphic(pqsSTATHandle,
										  ModuleID,	
										  &GraphicKey,
										  &GraphicName);
	while (rc == 0)	
	{
		// add to combobox
		Str = GraphicName;
		sprintf(s_str, "%s %s%d%s", Str, "(", GraphicKey, ")");
		m_ENUMGraphic.AddString(s_str);
		rc = pIqsSTATGraphic->GetNextGraphic(pqsSTATHandle,
										     ModuleID,	
										     &GraphicKey,
									     	 &GraphicName);
	}
	m_ENUMGraphic.SetCurSel(0);
	return TRUE;    
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektGrafKey::SetEnumGraphic()
{
	//not nedded!
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektGrafKey::SetGraphicKey( int value)
{
	if (value >= 1000)
	{
		m_GrafKey = value;
	}
	else{
		m_GrafKey = 1;
	}
}
//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetGraphicKey()
{
	return m_GrafKey;
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetGraphicSubkey()
{
	return m_GrafSubKey;
}

void	CSelektGrafKey::SetGraphicSubkey( int value)
{
	if (value >= 0)
	{
		m_GrafSubKey = value;
	}
	else
	{
		m_GrafSubKey = 0;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektGrafKey::SetPartNr()
{
    long value = 0;
	long rc;
	
	rc = pqsSTAT->GetGlobalInfo(pqsSTATHandle, 
                                0,
                                0,
                                1,
                                &value);
    if (rc == 0)
	{	
		m_PartNr = value;
	}

}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetPart_x()
{
	return m_Part_x;
}

void	CSelektGrafKey::SetPart_x( int value)
{
	if (value > 0)
	{
		m_Part_x = value;
	}
	else
	{
		m_Part_x = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektGrafKey::SetCharNr()
{
  	long value = 0;
	long rc;
	
	rc = pqsSTAT->GetGlobalInfo(pqsSTATHandle, 
                                1,
                                0,
                                3,
                                &value);
    if (rc == 0)
	{	
		m_CharNr = value;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetChar_x()
{
	return m_Char_x;
}
void	CSelektGrafKey::SetChar_x( int value)
{
	if (value > 0)
	{
		m_Char_x = value;
	}
	else
	{
		m_Char_x = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektGrafKey::SetValue_x( int value)
{
	if (value > 0)
	{
		m_Value_x = value;
	}
	else
	{
		m_Value_x = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetValue_x()
{
	return m_Value_x;
}


//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektGrafKey::SetPart_y( int value)
{
	if (value > 0)
	{
		m_Part_y = value;
	}
	else
	{
		m_Part_y = 1;
	}
}
//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetPart_y()
{
	return m_Part_y;
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektGrafKey::SetChar_y( int value)
{
	if (value > 0)
	{
		m_Char_y = value;
	}
	else
	{
		m_Char_y = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetChar_y()
{
	return m_Char_y;
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektGrafKey::SetValue_y( int value)
{
	if (value > 0)
	{
		m_Value_y = value;
	}
	else
	{
		m_Value_y = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektGrafKey::GetValue_y()
{
	return m_Value_y;
}
