// SelektPart.cpp : implementation file
//

#include "stdafx.h"
#include "VCPPCOMClient2.h"
#include "SelektPart.h"
#include <atlbase.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelektPart dialog


CSelektPart::CSelektPart(CWnd* pParent /*=NULL*/)
	: CDialog(CSelektPart::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelektPart)
	m_Key = 1002;
	m_Subkey = 0;
	m_Part = 1;
	m_Result = _T("");
	//}}AFX_DATA_INIT
}


void CSelektPart::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelektPart)
	DDX_Control(pDX, IDC_COB_PART, m_COB_PART);
	DDX_Text(pDX, IDC_ED_Key, m_Key);
	DDX_Text(pDX, IDC_ED_SubKey, m_Subkey);
	DDX_Text(pDX, IDC_ED_Part, m_Part);
	DDX_Text(pDX, IDC_ED_Result, m_Result);	
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelektPart, CDialog)
	//{{AFX_MSG_MAP(CSelektPart)
	ON_BN_CLICKED(IDC_BB_GetResult, OnBBGetResult)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelektPart message handlers

//------------------------------------------------------------------
//------------------------------------------------------------------
void CSelektPart::SetServerObject(IUnknown* pIUnknown, 
								  long qsSTATHandle)
{
	pIUnknown->QueryInterface(IID_ITQsstatRemoteControl,(void**)&pqsSTAT);
	pIUnknown->QueryInterface(IID_IEnumFieldKeyName,(void**)&pIqsSTATPart);
	pqsSTATHandle = qsSTATHandle;
}

BOOL CSelektPart::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	long		KFieldKey=0;
	long	    KFieldSubKey=0;
	CComBSTR	KFieldName;
	CString		Str;
	int			rc;
	char		s_str[255];

	rc = pIqsSTATPart->GetFirstPartField(pqsSTATHandle,
								     	 &KFieldKey,
									     KFieldSubKey,
										 &KFieldName);
	while (rc == 0)	
	{
		Str  = KFieldName;
	    sprintf(s_str, "%s %s%d%s", Str, "(", KFieldKey, ")");
		m_COB_PART.AddString(s_str);
		rc = pIqsSTATPart->GetNextPartField(pqsSTATHandle,
								     	    &KFieldKey,
										    KFieldSubKey,
											&KFieldName);
	}
	m_COB_PART.SetCurSel(0);
	
	return TRUE;	
}

void CSelektPart::OnOK() 
{
	CDialog::OnOK();
}

void CSelektPart::OnBBGetResult() 
{
	BSTR ValueText;
	HRESULT hr;

	UpdateData(TRUE);
	if (pqsSTAT)
	{
		hr = pqsSTAT->GetPartInfo(pqsSTATHandle,
								  m_Key,
								  m_Part,
								  0,
								  &ValueText);

		if (hr == S_OK)
		{
			m_Result = CString(ValueText);
		}
		else
		{
			m_Result = "Error";
		}
		UpdateData(FALSE);
	}

}
