// SelektReportKey.cpp : implementation file
//

#include "stdafx.h"

#include "vcppcomclient2.h"
#include "SelektReportKey.h"
#include "atlbase.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelektReportKey dialog

CSelektReportKey::CSelektReportKey(CWnd* pParent /*= NULL*/)   // standard constructor
: CDialog(CSelektReportKey::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelektReportKey) 
	m_PageNr = 1;
	m_Pages = 0;
	m_CharNr_x = 1;
	m_CharNr_y = 1;
	m_PartNr_x = 1;
	m_PartNr_y = 1;
	m_ValueNr_x = 1;
	m_ValueNr_y = 1;

	//}}AFX_DATA_INIT
	pIqsSTATReport = NULL;
	SelItem = -1;
}
	
void CSelektReportKey::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelektReportKey)
	DDX_Control(pDX, IDC_BB_GetPages, m_GetPages);
	DDX_Control(pDX, IDC_BB_Apply, m_Apply);
	DDX_Control(pDX, ID_BB_Page_BWD, m_PageBwd);
	DDX_Control(pDX, ID_BB_Page_FWD, m_PageFwd);
	DDX_Control(pDX, IDC_COB_Report, m_ENUMReport);
	DDX_Text(pDX, IDC_ED_PageNr, m_PageNr);
	DDX_Text(pDX, IDC_ED_Pages, m_Pages);
	DDX_Text(pDX, IDC_ED_Char_x, m_CharNr_x);
	DDX_Text(pDX, IDC_ED_Char_y, m_CharNr_y);
	DDX_Text(pDX, IDC_ED_Part_x, m_PartNr_x);
	DDX_Text(pDX, IDC_ED_Part_y, m_PartNr_y);
	DDX_Text(pDX, IDC_ED_Value_x, m_ValueNr_x);
	DDX_Text(pDX, IDC_ED_Value_y, m_ValueNr_y);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSelektReportKey, CDialog)
	//{{AFX_MSG_MAP(CSelektReportKey)
	ON_BN_CLICKED(IDC_BB_GetPages, OnBBGetPages)
	ON_BN_CLICKED(ID_BB_Page_BWD, OnBBPageBWD)
	ON_BN_CLICKED(IDC_BB_Apply, OnBBApply)
	ON_BN_CLICKED(ID_BB_Page_FWD, OnBBPageFWD)
	ON_CBN_EDITCHANGE(IDC_COB_Report, OnEditchangeReport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//------------------------------------------------------------------
//------------------------------------------------------------------

void CSelektReportKey::SetServerObject(CUpdateView* view,
									   IUnknown* pIUnknown, 
									   long qsSTATHandle)
{
	pIUnknown->QueryInterface(IID_IEnumReport,(void**)&pIqsSTATReport);
    pIUnknown->QueryInterface(IID_ITQsstatRemoteControl,(void**)&pqsSTAT);
	pqsSTATHandle = qsSTATHandle;
	pView = view;
}

//------------------------------------------------------------------
//------------------------------------------------------------------

BOOL CSelektReportKey::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	long		ReportNr = 0;
	CComBSTR	ReportName;
	CComBSTR	ReportFileName;
	CString		Str;
	CString		Str2;
	int			rc;
	char		s_str[255];

	rc = pIqsSTATReport->GetFirstReport(pqsSTATHandle,
									    &ReportNr,
										&ReportName,
										&ReportFileName);
	while (rc == 0)	
	{
		Str  = ReportName;
		Str2 = ReportFileName;
		ReportArr.Add(Str2);
	    sprintf(s_str, "%s%s%s %s%d%s", Str, "/", Str2, "(", ReportNr, ")");
		m_ENUMReport.AddString(s_str);
		rc = pIqsSTATReport->GetNextReport(pqsSTATHandle,
										   &ReportNr,
										   &ReportName,
										   &ReportFileName);
	}
	m_ENUMReport.SetCurSel(0);
	SelItem = 0;
	SetPages();
	return TRUE;	
}


void CSelektReportKey::OnEditchangeReport() 
{
	SelItem = m_ENUMReport.GetCurSel();	
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
CString CSelektReportKey::GetReportFileName()
{

	if (SelItem > -1)
	{
		return ReportArr.GetAt(SelItem);
	}
	else
	{
		return "-1";
	}
}

void CSelektReportKey::OnOK() 
{
	OnEditchangeReport();
	CDialog::OnOK();
}

void CSelektReportKey::OnBBGetPages() 
{
	SetPages();
}

void CSelektReportKey::OnBBApply() 
{
	CString str;
	int		i;
	CDataExchange dx(this, 1);

	DoDataExchange(&dx);

	i = m_ENUMReport.GetCurSel();
	str = ReportArr.GetAt(i);	
	LPTSTR p = str.GetBuffer(str.GetLength());
	pView->SetReportName(p);
	pView->SetReportPart_x(m_PartNr_x);
	pView->SetReportPart_y(m_PartNr_y);
	pView->SetReportChar_x(m_CharNr_x);
	pView->SetReportChar_y(m_CharNr_y);
	pView->SetReportValue_x(m_ValueNr_x);
	pView->SetReportValue_y(m_ValueNr_y);
	pView->SetReportPageNr(m_PageNr);
	pView->GetGraphicOrReport(2,1);
}
//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektReportKey::SetPages()
{
	CString	 CurReport;
	CComBSTR ReportFName;
	long	 PageCount;
	int		 rc;
	
	SelItem = m_ENUMReport.GetCurSel();	
	CurReport = GetReportFileName();
	ReportFName	= (CComBSTR)CurReport;

    rc = pqsSTAT->GetReportPages(pqsSTATHandle,
                                 ReportFName,
                                 &PageCount);
    if (rc == 0)
	{	
		m_Pages = PageCount;
		char buffer[20];

		_itoa(PageCount, buffer, 10);
		SetDlgItemText(IDC_ED_Pages, buffer);
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);
	}
}

void CSelektReportKey::OnBBPageBWD() 
{
	if (m_PageNr > 1)
	{
		m_PageNr = m_PageNr - 1;
		char buffer[20];
		_itoa(m_PageNr, buffer, 10);
		SetDlgItemText(IDC_ED_PageNr, buffer);	
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);
	}
}

void CSelektReportKey::OnBBPageFWD() 
{
	if (m_PageNr < 5)
	{
		m_PageNr = m_PageNr + 1;
		char buffer[20];
		_itoa(m_PageNr, buffer, 10);
		SetDlgItemText(IDC_ED_PageNr, buffer);	
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);  
	}
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int		CSelektReportKey::GetPartNr_x()
{
	return m_PartNr_x;
}

void	CSelektReportKey::SetPartNr_x( int value)
{
	if (value > 0)
	{
		m_PartNr_x = value;
	}
	else
	{
		m_PartNr_x = 1;
	}
}
//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektReportKey::GetCharNr_x()
{
	return m_CharNr_x;
}
void	CSelektReportKey::SetCharNr_x( int value)
{
	if (value > 0)
	{
		m_CharNr_x = value;
	}
	else
	{
		m_CharNr_x = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektReportKey::GetValueNr_x()
{
	return m_CharNr_x;
}
void	CSelektReportKey::SetValueNr_x( int value)
{
	if (value > 0)
	{
		m_ValueNr_x = value;
	}
	else
	{
		m_ValueNr_x = 0;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int		CSelektReportKey::GetPartNr_y()
{
	return m_CharNr_x;
}
void	CSelektReportKey::SetPartNr_y( int value)
{
	if (value > 0)
	{
		m_PartNr_y = value;
	}
	else
	{
		m_PartNr_y = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int	CSelektReportKey::GetCharNr_y()
{
	return m_CharNr_x;
}
void CSelektReportKey::SetCharNr_y(int value)
{
	if (value > 0)
	{
		m_CharNr_y = value;
	}
	else
	{
		m_CharNr_y = 1;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------

int	CSelektReportKey::GetValueNr_y()
{
	return m_CharNr_x;
}
void CSelektReportKey::SetValueNr_y(int value)
{
	if (value > 0)
	{
		m_ValueNr_y = value;
	}
	else
	{
		m_ValueNr_y = 0;
	}
}

//------------------------------------------------------------------
//------------------------------------------------------------------
int	CSelektReportKey::GetPageNr()
{
	return m_PageNr;
}
