// SelektStatKey.cpp : implementation file
//

#include "stdafx.h"
#include "vcppcomclient2.h"
#include "SelektStatKey.h"
#include <atlbase.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelektStatKey dialog


//--------------------------------------------------------------------
CSelektStatKey::CSelektStatKey(CWnd* pParent /*=NULL*/)
	: CDialog(CSelektStatKey::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelektStatKey)
	m_StatResultKey = 1000;
	m_StatResultSubkey = 0;
	m_CharNr = 1;
	m_PartNr = 1;
	m_StatResult = _T("");
	//}}AFX_DATA_INIT
}


void CSelektStatKey::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelektStatKey)
	DDX_Control(pDX, IDC_COB_StatResult, m_ENUMStatResult);
	DDX_Text(pDX, IDC_ED_Key, m_StatResultKey);
	DDX_Text(pDX, IDC_ED_SubKey, m_StatResultSubkey);
	DDX_Text(pDX, IDC_ED_Char_x, m_CharNr);
	DDX_Text(pDX, IDC_ED_Part_x, m_PartNr);
	DDX_Text(pDX, IDC_ED_Result, m_StatResult);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelektStatKey, CDialog)
	//{{AFX_MSG_MAP(CSelektStatKey)
	ON_BN_CLICKED(IDC_BB_GetResult, OnBBGetResult)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//------------------------------------------------------------------
//------------------------------------------------------------------
void CSelektStatKey::SetServerObject(IUnknown* pIUnknown, 
									   long qsSTATHandle,
									   long module)
{
	pIUnknown->QueryInterface(IID_IEnumStatResults,(void**)&pIqsSTATStatResult);
    pIUnknown->QueryInterface(IID_ITQsstatRemoteControl,(void**)&pqsSTAT);
	pqsSTATHandle = qsSTATHandle;
	qs_Module = module;
}

BOOL CSelektStatKey::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CDialog::CheckRadioButton(IDC_RADIO2, IDC_RADIO3, IDC_RADIO1);
	

	Transform = 0;
	long		StatKey;
	CComBSTR	StatName = "";
	CString		Str;
	int			rc;
	char		s_str[255];

	rc = pIqsSTATStatResult->GetFirstStatResult(pqsSTATHandle,
								     	        qs_Module,
									    	    &StatKey,
										    	&StatName);
	while (rc == 0)	
	{
		Str  = StatName;
	    sprintf(s_str, "%s %s%d%s", Str, "(", StatKey, ")");
		m_ENUMStatResult.AddString(s_str);
		StatName = "";
		rc = pIqsSTATStatResult->GetNextStatResult(pqsSTATHandle,
											   	   qs_Module,
											       &StatKey,
											       &StatName);
	}
	m_ENUMStatResult.SetCurSel(0);
	
	return TRUE;	
}

void CSelektStatKey::OnOK() 
{
	CDialog::OnOK();
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektStatKey::SetStatResultKey( int value)
{
	if (value >= 1000)
	{
		m_StatResultKey = value;
	}
	else{
		m_StatResultKey = 1;
	}
}
int		CSelektStatKey::GetStatResultKey()
{
	return m_StatResultKey;
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektStatKey::SetStatResultSubkey( int value)
{
	if (value >= 0)
	{
		m_StatResultSubkey = value;
	}
	else
	{
		m_StatResultSubkey = 0;
	}
}
int		CSelektStatKey::GetStatResultSubkey()
{
	return m_StatResultSubkey;
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektStatKey::SetPartNr( int value)
{
	if (value > 0)
	{
		m_PartNr = value;
	}
	else
	{
		m_PartNr = 1;
	}
}
int		CSelektStatKey::GetPartNr()
{
	return m_PartNr;
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void	CSelektStatKey::SetCharNr( int value)
{
	if (value > 0)
	{
		m_CharNr = value;
	}
	else
	{
		m_CharNr = 1;
	}
}
int		CSelektStatKey::GetCharNr()
{
	return m_CharNr;
}

//------------------------------------------------------------------
//------------------------------------------------------------------
void CSelektStatKey::GetStatResult()
{
	CComBSTR	StatResStr1 = 0;
	CComBSTR	StatResStr2 = 0;
	CComBSTR	StatResStr3 = 0;
	CComBSTR	StatResStr4 = 0;
	CComBSTR	StatResStr5 = 0;
	double		StatResDbl1 = 0;
	double		StatResDbl2 = 0;
	double		StatResDbl3 = 0;
	double		StatResDbl4 = 0;
	double		StatResDbl5 = 0;
	long		ResCount;
	HRESULT		hr;
	CString		tr;

	UpdateData(TRUE);
	if (pqsSTAT)
	{
  		hr = pqsSTAT->GetStatResultEx(pqsSTATHandle,
    			         		      m_PartNr,
									  m_CharNr,
						              0,
							          m_StatResultKey,
								      m_StatResultSubkey,
								 	  4,				    // content of the field
									  Transform,			// transformation						
									  0, 0,
									  &StatResStr1,
									  &StatResStr2,
									  &StatResStr3,
									  &StatResStr4,
									  &StatResStr5,
									  &ResCount,
									  &StatResDbl1,
	                                  &StatResDbl2,
		                              &StatResDbl3,
			                          &StatResDbl4,
				                      &StatResDbl5);
		if (hr == S_OK)
		{
			m_StatResult = CString(StatResStr1);
		}
		else
		{
			m_StatResult = "Error";
		}
		UpdateData(FALSE);
	}	

}

void CSelektStatKey::OnBBGetResult() 
{
	GetStatResult();			
}

void CSelektStatKey::OnRadio1() 
{
	Transform = 0;
}

void CSelektStatKey::OnRadio2() 
{
	Transform = 1;
}

void CSelektStatKey::OnRadio3() 
{
	Transform = 2;
}