// SelektValue.cpp : implementation file
//

#include "stdafx.h"
#include "VCPPCOMClient2.h"
#include "SelektValue.h"
#include <atlbase.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelektValue dialog


CSelektValue::CSelektValue(CWnd* pParent /*=NULL*/)
	: CDialog(CSelektValue::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelektValue)
	m_Key = 1;
	m_Subkey = 0;
	m_Part = 1;
	m_Char = 1;
	m_Value = 1;
	m_Result = _T("");
	//}}AFX_DATA_INIT
}


void CSelektValue::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelektValue)
	DDX_Control(pDX, IDC_COB_VALUE, m_COB_VALUE);
	DDX_Text(pDX, IDC_ED_Key, m_Key);
	DDX_Text(pDX, IDC_ED_SubKey, m_Subkey);
	DDX_Text(pDX, IDC_ED_Part, m_Part);
	DDX_Text(pDX, IDC_ED_Char, m_Char);
	DDX_Text(pDX, IDC_ED_Value, m_Value);
	DDX_Text(pDX, IDC_ED_Result, m_Result);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelektValue, CDialog)
	//{{AFX_MSG_MAP(CSelektValue)
	ON_BN_CLICKED(IDC_BB_GetResult, OnBBGetResult)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelektValue message handlers

//------------------------------------------------------------------
//------------------------------------------------------------------
void CSelektValue::SetServerObject(IUnknown* pIUnknown, 
								  long qsSTATHandle)
{
	pIUnknown->QueryInterface(IID_IEnumFieldKeyName,(void**)&pIqsSTATValue);
    pIUnknown->QueryInterface(IID_ITQsstatRemoteControl,(void**)&pqsSTAT);
	pqsSTATHandle = qsSTATHandle;
}

BOOL CSelektValue::OnInitDialog() 
{
	//-----------------------------------------------------------------------
	// 1. Show dialog
	// 2. Set COMBO
	// 3. Select first value
	//-----------------------------------------------------------------------
	
	CDialog::OnInitDialog();
	
	long		KFieldKey=0;
	long		KFieldSubKey=0;
	CComBSTR	KFieldName;
	CString		Str;
	int			rc;
	char		s_str[255];

	rc = pIqsSTATValue->GetFirstValueField(pqsSTATHandle,
								     	   &KFieldKey,
									       KFieldSubKey,
										   &KFieldName);
	while (rc == 0)	
	{
		Str  = KFieldName;
	    sprintf(s_str, "%s %s%d%s", Str, "(", KFieldKey, ")");
		m_COB_VALUE.AddString(s_str);
		rc = pIqsSTATValue->GetNextValueField(pqsSTATHandle,
								     		  &KFieldKey,
											  KFieldSubKey,
											  &KFieldName);
	}
	m_COB_VALUE.SetCurSel(0);

	return TRUE;	
}

void CSelektValue::OnOK() 
{
	CDialog::OnOK();
}

void CSelektValue::OnBBGetResult() 
{
	BSTR	ValueText;
	HRESULT	hr;


	UpdateData(TRUE);
	if (pqsSTAT)
	{
		hr = pqsSTAT->GetValueInfo(pqsSTATHandle,
								   m_Key,
								   m_Part,
								   m_Char,
								   m_Value,
								   0,
								   &ValueText);
 
		if (hr == S_OK)
		{
			m_Result = CString(ValueText);
		}
		else
		{
			m_Result = "Error";
		}
		UpdateData(FALSE);
	}
}