// VCPPCOMClient2View.cpp : implementation of the CVCPPCOMClient2View class
//

#define _WIN32_DCOM

#include "stdafx.h"
#include <atlbase.h>
#include <afxtempl.h>
#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <time.h>

#define DFQ_LINE_SIZE	80*2
#ifndef	INVALID_SET_FILE_POINTER
#define INVALID_SET_FILE_POINTER	(DWORD)(-1)
#endif

#include "VCPPCOMClient2.h"
#include "VCPPCOMClient2Doc.h"
#include "VCPPCOMClient2View.h"

//#include "MainFrm.h"
#include "SelektGrafKey.h"
#include "SelektStatKey.h"
#include "SelektReportKey.h"
#include "SelektCatalogue.h"
#include "ENumSelectDialog.h"
#include "AboutDialog.h"
#include "LoginDialog.h"
#include "QueryFilterDialog.h"
#include "SelektPart.h"
#include "SelektChar.h"
#include "SelektValue.h"
#include "OnlineTransmition.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCPPCOMClient2View

IMPLEMENT_DYNCREATE(CVCPPCOMClient2View, CFormView)

BEGIN_MESSAGE_MAP(CVCPPCOMClient2View, CFormView)
	//{{AFX_MSG_MAP(CVCPPCOMClient2View)
	ON_COMMAND(ID_Connect, OnConnect)
	ON_COMMAND(ID_Disconnect, OnDisconnect)
	ON_COMMAND(ID_FileOpen, OnFileOpen)
	ON_COMMAND(ID_FileTransmit, OnFileTransmit)
	ON_COMMAND(ID_COMMANDS_EVALUATE, OnEvaluate)
    ON_COMMAND(ID_PrintReport, OnPrintReport)
	ON_COMMAND(ID_StartServer, OnStartServer)
	ON_COMMAND(ID_GetGraphic, OnGetGraphic)
	ON_COMMAND(ID_GetResult, OnGetResult)
	ON_COMMAND(ID_GetReport, OnGetReport)
	ON_COMMAND(ID_GetValue, OnGetValue)
	ON_COMMAND(ID_SetModule, OnSetModule)	
	ON_COMMAND(ID_SetLanguage, OnSetLanguage)	
	ON_COMMAND(ID_SetStrategy, OnSetStrategy)	
	ON_COMMAND(ID_SetPrinter, OnSetPrinter)	
	ON_COMMAND(ID_DBOpen, OnSetDB)	
	ON_COMMAND(ID_About, OnAppAbout)
	ON_COMMAND(ID_GetCatalogue, OnGetCatalogue)
	ON_COMMAND(ID_GetChar, OnGetChar)
	ON_COMMAND(ID_GetPart, OnGetPart)
	ON_COMMAND(ID_ExecuteQuery, OnSetFilter)
	ON_COMMAND(ID_Transmition, OnTransmit)
	ON_COMMAND(ID_OnlineEval, OnONLINEEvaluation)
	ON_COMMAND(ID_SPCEval, OnSPCEvaluation)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCPPCOMClient2View construction/destruction

CVCPPCOMClient2View::CVCPPCOMClient2View()
	: CFormView(CVCPPCOMClient2View::IDD)
{
	pqsSTAT	= NULL;
	dib		= NULL;

	// Initialization for the Sink object
	pConnectionPointContainer = NULL;
	pConnectionPoint		  = NULL;	
	
	// IQSEventSink
	mySink			 = NULL;
	dwCookie		 = 0;
	
	//------------------------------------------------------------------
	// Server Thread Handling
	dwServerThreadId		= 0;
	h_ServerThread			= NULL;
	g_hTerminateQsSTATEvent = NULL; // Event for the StartServer Thread

	// connection handle
	qsSTATHandle	= 0;

	// internal variables for DATA
	NumOfChar = 0;
	K_Field_Up = 0;
	K_Field_Down = 0;
	PrinterNr = 0;
    
	// Parameters for dialogs
	PartNr_x = 1;
	CharNr_x = 1;
	PartNr_y = 1;
	CharNr_y = 1;
	Valuenr = 1;
	GIndex = 1; // default, GetGraphic
	GrafKey = 3100;// value chart
	GrafSubKey = 0;
	StatKey	= 1000;// average (stat.result)
	StatSubKey = 0;
	Transformation = 0;// not transformed
	ReportPageNr = 0;
	ReportPartNr_x = 1;
	ReportCharNr_x = 1;
	ReportPartNr_y = 1;
	ReportCharNr_y = 1;
	ReportValueNr_x = 1;
	ReportValueNr_y = 1;
}

CVCPPCOMClient2View::~CVCPPCOMClient2View()
{
	// diconnect and release COM object
	// Stop running threads

	
	DisconnectFromServer(TRUE);

	if (dib)
	{
		delete dib;
	}
}

void CVCPPCOMClient2View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCPPCOMClient2View)
	DDX_Control(pDX, IDC_IMAGE, m_Image);
	DDX_Control(pDX, IDC_EVENT_LIST, m_EventList);
	//}}AFX_DATA_MAP
}

BOOL CVCPPCOMClient2View::PreCreateWindow(CREATESTRUCT& cs)
{
	return CFormView::PreCreateWindow(cs);
}

void CVCPPCOMClient2View::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
}

/////////////////////////////////////////////////////////////////////////////
// CVCPPCOMClient2View diagnostics

#ifdef _DEBUG
void CVCPPCOMClient2View::AssertValid() const
{
	CFormView::AssertValid();
}

void CVCPPCOMClient2View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CVCPPCOMClient2Doc* CVCPPCOMClient2View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVCPPCOMClient2Doc)));
	return (CVCPPCOMClient2Doc*)m_pDocument;
}
#endif //_DEBUG


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


//--------------------------------------------------------------------------
// creating an instance of the object (Thread procedure)
//--------------------------------------------------------------------------
DWORD WINAPI lpQsStatConversation( LPVOID ptr )
{

	//---------------------------------------------------------
	// Starting the qs-STAT Server and register ConnectionPoints
	// 1. CoInitialize
	// 2. Create COM Object
	// 3. SEtup ConnectionPoints
	// 4. Wait for termination of Server-Session (g_hTerminateQsSTATEvent)
	//---------------------------------------------------------
	
	CString Str;
	char	s_str[255];
	CString  CurrentTime = "";

	CVCPPCOMClient2View * comclass = (CVCPPCOMClient2View * )ptr;
	
	CMainFrame* MainFrm = (CMainFrame*) ptr;
	
	if (!comclass->pqsSTAT)
	{
		IUnknown*	pUnknown;

		HRESULT hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);
	
		if (FAILED(hr))
		{
			CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
			Str  = CurrentTime + " -> CoInitialize failed";
        	sprintf(s_str, "%s", Str);
			comclass->AddToEventList(s_str);
		}
		hr = CoCreateInstance(  CLSID_TQsstatRemoteControl,NULL,CLSCTX_LOCAL_SERVER,
								IID_IUnknown,(void**)&pUnknown);
		if (SUCCEEDED(hr))
		{
			hr = pUnknown->QueryInterface(IID_ITQsstatRemoteControl,(void**)&comclass->pqsSTAT);
			if (SUCCEEDED(hr))
			{
				hr = pUnknown->QueryInterface(IID_IDataBase,(void**)&comclass->pIqsSTATDataBase);
				pUnknown->Release();	

				// createSink object(connection points)
				hr = comclass->pqsSTAT->QueryInterface(IID_IConnectionPointContainer, (void**)&comclass->pConnectionPointContainer);
				if(SUCCEEDED(hr))
				{
					hr = comclass->pConnectionPointContainer->FindConnectionPoint(IID_IQsEvents, &comclass->pConnectionPoint);
					if (SUCCEEDED(hr))
					{
						hr = comclass->pConnectionPoint->Advise((IUnknown*)comclass->mySink, &comclass->dwCookie);
						if (SUCCEEDED(hr))
						{
							// wait until server is initialized (15 seconds)
	/*			
							DWORD to = WaitForSingleObject(comclass->mySink->hServerInitializedEvent,15000);
							if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
							{
								CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
								Str  = CurrentTime + " -> OnQSSTATInitialize timeout";
        						sprintf(s_str, "%s", Str);
								comclass->AddToEventList(s_str);
							}
							else
							{
								
							//	((MainFrm*)->GetParent())->m_wndStatusBar.SetWindowText("Starting qs-STAT Server...Done.");				

								CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
								Str  = CurrentTime + " -> OnQSSTATInitialize.";
        						sprintf(s_str, "%s", Str);
								comclass->AddToEventList(s_str);
								
							};
	*/
						}
						else
						{
							CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
							Str  = CurrentTime + " -> pConnectionPoint->Advise failed";
        					sprintf(s_str, "%s", Str);
							comclass->AddToEventList(s_str);
						}
					}
					else
					{
						CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
						Str  = CurrentTime + " -> FindConnectionPoint failed";
						sprintf(s_str, "%s", Str);
						comclass->AddToEventList(s_str);
					}
				}
				else
				{
					CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
					Str  = CurrentTime + " -> cannot get IID_IConnectionPointContainer";
        			sprintf(s_str, "%s", Str);
					comclass->AddToEventList(s_str);
				};
			}
			else
			{
			
				comclass->pqsSTAT = NULL;
				CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
				Str  = CurrentTime + " -> QueryInterface (IID_ITQsstatRemoteControl) failed";
        		sprintf(s_str, "%s", Str);
				comclass->AddToEventList(s_str);
			}
		}
		else
		{
			CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
			Str  = CurrentTime + " -> CoCreateInstance failed";
        	sprintf(s_str, "%s", Str);
			comclass->AddToEventList(s_str);
		}
	}//(!pqsstat)

	// Wait for termination of server session
	comclass->g_hTerminateQsSTATEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
	WaitForSingleObject(comclass->g_hTerminateQsSTATEvent,INFINITE);
	CloseHandle(comclass->g_hTerminateQsSTATEvent);

	comclass->pqsSTAT->Release();
	comclass->pqsSTAT = NULL;
	CoUninitialize();

	return 0;
};


BOOL GetBinaryFromVariant(COleVariant & ovData, BYTE ** ppBuf,
                                unsigned long * pcBufLen)
{
	BOOL fRetVal = FALSE;

    //Binary data is stored in the variant as an array of unsigned char
    if(ovData.vt == (VT_ARRAY|VT_UI1))  // (OLE SAFEARRAY)
    {
		//Retrieve size of array
        *pcBufLen = ovData.parray->rgsabound[0].cElements;

        *ppBuf = new BYTE[*pcBufLen]; //Allocate a buffer to store the data
        if(*ppBuf != NULL)
        {
			void * pArrayData;

			//Obtain safe pointer to the array
			SafeArrayAccessData(ovData.parray,&pArrayData);

			//Copy the bitmap into our buffer
			memcpy(*ppBuf, pArrayData, *pcBufLen);

			//Unlock the variant data
			SafeArrayUnaccessData(ovData.parray);
			fRetVal = TRUE;
		}
	}
    return fRetVal;
}

BOOL PutBinaryIntoVariant(COleVariant * ovData, BYTE * pBuf,
                                unsigned long cBufLen)
{
	BOOL fRetVal = FALSE;

    VARIANT var;
    VariantInit(&var);  //Initialize our variant

    //Set the type to an array of unsigned chars (OLE SAFEARRAY)
    var.vt = VT_ARRAY | VT_UI1;

    //Set up the bounds structure
    SAFEARRAYBOUND  rgsabound[1];

    rgsabound[0].cElements = cBufLen;
    rgsabound[0].lLbound = 0;

    //Create an OLE SAFEARRAY
    var.parray = SafeArrayCreate(VT_UI1,1,rgsabound);

    if(var.parray != NULL)
    {
		void * pArrayData = NULL;

		//Get a safe pointer to the array
        SafeArrayAccessData(var.parray,&pArrayData);

        //Copy bitmap to it
        memcpy(pArrayData, pBuf, cBufLen);

        //Unlock the variant data
        SafeArrayUnaccessData(var.parray);

        *ovData = var;  // Create a COleVariant based on our variant
        VariantClear(&var);
        fRetVal = TRUE;
	}
    return fRetVal;
}

LRESULT CVCPPCOMClient2View::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if (message== RegisterWindowMessage("WM_FILESIZE_CHANGED"))
	{
	
	}
	if (message== RegisterWindowMessage("WM_STATISTIC_ALARM"))
	{

	}

	//--------------------------------------------------------------------
	//--------------------------------------------------------------------
	// Server Events passed by QsEventSink
	if (message== RegisterWindowMessage("MSG_OnQSSTATInitialized"))
	{		
		DoOnQSSTATInitialized();
	}

	if (message== RegisterWindowMessage("MSG_OnDataAvail"))
	{
		DoOnDataAvail(lParam);
	}

	if (message== RegisterWindowMessage("MSG_OnDataAvailExt"))
	{
		DoOnDataAvailExt(wParam, lParam);
	}

	if (message== RegisterWindowMessage("MSG_OnEvaluationDone"))
	{
		DoOnEvaluationDone();
	}

	if (message== RegisterWindowMessage("MSG_OnEvaluationDoneExt"))
	{
		DoOnEvaluationDoneExt(wParam);
	}
	
	if (message== RegisterWindowMessage("MSG_OnStatisticalAlarm"))
	{
		DoOnStatisticalAlarm((CAlarm*) lParam);
	}

	if (message== RegisterWindowMessage("MSG_OnStatisticalAlarmExt"))
	{
		DoOnStatisticalAlarmExt(wParam, (CAlarm*) lParam);
	}

	return CFormView::WindowProc(message, wParam, lParam);
}



//--------------------------------------------------------------------
// CVCPPCOMClient1View drawing
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnDraw(CDC* pDC)
{
	if (dib)
	{
		dib->Draw(*m_Image.GetDC());
		CDataExchange dx(this, 1);
		DoDataExchange(&dx);
		this->SetFocus();
	}
}

//--------------------------------------------------------------------
// Resize client
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	//redraw element on the form 070422, 314011, 630358, 374079
	if (m_EventList)
	{
		m_EventList.MoveWindow (cx-200, 0, cx-20, cy);
		m_Image.MoveWindow (0, 0, cx-200, cy);
	}
	//-----------------------------------------------------------------
	// request graphic in new dimensions /
	// zuletzt abgerufene Grafik in neuer Gre anfodern
	//-----------------------------------------------------------------
	GetGraphicOrReport(GIndex);
}


//--------------------------------------------------------------------
// Draw screen with GetGraphic or GetReport /
// Grafik oder Bericht vom Server anfordern
//--------------------------------------------------------------------
HRESULT CVCPPCOMClient2View::GetGraphicOrReport(int whattodo, int DoDraw)
{
	HRESULT hr;

	if ((pqsSTAT) && (qsSTATHandle))
	{
		if ((whattodo == 1) || (whattodo == 2))
		{
			GIndex = whattodo;
		}
		else
		{
			//maintain previous request (graphic or report)
		}

		COleVariant va;
		long	lbound,hbound;
		UINT	dim;
		void*	pBuffer;
		CRect	DrawRect;

		GetWindowRect(&DrawRect);

		COleVariant vaPartNr_x;
		COleVariant vaCharNr_x;
		COleVariant vaValueNr_x;
		COleVariant vaNrOfValues_x;
		COleVariant vaGroupNr_x;

		COleVariant vaPartNr_y;
		COleVariant vaCharNr_y;
		COleVariant vaValueNr_y;
		COleVariant vaNrOfValues_y;
		COleVariant vaGroupNr_y;

		VariantInit(&vaPartNr_x);  //
		vaPartNr_x[0].vt	= VT_I4;
		vaPartNr_x[0].lVal	= PartNr_x;

		VariantInit(&vaCharNr_x);  //
		vaCharNr_x[0].vt	= VT_I4;
		vaCharNr_x[0].lVal	= CharNr_x;

		VariantInit(&vaValueNr_x);  //
		vaValueNr_x[0].vt	= VT_I4;
		vaValueNr_x[0].lVal	= 0;

		VariantInit(&vaNrOfValues_x);  //
		vaNrOfValues_x[0].vt	= VT_I4;
		vaNrOfValues_x[0].lVal	= 0;

		VariantInit(&vaGroupNr_x);  //
		vaGroupNr_x[0].vt	= VT_I4;
		vaGroupNr_x[0].lVal	= 0;

		VariantInit(&vaPartNr_y);  //
		vaPartNr_y[0].vt	= VT_I4;
		vaPartNr_y[0].lVal	= PartNr_y;

		VariantInit(&vaCharNr_y);  //
		vaCharNr_y[0].vt	= VT_I4;
		vaCharNr_y[0].lVal	= CharNr_y;

		VariantInit(&vaValueNr_y);  //
		vaValueNr_y[0].vt	= VT_I4;
		vaValueNr_y[0].lVal	= 0;

		VariantInit(&vaNrOfValues_y);  //
		vaNrOfValues_y[0].vt	= VT_I4;
		vaNrOfValues_y[0].lVal	= 0;
		
		VariantInit(&vaGroupNr_y);  //
		vaGroupNr_y[0].vt	= VT_I4;
		vaGroupNr_y[0].lVal	= 0;

		//--------------------------------------------------------------------
		// select between Graphic and Report
		//--------------------------------------------------------------------
		CRect WndRect;
		GetClientRect(&WndRect);

		hr = E_INVALIDARG;
		if (GIndex==1)
		{
			//--------------------------------------------------------------------
			// request the graphic as a memory stream / 
			// qs-STAT Grafik abrufen
			//--------------------------------------------------------------------
			hr = pqsSTAT->GetGraphicExt(qsSTATHandle,		//qs-STAT Handle
										GrafKey,			//Graphic Key
										GrafSubKey,			//Graphic SubKey
										vaPartNr_x,			//PartNr_x
										vaCharNr_x,			//CharNr_x
										vaValueNr_x,		//ValueNr_x
										vaNrOfValues_x,		//NumOfValues_x
										vaGroupNr_x,		//GroupNr_x
										vaPartNr_y,			//PartNr_y
										vaCharNr_y,			//CharNr_y
										vaValueNr_y,		//ValueNr_y
										vaNrOfValues_y,		//NumOfValues_y
										vaGroupNr_y,		//GroupNr_y
										WndRect.right - 202,//image width
										WndRect.bottom-1,	//image hight 
										1,					//image mode
										1,					//image format
										0,					
										0,
										&va);
			
		};

		if (GIndex==2)
		{
			//--------------------------------------------------------------------
			// request a report as a memory stream /
			// Bericht abrufen
			//--------------------------------------------------------------------
			hr = pqsSTAT->GetReport(qsSTATHandle,
									(CComBSTR)ReportFileName,	//Report File Name
									ReportPartNr_x,				//partnr_x: olevariant;
									ReportCharNr_x,				//charnr_x: olevariant
									0,							//valuenr_x: olevariant
									0,							//nrofvalues_x: olevariant;
									ReportPartNr_y,				//partnr_y: olevariant;
									ReportCharNr_y,				//charnr_y: olevariant
									0,							//valuenr_y: olevariant;
									0,							//nrofvalues_y: olevariant;
									ReportPageNr,				//pagenr: olevariant;
								    WndRect.right - 202,		//width
									WndRect.bottom-1,			//hight
									0,							//configid: integer
									&va);				
		};
		
		if (SUCCEEDED(hr))
		{
			//-------------------------------------------------------------------
			// convert memory stream to CDib object 
			//-------------------------------------------------------------------
			dim = SafeArrayGetDim(((LPCVARIANT)va)->parray);
			hr	= SafeArrayGetLBound(((LPCVARIANT)va)->parray,dim,&lbound);
			hr	= SafeArrayGetUBound(((LPCVARIANT)va)->parray,dim,&hbound);
			hr	= SafeArrayAccessData(((LPCVARIANT)va)->parray,&pBuffer);

			CFile f1("C:\\test.bmp",CFile::modeCreate | CFile::modeReadWrite );
			try
			{
				f1.Write(pBuffer,lbound+hbound);
				f1.Close();
				hr	= SafeArrayUnaccessData(((LPCVARIANT)va)->parray);
				if (dib)
				{
					delete dib;
				}
				dib = new CDib();
				dib->Load("C:\\test.bmp");
			}
			catch (int)
			{
				hr = E_UNEXPECTED;
			}
		}
	}// (pqsstat)
	else
	{
		hr = OLE_E_NOTRUNNING;
	}

	if ((SUCCEEDED(hr)) && (DoDraw))
	{
		//--------------------------------------------------------------------------
		// draw CDib object
		//--------------------------------------------------------------------------
		OnDraw(this->GetDC());
	}
	return hr;
}



//--------------------------------------------------------------------
// Set qs-STAT module / 
// Server Auswertemodul umschalten
//--------------------------------------------------------------------
int CVCPPCOMClient2View::SetModule(int ModuleKey)
{
	//------------------------------------------------------------------------
	// 1. setting the selected module inside the server
	// 2. reset the selected strategy, since this the previous strat. might be invalid
	//------------------------------------------------------------------------
	HRESULT hr;
	int		rc;
	if (pqsSTAT)
	{
		hr = pqsSTAT->SetModule(qsSTATHandle, ModuleID);
		if (SUCCEEDED(hr))
		{
			StrategyID	= 0; //Must be reselected
			NumOfChar	= 0; //Data Must be reloaded
			rc = 0;
		}
		else
		{
			rc = 1;
		}
	}
	else
	{
		rc = -1;
	}
	return rc;
}


void CVCPPCOMClient2View::UpdateStatusBar(int index, char* s)
{
	((CMainFrame*)GetParent())->m_wndStatusBar.SetPaneText(index,s,TRUE);
}

void CVCPPCOMClient2View::AddToEventList(char* s)
{
    if (m_EventList)
	{
		m_EventList.AddString(s);
		m_EventList.SetCurSel(m_EventList.GetCount()-1);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CVCPPCOMClient2View message handlers

//----------------------------------------------------------------------------
// start server-thread / Server Proze starten
//----------------------------------------------------------------------------
void CVCPPCOMClient2View::OnStartServer() 
{

	CString Str;
	CString  CurrentTime = "";

	UpdateStatusBar(2,"");

	if (!mySink)
	{
		mySink = new CSink;
	}
	mySink->Owner = m_hWnd;

	if (!pqsSTAT)
	{
		// Start the server in a separate Thread
		UpdateStatusBar(1,"Starting qs-STAT Server...");

		h_ServerThread = CreateThread(NULL,0,&lpQsStatConversation, (LPVOID )this , 0, &dwServerThreadId); 
		DWORD to = WaitForSingleObject(mySink->hServerInitializedEvent,15000);
		if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
		{
			UpdateStatusBar(2,"timeout while starting qs-STAT server");
		} 
		else
		{
			UpdateStatusBar(1,"qs-STAT server started");
			UpdateStatusBar(2,"");
		}
	}
	else
	{
		UpdateStatusBar(2,"Server already started");
	}
}


//----------------------------------------------------------------------------
// create data connection / Datenverbindung aufbauen
//----------------------------------------------------------------------------
void CVCPPCOMClient2View::OnConnect() 
{
	char			s_str[255];

	UpdateStatusBar(2,"");

	//---------------------------------------------------------
	// Connecting to the qs-STAT Server
	// 1. Show Login Dialog
	// 2. take qs-STAT user / password / startup language, startupmodule
	// 3. create connection and store connection handle
	// 4. request server version
	//---------------------------------------------------------
	if (pqsSTAT)
	{
		HRESULT			hr = S_OK;
		CString			CurrentTime = "";
		CLoginDialog*	pLoginDialog = new CLoginDialog(this);
		pLoginDialog->SetServerObject(pqsSTAT);
		pLoginDialog->m_PWD = "Superuser";
		if (pLoginDialog->DoModal() == IDOK)
		{
			UpdateStatusBar(1, "Connecting to qs-STAT...");
			
			CString		Str			= pLoginDialog->GetUName();
			CComBSTR	Username	= Str.GetBuffer(Str.GetLength());
			CComBSTR	password	= pLoginDialog->m_PWD;
			int			ModuleKey	= pLoginDialog->GetModKey();
			int			LangKey		= pLoginDialog->GetLangKey();

			hr = pqsSTAT->ClientConnect(&qsSTATHandle,
										ModuleKey,
										LangKey,  
										Username.m_str,
										password.m_str);
			
			if (SUCCEEDED(hr))
			{
				BSTR	VersionStr;
				ModuleID	= ModuleKey;
				LanguageID	= LangKey;

				hr = pqsSTAT->QsstatVersion(qsSTATHandle, &VersionStr);
				if (SUCCEEDED(hr))
				{
					qs_ServerVersion = VersionStr;

					Str  = "Connected to qs-STAT Ver: " + CString(VersionStr);
					sprintf(s_str, "%s", Str);
					UpdateStatusBar(1, s_str);
					UpdateStatusBar(2, "");
				

					CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
					Str  = CurrentTime + " -> Connected to qs-STAT.";
        			sprintf(s_str, "%s", Str);
					AddToEventList(s_str);
				}
			}
			else
			{
				sprintf(s_str, "%s%d", "Connection failed", hr);
				UpdateStatusBar(2, s_str);

				CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
				Str  = CurrentTime + " -> Connection failed!";
        		sprintf(s_str, "%s", Str);
				AddToEventList(s_str);
			}
		}
		delete pLoginDialog;
	}
	else
	{
		sprintf(s_str, "%s", "server not startet");
		UpdateStatusBar(2,s_str);
	}
}


//------------------------------------------------------------------------
// Disconnect and release of connectionpoints /
// Verbindungsabbau, abmelden der ConnectionPoints und anhalten des Server threads
//------------------------------------------------------------------------
int CVCPPCOMClient2View::DisconnectFromServer( BOOL final)
{
	//--------------------------------------------------------------------
	// 1. Disconnect from server
	// 2. Release sink object
	// 3. Stop / release server object/thread
	//--------------------------------------------------------------------
	char	s_str[255];
	if (!final)
	{
		UpdateStatusBar(2,"");
	}

	if (pqsSTAT)
	{
		//----------------------------------------------------------------
		// Disconnect the client / Verbindungsabbau
		//----------------------------------------------------------------
		if (qsSTATHandle )
		{
			pqsSTAT->ClientDisconnect(qsSTATHandle);
			qsSTATHandle = 0;

			if (!final)
			{
				sprintf(s_str, "%s", "disconnected");
				UpdateStatusBar(1,s_str);
			}
		}
		else
		{
			if (!final)
			{
				UpdateStatusBar(1,"");
				sprintf(s_str, "%s", "not connected");
				UpdateStatusBar(2,s_str);
			}
		}


		//--------------------------------------------------------------------
		// Release connection point / ConnectionPoints abmelden
		//--------------------------------------------------------------------
		if (pConnectionPoint)
		{
			pConnectionPoint->Unadvise(dwCookie);
			pConnectionPoint->Release();
			pConnectionPoint = NULL;
			
			pConnectionPointContainer->Release();
			pConnectionPointContainer = NULL;
		}

		if (mySink) 
		{
			//delete mySink;//already realeased by unadvise
			mySink = NULL;
		}

		//--------------------------------------------------------------------
		// Stop the Thread / Server Thread beenden
		//--------------------------------------------------------------------
		SetEvent(g_hTerminateQsSTATEvent);
		if (h_ServerThread)
		{
			WaitForSingleObject(h_ServerThread, INFINITE);
		};


		if(!final)
		{
			//--------------------------------------------------------------------
			// Display Status / Statusanzeige, sofern Anwendung nicht beendet wird
			//--------------------------------------------------------------------
			char	s_str[255];	
			CString Str;
			CString  CurrentTime = "";
			CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
			Str  = CurrentTime + " -> Disconnected from qs-STAT";
			sprintf(s_str, "%s", Str);

			AddToEventList(s_str);
		}
	}
	else
	{
		sprintf(s_str, "%s", "server not started");
		if (!final)
		{
			UpdateStatusBar(2,s_str);
		}
	}
	return 0;
}


void CVCPPCOMClient2View::OnDisconnect() 
{
	DisconnectFromServer(FALSE);
}

//--------------------------------------------------------------------
// FileOpen function / Datei durch Server einlesen lassen
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnFileOpen() 
{
	char	s_str[255];

	UpdateStatusBar(2,"");
	//--------------------------------------------------------------------
	// 1. Show open dialog
	// 2. call the open command
	// 3. wait until data is completely loaded
	//--------------------------------------------------------------------
	if ((pqsSTAT) && (qsSTATHandle))
	{
		CString Str;
		HRESULT	hr = S_OK;
		CString CurrentTime = "";

		CFileDialog dlg(TRUE);
		if (dlg.DoModal() == IDOK)
		{
			Str= dlg.GetPathName();
			sprintf(s_str, "%s%s%s", "Opening ", Str);
			UpdateStatusBar(1,s_str);
			UpdateStatusBar(2,"");


			//--------------------------------------------------------------------
			// Opening a file directly
			//--------------------------------------------------------------------
			CComBSTR FileName(Str);
			hr = pqsSTAT->OpenFile(qsSTATHandle,FileName.m_str);

			if (SUCCEEDED(hr))
			{
				// wait until data is loaded
				// reload data on qs-STAT Server
				//DWORD to = WaitForSingleObject(mySink->hDataAvailEvent,INFINITE);
				DWORD to = WaitForSingleObject(mySink->hDataAvailEvent,15000);
				if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
				{
					sprintf(s_str, "%s%s", "Open", "...timeout");
					UpdateStatusBar(2,s_str);

					CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
					Str  = CurrentTime + " -> Timeout expired while loading data"; // + NumOfChar ;
					sprintf(s_str, "%s", Str);
					AddToEventList(s_str);
				}
				else
				{
					
					sprintf(s_str, "%s%s%s", "OpenFile: ", FileName, "...Done");
					UpdateStatusBar(1,s_str);
					UpdateStatusBar(2,"");

				};
			}
		}
		else
		{
			sprintf(s_str, "%s%d", "OpenFile failed: ", hr);
			UpdateStatusBar(2,s_str);
		}
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//--------------------------------------------------------------------
// Transmit file to qs_STAT Server / 
// angegebene Datei einlesen und zum Server bertragen
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnFileTransmit() 
{
	char	s_str[255];
	UpdateStatusBar(2,"");
	//--------------------------------------------------------------------
	// 1. Show open dialog
	// 2. Read entire File to a memory stream
	// 3. transmit memory stream to server
	// 4. wait until data is completely loaded
	//--------------------------------------------------------------------
	if ((pqsSTAT) && (qsSTATHandle))
	{
		CString Str;
		CString CurrentTime = "";


		CFileDialog dlg(TRUE);
		if (dlg.DoModal() == IDOK)
		{
			Str = dlg.GetPathName();
		}
		else
		{
			return;
		}

		
		if (Str == "")
		{
			return;
		}
		
		sprintf(s_str, "%s%s%s", "Transmitting: ", Str, "...");
		UpdateStatusBar(1,s_str);
	

		//---------------------------------------------------------
		// write transmitted file to temporary local buffer
		//---------------------------------------------------------
		BYTE*		pBuffer;		
		long		BufLen;
		COleVariant vaData;
		CComBSTR	FileName(Str);
		CFile		f1(Str,CFile::modeRead | CFile::shareDenyWrite);
		HRESULT		hr = S_OK;

		LastReadFilePos = f1.GetLength();
		BufLen = LastReadFilePos;
		pBuffer = (BYTE*)malloc(BufLen);
		if (pBuffer)
		{
			f1.ReadHuge(pBuffer,LastReadFilePos);
			// prepare the buffer for transmission
			PutBinaryIntoVariant(&vaData,pBuffer,BufLen);

			//---------------------------------------------------------
			// Transmit the data to server and reset data previously loaded data
			//---------------------------------------------------------
			hr = pqsSTAT->TransmitFileExt(	qsSTATHandle,
											vaData,
											0,//mode = load new
											0 //reserve
											);
			if (SUCCEEDED(hr))
			{
				DWORD to = WaitForSingleObject(mySink->hDataAvailEvent,15000);
				if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
				{
					NumOfChar = 0;

					sprintf(s_str, "%s%s", "Transmission: ", "...Timeout");
					UpdateStatusBar(2,s_str);
					
					CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
					Str  = CurrentTime + " -> Timeout transmiting data.";
					sprintf(s_str, "%s", Str);
					AddToEventList(s_str);
				}
				else
				{
					NumOfChar = mySink->NumOfChar;

					sprintf(s_str, "%s%s%s", "Transmission: ", Str, "...Done.");
					UpdateStatusBar(1,s_str);
					UpdateStatusBar(2,"");
				};
			}
			else
			{
				sprintf(s_str, "%s%d", "Transmit failed: ", hr);
				UpdateStatusBar(2,s_str);
			}
			free(pBuffer);
		}
		f1.Close();
	}	
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//--------------------------------------------------------------------
// Execute Query / Datenbankabfrage erstellen und ausfhren
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnSetFilter() 
{
	//--------------------------------------------------------------------
	// 1. Ask for available part types at the qs-stat database
	// 2. select a certain part
	// 3. query the qs-stat database (load the selected part)
	//--------------------------------------------------------------------
	char	s_str[255];

	UpdateStatusBar(2,"");

	if ((pqsSTAT) && (qsSTATHandle))
	{
		long	QueryHandle = 0;
	
		QueryFilterDialog*	pQueryFilterDialog = new QueryFilterDialog(this);
		pQueryFilterDialog->SetServerObject(pqsSTAT, qsSTATHandle);
		if (pQueryFilterDialog->DoModal() == IDOK)
		{

			HRESULT	hr = S_OK;

			sprintf(s_str, "%s", "Execute query in progress...");
			UpdateStatusBar(1,s_str);

			COleVariant vaFilter;
			VariantInit(&vaFilter);
			vaFilter[0].vt		= VT_I4;
			vaFilter[0].lVal	= pQueryFilterDialog->GetFilter();

			QueryHandle = pQueryFilterDialog->GetQuery();
			hr = pIqsSTATDataBase->ExecuteQuery( qsSTATHandle,
												 QueryHandle, 
												 vaFilter);
		
			if (SUCCEEDED(hr))
			{
				DWORD to = WaitForSingleObject(mySink->hDataAvailEvent,25000);
				if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
				{
					NumOfChar = 0;

					sprintf(s_str, "%s", "Executing query timeout");
					UpdateStatusBar(2,s_str);

					CString CurrentTime = CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
					CString	Str			= CurrentTime + " -> Timeout loading data"; // + NumOfChar ;
					sprintf(s_str, "%s", Str);
					AddToEventList(s_str);
				}
				else
				{
					sprintf(s_str, "%s", "Execute query ... done");
					UpdateStatusBar(1,s_str);
				};
			}
			else
			{
				sprintf(s_str, "%s %d", "Execute query failed", hr);
				UpdateStatusBar(2,s_str);
			}

			hr = pIqsSTATDataBase->FreeQuery( qsSTATHandle, QueryHandle);
			if (SUCCEEDED(hr))
			{
				sprintf(s_str, "%s %d", "FreeQuery failed", hr);
				UpdateStatusBar(2,s_str);
			}
		}
		delete pQueryFilterDialog;
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//--------------------------------------------------------------------
// Load predefined Database selection /
// gespeicherte Datenbankselektion ausfhren
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnSetDB()
{
	char	s_str[255];
	UpdateStatusBar(2,"");

	if ((pqsSTAT) && (qsSTATHandle))
	{
		
		CSelektDialog*	SelektDialog = new CSelektDialog(this);
		SelektDialog->SetServerObject(pqsSTAT, qsSTATHandle, ModuleID);
		SelektDialog->SetItemType(5);
		if (SelektDialog->DoModal() == IDOK)
		{
			HRESULT	hr = S_OK;

			sprintf(s_str, "%s", "DBOpen in progress...");
			UpdateStatusBar(1,s_str);
			
			DBName = (CString)SelektDialog->GetDBName();
			hr = pqsSTAT->DBOpen(qsSTATHandle, (CComBSTR)DBName);
			if (SUCCEEDED(hr))
			{
				DWORD to = WaitForSingleObject(mySink->hDataAvailEvent,15000);
				if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
				{
					NumOfChar = 0;
					sprintf(s_str, "%s", "DBOpen timeout");
					UpdateStatusBar(2,s_str);

					CString	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
					CString	Str			= CurrentTime + " -> Timeout expired while loading data"; // + NumOfChar ;
					sprintf(s_str, "%s", Str);
					AddToEventList(s_str);
				}
				else
				{
				
					NumOfChar = mySink->NumOfChar;

					sprintf(s_str, "%s", "DBOpen ...Done");
					UpdateStatusBar(1,s_str);
				}
			}
			else
			{
				sprintf(s_str, "%s %d", "DBOpen failed", hr);
				UpdateStatusBar(2,s_str);
			}
		}
		delete SelektDialog;
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//--------------------------------------------------------------------
// Print report / Bericht ausdrucken
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnPrintReport() 
{
	//--------------------------------------------------------------------
	// 1. Show modal dialog	
	// 2. Get Report from qs-STAT Server
	// 3. Set info
	//--------------------------------------------------------------------
	char	s_str[255];

	UpdateStatusBar(2,"");

	if ((pqsSTAT) && (qsSTATHandle))
	{	
		HRESULT	hr = S_OK;

		CString Str="1";
		CComBSTR NumOfCopys = (CComBSTR)Str;
				
		sprintf(s_str, "%s%d%s", "Print: ", ReportFileName, "...");
		UpdateStatusBar(1,s_str);


		//--------------------------------------------------------------------
		// Print selected report with qs_Stat print function
		// to the predefined (SetPrinter) printer
		//--------------------------------------------------------------------
		hr = pqsSTAT->PrintReportExt(qsSTATHandle,
	       		 					 ReportNr,					// Report Number
									 (CComBSTR)ReportFileName,	// Report File Name
									 PrinterNr,					// Printer ID (by default)
									 NumOfCopys,				// Number of copyes	(set to print all pages)
									 33,						// Print mode (set to print direct)
									 2,							// Color mode (Black and White)
									 0);						// Orientation (by default)

		if (SUCCEEDED(hr))
		{
			sprintf(s_str, "%s %s %s", "Print: ", ReportFileName, "...Done.");
			UpdateStatusBar(1,s_str);
		}
		else
		{
			sprintf(s_str, "%s %s %s %d", "Print: ", ReportFileName, "...failed.", hr);
			UpdateStatusBar(2,s_str);
		}
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//--------------------------------------------------------------------
// Evaluation / Auswertung anstoen
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnEvaluate() 
{
	char	s_str[255];
	UpdateStatusBar(2,"");

	if ((pqsSTAT) && (qsSTATHandle))
	{
		
		HRESULT hr = S_OK;

		sprintf(s_str, "%s", "Evaluation in progress...");
		UpdateStatusBar(1,s_str);
		
		//--------------------------------------------------------------------
		// Evaluate the Data with qs_Stat evaluate function
		//--------------------------------------------------------------------
		hr = pqsSTAT->EvaluateAllChars(qsSTATHandle);
		if (SUCCEEDED(hr))
		{
			//--------------------------------------------------------------------
			// Wait until evaluation is done
			//--------------------------------------------------------------------
			DWORD to = WaitForSingleObject(mySink->hEvaluationDoneEvent,
										   15000/*INFINITE*/); //Evaluation timeout
			if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
			{
				sprintf(s_str, "%s", "Evaluation timeout");
				UpdateStatusBar(2,s_str);
			
				CString CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
				CString Str  = CurrentTime + " -> Evaluation Timeout.";
				sprintf(s_str, "%s", Str);
				AddToEventList(s_str);
			}
			else
			{
				sprintf(s_str, "%s", "Evaluation ...Done.");
				UpdateStatusBar(1,s_str);
			};
		}
		else
		{
			sprintf(s_str, "%s %d", "EvaluateAllChars failed", hr);
			UpdateStatusBar(2,s_str);
		}
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}


//--------------------------------------------------------------------
// GetGraphic function / Grafik abrufen
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnGetGraphic() 
{
	char	s_str[255];

	UpdateStatusBar(2,"");

	//------------------------------------------------------------------------
	// 1. Ask the desired qs-STAT graphic
	// 2. Request Graphic from qs-STAT server
	// 3. Draw the graphic at the view
	//------------------------------------------------------------------------
	if ((pqsSTAT) && (qsSTATHandle))
	{
		HRESULT	hr = S_OK;

		CSelektGrafKey* SelektGrafKey = new(CSelektGrafKey);
		SelektGrafKey->SetServerObject(this, pqsSTAT, qsSTATHandle, ModuleID);
		SelektGrafKey->SetEnumGraphic();
		SelektGrafKey->SetPartNr();
		SelektGrafKey->SetCharNr();
		SelektGrafKey->SetPart_x(PartNr_x);
		SelektGrafKey->SetChar_x(CharNr_x);
		SelektGrafKey->SetValue_x(1);
		SelektGrafKey->SetPart_y(PartNr_y);
		SelektGrafKey->SetChar_y(CharNr_y);
		SelektGrafKey->SetValue_y(0);
		SelektGrafKey->SetGraphicKey(GrafKey);
		SelektGrafKey->SetGraphicSubkey(GrafSubKey);
		if (SelektGrafKey->DoModal() == IDOK)
		{
			//---------------------------------------------------------------
			// retrieve parameters from dialog
			//---------------------------------------------------------------
			GrafKey		= SelektGrafKey->GetGraphicKey();
			GrafSubKey	= SelektGrafKey->GetGraphicSubkey();
			PartNr_x	= SelektGrafKey->GetPart_x();
			CharNr_x	= SelektGrafKey->GetChar_x();
			ValueNr_x	= SelektGrafKey->GetValue_x();
			PartNr_y	= SelektGrafKey->GetPart_y();
			CharNr_y	= SelektGrafKey->GetChar_y();
			ValueNr_y	= SelektGrafKey->GetValue_y();
	
			//---------------------------------------------------------------
			// requesting the graphic from the server
			//---------------------------------------------------------------
			HRESULT	hr = S_OK;
			sprintf(s_str, "%s %d", "Getting graphic", GrafKey);
			UpdateStatusBar(1,s_str);
			
			hr = GetGraphicOrReport(1);
			if (SUCCEEDED (hr))
			{
				// Painting the graphic onto the view
				OnDraw(this->GetDC());

				sprintf(s_str, "%s %d", "Graphic refreshed", GrafKey);
				UpdateStatusBar(1,s_str);
			}
			else
			{
				sprintf(s_str, "%s %d %s", "GetGraphic", GrafKey, "failed" );
				UpdateStatusBar(2,s_str);
			}
		}
		else
		{
		// cancel dialog
		}
		delete SelektGrafKey;
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}


//--------------------------------------------------------------------
// Getting qs-STAT Reports / qs-STAT Bericht abrufen
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnGetReport() 
{

	char	s_str[255];

	UpdateStatusBar(2,"");

	//------------------------------------------------------------------------
	// 1. Ask the desired predefined qs-STAT report
	// 2  Request the report as a graphic from the server
	// 3. Draw the report at the view
	//------------------------------------------------------------------------
	if ((pqsSTAT) && (qsSTATHandle))
	{
		COleVariant va;
		CString Str="1";
		CString sReportFileName = "";
		CComBSTR NumOfCopys = (CComBSTR)Str;
		
		CSelektReportKey*	SelektReportKey = new CSelektReportKey(this);
		SelektReportKey->SetServerObject(this, pqsSTAT, qsSTATHandle);

		//--------------------------------------------------------------------
		// query parameters and paint report
		//--------------------------------------------------------------------
		if (SelektReportKey->DoModal() == IDOK)
		{
		
			ReportFileName	= SelektReportKey->GetReportFileName();
			ReportPartNr_x	= SelektReportKey->GetPartNr_x();
			ReportCharNr_x	= SelektReportKey->GetPartNr_y();
			ReportPartNr_y	= SelektReportKey->GetCharNr_x();
			ReportCharNr_y	= SelektReportKey->GetCharNr_y();
			ReportValueNr_x	= SelektReportKey->GetValueNr_x();
			ReportValueNr_y	= SelektReportKey->GetValueNr_y();
			ReportPageNr	= SelektReportKey->GetPageNr();

			//--------------------------------------------------------------------
			// requesting the report for the addressed chararcteristic
			//--------------------------------------------------------------------
			if (ReportFileName == "-1")
			{
				sprintf(s_str, "%s", "No Report selected");
				UpdateStatusBar(2,s_str);
			}
			else
			{
				//--------------------------------------------------------------------
				// Request the selected report and painting it onto screan
				//--------------------------------------------------------------------
				HRESULT	hr = S_OK;
				sprintf(s_str, "%s %s", "Getting report", ReportFileName);
				UpdateStatusBar(1,s_str);
				
				hr = GetGraphicOrReport(2);	
				if (SUCCEEDED (hr))
				{
					// Painting the graphic onto the view
					OnDraw(this->GetDC());

					sprintf(s_str, "%s %s", "Report refreshed", ReportFileName);
					UpdateStatusBar(1,s_str);
				}
				else
				{
					sprintf(s_str, "%s %s %s", "GetReport", ReportFileName, "failed" );
					UpdateStatusBar(2,s_str);
				}
			}
		}
		delete SelektReportKey;
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//--------------------------------------------------------------------
// Getting statistical results / stat. Kennwerte abrufen 
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnGetResult() 
{
	//------------------------------------------------------------------------
	// 1. Ask the desired statistical result
	// 2  Request the result from the server
	// 3. Show the result in a messagebox
	//------------------------------------------------------------------------

	char	s_str[255];
	UpdateStatusBar(2,"");
	
	if ((pqsSTAT) && (qsSTATHandle))
	{
		CSelektStatKey*	SelektStatKey = new CSelektStatKey(this);
		SelektStatKey->SetServerObject(pqsSTAT, qsSTATHandle, ModuleID);
		SelektStatKey->SetStatResultKey(StatKey);
		SelektStatKey->SetStatResultSubkey(StatSubKey);
		SelektStatKey->SetPartNr(1);
		SelektStatKey->SetCharNr(1);
		if (SelektStatKey->DoModal() == IDOK)
		{
			//nothing
		}
		delete SelektStatKey;
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

void CVCPPCOMClient2View::OnGetCatalogue() 
{
	//------------------------------------------------------------------------
	// 1. Ask the desired Catalogue and Sub Catalogue
	// 2  Request Catalogue from the server
	// 3. Show the Catalogue in a ListBox
	//------------------------------------------------------------------------

	char	s_str[255];

	UpdateStatusBar(2,"");
	
	if ((pqsSTAT) && (qsSTATHandle))
	{
		SelektCatalogue*	SelektCat = new SelektCatalogue(this);
		SelektCat->SetServerObject(pqsSTAT, qsSTATHandle);
		if (SelektCat->DoModal() == IDOK)
		{
			//nothing
		}
		delete SelektCat;
	}	
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}


//----------------------------------------------------------------------------
// Select qs-STAT Modul / qs-STAT Modul auswhlen und aktivieren
//----------------------------------------------------------------------------
void CVCPPCOMClient2View::OnSetModule()
{
	//------------------------------------------------------------------------
	// 1. Ask for registered qs-STAT modules
	// 2. switch to the selected module (resets the loaded data)
	//------------------------------------------------------------------------
	char	s_str[255];
	UpdateStatusBar(2,"");

	if ((pqsSTAT) && (qsSTATHandle))
	{
		CSelektDialog*	SelektDialog = new CSelektDialog(this);
		SelektDialog->SetServerObject(pqsSTAT, qsSTATHandle, ModuleID);
		SelektDialog->SetItemType(1);

		if (SelektDialog->DoModal() == IDOK)
		{
			HRESULT	hr = S_OK;

			ModuleID = SelektDialog->GetModKey();

			sprintf(s_str, "%s %d", "SetModule:", ModuleID);
			UpdateStatusBar(2,s_str);

			hr = SetModule(ModuleID); 
			if ( SUCCEEDED(hr))
			{
				sprintf(s_str, "%s %d", "Module changed to:", ModuleID);
				UpdateStatusBar(1,s_str);
			}
			else
			{
				sprintf(s_str, "%s %d", "SetModule failed", hr);
				UpdateStatusBar(2,s_str);
			}
		}
		delete SelektDialog;
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//----------------------------------------------------------------------------
// selekt server language / Serversprache auswhlen und aktivieren
//----------------------------------------------------------------------------
void CVCPPCOMClient2View::OnSetLanguage()
{
	//------------------------------------------------------------------------
	// 1. Ask the registered qs-stat languages
	// 2. Aktivate the selected languages
	//------------------------------------------------------------------------
	char	s_str[255];
	UpdateStatusBar(2,"");
	
	if ((pqsSTAT) && (qsSTATHandle))
	{
		BSTR	sLanguageName;
		

		CSelektDialog*	SelektDialog = new CSelektDialog(this);
		SelektDialog->SetServerObject(pqsSTAT, qsSTATHandle, ModuleID);
		SelektDialog->SetItemType(2);

		if (SelektDialog->DoModal() == IDOK)
		{
			HRESULT	hr = S_OK;
			LanguageID = SelektDialog->GetLangKey();

			hr = pqsSTAT->SetLanguage(qsSTATHandle, LanguageID, &sLanguageName);
			if (SUCCEEDED(hr))
			{
				sprintf(s_str, "%s %d %s", "Language:", LanguageID, sLanguageName);
				UpdateStatusBar(1,s_str);
			}
			else
			{
				sprintf(s_str, "%s %d", "SetLanguage failed", hr);
				UpdateStatusBar(2,s_str);
			}
		}
		delete SelektDialog;
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//----------------------------------------------------------------------------
// Select and Set Evaluation strategy / Auswertestrategie auswhlen und anzeigen
//----------------------------------------------------------------------------
void CVCPPCOMClient2View::OnSetStrategy()
{
	//------------------------------------------------------------------------
	// 1. Ask the predefined evaluation strategies
	// 2. Aktivate the selected strategy
	//------------------------------------------------------------------------
	char	s_str[255];
	UpdateStatusBar(2,"");

	if ((pqsSTAT) && (qsSTATHandle))
	{
		CSelektDialog*	SelektDialog = new CSelektDialog(this);
		SelektDialog->SetServerObject(pqsSTAT, qsSTATHandle, ModuleID);
		SelektDialog->SetItemType(3);

		if (SelektDialog->DoModal() == IDOK)
		{
			HRESULT	hr = S_OK;

			StrategyID = SelektDialog->GetStratKey();

			sprintf(s_str, "%s %d", "SetStrategy:", StrategyID);
			UpdateStatusBar(1,s_str);
			
			hr = pqsSTAT->SetEvaluationStrategy(qsSTATHandle, 0, StrategyID);
			if (SUCCEEDED(hr))
			{
				sprintf(s_str, "%s %d", "Strategy set:", StrategyID);
				UpdateStatusBar(1,s_str);
			}
			else
			{
				sprintf(s_str, "%s %d", "SetStrategy failed", hr);
				UpdateStatusBar(2,s_str);
			}
		}
		delete SelektDialog;
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//--------------------------------------------------------------------
// Set Printer / (Server-) Drucker auswhlen und merken
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnSetPrinter()
{
	//------------------------------------------------------------------------
	// 1. Ask the desired Catalogue and Sub Catalogue
	// 2. Request Catalogue from the server
	// 3. Add print dialog
	//------------------------------------------------------------------------
	char	s_str[255];
	UpdateStatusBar(2,"");

	if ((pqsSTAT)&&(qsSTATHandle))
	{
		CSelektDialog*	SelektDialog = new CSelektDialog(this);
		SelektDialog->SetServerObject(pqsSTAT, qsSTATHandle, ModuleID);
		SelektDialog->SetItemType(4);
		if (SelektDialog->DoModal() == IDOK)
		{
			PrinterID = SelektDialog->GetPrinterNr();
			sprintf(s_str, "%s%d", "Printer Nr.: ", PrinterID);
 			UpdateStatusBar(1,s_str);
		}
		delete SelektDialog;
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//----------------------------------------------------------------------------
// request parttype field contents / Inhalte von Teile(typ)feldern abrufen
//----------------------------------------------------------------------------
void CVCPPCOMClient2View::OnGetPart() 
{
	//------------------------------------------------------------------------
	// 1. Ask the available k-fields at part level
	// 2. ask for the content of the selected field
	// 3. needed Parameters are Part#, K-field, 
	//------------------------------------------------------------------------
	char	s_str[255];
	UpdateStatusBar(2,"");

	if ((pqsSTAT) && (qsSTATHandle))
	{
		CSelektPart*	SelektPartDialog = new CSelektPart(this);
		SelektPartDialog->SetServerObject(pqsSTAT, qsSTATHandle);
		if (SelektPartDialog->DoModal() == IDOK)
		{
			//nothing
		}
		delete SelektPartDialog;
	}	
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//----------------------------------------------------------------------------
// request characteritic field contents / Inhalte von Merkmalsfeldern abrufen
//----------------------------------------------------------------------------
void CVCPPCOMClient2View::OnGetChar() 
{
	//------------------------------------------------------------------------
	// 1. Ask the available k-fields at characteristic level (K2000..K2999, K8000..K8999)
	// 2. Request the content of the selected kfield and characteristic
	// 3. needed Parameters arevPart#, char# K-field, 
	//------------------------------------------------------------------------
	char	s_str[255];
	UpdateStatusBar(2,"");

	if ((pqsSTAT) && (qsSTATHandle))
	{
		CSelektChar*	SelektCharDialog = new CSelektChar(this);
		SelektCharDialog->SetServerObject(pqsSTAT, qsSTATHandle);
		if (SelektCharDialog->DoModal() == IDOK)
		{
			//nothing
		}
		delete SelektCharDialog;
	}	
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//----------------------------------------------------------------------------
// request measured values and additional data / Mewerte und Zusatzdaten abrufen
//----------------------------------------------------------------------------
void CVCPPCOMClient2View::OnGetValue() 
{
	//------------------------------------------------------------------------
	// 1. Ask the desired K-Field at the value level
	// 2. Request value information acc. to the k-field
	// 3. needed Parameters are Part#, Char#, Vakue#, K-field, 
	// 4. display the result
	//------------------------------------------------------------------------

	char	s_str[255];
	UpdateStatusBar(2,"");

	if ((pqsSTAT) && (qsSTATHandle))
	{
		CSelektValue*	SelektValueDialog = new CSelektValue(this);
		SelektValueDialog->SetServerObject(pqsSTAT, qsSTATHandle);
		if (SelektValueDialog->DoModal() == IDOK)
		{
			//nothing		
		}
		delete SelektValueDialog;
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//----------------------------------------------------------------------------
// Online Server demo
//----------------------------------------------------------------------------
void CVCPPCOMClient2View::OnTransmit()
{
	//------------------------------------------------------------------------
	// 1. switch to online server
	// 2. Show the dialog for Online-server demo
	// 3. switch to module procella (26)
	// 4. transmit header (control plan) information
	// 5. Display a graphic
	// 6. Transmit the measurement values
	// 7. refresh the view / graphic
	// 8. Loop to (6) or load another control plan (4)
	//------------------------------------------------------------------------
	char	s_str[255];

	UpdateStatusBar(2,"");

	if ((pqsSTAT) && (qsSTATHandle))
	{
		if (SetModule(26) == 0)
		{
			COnlineTransmition*	OnlineTransmition = new COnlineTransmition(this);
			OnlineTransmition->SetServerObject(this, pqsSTAT, qsSTATHandle, mySink);
			if (OnlineTransmition->DoModal() == IDOK)
			{
				//nothing
			}
			delete OnlineTransmition;
		}
		else
		{
			char s_str[255];
			sprintf(s_str, "%s", "SetModule (26) failed");
			((CMainFrame*)GetParent())->m_wndStatusBar.SetWindowText(s_str);
		}
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//--------------------------------------------------------------------------------
// call "Online" evaluation (Online or Online analysis server only) /
//--------------------------------------------------------------------------------
void CVCPPCOMClient2View::OnONLINEEvaluation() 
{
	//----------------------------------------------------------------------------
	// 1. call the evaluate method (set parameter SPCevaluation == false)
	// 2. wait until server has performed the requestet operation
	// remarks: only usefull when using the online or online analysis server (module=26)
	//----------------------------------------------------------------------------
	char	s_str[255];
	UpdateStatusBar(2,"");
	
	if ((pqsSTAT) && (qsSTATHandle))
	{
		HRESULT	hr = S_OK;

		sprintf(s_str, "%s", "EvaluateCharExt in progress...");
		UpdateStatusBar(1,s_str);

		//-------------------------------------------------------------------------------
		// evaluate the data / Auswertung anstoen (Online-Auswertung)
		//-------------------------------------------------------------------------------
		hr = pqsSTAT->EvaluateCharExt(	qsSTATHandle, 
										FALSE,			   
										0,
										0,
										0,
										0,
										0);
		if (SUCCEEDED(hr))
		{
			//---------------------------------------------------------------------------
			// Wait for Server acknolegde / Warten auf Abschlu der Auswertung
			//---------------------------------------------------------------------------
			DWORD to = WaitForSingleObject(mySink->hEvaluationDoneEvent,25000 /*INFINITE*/);
			if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
			{
				sprintf(s_str, "%s", "Evaluation timeout");
				UpdateStatusBar(2,s_str);
			}
			else
			{
				sprintf(s_str, "%s", "Evaluation ...Done.");
				UpdateStatusBar(1,s_str);

				CString	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
				CString	Str  = CurrentTime + " -> SPC evaluation complete.";
				sprintf(s_str, "%s", Str);
				AddToEventList(s_str);
			}
		}
		else
		{
			sprintf(s_str, "%s %d", "EvaluateCharExt failed", hr);
			UpdateStatusBar(2,s_str);
		}
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//--------------------------------------------------------------------------------
// call SPC evaluation (Online analysis server only) /
// SPC-Auswertung anstoen ( nur bei Online analysis server)
//--------------------------------------------------------------------------------
void CVCPPCOMClient2View::OnSPCEvaluation() 
{
	//----------------------------------------------------------------------------
	// 1. call the evaluate method (set parameter SPCevaluation == TRUE)
	// 2. wait until server has performed the requestet operation
	// remarks: only usefull when using the online or online analysis server (module=26)
	//----------------------------------------------------------------------------
	char	s_str[255];
	UpdateStatusBar(2,"");

	if ((pqsSTAT) && (qsSTATHandle))
	{
		HRESULT	hr = S_OK;

		sprintf(s_str, "%s", "EvaluateCharExt in progress...");
		UpdateStatusBar(1,s_str);

		//-------------------------------------------------------------------------------
		// evaluate the data / Auswertung anstoen (SPC-Auswertung)
		//-------------------------------------------------------------------------------
		hr = pqsSTAT->EvaluateCharExt(	qsSTATHandle, //qs-STAT Handle
										TRUE,// SPC-Evaluation			
										0,
										0,
										0,
										0,
										0);
		
		if (SUCCEEDED(hr))
		{
			//---------------------------------------------------------------------------
			// Wait for Server acknolegde / Warten auf Abschlu der Auswertung
			//---------------------------------------------------------------------------
			DWORD to = WaitForSingleObject(mySink->hEvaluationDoneEvent,25000 /*INFINITE*/);
			if ((to  & WAIT_TIMEOUT)==WAIT_TIMEOUT)
			{
				sprintf(s_str, "%s", "Evaluation timeout");
				UpdateStatusBar(2,s_str);
			}
			else
			{
				sprintf(s_str, "%s", "Evaluation ...Done.");
				UpdateStatusBar(1,s_str);

				CString	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
				CString	Str  = CurrentTime + " -> SPC evaluation complete.";
				sprintf(s_str, "%s", Str);
				AddToEventList(s_str);
			}
		}
		else
		{
			sprintf(s_str, "%s %d", "EvaluateCharExt failed", hr);
			UpdateStatusBar(2,s_str);
		}
	}
	else
	{
		sprintf(s_str, "%s", "server not startet or not connected");
		UpdateStatusBar(2,s_str);
	}
}

//--------------------------------------------------------------------
// About dialog
//--------------------------------------------------------------------
void CVCPPCOMClient2View::OnAppAbout() 
{
	CAboutDialog*	pAboutDialog = new CAboutDialog(this);
	BSTR	Version;
	CString	sVersion;

	if (pqsSTAT)
	{
		if (qsSTATHandle)
		{
			HRESULT hr;
			hr = pqsSTAT->QsstatVersion(qsSTATHandle,&Version);
			if (SUCCEEDED(hr))
			{
				sVersion = Version;
			}
			else
			{
				sVersion = "???";
			}
		}
		else
		{
			sVersion = "not connected";
		}
	}
	else
	{
		sVersion = "Server not started";
	}
	pAboutDialog->SetServerVer(sVersion);
	// Show client info
	pAboutDialog->DoModal();
	delete pAboutDialog;
}





void CVCPPCOMClient2View::SetGrafikKey(int Key)
{
	GrafKey = Key;
}

void CVCPPCOMClient2View::SetGrafikSubKey(int Key)
{
	GrafSubKey = Key;
}

void CVCPPCOMClient2View::SetGrafikPart_x(int Key)
{
	PartNr_x = Key;
}

void CVCPPCOMClient2View::SetGrafikPart_y(int Key)
{
	PartNr_y = Key;
}

void CVCPPCOMClient2View::SetGrafikChar_x(int Key)
{
	CharNr_x = Key;
}

void CVCPPCOMClient2View::SetGrafikChar_y(int Key)
{
	CharNr_y = Key;
}

void CVCPPCOMClient2View::SetGrafikValue_x(int Key)
{
	ValueNr_x = Key;
}

void CVCPPCOMClient2View::SetGrafikValue_y(int Key)
{
	ValueNr_y = Key;
}

void CVCPPCOMClient2View::SetGrafikPageNr( int Key)
{
	GraphicPageNr = Key;
}

void CVCPPCOMClient2View::SetReportName(LPTSTR FName)
{
	ReportFileName = FName;
}

void CVCPPCOMClient2View::SetReportPart_x(int Key)
{
	ReportPartNr_x = Key;
}

void CVCPPCOMClient2View::SetReportPart_y(int Key)
{
	ReportPartNr_y = Key;
}

void CVCPPCOMClient2View::SetReportChar_x(int Key)
{
	ReportCharNr_x = Key;
}

void CVCPPCOMClient2View::SetReportChar_y(int Key)
{
	ReportCharNr_y = Key;

}
void CVCPPCOMClient2View::SetReportValue_x(int Key)
{
	ReportValueNr_x = Key;
}

void CVCPPCOMClient2View::SetReportValue_y(int Key)
{
	ReportValueNr_y = Key;
}

void CVCPPCOMClient2View::SetReportPageNr(int Key)
{
	ReportPageNr = Key;
}

//--------------------------------------------------------------------------
// Server event-handler functions
//--------------------------------------------------------------------------
void CVCPPCOMClient2View::DoOnQSSTATInitialized()
{
	char	s_str[255];
	CString	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	CString	Str			= CurrentTime + " -> OnQSSTATInitialize.";
	sprintf(s_str, "%s", Str);
	AddToEventList(s_str);
}

void CVCPPCOMClient2View::DoOnDataAvail(int aNumOfChar)
{
	char	s_str[255];
	CString	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	CString	Str  = CurrentTime + " -> OnDataAvail";
	sprintf(s_str, "%s", Str);
	m_EventList.AddString(s_str);

	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	Str  = CurrentTime + " ->   NumOfChar: ";
	sprintf(s_str, "%s%d", Str, aNumOfChar);
	AddToEventList(s_str);

	this->NumOfChar = mySink->NumOfChar;
}

void CVCPPCOMClient2View::DoOnDataAvailExt(int ConnectionHandle, int aNumOfChar)
{
	char	s_str[255];
	CString	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	CString	Str  = CurrentTime + " -> OnDataAvailExt";
	sprintf(s_str, "%s", Str);
	AddToEventList(s_str);

	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	Str			= CurrentTime + " ->   Handle: ";
	sprintf(s_str, "%s%d", Str, ConnectionHandle);
	AddToEventList(s_str);

	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	Str			= CurrentTime + " ->   NumOfChar: ";
	sprintf(s_str, "%s%d", Str, aNumOfChar);
	AddToEventList(s_str);

	this->NumOfChar = mySink->NumOfChar;
}

void CVCPPCOMClient2View::DoOnEvaluationDoneExt( int ConnectionHandle)
{
	char	s_str[255];
	CString	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	CString	Str  = CurrentTime + " -> OnEvaluationDoneExt";
	sprintf(s_str, "%s", Str);
	AddToEventList(s_str);

	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	Str			= CurrentTime + " ->   Handle: ";
	sprintf(s_str, "%s%d", Str, ConnectionHandle);
	AddToEventList(s_str);
}

void CVCPPCOMClient2View::DoOnEvaluationDone()
{
	char	s_str[255];
	CString	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	CString	Str  = CurrentTime + " -> OnEvaluationDone";
	sprintf(s_str, "%s", Str);
	AddToEventList(s_str);
}


void CVCPPCOMClient2View::DoOnStatisticalAlarmExt(int ConnectionHandle, CAlarm* pAlarm)
{
	char	s_str[255];
	CString	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	CString	Str  = CurrentTime + " -> OnStatisticalAlarmExt";
	sprintf(s_str, "%s", Str);
	AddToEventList(s_str);

	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	Str			= CurrentTime + " ->   Handle: ";
	sprintf(s_str, "%s%d", Str, ConnectionHandle);
	AddToEventList(s_str);

	if (pAlarm)
	{
		try
		{
			sprintf(s_str, "    %s: %d", "AlarmEW1", pAlarm->AlarmEW1);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "AlarmEW2", pAlarm->AlarmEW2);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "AlarmQRK_L", pAlarm->AlarmQRK_l);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "AlarmQRK_S", pAlarm->AlarmQRK_s);
			AddToEventList(s_str);
		
			sprintf(s_str, "    %s: %d", "part#", pAlarm->PartNr);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "char#", pAlarm->CharNr);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "value#", pAlarm->ValueNr);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "sample#", pAlarm->SampleNr);
			AddToEventList(s_str);

			delete(pAlarm);
		}
		catch (int)
		{

		}
	}
}

void CVCPPCOMClient2View::DoOnStatisticalAlarm(CAlarm* pAlarm)
{
	char	s_str[255];
	CString	CurrentTime = COleDateTime::GetCurrentTime().Format("%H:%M:%S");
	CString	Str  = CurrentTime + " -> OnStatisticalAlarm";
	sprintf(s_str, "%s", Str);
	AddToEventList(s_str);

	if (pAlarm)
	{
		try
		{
/*
			sprintf(s_str, "    %s: %d", "AlarmEW1", pAlarm->AlarmEW1);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "AlarmEW2", pAlarm->AlarmEW2);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "AlarmQRK_L", pAlarm->AlarmQRK_l);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "AlarmQRK_S", pAlarm->AlarmQRK_s);
			AddToEventList(s_str);
		
			sprintf(s_str, "    %s: %d", "part#", pAlarm->PartNr);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "char#", pAlarm->CharNr);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "value#", pAlarm->ValueNr);
			AddToEventList(s_str);

			sprintf(s_str, "    %s: %d", "sample#", pAlarm->SampleNr);
			AddToEventList(s_str);
*/			
			delete(pAlarm);
		}
		catch (int)
		{
		}
	}
}
