// VCPPCOMClient2View.h : interface of the CVCPPCOMClient2View class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_VCPPCOMCLIENT2VIEW_H__3894E79D_1D63_43B0_8B29_1C88713E9FC3__INCLUDED_)
#define AFX_VCPPCOMCLIENT2VIEW_H__3894E79D_1D63_43B0_8B29_1C88713E9FC3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "qsEventSink.h"
#include "dib.h"
#include "stdafx.h"
#include <atlbase.h>
#include <afxtempl.h>
#include "MainFrm.h"
#include "OnlineTransmition.h"
#include "UpdateView.h" 

class CVCPPCOMClient2View : public CFormView, public CUpdateView
{
protected: // create from serialization only
	CVCPPCOMClient2View();
	DECLARE_DYNCREATE(CVCPPCOMClient2View)

public:
	//{{AFX_DATA(CVCPPCOMClient2View)
	enum { IDD = IDD_VCPPCOMCLIENT2_FORM };
	CStatic		m_Image;
	CListBox	m_EventList;
	//}}AFX_DATA

// Attributes
public:
	CVCPPCOMClient2Doc* GetDocument();
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVCPPCOMClient2View)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
protected:
	HRESULT GetGraphicOrReport(int whattodo, int DoDraw = 0);
	int GIndex;
	int DisconnectFromServer( BOOL final);

public:

	void UpdateStatusBar( int index, char* s);
	void AddToEventList(char* s);

	int SetModule( int ModuleKey);

	ITQsstatRemoteControl*	pqsSTAT;
	
	IDataBase * pIqsSTATDataBase;

	long	qsSTATHandle;
	CDib*	dib;

	CString qs_ServerVersion;

	// connection point
	IConnectionPointContainer*	pConnectionPointContainer;
	IConnectionPoint*			pConnectionPoint;
	IConnectionPoint*			pConnectionPointAlarm;
	//-------------------------------------------------------------------------
	// Sink Object
	CSink*  mySink;
	DWORD	dwCookie;

	//-------------------------------------------------------------------------
	DWORD  dwServerThreadId;
    HANDLE h_ServerThread; // handle for thread, that runs the qs-STAT Server
	HANDLE g_hTerminateQsSTATEvent;// Event for termination server thread

	// number of charactaristics loaded
	long NumOfChar;
	BSTR K_Field_Up;
	BSTR K_Field_Down;

	//Graphic parametrs
	int		GrafKey;
	int		GrafSubKey;
	int		PartNr_x;
	int		CharNr_x;
	int		PartNr_y;
	int		CharNr_y;
	int		ValueNr_x;
	int		ValueNr_y;
	int		GraphicPageNr;

	//Statistical parametrs
	int		StatKey;
	int		StatSubKey;
	int		Transformation;

	//Report var
	BSTR	ReportName;
	CString ReportFileName;
	int		ReportPartNr_x;
	int		ReportCharNr_x;
	int		ReportPartNr_y;
	int		ReportCharNr_y;
	int		ReportValueNr_x;
	int		ReportValueNr_y;
	long	ReportNr;
	long	ReportPageNr;

	//Image parameters
	int		Width;
	int		Height;

	long	Valuenr;

    long	ModuleID;
	long	LanguageID;
	long	StrategyID;
	long	PrinterID;
	CString	DBName;

	CString sTransmitFilePath;
	long	LastReadFilePos;		// alread read Bytes from Base file

	//Printer parameters
	BOOL	ReportPrn;
	int		PrinterNr;

	virtual ~CVCPPCOMClient2View();

	void SetGrafikKey( int Key);
	void SetGrafikSubKey( int Key);
	void SetGrafikPart_x( int Key);
	void SetGrafikPart_y( int Key);
	void SetGrafikChar_x( int Key);
	void SetGrafikChar_y( int Key);
	void SetGrafikValue_x( int Key);
	void SetGrafikValue_y( int Key);
	void SetGrafikPageNr( int Key);
	void SetReportName(LPTSTR FName);
	void SetReportPart_x( int Key);
	void SetReportPart_y( int Key);
	void SetReportChar_x( int Key);
	void SetReportChar_y( int Key);
	void SetReportValue_x( int Key);
	void SetReportValue_y( int Key);
	void SetReportPageNr( int Key);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	void DoOnQSSTATInitialized();
	void DoOnDataAvailExt( int ConnectionHandle, int NumOfChar);
	void DoOnDataAvail( int NumOfChar);
	void DoOnEvaluationDoneExt( int ConnectionHandle);
	void DoOnEvaluationDone();
	void DoOnStatisticalAlarm(CAlarm* pAlarm);
	void DoOnStatisticalAlarmExt( int ConnectionHandle, CAlarm* pAlarm);

	//{{AFX_MSG(CVCPPCOMClient2View)
	afx_msg void OnConnect();
	afx_msg void OnDisconnect();
	afx_msg void OnFileOpen();
	afx_msg void OnEvaluate();
	afx_msg void OnFileTransmit();
	afx_msg void OnPrintReport();
	afx_msg void OnStartServer();
	afx_msg void OnConnectStart();
	afx_msg void OnGetGraphic();
	afx_msg void OnGetResult();
	afx_msg void OnGetCatalogue();
	afx_msg void OnGetReport();
	afx_msg void OnGetValue();
	afx_msg void OnSetModule();
	afx_msg void OnSetLanguage();
	afx_msg void OnSetStrategy();
	afx_msg void OnSetPrinter();
	afx_msg void OnSetDB();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFilter();
	afx_msg void OnAppAbout();
	afx_msg void OnGetChar();
	afx_msg void OnGetPart();	
	afx_msg void OnTransmit();
	afx_msg void OnSPCEvaluation();
	afx_msg void OnONLINEEvaluation();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in VCPPCOMClient2View.cpp
inline CVCPPCOMClient2Doc* CVCPPCOMClient2View::GetDocument()
   { return (CVCPPCOMClient2Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VCPPCOMCLIENT2VIEW_H__3894E79D_1D63_43B0_8B29_1C88713E9FC3__INCLUDED_)
